# pyrhessys

| pyrhessys Links & Badges              |                                                                             |
|------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| pyRHESSys Tutorial      |[![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/DavidChoi76/rhessys_binder_test.git/master)
| pyRHESSys Documentation      | [![Documentation Status](http://readthedocs.org/projects/pyrhessys/badge/?version=latest)](http://pyrhessys.readthedocs.io/en/latest/?badge=latest) |

pyRHESSys (Python-the Regional Hydro-Ecologic Simulation System) is an Object-Oriented Python wrapper for the model input creation and manipulation, model execution, model output visualization and analysis.

* [RHESSys Website at GitHub ](https://github.com/RHESSys)
* [RHESSys Website - Naomi Tague ](http://fiesta.bren.ucsb.edu/~rhessys/)

pyrhessys provides methods for:
------------

 - Get and set model input
 - Run the RHESSys Model on local computers and scientific cyberinfrastructures (especially, CyberGIS-Jupyter for water) 
 - Visualize RHESSys outputs (In progress)
 - Be integrated with pyRHESSys with Jupyter Notebook environment 
 - Interact with Hydorshare to download RHESSys test cases and upload RHESSys outputs
 - Create model input using GRASS GIS and R library (in progress)
 - Automate model calibration or sensitivity analysis (Future work)
 
Installation
------------

pyrhessys can be installed from `pip`.

To install via `pip` use:

```pip install pyrhessys```

rhessys can be installed from 'conda'

To install via 'conda' use:

```conda install -c conda-forge rhessysec```

Installing pyrhessys from source
------------------------------

Installing pyrhessys from source can be useful for developing new features. This can be accomplished by
running:

    git clone https://github.com/DavidChoi76/pyrhessys.git
    cd pyrhessys
    conda env create -f environment.yml
    python -m ipykernel install --user --name=pyrhessys
    pip install .

        
## Bugs
  Our issue tracker is at https://github.com/DavidChoi76/pyrhessys/issues.
  Please report any bugs that you find.  Or, even better, fork the repository on
  GitHub and create a pull request.  All changes are welcome, big or small, and we
  will help you make the pull request if you are new to git
  (just ask on the issue).

## License
  Distributed with a MIT license; see LICENSE.txt::

  Copyright (C) 2020 pyrhessys Developers
  YoungDon Choi <choiyd1115@gmail.com or yc5ef@virginia.edu>
 

options(scipen=999)
options(stringsAsFactors = FALSE)
LIBnrow = function(x){
	return <- ifelse(is.null(dim(x)[1]), 1, dim(x)[1]) 
}#function

arg=commandArgs(T)
#header = 'NA' #arg[1]
#basefile = '/Users/laurencelin/Library/Mobile Documents/com~apple~CloudDocs/Workspace/current_projects/Coweeta/rhessys_ws18_nlcd_local/worldfiles_explicitsoil/worldfile_test.Y2010M12D31H24.csv' #arg[2]
#outputfile = '/Users/laurencelin/Library/Mobile Documents/com~apple~CloudDocs/Workspace/current_projects/Coweeta/rhessys_ws18_nlcd_local/worldfiles_explicitsoil/worldfile_test.Y2010M12D31H24' #arg[3]
header = arg[1]
basefile = arg[2]
outputfile = arg[3]
print( paste('header = ', header,sep='') )
print( paste('basefile = ', basefile,sep='') )
print( paste('outputfile = ', outputfile,sep='') )

dd = as.matrix(read.csv(basefile))
keytable=data.frame(key=unlist(strsplit(readLines(basefile, n=1),',')),index=seq_len(dim(dd)[2])); 
keytable$format = 1; keytable$format[sapply(keytable$key, function(x){grepl('ID',x)})]=0
	# .. special
	keytable$format[which(keytable$key=='epv.wstress_days')]=0
	keytable$format[which(keytable$key=='cs.age')]=0
	keytable$format[which(keytable$key=='canopy_strata_n_basestations')]=0
	keytable$format[which(keytable$key=='hillslope_n_basestations')]=0
	keytable$format[which(keytable$key=='patch_n_basestations')]=0	
	keytable$format[which(keytable$key=='zone_n_basestations')]=0	
	keytable$format[which(keytable$key=='basin_n_basestations')]=0
		
ID_start_index = sapply(c('basin_ID','hillslope_ID','zone_ID','patch_ID','canopy_strata_ID'),function(x){which(keytable$key==x)})
ID_end_index = c(ID_start_index[-1]-1, dim(dd)[2])
LEN = 1:dim(dd)[1]

	## this indexing system here is not efficient! maybe future updates
worldIndex = 1
basin_ID = unique(dd[,'basin_ID']); basinIndex = t(simplify2array(tapply(LEN, INDEX=match(dd[,'basin_ID'],basin_ID),function(ii){return<-c(dd[ii,'world_ID'][1],dd[ii,'basin_ID'][1], ii[1]); })))
hillslope_ID = unique(dd[,'hillslope_ID']); hillIndex = t(simplify2array(tapply(LEN, INDEX=match(dd[,'hillslope_ID'],hillslope_ID),function(ii){return<-c(dd[ii,'world_ID'][1],dd[ii,'basin_ID'][1],dd[ii,'hillslope_ID'][1], ii[1]); })))
zone_ID = unique(dd[,'zone_ID']); zoneIndex = t(simplify2array(tapply(LEN, INDEX=match(dd[,'zone_ID'],zone_ID),function(ii){return<-c(dd[ii,'world_ID'][1],dd[ii,'basin_ID'][1],dd[ii,'hillslope_ID'][1], dd[ii,'zone_ID'][1], ii[1]); })))
patch_ID = unique(dd[,'patch_ID']); patchIndex = t(simplify2array(tapply(LEN, INDEX=match(dd[,'patch_ID'],patch_ID),function(ii){return<-c(dd[ii,'world_ID'][1],dd[ii,'basin_ID'][1],dd[ii,'hillslope_ID'][1], dd[ii,'zone_ID'][1],dd[ii,'patch_ID'][1], ii[1]); })))
stratumID = unique(dd[,'canopy_strata_ID']); stratumIndex = t(simplify2array(tapply(LEN, INDEX=match(dd[,'canopy_strata_ID'],stratumID),function(ii){return<-c(dd[ii,'world_ID'][1],dd[ii,'basin_ID'][1],dd[ii,'hillslope_ID'][1], dd[ii,'zone_ID'][1],dd[ii,'patch_ID'][1],dd[ii,'canopy_strata_ID'][1], ii[1]); })))


### for header
goingAppend=T
if(header=="" | header=="NA" | header=='0' | header=='na'){
	# do nothing
	goingAppend=F
}else{
	con=file(header); open(con)
	line = readLines(con,warn=F); close(con)
	write(line,file=outputfile,ncolumn=1,append=F)
}

# world

num_world = length(worldIndex);
for(worldi in 1:num_world){
	
	world_ID = dd[worldIndex[worldi],'world_ID']
	basinIndex_ = basinIndex[basinIndex[,1]==world_ID,]
	num_basin = LIBnrow(basinIndex_) ## special case: only one basin and one world
	if(num_basin ==1){basinIndex_ = t(as.matrix(basinIndex_)) }
	
	line=c(
		paste(world_ID,"world_id"),
		paste(num_basin,"NUM_of_")
	)#line
	write(line,file=outputfile,ncolumn=1,append=goingAppend); goingAppend=T
	
	for(basini in 1:num_basin){
		
		basin_ID = dd[basinIndex_[basini,3],'basin_ID']
		hillIndex_ = hillIndex[hillIndex[,1]==world_ID & hillIndex[,2]==basin_ID,]
		num_hill = LIBnrow(hillIndex_)
		if(num_hill ==1){hillIndex_ = t(as.matrix(hillIndex_)) }
		
		line = c(
			sapply(ID_start_index[1]:ID_end_index[1],function(ii){ xx=dd[basinIndex_[basini,3],ii]; ifelse(keytable$format[ii]>0, 
				paste(formatC(xx,format="e",digits=6), keytable$key[ii]),
				paste(formatC(xx,format="d"),keytable$key[ii])
				) }),#sapply
			paste(formatC(num_hill,format="d"),"NUM_of_"))#c
		write(line,file=outputfile,ncolumn=1,append=T)
		
		
		for(hilli in 1:num_hill){
			
			hillslope_ID = dd[hillIndex_[hilli,4],'hillslope_ID']
			zoneIndex_ = zoneIndex[zoneIndex[,1]==world_ID & zoneIndex[,2]==basin_ID & zoneIndex[,3]==hillslope_ID,]
			num_zone = LIBnrow(zoneIndex_)
			if(num_zone ==1){zoneIndex_ = t(as.matrix(zoneIndex_)) }
			
			line = c(
				sapply(ID_start_index[2]:ID_end_index[2],function(ii){ xx=dd[hillIndex_[hilli,4],ii]; ifelse(keytable$format[ii]>0, 
					paste(formatC(xx,format="e",digits=6), keytable$key[ii]),
					paste(formatC(xx,format="d"),keytable$key[ii])
					) }),#sapply	
				paste(formatC(num_zone,format="d"),"NUM_of_"))#c
			write(line,file=outputfile,ncolumn=1,append=T)
			
			
			for(zonei in 1:num_zone){	#this num_zone need to read from a quick table
				
				zone_ID = dd[zoneIndex_[zonei,5],'zone_ID']
				patchIndex_ = patchIndex[patchIndex[,1]==world_ID & patchIndex[,2]==basin_ID & patchIndex[,3]==hillslope_ID & patchIndex[,4]==zone_ID,]
				num_patch = LIBnrow(patchIndex_)
				if(num_patch==1){patchIndex_ = t(as.matrix(patchIndex_)) }
				
				line = c(
					sapply(ID_start_index[3]:ID_end_index[3],function(ii){ xx=dd[zoneIndex_[zonei,5],ii]; ifelse(keytable$format[ii]>0, 
						paste(formatC(xx,format="e",digits=6), keytable$key[ii]),
						paste(formatC(xx,format="d"),keytable$key[ii])
						) }),#sapply	
					paste(formatC(num_patch,format="d"),"NUM_of_"))#c
				write(line,file=outputfile,ncolumn=1,append=T)
				
				
				
				for(patchi in 1:num_patch){
					
					patch_ID = dd[patchIndex_[patchi,6],'patch_ID']
					stratumIndex_ = stratumIndex[stratumIndex[,1]==world_ID & stratumIndex[,2]==basin_ID & stratumIndex[,3]==hillslope_ID & stratumIndex[,4]==zone_ID & stratumIndex[,5]==patch_ID,]
					num_strate = LIBnrow(stratumIndex_)
					if(num_strate==1){stratumIndex_ = t(as.matrix(stratumIndex_)) }
				
					line = c(
						sapply(ID_start_index[4]:ID_end_index[4],function(ii){ xx=dd[patchIndex_[patchi,6],ii]; ifelse(keytable$format[ii]>0, 
							paste(formatC(xx,format="e",digits=6), keytable$key[ii]),
							paste(formatC(xx,format="d"),keytable$key[ii])
							) }),#sapply	
						paste(formatC(num_strate,format="d"),"NUM_of_"))#c
					write(line,file=outputfile,ncolumn=1,append=T)



					for(stratei in 1:num_strate){
						
						line = sapply(ID_start_index[5]:ID_end_index[5],function(ii){ xx=dd[stratumIndex_[stratei,7],ii]; ifelse(keytable$format[ii]>0, 
							paste(formatC(xx,format="e",digits=6), keytable$key[ii]),
							paste(formatC(xx,format="d"),keytable$key[ii])
							) })#sapply	
						write(line,file=outputfile,ncolumn=1,append=T)
					}#stratei
				}#patchi
			}#zonei
		}#hilli
	}#basini
}#worldi

arg=commandArgs(T)

library(rgrass7)
library(sp)
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})
# need to set comuptation region. it does change how much memory R uses to hold raster vectors
rast = readRAST(c(arg[1],arg[2]))
mask = !is.na(rast@data[[1]])
lulc = rast@data[[2]][mask]
lulcID = unique(lulc); lulcID=lulcID[order(lulcID)]

buffer = tapply( lulc, INDEX=rast@data[[1]][mask], function(x){
	paste(c(
		length(x),
		sapply(lulcID,function(j){sum(x==j)})
	),collapse=',')	
})#tapply


write(paste(c('patchID','total',paste('lulc',lulcID,sep='')),collapse=','),arg[3],append=F)
write.table(cbind(names(buffer),buffer),arg[3],row.names=F,col.names=F,sep=',', quote=F,append=T)

options(scipen=999)	
arg=commandArgs(T)
# arg=c('dem', 'slope', 'aspect', 'hill', 'zone_cluster')

library(rgrass7)
library(sp)
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})
rast = readRAST(arg[1:4])
mask = !is.na(rast@data[[1]])
dem = rast@data[[1]][mask]
slope = rast@data[[2]][mask]
aspect = rast@data[[3]][mask]
hill = rast@data[[4]][mask]
DtoR = pi/180


zoneclassindex = tapply(seq_along(mask)[mask], hill, function(ii){ return <- ii })
zoneclasshill = tapply(seq_along(hill), hill, function(ii){ return <- hill[ii][1] })
zoneclassLen = tapply(seq_along(hill), hill, function(ii){ return <- length(ii) })
zoneclass = tapply(seq_along(hill), hill, function(ii){
	# ii = seq_along(hill)[hill==65]
	# In mathematical speak that is 9.8°C per 1,000 meters; Google
	# form dataset for cluster analysis
	print(hill[ii][1])
	
	clusterData = cbind(
		(dem[ii]-mean(dem[ii]))*0.02, # 50 m elevation band
		scale(slope[ii]),
		scale(cos(aspect[ii]*DtoR)*sin(slope[ii]*DtoR)),
		scale(sin(aspect[ii]*DtoR)*sin(slope[ii]*DtoR))
	); colnames(clusterData)=c('dem','slope','aspectx','aspecty')
	
	# numer of cluster
	# elevationAspect = ceiling((max(dem[ii])-min(dem[ii]))*0.1)*8 # 10m by 8 direction
	# maxNumCluster = min( max(floor(length(ii)*0.1), elevationAspect), elevationAspect) 
	# if( length(ii) < maxNumCluster ) maxNumCluster=length(ii)-1
	
	# elevation band first
	numCluster = max(1,ceiling((max(dem[ii])-min(dem[ii]))*0.02))
	fit <- kmeans(clusterData[,'dem'], numCluster,iter.max=1000,algorithm="MacQueen") #
	elevationBand = fit$cluster
	
	
	# slope-aspect second
	maxNumCluster = 100; if( length(ii) < maxNumCluster ) maxNumCluster=length(ii)-2
	if(maxNumCluster > 3){
		wss <- (dim(clusterData)[1]-2)*sum(apply(clusterData[,c('slope','aspectx','aspecty')],2,var))
		for (i in 2: maxNumCluster) wss[i] <- sum(kmeans(clusterData[,c('slope','aspectx','aspecty')], centers=i,iter.max=1000, algorithm="MacQueen")$withinss)
		AccumImprovement = cumsum(diff(wss))
		#plot( AccumImprovement, type='b')
		numCluster = which( AccumImprovement/min(AccumImprovement) > 0.8)[1]; numCluster
		fit <- kmeans(clusterData[,c('slope','aspectx','aspecty')], numCluster, iter.max=1000,algorithm="MacQueen")
		slope_aspect_cluster = fit$cluster	
	}else{
		slope_aspect_cluster = rep(1,dim(clusterData)[1])
	}#if
	
	
	# combine	
	comb = paste(elevationBand, slope_aspect_cluster,sep='-')	
	comb_class = match(comb,unique(comb))
		
	return <- comb_class
})#tapply

max_num_zone = max(sapply(seq_along(zoneclassindex),function(i){ max(zoneclass[[i]]) }))
hill_multipler = 10^ceiling(log(max_num_zone,base=10))

zoneGIS = rep(NA,length(mask))
for(ii in seq_along(zoneclassindex)){
	zoneGIS[ zoneclassindex[[ii]] ] = zoneclasshill[[ii]]* hill_multipler + zoneclass[[ ii ]]
}#ii
	

rast$zone = as.integer(zoneGIS);
writeRAST(rast, arg[5], zcol="zone", overwrite=T)

mapunitTitle=c('musym','muname','mukind','mustatus','muacres','mapunitlfw_l','mapunitlfw_r','mapunitlfw_h','mapunitpfa_l','mapunitpfa_r','mapunitpfa_h','farmlndcl','muhelcl','muwathelcl','muwndhelcl','interpfocus','invesintens','iacornsr','nhiforsoigrp','nhspiagr','vtsepticsyscl','mucertstat','lkey','mukey')
compTitle=c('comppct_l','comppct_r','comppct_h','compname','compkind','majcompflag','otherph','localphase','slope_l','slope_r','slope_h','slopelenusle_l','slopelenusle_r','slopelenusle_h','runoff','tfact','wei','weg','erocl','earthcovkind1','earthcovkind2','hydricon','hydricrating','drainagecl','elev_l','elev_r','elev_h','aspectccwise','aspectrep','aspectcwise','geomdesc','albedodry_l','albedodry_r','albedodry_h','airtempa_l','airtempa_r','airtempa_h','map_l','map_r','map_h','reannualprecip_l','reannualprecip_r','reannualprecip_h','ffd_l','ffd_r','ffd_h','nirrcapcl','nirrcapscl','nirrcapunit','irrcapcl','irrcapscl','irrcapunit','cropprodindex','constreeshrubgrp','wndbrksuitgrp','rsprod_l','rsprod_r','rsprod_h','foragesuitgrpid','wlgrain','wlgrass','wlherbaceous','wlshrub','wlconiferous','wlhardwood','wlwetplant','wlshallowwat','wlrangeland','wlopenland','wlwoodland','wlwetland','soilslippot','frostact','initsub_l','initsub_r','initsub_h','totalsub_l','totalsub_r','totalsub_h','hydgrp','corcon','corsteel','taxclname','taxorder','taxsuborder','taxgrtgroup','taxsubgrp','taxpartsize','taxpartsizemod','taxceactcl','taxreaction','taxtempcl','taxmoistscl','taxtempregime','soiltaxedition','castorieindex','flecolcomnum','flhe','flphe','flsoilleachpot','flsoirunoffpot','fltemik2use','fltriumph2use','indraingrp','innitrateleachi','misoimgmtgrp','vasoimgtgrp','mukey','cokey')
chorizonTitle = c('hzname','desgndisc','desgnmaster','desgnmasterprime','desgnvert','hzdept_l','hzdept_r','hzdept_h','hzdepb_l','hzdepb_r','hzdepb_h','hzthk_l','hzthk_r','hzthk_h','fraggt10_l','fraggt10_r','fraggt10_h','frag3to10_l','frag3to10_r','frag3to10_h','sieveno4_l','sieveno4_r','sieveno4_h','sieveno10_l','sieveno10_r','sieveno10_h','sieveno40_l','sieveno40_r','sieveno40_h','sieveno200_l','sieveno200_r','sieveno200_h','sandtotal_l','sandtotal_r','sandtotal_h','sandvc_l','sandvc_r','sandvc_h','sandco_l','sandco_r','sandco_h','sandmed_l','sandmed_r','sandmed_h','sandfine_l','sandfine_r','sandfine_h','sandvf_l','sandvf_r','sandvf_h','silttotal_l','silttotal_r','silttotal_h','siltco_l','siltco_r','siltco_h','siltfine_l','siltfine_r','siltfine_h','claytotal_l','claytotal_r','claytotal_h','claysizedcarb_l','claysizedcarb_r','claysizedcarb_h','om_l','om_r','om_h','dbtenthbar_l','dbtenthbar_r','dbtenthbar_h','dbthirdbar_l','dbthirdbar_r','dbthirdbar_h','dbfifteenbar_l','dbfifteenbar_r','dbfifteenbar_h','dbovendry_l','dbovendry_r','dbovendry_h','partdensity','ksat_l','ksat_r','ksat_h','awc_l','awc_r','awc_h','wtenthbar_l','wtenthbar_r','wtenthbar_h','wthirdbar_l','wthirdbar_r','wthirdbar_h','wfifteenbar_l','wfifteenbar_r','wfifteenbar_h','wsatiated_l','wsatiated_r','wsatiated_h','lep_l','lep_r','lep_h','ll_l','ll_r','ll_h','pi_l','pi_r','pi_h','aashind_l','aashind_r','aashind_h','kwfact','kffact','caco3_l','caco3_r','caco3_h','gypsum_l','gypsum_r','gypsum_h','sar_l','sar_r','sar_h','ec_l','ec_r','ec_h','cec7_l','cec7_r','cec7_h','ecec_l','ecec_r','ecec_h','sumbases_l','sumbases_r','sumbases_h','ph1to1h2o_l','ph1to1h2o_r','ph1to1h2o_h','ph01mcacl2_l','ph01mcacl2_r','ph01mcacl2_h','freeiron_l','freeiron_r','freeiron_h','feoxalate_l','feoxalate_r','feoxalate_h','extracid_l','extracid_r','extracid_h','extral_l','extral_r','extral_h','aloxalate_l','aloxalate_r','aloxalate_h','pbray1_l','pbray1_r','pbray1_h','poxalate_l','poxalate_r','poxalate_h','ph2osoluble_l','ph2osoluble_r','ph2osoluble_h','ptotal_l','ptotal_r','ptotal_h','excavdifcl','excavdifms','cokey','chkey')
chtexgrpTitle=c('texture','stratextsflag','rvindicator','texdesc','chkey','chtgkey')
chtexturTitle=c('texcl','lieutex','chtgkey','chtkey')
chporesTitle=c('poreqty','poresize','porecont','poreshp','rvindicator','chkey','chporeskey')


arg=commandArgs(T);
target = paste(arg[1],'/tabular',sep='') 
print(target)


mapunit = read.table(paste(target,'/mapunit.txt',sep=''),sep='|',stringsAsFactors=F) #mukey
colnames(mapunit) = mapunitTitle
	## 1 mukey to many componments [cokey]
comp = read.table(paste(target,'/comp.txt',sep=''),sep='|',stringsAsFactors=F) #cokey
colnames(comp) = compTitle
	## 1 cokey to many horizons [chkey]
chorizon = read.table(paste(target,'/chorizon.txt',sep=''),sep='|',stringsAsFactors=F) #chkey
colnames(chorizon) = chorizonTitle

chtexgrp = read.table(paste(target,'/chtexgrp.txt',sep=''),sep='|',stringsAsFactors=F) #chkey
colnames(chtexgrp) = chtexgrpTitle

chtextur = read.table(paste(target,'/chtextur.txt',sep=''),sep='|',stringsAsFactors=F) #chkey
colnames(chtextur) = chtexturTitle

## mapunit:component:horizon
## extract (weighted average[thickness] of soil horizon in a soil component; then weighted [%composition] by componments):
	# 1 permeability
	# 2 watercapacity
	# 3 bulkdensity
	# 4 saturatedhydraulicconductivity
	# 5 erodibility
	# 6 field capacity
	# 7 porosity
	# 8 soilthickness
	# 9 organ matter 
    # AWC?

	# relationshup
	# 1 mukey: N cokey (componments) : N chkey (horizons)
 	#        : fraction "comppct_r"  : fraction "hzdepb_r" -> thickness

replaceNA0 = function(x,value){
	x[is.na(x) | x<=0] = value;
	return <- x;	
}#function
weightedAverage = function(xx,weight){
    new_weight = weight;
    new_weight[is.na(xx)] = 0;
    if( sum(new_weight)>0 ){
        return <- sum(xx * new_weight/sum(new_weight), na.rm=T)
    }else{
        return <- NA
    }
}#function
getDistMatrix = function(x){
    len = dim(x)[1]
    len_index = seq_len(len)
    len_index2 = seq_len(dim(x)[2])
    dm = matrix(NA,len,len)
    for(i in len_index){
        for(j in len_index){
            dm[i,j] = sqrt(sum(sapply(len_index2,function(ii){
                return <- (x[i,ii]-x[j,ii])^2
            }),na.rm=T ))
        }#j
    }#i
    return <- dm
}#function

horizonOrder = c('H','O','A','E','B','C','R')	# there is horizon 'H' H horizons or layers: Layers dominated by organic material, formed from accumulations of undecomposed or partially decomposed organic material at the soil surface which may be underwater. All H horizons are saturated with water for prolonged periods or were once saturated but are now artificially drained. An H horizon may be on top of mineral soils or at any depth beneath the surface if it is buried. (http://www.fao.org/3/w8594e/w8594e0g.htm)
    # H - B microbial activities, but no evidence of such activities in C or deeper
    # plant roots can penetrate C horizon
    # R is hard bedrock
    # ---------------------------------------------
	# make horizon H as O
horizonOrderScore = c(1,1,1,1,2,3,4)
horizonThicknessDefault = c(0, 2, 5, 5, 10, 10, 10)*0.0254 #inches to meter; https://www.sheffield.ac.uk/ssa/soil-facts/horizons
horizonThicknessDefault_acc = cumsum(horizonThicknessDefault)
horizonThicknessDefault_scale2soildepth = max(horizonThicknessDefault_acc)/horizonThicknessDefault_acc
horizonUpperZDefault = c(0, cumsum(horizonThicknessDefault)[1:(length(horizonThicknessDefault)-1)])
horizonlowerZDefault = cumsum(horizonThicknessDefault)[1:length(horizonThicknessDefault)]

	# this part need to be read in from a file!
	soilscoreNames = c('Clay','Silty clay','Silty clay loam','Sandy clay','Sandy clay loam','Clay loam','Silt','Silt loam','Loam','Sand','Loamy sand','Sandy loam')
	soilscore = c(1,2,3,4,5,6,7,8,9,10,11,12); names(soilscore)=soilscoreNames
	
	soilscore_db = data.frame(
		sand = c(0.2,0.05,0.1,0.5,0.6,0.34,0.05,0.17,0.43,0.92,0.85,0.7),
		silt = c(0.2,0.475,0.55,0.05,0.1,0.33,0.9,0.7,0.39,0.05,0.1,0.2),
		clay = c(0.6,0.475,0.35,0.45,0.3,0.33,0.05,0.13,0.18,0.03,0.05,0.1),
		ksat = c(0.111,0.089,0.147,0.188,0.544,0.212,0.622,0.622,0.6,15.2064,13.5,3),
		por = c(0.482,0.492,0.477,0.426,0.42,0.476,0.485,0.485,0.451,0.395,0.41,0.435),
		por_size_index = c(0.088,0.96,0.129,0.096,0.14,0.117,0.189,0.189,0.204,0.204,0.228,0.204),
		psi_air_entry = c(0.405,0.49,0.356,0.153,0.299,0.63,0.786,0.786,0.478,0.121,0.09,0.218),
		albedo = c(0.23,0.229,0.238,0.253,0.265,0,0.253,0.253,0.28,0.28,0.29,0.28)
	)#data.frame

mukey = mapunit[,'mukey']	
#mukeyHold = matrix(NA,length(mukey), 17);
#profileDEPTH = seq(0,10,0.01)
#profile_ksat_table = data.frame(z=profileDEPTH)
#profile_POR_table = data.frame(z=profileDEPTH)

###---------------------------------------------------------- extracting
textureFILE = paste(arg[1],'/soil_mukey_texture.csv',sep='')
for(i in seq_along(mukey)){
	## for each mukey, we have N cokey
    ## mukey soil texture class
    
    
	cond1 = comp[,'mukey']== mukey[i]; sum(cond1)
	
	## 1 find overall soil type and develop default parameter values; not component/horizon specific
	overall_NODATA = F
    cond25 = chorizon[,'cokey'] %in% comp[cond1,'cokey']; sum(cond25)
    if(sum(cond25)>0){
    	cond3 = chtexgrp[,'chkey'] %in% chorizon[cond25,'chkey']; sum(cond3)
	    cond4 = chtextur[,'chtgkey'] %in% chtexgrp[cond3,'chtgkey']; sum(cond4)
        default_overallsoil = table(soilscore[match(chtextur[cond4,1], soilscoreNames)]) # could have chtextur[cond4,1]='' problem!
        
	    	default_overallsoil_index = as.numeric(names(default_overallsoil))
	        default_overallsoil_weight = default_overallsoil/sum(default_overallsoil)
	        default_overallsoil_char = unlist(list(
	            sand = sum(soilscore_db$sand[default_overallsoil_index]* default_overallsoil_weight),
	            silt = sum(soilscore_db$silt[default_overallsoil_index]* default_overallsoil_weight),
	            clay = sum(soilscore_db$clay[default_overallsoil_index]* default_overallsoil_weight),
				por_size_index = sum(soilscore_db$por_size_index[default_overallsoil_index]* default_overallsoil_weight),
				psi_air_entry = sum(soilscore_db$psi_air_entry[default_overallsoil_index]* default_overallsoil_weight),
				albedo = sum(soilscore_db$albedo[default_overallsoil_index]* default_overallsoil_weight),
	            ksat = sum(soilscore_db$ksat[default_overallsoil_index]* default_overallsoil_weight),
	            POR = sum(soilscore_db$por[default_overallsoil_index]* default_overallsoil_weight)
	            ))#
	    soilID_ = ifelse(length(default_overallsoil)>0, as.numeric(names(which.max(default_overallsoil))), NA)
	    soilID_name = ifelse(length(default_overallsoil)>0, soilscoreNames[soilID_], NA)
	    # default_overallsoil_char
	    # soilID_name
	}else{
		overall_NODATA = T
		default_overallsoil_char = unlist(list(
	            sand = NA, silt = NA, clay = NA,
				por_size_index = NA, psi_air_entry = NA, albedo = NA,
	            ksat = NA, POR = NA
	            ))#
		soilID_name = NA
    }# cond25
	
	
    
    
	## 2 find all the components and horizons and extract specific information
	if(! overall_NODATA){
		
        ## 2.1 reoganizing information by horizon
        mukeyHorizonLIST = list()
        for(cokeyii in seq_along(comp[cond1,'cokey'])){
        
            cokey = comp[cond1,'cokey'][cokeyii]
            cond2 = chorizon[,'cokey']== cokey; sum(cond2) # finding component-specific horizons
            if(sum(cond2)>0){
                # found matched component-specific horizons
                component_NODATA = F
                
                ## 2.1.1 ..... default
                # sort the component specific soil types --> develop component-specific default parameters
                cond3 = chtexgrp[,'chkey'] %in% chorizon[cond2,'chkey']; sum(cond3)
                cond4 = chtextur[,'chtgkey'] %in% chtexgrp[cond3,'chtgkey']; sum(cond4)
                default_soil = table(soilscore[match(chtextur[cond4,1], soilscoreNames)]); length(default_soil)
                if(length(default_soil)==0){
                    # cannot find the component soil name
                    component_NODATA = T
                    default_soil = default_overallsoil;
                }#if
                default_soil_index = as.numeric(names(default_soil))
                default_soil_weight = default_soil/sum(default_soil)
                default_soil = unlist(list(
                    sand = sum(soilscore_db$sand[default_soil_index]*default_soil_weight),
                    silt = sum(soilscore_db$silt[default_soil_index]*default_soil_weight),
                    clay = sum(soilscore_db$clay[default_soil_index]*default_soil_weight),
                    por_size_index = sum(soilscore_db$por_size_index[default_soil_index]*default_soil_weight),  # <<-- not from surrgo
                    psi_air_entry = sum(soilscore_db$psi_air_entry[default_soil_index]*default_soil_weight),    # <<-- not from surrgo
                    albedo = sum(soilscore_db$albedo[default_soil_index]*default_soil_weight),                  # <<-- not from surrgo
                    ksat = sum(soilscore_db$ksat[default_soil_index]*default_soil_weight),
                    POR = sum(soilscore_db$por[default_soil_index]*default_soil_weight)
                ))#
                
                
                ## 2.1.2 ... SSURGO specific
                horizonSummaryTable = data.frame(id = chorizon[cond2,'chkey'])
                horizonSummaryTable$horizonThinkness = NA#(chorizon[cond2,'hzdepb_r']-chorizon[cond2,'hzdept_r'])*0.01 #cm -> m
                horizonSummaryTable$horizonMeanDepth = NA#0.5*(chorizon[cond2,'hzdepb_r']+chorizon[cond2,'hzdept_r'])*0.01 # m (real depth)
                horizonSummaryTable$horizonTopDepth = chorizon[cond2,'hzdept_r']*0.01 #m
                horizonSummaryTable$horizonBottomDepth = chorizon[cond2,'hzdepb_r']*0.01 #m <<-- for microbial activities depth & max root depth
                # microbial activities stop at the bottom of B
                # max plant root could be at the bottom of C
                #horizonSummaryTable$horizonOriginal = chorizon[cond2,'hzname']
                horizonSummaryTable$horizonClass = sapply(chorizon[cond2,'hzname'],function(nn){
                    tmp = sapply(horizonOrder, function(x){grepl(x,nn)})
                    if(sum(tmp)>0) return <- horizonOrder[tmp]
                    else return <- NA
                })#
                horizonSummaryTable$horizonName = chorizon[cond2,'hzname']
                
                horizonSummaryTable$sand = replaceNA0(chorizon[cond2,'sandtotal_r']*0.01, default_soil['sand']); #% -> [0,1]
                horizonSummaryTable$silt = replaceNA0(chorizon[cond2,'silttotal_r']*0.01, default_soil['silt']); #% -> [0,1]
                horizonSummaryTable$clay = replaceNA0(chorizon[cond2,'claytotal_r']*0.01, default_soil['clay']); #% -> [0,1]
                horizonSummaryTable$ksat = replaceNA0(chorizon[cond2,'ksat_r']*1e-6*3600*24, default_soil['ksat']); # m/day;
                horizonSummaryTable$ksat[horizonSummaryTable$ksat<=0] = 0.001 # m/day
                horizonSummaryTable$POR = replaceNA0(chorizon[cond2,'wsatiated_r']*0.01, default_soil['POR']); #% -> [0,1]
                horizonSummaryTable$POR[horizonSummaryTable$POR<=0] = 0.01
                
                horizonSummaryTable$BD = chorizon[cond2,'dbovendry_r'] #g/cm3 bulk density [0.02 - 2.6]; the oven dry weight of the less than 2 mm soil material per unit volume of soil exclusive of the desication cracks, measured on a costed clod;
                horizonSummaryTable$fc = chorizon[cond2,'wthirdbar_r']*0.01 #% -> [0,1]; field capacity; the volumetric content of soil water retained at the tension of 1/3 bar (33 kPa), expressed as a percentage of the whole soil.
                horizonSummaryTable$awc = chorizon[cond2,'awc_r']*0.01 # cm/cm; Amount of water that an increment of soil depth, inclusive of fragements, can store that is available to plants.
                horizonSummaryTable$kffact = chorizon[cond2,'kffact'] # soil erodibility factor [0-1]; an erodibility factor which quantifies the susceptibility of doil particles to detechment by water
                horizonSummaryTable$density = horizonSummaryTable$BD / (1 - horizonSummaryTable$POR)
                #chorizon[cond2,'partdensity']
                # g/cm3; [0.01 - 5] mass per unit volume (not including pore space) of the solid particle either mineral or organic.
                # from text book: % pore space = porosity = (1 - BD / density) * 100 %
                # from my note: density = BD / (1 - POR)
                horizonSummaryTable$om = chorizon[cond2,'om_r']*0.01
                #% -> [0,1]; the amount by weight of decomposed plant and animal residue expressed as weight percentage of the less than 2 mm soil material (not the top 2 mm soil!).
                
                horizonSummaryTable$compWeight = comp[cond1,'comppct_r'][cokeyii]
                
                # try to find horizon specific soil class, but it return multiple!!
                # why there is multiple soil class in one horizon?
                horizonSoilCl_varx = sapply(chorizon[cond2,'chkey'],function(hh){
                    horizonSoilCl = chtextur[ (chtextur[,'chtgkey'] %in% chtexgrp[ (chtexgrp[,'chkey'] == hh),'chtgkey']),'texcl']
                    horizonSoilCl_index = match(horizonSoilCl, soilscoreNames)
                    horizonSoilCl_count = table(horizonSoilCl_index)
                    horizonSoilCl_weight = horizonSoilCl_count/sum(horizonSoilCl_count)
                    horizonSoilCl_index = as.numeric(names(horizonSoilCl_count))
                    return <- c(
                        weightedAverage(soilscore_db$por_size_index[horizonSoilCl_index],horizonSoilCl_weight),
                        weightedAverage(soilscore_db$psi_air_entry[horizonSoilCl_index],horizonSoilCl_weight),
                        weightedAverage(soilscore_db$albedo[horizonSoilCl_index],horizonSoilCl_weight))
                })#
                horizonSummaryTable$por_size_index = horizonSoilCl_varx[1,]
                horizonSummaryTable$psi_air_entry = horizonSoilCl_varx[2,]
                horizonSummaryTable$albedo = horizonSoilCl_varx[3,]
       
       
                ## ... ## ... 2.1.2.1 resolve horizon names :: analyzing
                # a profile containing a buried sequence could be structured O, A1, A2, B2, 2A2, 2B21, 2B22, 2C with the buried profile commencing at 2A2.
                # take another approach for this: keep the seq and find break
                workingPattern_order = order( horizonSummaryTable$horizonTopDepth + horizonSummaryTable$horizonBottomDepth )
                horizonSummaryTable = horizonSummaryTable[workingPattern_order,]
                horizonSummaryTable$horizonIndex = sapply(horizonSummaryTable$horizonClass,function(x){ horizonOrderScore[match(x,horizonOrder)] })
                
                excludedR = sapply(horizonSummaryTable$horizonClass,function(x){ sum(grepl('R',x))==0 })
                if(sum(excludedR)>2){
                    ## 1) sort the horizon by depths
                    ## 2) determine to horizon class --> output A, B, C, R
                    ## 3) how to determine? ksat? POR? om? sand, slit, clay? letter classes
                    ## horizonSummaryTable[,c('horizonClass','horizonName','sand','silt','clay','ksat','POR','om')]
                    ##
                    #  horizonClass horizonName sand silt clay   ksat  POR    om
                    #             A           A 0.44 0.41 0.15 0.7776 0.50 0.100
                    #             B          Bw 0.47 0.37 0.16 0.7776 0.33 0.005
                    #             C          BC 0.67 0.20 0.13 2.4192 0.30 0.002
                    ## how to form dist matrix?
                    horizonPTs = cbind(
                        numclass=sapply(horizonSummaryTable$horizonClass[excludedR],length),
                        indexclass=sapply(horizonSummaryTable$horizonIndex[excludedR],mean),
                        depth=0.5*(horizonSummaryTable$horizonTopDepth[excludedR]+horizonSummaryTable$horizonBottomDepth[excludedR])/max(horizonSummaryTable$horizonBottomDepth),
                        horizonSummaryTable[excludedR,c('sand','silt','clay','POR','om')])#cbind 'ksat',
                    distmatrix = getDistMatrix( horizonPTs )
                    
                    horizonLumpList = list()
                    currentJJ = 1;
                    for(jj in 1:2){
                        JJseq = currentJJ:dim(distmatrix)[1]
                        distinguishingDist = min(1.5, max(distmatrix[JJseq,currentJJ])/(4-jj) )
                         selectedIndex = JJseq[ distmatrix[JJseq,currentJJ]<distinguishingDist ]
                         selectedIndex_cond = sapply(seq_along(selectedIndex),function(yy){ length(selectedIndex[1]:selectedIndex[yy]) == yy })
                         
                         horizonLumpList[[jj]] = selectedIndex[selectedIndex_cond]
                         currentJJ = 1+max(selectedIndex[selectedIndex_cond])
                         if(currentJJ>=dim(distmatrix)[1]){ break; }
                         ## problem: two horizons; jj=1 pass; then what is the second horizon? B or C?
                    }#jj for
                    if(currentJJ<=dim(distmatrix)[1]){ horizonLumpList[[3]] = currentJJ:dim(distmatrix)[1] }
                    
                    outputHorizon = c('A','B','C')
                    horizonSummaryTable$horizonClass = sapply(horizonSummaryTable$horizonClass,function(x){x[1]})
                    horizonSummaryTable$horizonIndex = sapply(horizonSummaryTable$horizonIndex,function(x){x[1]})
                    for(jj in seq_along(horizonLumpList)){
                        horizonSummaryTable$horizonClass[ horizonLumpList[[jj]] ] = outputHorizon[jj]
                        horizonSummaryTable$horizonIndex[ horizonLumpList[[jj]] ] = horizonOrderScore[match(outputHorizon[jj],horizonOrder)]
                    }#jj
                }else{
                    horizonSummaryTable$horizonClass = sapply(horizonSummaryTable$horizonName,function(nn){
                        tmp = sapply(horizonOrder, function(x){grepl(x,substr(nn,1,1) )})
                        if(sum(tmp)>0) return <- horizonOrder[tmp]
                        else return <- NA
                    })#
                    # lumping
                    horizonSummaryTable$horizonClass[horizonSummaryTable$horizonClass=='H'] = 'A'
                    horizonSummaryTable$horizonClass[horizonSummaryTable$horizonClass=='O'] = 'A'
                    horizonSummaryTable$horizonClass[horizonSummaryTable$horizonClass=='E'] = 'A'
                    
                    horizonSummaryTable$horizonIndex = sapply(horizonSummaryTable$horizonClass,function(x){ horizonOrderScore[match(x,horizonOrder)] })
                    
                }# if(dim(horizonSummaryTable)[1]>1)
                
                
                ## ... ## ... 2.1.2.2 sorting horizonSummaryTable by horizonName
                horizonSummaryTable$horizonThinkness = sapply(seq_len(dim(horizonSummaryTable)[1]),function(jj){
                    if( is.na(horizonSummaryTable$horizonTopDepth[jj]) | horizonSummaryTable$horizonTopDepth[jj]<0 |
                    is.na(horizonSummaryTable$horizonBottomDepth[jj]) | horizonSummaryTable$horizonBottomDepth[jj]<0){
                        ## no data boundaries
                        return <- horizonThicknessDefault[horizonSummaryTable$horizonIndex[jj]]
                    }else{
                        ## yes data define boundaries
                        tmp = horizonSummaryTable$horizonBottomDepth[jj] - horizonSummaryTable$horizonTopDepth[jj]
                        return <- ifelse(tmp<=0, horizonThicknessDefault[horizonSummaryTable$horizonIndex[jj]], tmp)
                    }# if
                })#sapply
                endpoints = c(0, cumsum(horizonSummaryTable$horizonThinkness))
                horizonSummaryTable$horizonTopDepth = endpoints[1:(length(endpoints)-1)]
                horizonSummaryTable$horizonBottomDepth = endpoints[-1]
                horizonSummaryTable$horizonMeanDepth = 0.5*(horizonSummaryTable$horizonTopDepth+horizonSummaryTable$horizonBottomDepth)
                
    
                ## ... ## ... 2.1.2.3 convert OM from % to kgC/m2 (total decaying organic)
                # the amount by weight of decomposed plant and animal residue expressed as weight percentage of the less than 2 mm soil material (not the top 2 mm soil!).
                horizonSummaryTable$om = 500*horizonSummaryTable$BD*chorizon[cond2,'om_r']*0.01*horizonSummaryTable$horizonThinkness # kgC/m2
                # g/cm3 = 100*100*100 g/m3 = 100*100*100/1000 kg/m3 => 500 kgC/m3
                # percent * PD * thickness (kg/m3 * m) -> kgC/m2
                # 0.5 kg/m3 = kgC/m3
                # we need to count for the POR in the actual soil core, so we use "BD" instead of "PD"
                
                
                
                ## ... ## ... 2.1.2.4 how to unpack "horizonSummaryTable" to "mukeyHorizonLIST" ?
                ### <<----- lumping O and E to A for simplicity
                #horizonSummaryTable$horizonName[horizonSummaryTable$horizonClass=='H']= 'A'
                #horizonSummaryTable$horizonName[horizonSummaryTable$horizonClass=='O']= 'A'
                #horizonSummaryTable$horizonName[horizonSummaryTable$horizonClass=='E']= 'A'
                horizonSummaryTable_class = match(horizonSummaryTable$horizonClass,horizonOrder)
                horizonSummaryTable_class_index = tapply(seq_along(horizonSummaryTable_class),horizonSummaryTable_class,function(ii){return <- ii})
                
                for(iij in seq_along(horizonSummaryTable_class_index) ){
                    
                    tmp = horizonSummaryTable[horizonSummaryTable_class_index[[iij]],]
                    tmp_name = tmp$horizonClass[1]
                    if(dim(tmp)[1]>1){
                        ## merging repeated horizon
                        temp_weight = tmp$horizonThinkness/sum(tmp$horizonThinkness)
                        
                        finalHorizon = tmp[1,]
                        ## somehow it creates new column below!!!
                        finalHorizon$horizonThinkness = sum(tmp$horizonThinkness, na.rm=T)
                        finalHorizon$horizonTopDepth = min(tmp$horizonTopDepth, na.rm=T)
                        finalHorizon$horizonBottomDepth = max(tmp$horizonBottomDepth, na.rm=T)
                        finalHorizon$horizonMeanDepth = 0.5*(finalHorizon$horizonTopDepth + finalHorizon$horizonBottomDepth)
                        
                        finalHorizon$sand = weightedAverage(tmp$sand, temp_weight)
                        finalHorizon$silt = weightedAverage(tmp$silt, temp_weight)
                        finalHorizon$clay = weightedAverage(tmp$clay, temp_weight)
                        finalHorizon$ksat = weightedAverage(tmp$ksat, temp_weight)
                        finalHorizon$POR = weightedAverage(tmp$POR, temp_weight); #dim(finalHorizon)
                        finalHorizon$BD = weightedAverage(tmp$BD, temp_weight); #dim(finalHorizon)
                        finalHorizon$fc = weightedAverage(tmp$fc, temp_weight); #dim(finalHorizon)
                        finalHorizon$awc = weightedAverage(tmp$awc, temp_weight); #dim(finalHorizon)
                        finalHorizon$kffact = weightedAverage(tmp$kffact, temp_weight); #dim(finalHorizon)
                        finalHorizon$om = weightedAverage(tmp$om, temp_weight); #dim(finalHorizon)
                        
                        finalHorizon$density = finalHorizon$BD / (1 - finalHorizon$POR); #dim(finalHorizon)
                    }else{
                        finalHorizon = tmp
                    }
                    
                    if( is.null(mukeyHorizonLIST[[ tmp_name ]]) ){
                        # need to make data.frame
                        # list$A = table [soil variable]
                        # colname [cokey]
                        mukeyHorizonLIST[[ tmp_name ]] = finalHorizon
                    }else{
                        # add to data.frame
                        mukeyHorizonLIST[[ tmp_name ]] = rbind(mukeyHorizonLIST[[ tmp_name ]], finalHorizon)
                    }
                }# for loop iij
                
            
            }else{
                ## 2.1.2
                # component_NODATA = T :: no information about this component at all :: no info on default_overallsoil
                # do something?
            }# else of sum(cond2)>0
        }# for loop of cokey
        # mukeyHorizonLIST
        
        ## 3 mukeyHorizon Table (row = mukey, column = variation
        # horizonOrder = c('O','A','E','B','C','R')
       	mukeyHorizonLIST_order = order(sapply(seq_along(mukeyHorizonLIST),function(ii){
            return <- mukeyHorizonLIST[[ii]]$horizonIndex[1]
        }))
        aggregatedHorian_name = sapply(mukeyHorizonLIST_order,function(ii){
            return <- mukeyHorizonLIST[[ii]]$horizonClass[1]
        })
        aggregatedHorian_num = sapply(mukeyHorizonLIST_order,function(ii){
        		length(mukeyHorizonLIST[[ii]]$horizonClass)
        	})
        aggregatedHorian_table = as.data.frame(do.call(rbind,lapply(mukeyHorizonLIST_order,function(ii){
            if(sum(mukeyHorizonLIST[[ii]]$compWeight)==0){
            		weight = rep(1,length(mukeyHorizonLIST[[ii]]$compWeight))
            		weight = weight/sum(weight)
            }else{
            		weight = mukeyHorizonLIST[[ii]]$compWeight/sum(mukeyHorizonLIST[[ii]]$compWeight);
            }
            return <- c(
            horizonThinkness = weightedAverage(mukeyHorizonLIST[[ii]]$horizonThinkness,weight),
            horizonMeanDepth = weightedAverage(mukeyHorizonLIST[[ii]]$horizonMeanDepth,weight),
            horizonTopDepth = weightedAverage(mukeyHorizonLIST[[ii]]$horizonTopDepth,weight),
            horizonBottomDepth = weightedAverage(mukeyHorizonLIST[[ii]]$horizonBottomDepth,weight),
            sand = weightedAverage(mukeyHorizonLIST[[ii]]$sand,weight),
            silt = weightedAverage(mukeyHorizonLIST[[ii]]$silt,weight),
            clay = weightedAverage(mukeyHorizonLIST[[ii]]$clay,weight),
            ksat = weightedAverage(mukeyHorizonLIST[[ii]]$ksat,weight),
            POR = weightedAverage(mukeyHorizonLIST[[ii]]$POR,weight),
            
            BD = weightedAverage(mukeyHorizonLIST[[ii]]$BD,weight), # one of it is NA
            om = weightedAverage(mukeyHorizonLIST[[ii]]$om,weight),
            density = weightedAverage(mukeyHorizonLIST[[ii]]$BD,weight) / (1 - weightedAverage(mukeyHorizonLIST[[ii]]$POR,weight)),
            
            por_size_index = weightedAverage(mukeyHorizonLIST[[ii]]$por_size_index,weight),
            psi_air_entry = weightedAverage(mukeyHorizonLIST[[ii]]$psi_air_entry,weight),
            albedo = weightedAverage(mukeyHorizonLIST[[ii]]$albedo,weight)
            )
        })))
        ## ... adjust horizon depths after averaging
        len = dim(aggregatedHorian_table)[1]
        if(len>1){
        
            issuedepth = aggregatedHorian_table$horizonTopDepth != c(0,aggregatedHorian_table$horizonBottomDepth[1:(len-1)]) |
                c(F,diff(aggregatedHorian_table$horizonTopDepth)<0) |
                c(F,diff(c(0,aggregatedHorian_table$horizonBottomDepth[1:(len-1)]))<0)
            #up_adjust = c(F,aggregatedHorian_num[1:(len-1)] < aggregatedHorian_num[2:len]) # make adjust to the up horizon
            #down_adjust = c(aggregatedHorian_num[1:(len-1)] >= aggregatedHorian_num[2:len],F)
	        
            # cbind(aggregatedHorian_table$horizonTopDepth, aggregatedHorian_table$horizonBottomDepth, issuedepth, aggregatedHorian_table$horizonThinkness)
            
            for(jj in seq_along(issuedepth)){
                
                up_adjust = ifelse(jj==1, F, ifelse(jj==len,F, aggregatedHorian_num[jj] < aggregatedHorian_num[jj+1]) )
                
                if(issuedepth[jj] & !up_adjust){
                    # because cannot adjust up, we adjust current
                    newtop = ifelse(jj-1>=1, aggregatedHorian_table$horizonBottomDepth[jj-1], aggregatedHorian_table$horizonTopDepth[1])
                }else{ newtop = aggregatedHorian_table$horizonTopDepth[jj] }
                    
                if(issuedepth[jj] & up_adjust){
                    # because cannot adjust down, we adjust current
                    newbottom = ifelse(jj+1<=len, aggregatedHorian_table$horizonTopDepth[jj+1], aggregatedHorian_table$horizonBottomDepth[len])
                }else{ newbottom = aggregatedHorian_table$horizonBottomDepth[jj] }
                    
                    
                if(newtop > newbottom) newbottom = newtop + aggregatedHorian_table$horizonThinkness[jj]
                
                aggregatedHorian_table$horizonTopDepth[jj] = newtop
                aggregatedHorian_table$horizonBottomDepth[jj] = newbottom
            }# jj for loop
            
        }# if(len>1)
        # cbind(aggregatedHorian_name, aggregatedHorian_num, aggregatedHorian_table)
        # cbind(aggregatedHorian_name, aggregatedHorian_num, aggregatedHorian_table[,c('horizonTopDepth','horizonBottomDepth')])
        # cbind(aggregatedHorian_name, aggregatedHorian_table[,c('horizonTopDepth','horizonBottomDepth')])
        
        ## final check on thickness and top-bottom depths
        #tmp_thickness = aggregatedHorian_table$horizonBottomDepth - aggregatedHorian_table$horizonTopDepth
        #cbind(aggregatedHorian_table$horizonThinkness,tmp_thickness)
        if(len>1) aggregatedHorian_table$horizonThinkness[1:(len-1)] = aggregatedHorian_table$horizonBottomDepth[1:(len-1)] - aggregatedHorian_table$horizonTopDepth[1:(len-1)]
        
        aggregatedHorian_table$horizonBottomDepth[len] = aggregatedHorian_table$horizonTopDepth[len] +aggregatedHorian_table$horizonThinkness[len]
        
        ## 4a output aggregated horizon information, rhessys_soilid
        if(i==1){
        		write( paste(c('mukey','texture',do.call(c,lapply(horizonOrder[c(2,4,5,6)+1],function(x){ paste(x, colnames(aggregatedHorian_table), sep="_") }))),collapse=','), textureFILE)
        	}# if header
        write( paste(c(mukey[i],soilID_,unlist(lapply(horizonOrder[c(2,4,5,6)+1],function(x){
        		index_ = match(x,aggregatedHorian_name)
        		if(is.na(index_)){
        			return <- rep(NA,15)
        		}else{
        			return <- aggregatedHorian_table[index_,]
        		}
        	}))),collapse=','), textureFILE,append=T)
        
               
       
        
	}else{
        # overall_NODATA=T case (absolutely no data at all; do not know the default soil neither )
        
        ## 4a output aggregated horizon information
        if(i==1){
       		write( paste(c('mukey','texture',do.call(c,lapply(horizonOrder[c(2,4,5,6)+1],function(x){ paste(x, colnames(aggregatedHorian_table), sep="_") }))),collapse=','), textureFILE)
        }# if header
        write( paste(c(mukey[i],soilID_,rep(NA,60)), collapse=','), textureFILE, append=T) #90
        


	}# end of if
}# for loop i

mapunitTitle=c('musym','muname','mukind','mustatus','muacres','mapunitlfw_l','mapunitlfw_r','mapunitlfw_h','mapunitpfa_l','mapunitpfa_r','mapunitpfa_h','farmlndcl','muhelcl','muwathelcl','muwndhelcl','interpfocus','invesintens','iacornsr','nhiforsoigrp','nhspiagr','vtsepticsyscl','mucertstat','lkey','mukey')
compTitle=c('comppct_l','comppct_r','comppct_h','compname','compkind','majcompflag','otherph','localphase','slope_l','slope_r','slope_h','slopelenusle_l','slopelenusle_r','slopelenusle_h','runoff','tfact','wei','weg','erocl','earthcovkind1','earthcovkind2','hydricon','hydricrating','drainagecl','elev_l','elev_r','elev_h','aspectccwise','aspectrep','aspectcwise','geomdesc','albedodry_l','albedodry_r','albedodry_h','airtempa_l','airtempa_r','airtempa_h','map_l','map_r','map_h','reannualprecip_l','reannualprecip_r','reannualprecip_h','ffd_l','ffd_r','ffd_h','nirrcapcl','nirrcapscl','nirrcapunit','irrcapcl','irrcapscl','irrcapunit','cropprodindex','constreeshrubgrp','wndbrksuitgrp','rsprod_l','rsprod_r','rsprod_h','foragesuitgrpid','wlgrain','wlgrass','wlherbaceous','wlshrub','wlconiferous','wlhardwood','wlwetplant','wlshallowwat','wlrangeland','wlopenland','wlwoodland','wlwetland','soilslippot','frostact','initsub_l','initsub_r','initsub_h','totalsub_l','totalsub_r','totalsub_h','hydgrp','corcon','corsteel','taxclname','taxorder','taxsuborder','taxgrtgroup','taxsubgrp','taxpartsize','taxpartsizemod','taxceactcl','taxreaction','taxtempcl','taxmoistscl','taxtempregime','soiltaxedition','castorieindex','flecolcomnum','flhe','flphe','flsoilleachpot','flsoirunoffpot','fltemik2use','fltriumph2use','indraingrp','innitrateleachi','misoimgmtgrp','vasoimgtgrp','mukey','cokey')
chorizonTitle = c('hzname','desgndisc','desgnmaster','desgnmasterprime','desgnvert','hzdept_l','hzdept_r','hzdept_h','hzdepb_l','hzdepb_r','hzdepb_h','hzthk_l','hzthk_r','hzthk_h','fraggt10_l','fraggt10_r','fraggt10_h','frag3to10_l','frag3to10_r','frag3to10_h','sieveno4_l','sieveno4_r','sieveno4_h','sieveno10_l','sieveno10_r','sieveno10_h','sieveno40_l','sieveno40_r','sieveno40_h','sieveno200_l','sieveno200_r','sieveno200_h','sandtotal_l','sandtotal_r','sandtotal_h','sandvc_l','sandvc_r','sandvc_h','sandco_l','sandco_r','sandco_h','sandmed_l','sandmed_r','sandmed_h','sandfine_l','sandfine_r','sandfine_h','sandvf_l','sandvf_r','sandvf_h','silttotal_l','silttotal_r','silttotal_h','siltco_l','siltco_r','siltco_h','siltfine_l','siltfine_r','siltfine_h','claytotal_l','claytotal_r','claytotal_h','claysizedcarb_l','claysizedcarb_r','claysizedcarb_h','om_l','om_r','om_h','dbtenthbar_l','dbtenthbar_r','dbtenthbar_h','dbthirdbar_l','dbthirdbar_r','dbthirdbar_h','dbfifteenbar_l','dbfifteenbar_r','dbfifteenbar_h','dbovendry_l','dbovendry_r','dbovendry_h','partdensity','ksat_l','ksat_r','ksat_h','awc_l','awc_r','awc_h','wtenthbar_l','wtenthbar_r','wtenthbar_h','wthirdbar_l','wthirdbar_r','wthirdbar_h','wfifteenbar_l','wfifteenbar_r','wfifteenbar_h','wsatiated_l','wsatiated_r','wsatiated_h','lep_l','lep_r','lep_h','ll_l','ll_r','ll_h','pi_l','pi_r','pi_h','aashind_l','aashind_r','aashind_h','kwfact','kffact','caco3_l','caco3_r','caco3_h','gypsum_l','gypsum_r','gypsum_h','sar_l','sar_r','sar_h','ec_l','ec_r','ec_h','cec7_l','cec7_r','cec7_h','ecec_l','ecec_r','ecec_h','sumbases_l','sumbases_r','sumbases_h','ph1to1h2o_l','ph1to1h2o_r','ph1to1h2o_h','ph01mcacl2_l','ph01mcacl2_r','ph01mcacl2_h','freeiron_l','freeiron_r','freeiron_h','feoxalate_l','feoxalate_r','feoxalate_h','extracid_l','extracid_r','extracid_h','extral_l','extral_r','extral_h','aloxalate_l','aloxalate_r','aloxalate_h','pbray1_l','pbray1_r','pbray1_h','poxalate_l','poxalate_r','poxalate_h','ph2osoluble_l','ph2osoluble_r','ph2osoluble_h','ptotal_l','ptotal_r','ptotal_h','excavdifcl','excavdifms','cokey','chkey')
chtexgrpTitle=c('texture','stratextsflag','rvindicator','texdesc','chkey','chtgkey')
chtexturTitle=c('texcl','lieutex','chtgkey','chtkey')
chporesTitle=c('poreqty','poresize','porecont','poreshp','rvindicator','chkey','chporeskey')


arg=commandArgs(T)
target = paste(arg[1],'/tabular',sep='') # e.g., 'VA113/tabular'
#target = '/Volumes/LaCie/current_work/SEES/BAISMAN/raw_data/MD005/tabular/'
#target = '/Volumes/LaCie/workArch/University_of_North_Carolina/WS14/Rhessys520_src_Laurence/setup_rhessys_5_20_debug2_bolstad_zone_bgc_cwt/raw_data/NC113/tabular/'

mapunit = read.table(paste(target,'/mapunit.txt',sep=''),sep='|',stringsAsFactors=F) #mukey
colnames(mapunit) = mapunitTitle
	## 1 mukey to many componments [cokey]
comp = read.table(paste(target,'/comp.txt',sep=''),sep='|',stringsAsFactors=F) #cokey
colnames(comp) = compTitle
	## 1 cokey to many horizons [chkey]
chorizon = read.table(paste(target,'/chorizon.txt',sep=''),sep='|',stringsAsFactors=F) #chkey
colnames(chorizon) = chorizonTitle

chtexgrp = read.table(paste(target,'/chtexgrp.txt',sep=''),sep='|',stringsAsFactors=F) #chkey
colnames(chtexgrp) = chtexgrpTitle

chtextur = read.table(paste(target,'/chtextur.txt',sep=''),sep='|',stringsAsFactors=F) #chkey
colnames(chtextur) = chtexturTitle

# chpores = read.table(paste(target,'/chpores.txt',sep=''),sep='|',stringsAsFactors=F) #chkey
# colnames(chpores) = chporesTitle
#chpores # new table
	# chkey -> chorizon
	# chporeskey ->
	

## mapunit:component:horizon
## extract (weighted average[thickness] of soil horizon in a soil component; then weighted [%composition] by componments):
	# 1 permeability
	# 2 watercapacity
	# 3 bulkdensity
	# 4 saturatedhydraulicconductivity
	# 5 erodibility
	# 6 field capacity
	# 7 porosity
	# 8 soilthickness
	# 9 organ matter 
	
	# relationshup
	# 1 mukey: N cokey (componments) : N chkey (horizons)
 	#        : fraction "comppct_r"  : fraction "hzdepb_r" -> thickness


horizonOrder = c('O','A','E','B','C','R')	
soilscoreNames = c('Clay','Silty clay','Silty clay loam','Sandy clay','Sandy clay loam','Clay loam','Silt','Silt loam','Loam','Sand','Loamy sand','Sandy loam')		
soilscore = c(1,2,3,4,5,6,7,8,9,10,11,12); names(soilscore)=soilscoreNames

mukey = mapunit[,'mukey']	
mukeyHold = matrix(NA,length(mukey), 20);

for(i in 1:length(mukey)){
	## for each mukey, we have N cokey
	
	cond1 = comp[,'mukey']== mukey[i]
	# sum(cond1)
	
	componentSummaryTable = as.data.frame(t(sapply( comp[cond1,'cokey'], function(cokey){
		# linking horizons to component
		
			# cokey = comp[cond1,'cokey'][3]
		
		cond2 = chorizon[,'cokey']== cokey
        horizonSummaryTable = data.frame(id = chorizon[cond2,'chkey']) 
        horizonSummaryTable$horizonThinkness = (chorizon[cond2,'hzdepb_r']-chorizon[cond2,'hzdept_r'])*0.01 #cm -> m
        horizonSummaryTable$horizonMeanDepth = 0.5*(chorizon[cond2,'hzdepb_r']+chorizon[cond2,'hzdept_r'])*0.01 # m
        horizonSummaryTable$horizonName = chorizon[cond2,'hzname']
       
        horizonSummaryTable$horizonWeight = horizonSummaryTable$horizonThinkness / sum(horizonSummaryTable$horizonThinkness, na.rm=T)
        horizonSummaryTable$ksat = chorizon[cond2,'ksat_r']*1e-6*3600*24 # m/day
        horizonSummaryTable$ksat[horizonSummaryTable$ksat<=0] = 0.001 # m/day
        horizonSummaryTable$ksat_log = log(horizonSummaryTable$ksat);
        #horizonSummaryTable$ksat_log[!is.finite(horizonSummaryTable$ksat_log)] = NA
        horizonSummaryTable$sand = chorizon[cond2,'sandtotal_r']*0.01 #% -> [0,1]
        horizonSummaryTable$silt = chorizon[cond2,'silttotal_r']*0.01 #% -> [0,1]
        horizonSummaryTable$clay = chorizon[cond2,'claytotal_r']*0.01 #% -> [0,1]
        horizonSummaryTable$POR = chorizon[cond2,'wsatiated_r']*0.01 #% -> [0,1]
        horizonSummaryTable$POR[horizonSummaryTable$POR<=0] = 0.01
        horizonSummaryTable$POR_log = log(horizonSummaryTable$POR)
        #horizonSummaryTable$POR_log[!is.finite(horizonSummaryTable$POR_log)] = NA
        horizonSummaryTable$BD = chorizon[cond2,'dbovendry_r'] #g/cm3
        horizonSummaryTable$fc = chorizon[cond2,'wthirdbar_r']*0.01 #% -> [0,1]
        horizonSummaryTable$awc = chorizon[cond2,'awc_r']*0.01 # cm/cm
        horizonSummaryTable$kffact = chorizon[cond2,'kffact'] # soil erodibility factor
        horizonSummaryTable$om = chorizon[cond2,'om_r']*0.01 #% -> [0,1]
        #horizonSummaryTable$density = chorizon[cond2,'partdensity'] # g/cm3 <<------
        horizonSummaryTable$density = horizonSummaryTable$BD / (1 - horizonSummaryTable$POR)
        	# form text book: % pore space = porosity = (1 - BD / density) * 100 %
        	# from my note: density = BD / (1 - POR)
        	
        ksatLM = NULL
        tryCatch({
        	if(dim(horizonSummaryTable)[1]<2 | sum(!is.na(horizonSummaryTable$ksat_log))<2) stop('no data')
        	ksatLM = lm(ksat_log~horizonMeanDepth, horizonSummaryTable)
        }, error=function(e){ 
        	# print(e);
        	ksatLM <<- list(coefficients=c(
        		-1/4000,
        		sum(horizonSummaryTable$horizonWeight*horizonSummaryTable$ksat_log,na.rm=T)
        	)) 
        })
        
        porLM = NULL
        tryCatch({
        	if(dim(horizonSummaryTable)[1]<2 | sum(!is.na(horizonSummaryTable$POR_log))<2 ) stop('no data')
        	porLM = lm(POR_log~horizonMeanDepth, horizonSummaryTable)
        }, error=function(e){ 
        	porLM <<- list(coefficients=c(
        		-1/4000,
        		sum(horizonSummaryTable$horizonWeight*horizonSummaryTable$POR_log,na.rm=T)
        	)) 
        })
        
        
        # dev.new()
        # plot(horizonSummaryTable $horizonMeanDepth, horizonSummaryTable $ksat_log)
        # abline(ksatLM, col='blue')
        
        deephorizonname = match(substr(gsub('[a-z0-9, ]','',horizonSummaryTable$horizonName[which.max(horizonSummaryTable$horizonMeanDepth)]),1,1), horizonOrder)
        if(length(deephorizonname)<=0) deephorizonname=NA
        
        return <- unlist(list(
        	id = cokey,
        	horizonThinkness = sum(horizonSummaryTable$horizonThinkness,na.rm=T),
        	deepHorizon = deephorizonname,
        	ksat = sum(horizonSummaryTable$horizonWeight * horizonSummaryTable$ksat, na.rm=T),
        	ksat_0 = as.numeric(exp(ksatLM$coefficients[1])),
        	ksat_decay = as.numeric(-ksatLM$coefficients[2]), # 1/m
        	vksat = sum(horizonSummaryTable$horizonThinkness,na.rm=T) / sum(horizonSummaryTable$horizonThinkness/horizonSummaryTable$ksat, na.rm=T),
        	por_0 = as.numeric(exp(porLM$coefficients[1])),
        	por_decay = as.numeric(-porLM$coefficients[2]), # 1/m
        	sand = sum(horizonSummaryTable$horizonWeight * horizonSummaryTable$sand, na.rm=T),
        	silt = sum(horizonSummaryTable$horizonWeight * horizonSummaryTable$silt, na.rm=T),
        	clay = sum(horizonSummaryTable$horizonWeight * horizonSummaryTable$clay, na.rm=T),
        	
        	BD = sum(horizonSummaryTable$horizonWeight * horizonSummaryTable$BD, na.rm=T),
        	partdensity = sum(horizonSummaryTable$horizonWeight * horizonSummaryTable$density, na.rm=T),
        	
        	fc = sum(horizonSummaryTable$horizonWeight * horizonSummaryTable$fc, na.rm=T),
        	awc = sum(horizonSummaryTable$horizonWeight * horizonSummaryTable$awc, na.rm=T),
        	kffact = sum(horizonSummaryTable$horizonWeight * horizonSummaryTable$kffact, na.rm=T),
        	om = sum(horizonSummaryTable$horizonWeight * horizonSummaryTable$om, na.rm=T)
        ))
	})))
	componentSummaryTable$por = 1 - componentSummaryTable$BD/componentSummaryTable$partdensity
	componentSummaryTable$Percent = comp[cond1,'comppct_r']
	componentSummaryTable$Weight = componentSummaryTable$Percent/sum(componentSummaryTable$Percent)
	
	
	
	## mukey soil texture class
	cond25 = chorizon[,'cokey']%in% componentSummaryTable$id
	cond3 = chtexgrp[,'chkey'] %in% chorizon[cond25,'chkey']
	cond4 = chtextur[,'chtgkey'] %in% chtexgrp[cond3,'chtgkey']
	tmp = table(soilscore[match(chtextur[cond4,1], soilscoreNames)])
	soilID_ = ifelse(length(tmp)>0, as.numeric(names(which.max(tmp))), NA)
	soilID_name = ifelse(length(tmp)>0, soilscoreNames[soilID_], NA) 
	
	
	
	## ksat and por distributions
	mydata = data.frame(depthzz = seq(0,10,0.001) )
	ksat = sapply( seq_len(dim(componentSummaryTable)[1]), function(ii){
		componentSummaryTable$ksat_0[ii]*exp(-componentSummaryTable$ksat_decay[ii]*mydata$depthzz) * componentSummaryTable$Weight[ii]
	}); 
	mydata$total_ksat = rowSums(ksat)
	mydata$total_ksat_log = log(mydata$total_ksat)
	
	PORz = sapply( seq_len(dim(componentSummaryTable)[1]), function(ii){
		componentSummaryTable$por_0[ii]*exp(-componentSummaryTable$por_decay[ii]*mydata$depthzz) * componentSummaryTable$Weight[ii]
	}); 
	mydata$total_por = rowSums(PORz)
	mydata$total_por_log = log(mydata$total_por)
	
	mukeyksatLM = lm(total_ksat_log~depthzz, mydata)
    mukeyporLM = lm(total_por_log~depthzz, mydata)
      
        
	# layout(matrix(1:2,nrow=1))
	# plot(ksat[,1], mydata$depthzz, type='l', ylim=c(10,0), xlim=c(0,0.5))
	# lines(ksat[,2], mydata$depthzz)
	# lines(mydata$total_ksat, mydata$depthzz, col='red')
	# lines(exp(mukeyksatLM$coefficients[2]*mydata$depthzz + mukeyksatLM$coefficients[1]), mydata$depthzz, col='blue' )
	
	# plot(PORz[,1], mydata$depthzz, type='l', ylim=c(10,0), xlim=c(0,0.5))
	# lines(PORz[,2], mydata$depthzz)
	# lines(mydata$total_por, mydata$depthzz, col='red')
	# lines(exp(mukeyporLM$coefficients[2]*mydata$depthzz + mukeyporLM$coefficients[1]), mydata$depthzz, col='blue' )
	
	mukey_sand = sum(componentSummaryTable$Weight*componentSummaryTable$sand,na.rm=T)
	mykey_silt = sum(componentSummaryTable$Weight*componentSummaryTable$silt,na.rm=T)
	mykey_clay = sum(componentSummaryTable$Weight*componentSummaryTable$clay,na.rm=T)
	mykey_total = mukey_sand + mykey_silt + mykey_clay
		mukey_sand = mukey_sand/mykey_total
		mykey_silt = mykey_silt/mykey_total
		mykey_clay = mykey_clay/mykey_total
	
	tmp = unlist(list(
		mukey = mukey[i],
		rhessys_soilid = soilID_,
		#soil_name = soilID_name,
		soilDepth = sum(componentSummaryTable$Weight*componentSummaryTable$horizonThinkness,na.rm=T),
		soilhorizon = componentSummaryTable$deepHorizon[which.max(componentSummaryTable$Weight)],
		ksat = sum(componentSummaryTable$Weight*componentSummaryTable$ksat,na.rm=T),
		vksat = sum(componentSummaryTable$Weight*componentSummaryTable$vksat,na.rm=T),
		ksat_0 = as.numeric(exp(mukeyksatLM$coefficients[1])),
		ksat_decay = as.numeric(-mukeyksatLM$coefficients[2]),
		por = sum(componentSummaryTable$Weight*componentSummaryTable$por,na.rm=T),
		por_0 = as.numeric(exp(mukeyporLM$coefficients[1])),
		por_decay = as.numeric(-mukeyporLM$coefficients[2]),
		sand = mukey_sand,
		silt = mykey_silt,
		clay = mykey_clay,
		BD = sum(componentSummaryTable$Weight*componentSummaryTable$BD,na.rm=T),
		partdensity = sum(componentSummaryTable$Weight*componentSummaryTable$partdensity,na.rm=T),
		fc = sum(componentSummaryTable$Weight*componentSummaryTable$fc,na.rm=T),
		awc = sum(componentSummaryTable$Weight*componentSummaryTable$awc,na.rm=T),
		kffact = sum(componentSummaryTable$Weight*componentSummaryTable$kffact,na.rm=T),
		om = sum(componentSummaryTable$Weight*componentSummaryTable$om,na.rm=T)
	))
	mukeyHold[i,] = tmp
	if(i==1) colnames(mukeyHold)=names(tmp)
	
}#i
# write.csv(mukeyHold, paste('~/Downloads/soil_mukey_texture.csv',sep=''),row.names=F)
write.csv(mukeyHold, paste(arg[1],'/soil_mukey_texture.csv',sep=''),row.names=F)

## single basin
## sub-patch/grid setting
#----------------------------------------------------------------------------------------------
	options(scipen=999)	
	arg=commandArgs(T)
	
	DtoR = pi/180
	RtoD = 1/DtoR
	defaultWorldName = c('worldID')
	defaultBasinName = c('basinID','basinX','basinY','basinZ','basinDefID','basinLatitude','basinBase')
	defaultHillName = c('hillID','hillX','hillY','hillZ','hillDefID','hillgws','hillgwno3','hillBase')
	defaultZoneName = c('zoneID','zoneX','zoneY','zoneZ','zoneDefID','zoneArea','zoneSlope','zoneAspect','zoneIso','zoneEH','zoneWH','zoneBase','zoneBaseID')
	defaultPatchName = c('patchID','patchX','patchY','patchZ','patchsoilID','patchLandID','patchArea','patchSlope','patchLNA','patchKsat','patchMpar','patchRZstorage','patchUnsat','patchSat','patchSnowEZ','patchSnowZ','patchSnowT','patchSnowAge','patchSnowED','patchLittercfrac','patchLitterStorage','patchLitterc1','patchLittern1','patchLitterc2','patchLitterc3','patchLitterc4','patchsoilIDc1','patchsoilIDsminn','patchsoilIDNO3','patchsoilIDc2','patchsoilIDc3','patchsoilIDc4','patchBase')
	defaultStratumName = c('strateID','stratePlantID','stratecfrac','strateGap','strateRZ','strateSnowStored','strateRainStored','stratecpool','strateleafc','stratedleafc','strateleafcstore','strateleafctrans','stratelstemc','stratelstemcstore','stratelstemctrans','stratedstemc','stratedstemcstore','stratedstemctrans','stratelrootc','stratelrootcstore','stratelrootctrans','stratedrootc','stratedrootcstore','stratedrootctrans','stratefrootc','stratefrootcstore','stratefrootctrans','stratecwdc','strateEPVleafcalloc','stratenpool','strateleafn','stratedleafn','strateleafnstore','strateleafntrans','stratelstemn','stratelstemnstore','stratelstemntrans','stratedstemn','stratedstemnstore','stratedstemntrans','stratelrootn','stratelrootnstore','stratelrootntrans','stratedrootn','stratedrootnstore','stratedrootntrans','stratefrootn','stratefrootnstore','stratefrootntrans','stratecwdn','strateRetransn','epv_wstress_days','epv_max_fparabs','epv_min_vwc','strateBase')
	title = c(defaultWorldName, defaultBasinName, defaultHillName, defaultZoneName, defaultPatchName, defaultStratumName)
	
	# arg=c('/Volumes/LaCie/current_work/SEES/SLB', '101', 'clim/SLB.base',
		  # '/Volumes/LaCie/current_work/SEES/SLB/rhessys_SLB10m/GIS2RHESSys-master/vegCollection.csv',
		  # '/Volumes/LaCie/current_work/SEES/SLB/rhessys_SLB10m/GIS2RHESSys-master/soilCollection.csv',
		  # '/Volumes/LaCie/current_work/SEES/SLB/rhessys_SLB10m/GIS2RHESSys-master/lulcCollection.csv',
		  # '/Volumes/LaCie/current_work/SEES/SLB/rhessys_SLB10m/worldfile.csv',
		  # '/Volumes/LaCie/current_work/SEES/SLB/rhessys_SLB10m/worldfiles/worldfile.hdr',
		  # '/Volumes/LaCie/current_work/SEES/SLB/rhessys_SLB10m/defs'
		 # )
#----------------------------------------------------------------------------------------------
	projectFolder = arg[1]
	climateStationID = as.numeric(arg[2])
	climateStationNAME = arg[3]
		
	## user provides a customized vegetation.csv containing all vegetation vegParameters.
	vegParam = read.csv(arg[4],skip=4,header=T,stringsAsFactors=F) #<<------
	vegParamCOL = cbind(as.numeric(unique(vegParam[1,3:ncol(vegParam)])), 3:ncol(vegParam)); 
	colnames(vegParamCOL) = c('vegID','vegDefIndex')
	vegParam_len = ncol(vegParam)
	
	soilParam = read.csv(arg[5],skip=4,header=T,stringsAsFactors=F) #<<------
	soilParamCOL = cbind(as.numeric(unique(soilParam[1,3:ncol(soilParam)])), 3:ncol(soilParam)); 
	colnames(soilParamCOL) = c('soilID','soilDefIndex')
	soilParam_len = ncol(soilParam)
	
	lulcParam = read.csv(arg[6],skip=4,header=T,stringsAsFactors=F) #<<------
	lulcParamCOL = cbind(as.numeric(unique(lulcParam[1,3:ncol(lulcParam)])), 3:ncol(lulcParam)); 
	colnames(lulcParamCOL) = c('lulcID','lulcDefIndex')
	lulcParam_len = ncol(lulcParam)
	
#----------------------------------------------------------------------------------------------
	# read in rast
	library(rgrass7)
	library(rgdal)
	gis = gmeta()
	gridarea = round(gis$nsres * gis$ewres)
	
	# bounded by GIS mask
	basinMap = 'basin'
	hillslopeMap = 'hill'
	zoneMAP = 'zone'
	patchMAP = 'patch'
	# extract RHESSys structural IDs 
	rast0 = readRAST(c(basinMap, hillslopeMap, zoneMAP, patchMAP),NODATA=0)
		mask = !is.na(rast0@data[[1]])
		hill = rast0@data[[2]][mask]
		zone = rast0@data[[3]][mask]
		patch = rast0@data[[4]][mask]
	
	# extract patch def IDs
	soilidMAP = 'soil_texture'
	rast1 = readRAST(c(soilidMAP),NODATA=0)
		soil = rast1@data[[1]][mask]


	# extract patch positive numerical values [0 -> +X]
	xMAP = 'xmap' 	##<<---- use raster calculator
	yMAP = 'ymap'	##<<---- use raster calculator
	demMAP = 'dem' ##<<---- from USGS
	slopeMap = 'slope' 
	aspectMAP = 'aspect' ##<<----- 90=north, 360=east, 180=west 270=south
	twiMAP = 'wetness_index' ##<<---- r.topidx
	whorizonMAP = 'west_180' 
	ehorizonMAP = 'east_000' 
	isohyetMAP = 'isohyet' # <------ "precipitation" mm/m (x >= 1.0)
	rast2 = readRAST(c(xMAP, yMAP, demMAP, slopeMap, aspectMAP, twiMAP, whorizonMAP, ehorizonMAP, isohyetMAP), NODATA=-1)
		xx = rast2@data[[1]][mask]
		yy = rast2@data[[2]][mask]
		dem = rast2@data[[3]][mask]
		slope = rast2@data[[4]][mask] ## ... could be a problem at the edge of the DEM
		aspect = rast2@data[[5]][mask] ## ... could be a problem at the edge of the DEM 
		twi = rast2@data[[6]][mask] ## ... could be a problem at the edge of the DEM
		whorizon = rast2@data[[7]][mask]
		ehorizon = rast2@data[[8]][mask]
		isohyet = rast2@data[[9]][mask]
		
		
	lulcMAP = 'landuse' 
	vegMAP = 'vegid' 
	rast3 = readRAST(c(lulcMAP, vegMAP),NODATA=0)
	lulc = rast3@data[[1]][mask]	
	vegid = rast3@data[[2]][mask]	
	
	laiMAP = 'lai'
    	rast4 = readRAST(laiMAP)
	lai = rast4@data[[1]][mask]	

	coverMAP = 'coverFrac'
    	rast5 = readRAST(coverMAP)
	coverFrac = rast5@data[[1]][mask]	

	impMAP = 'impervious'
	rast6 = readRAST(impMAP)
	imp = rast6@data[[1]][mask]			
		
		
		
	## centroid 
	sputm <- SpatialPoints(cbind(mean(xx),mean(yy)), proj4string=CRS(gmeta()$proj4) )  
  	spgeo <- spTransform(sputm, CRS("+proj=longlat +datum=WGS84"))
	latitude = spgeo@coords[2]
	
	##-----<< order >>------#
	len = sum(mask)
	RHESSysOrder = order(hill,zone,patch) ### somehow we need to cut deplulated
	tapplyOrder = rep(NA,sum(mask)); tapplyOrder[RHESSysOrder] = match(patch[RHESSysOrder], unique(patch[RHESSysOrder]))
	
	##-----<< list out IDs >>------#
	idMatrix = unique(cbind(patch,zone,hill)[RHESSysOrder,])
	colnames(idMatrix) = c('patchList', 'zoneList', 'hillList')
	
	## hill 
	hillX = tapply(xx,INDEX=hill, FUN=mean)
	hillY = tapply(yy,INDEX=hill, FUN=mean)
	hillZ = tapply(dem,INDEX=hill, FUN=mean)
		hillID = as.numeric(names(hillX))
		numhill = length(hillID)
		hillIDrhessysOrder = match(idMatrix[,'hillList'], hillID) ## organize unique hill into the idMatrix order

	## zone
	zoneEast = tapply(sin(ehorizon*DtoR),INDEX=zone, FUN=mean)
	zoneWest = tapply(sin(whorizon*DtoR),INDEX=zone, FUN=mean)
	
	zoneSlope = tapply(slope,INDEX=zone, FUN=mean) # vector
		aspectcos = tapply(cos(aspect*DtoR)*sin(slope*DtoR),INDEX=zone, FUN=mean)
		aspectsin = tapply(sin(aspect*DtoR)*sin(slope*DtoR),INDEX=zone, FUN=mean)
	zoneAspect = atan(aspectsin/aspectcos)* RtoD ## always between -90 and 90
		zoneAspect[aspectcos<0] = zoneAspect[aspectcos<0] + 180 #yes
		zoneAspect[aspectsin<0 & aspectcos>0] = zoneAspect[aspectsin<0 & aspectcos>0] + 360
		
	zoneX = tapply(xx,INDEX=zone, FUN=mean)
	zoneY = tapply(yy,INDEX=zone, FUN=mean)
	zoneZ = tapply(dem,INDEX=zone, FUN=mean)
	zoneArea = tapply(rep(1,len),INDEX=zone, FUN=sum)*gridarea
	zoneISO = tapply(isohyet,INDEX=zone, FUN=mean)
		zoneID = as.numeric(names(zoneX))
		numzone = length(zoneID)
		zoneIDrhessysOrder = match(idMatrix[,'zoneList'], zoneID) ## organize unique zone into the idMatrix order
	
	# cbind(zoneAspect,aspect,slope)[80:100,]
	# plot(aspect, zoneAspect); abline(a=0,b=1,lty=2)
	
	
	## patch (patch >= grid)
	patchX = tapply(xx,INDEX=patch, FUN=mean)
	patchY = tapply(yy,INDEX=patch, FUN=mean)
	patchZ = tapply(dem,INDEX=patch, FUN=mean)
	patchCount = tapply(rep(1,len),INDEX=patch, FUN=sum)
	patchArea = patchCount* gridarea
	patchSOIL = tapply(seq_along(patch),INDEX=patch, FUN=function(ii){
		hold=table(soil[ii]); 
		return <- as.numeric(names(hold)[which.max(hold)])
	} )
	patchSLOPE = tapply(slope,INDEX=patch, FUN=mean)
	patchTWI = tapply(abs(twi),INDEX=patch, FUN=mean); patchTWI[is.na(patchTWI)]=0;
		patchID = as.numeric(names(patchX))
		numpatch = length(patchID)	
		patchIDrhessysOrder = match(idMatrix[,'patchList'], patchID) ## organize unique patch into the idMatrix order
	#patchSTR = tapply(str,INDEX=patch, FUN=sum, na.rm=T)

	# rep(patchIDrhessysOrder, times=patchVegnum) in below is expending the idMatrix order by Vegnum
	
	
	
	patchVegCover = coverFrac
	patchVegLAI = lai
	patchVegID = vegid
	patchLAND = lulc 	
	patchIMP = imp  #<<----	
	patchRZ = rep(1,length(imp))
	patchVegnum = rep(1,length(imp))
	lai_ = lai ## already ordered
		stratum = patchVegID
		vegDefID = as.numeric(vegParam[1,3:ncol(vegParam)])
		stratumIndex = match(stratum, vegDefID) # return index
		stratumMass=matrix(0,length(lai_),13)
		colnames(stratumMass) = c("leafc","lstemc","dstemc","lrootc","drootc","frootc","leafcalloc","leafn","lstemn","dstemn","lrootn","drootn","frootn")
		
		cond = lai_ >0 
		stratum.SLA = as.numeric(vegParam[48,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.LS = as.numeric(vegParam[12,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.LIVED = as.numeric(vegParam[10,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.DEAD = 1/stratum.LIVED -1; 
		stratum.DEAD[!is.finite(stratum.DEAD)]=0
		stratum.SC = as.numeric(vegParam[8,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.LR = as.numeric(vegParam[9,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.CNL = as.numeric(vegParam[33,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.CNR = as.numeric(vegParam[21,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.CNLW = as.numeric(vegParam[39,3:ncol(vegParam)])[stratumIndex[cond]]
		#stratum.CNDW = rep(333.33,sum(cond))
		stratum.CNDW = 1/(as.numeric(vegParam[17,3:ncol(vegParam)])[stratumIndex[cond]]/450 + as.numeric(vegParam[18,3:ncol(vegParam)])[stratumIndex[cond]]/600)
	
		stratumMass[cond,1] =  lai_[cond]/stratum.SLA #leafc
		stratumMass[cond,2] = stratumMass[cond,1]* stratum.LS * stratum.LIVED #live stemc
		stratumMass[cond,3] = stratumMass[cond,2]* stratum.DEAD # dead stemc
		stratumMass[cond,4] = (stratumMass[cond,2]+stratumMass[cond,3])* stratum.SC* stratum.LIVED # live crootc
		stratumMass[cond,5] = stratumMass[cond,4]*stratum.DEAD #dead crootc
		stratumMass[cond,6] = stratumMass[cond,1]* stratum.LR #frootc
		stratum.totmass = rowSums(stratumMass)
		stratumMass[cond,7] = stratumMass[cond,1]*0.05 ##strateEPVleafcalloc
		stratumMass[cond,8] = stratumMass[cond,1]/stratum.CNL
		stratumMass[cond,9] = stratumMass[cond,2]/stratum.CNLW
		stratumMass[cond,10] = stratumMass[cond,3]/stratum.CNDW
		stratumMass[cond,11] = stratumMass[cond,4]/stratum.CNLW
		stratumMass[cond,12] = stratumMass[cond,5]/stratum.CNDW
		stratumMass[cond,13] = stratumMass[cond,6]/stratum.CNR	
		

#----------------------------------------------------------------------------------------------		
	outWorldFilePath = arg[7]
	title = c(defaultWorldName, defaultBasinName, defaultHillName, defaultZoneName, defaultPatchName, defaultStratumName)
	write( title, outWorldFilePath, ncolumns=length(title), append=F, sep=',')
		
		
	WorldBasinColumn = rep(1, sum(patchVegnum)) %o% c(1,1, mean(xx), mean(yy), mean(dem), 1, latitude, 0) #<<---- debug
	
	hillColumn = cbind(
		hillID,hillX, hillY, hillZ,
		rep(1, numhill) %o% c(1,0,0,0)
		)[rep(hillIDrhessysOrder, times=patchVegnum),]## hill
		
	zoneColumn = cbind(
		zoneID, zoneX, zoneY, zoneZ, 
		rep(1, numzone), zoneArea, zoneSlope, zoneAspect,
		zoneISO, zoneEast, zoneWest,  
		rep(1, numzone) %o% c(1, climateStationID)
		)[rep(zoneIDrhessysOrder, times=patchVegnum),]## zone
	
	patchColumn1 = cbind(
		patchID, patchX, patchY, patchZ, patchSOIL)[rep(patchIDrhessysOrder, times=patchVegnum),]## patch
	
	patchColumn2 = cbind(
		patchArea, patchSLOPE, patchTWI)[rep(patchIDrhessysOrder, times=patchVegnum),]## patch
		
	patchColumn3 = cbind(rep(1, numpatch) %o% c(0.12, 0,0,0, 0.28, 0, -10, 0, -0.5,1,0, 0.0000001,0.0000001,0.0000002,0.0000003,0.0000004,0.0000001, 0,0, 0.0000002,0.0000003,4e-9,0))[rep(patchIDrhessysOrder, times=patchVegnum),]## patch
						
	stratumColumn = matrix(0, sum(patchVegnum),length(defaultStratumName))	
	stratumColumn[,1] = 1:dim(stratumColumn)[1] #strateID
	stratumColumn[,2] = patchVegID # stratePlantID
	stratumColumn[,3] = patchVegCover # stratecfrac -->affect precipitation intercept 
	stratumColumn[,4] = 0 # strateGap -->affect sunlight intercept 
	stratumColumn[,5] = patchRZ # strateRZ 1m by default
	stratumColumn[,c(9,13,16,19,22,25,29,31,35,38,41,44,47)] = stratumMass
	
	
	write.table(cbind(
		WorldBasinColumn,
		hillColumn,
		zoneColumn,
		patchColumn1,
		patchLAND,
		patchColumn2,
		1-patchIMP,
		patchColumn3,
		stratumColumn
	), outWorldFilePath, row.names=F,col.names=F, append=T, sep=',')
					
#----------------------------------------------------------------------------------------------	
	tmp = unlist(strsplit(arg[9],'/'))
	defsFolder = tmp[length(tmp)]
	rhessysFolder = tmp[length(tmp)-1]
	
	## write out selected veg definition files
	vegHEADER = NULL
	selectedVeg = vegParamCOL[match(unique(patchVegID), vegParamCOL[,'vegID']), 'vegDefIndex']
	for(ii in selectedVeg ){
		filename = paste(defsFolder,"/stratum_",gsub("\\.","_",colnames(vegParam)[ii]),".def",sep="")
		vegHEADER = c(vegHEADER, paste(filename,'stratum_default_filename'))
		filepth = paste(arg[1],'/',rhessysFolder,'/', filename,sep="")
		write.table(cbind(vegParam[, ii], vegParam[,2]), filepth,sep="\t",row.names=F,col.names=F, quote=F)
	}#i

	
	## write out selected soil definition files
	soilHEADER = NULL
	selectedsoil = soilParamCOL[match(unique(patchSOIL), soilParamCOL[,'soilID']), 'soilDefIndex']
	for(ii in selectedsoil ){
		filename = paste(defsFolder,"/soil_",gsub("\\.","_",colnames(soilParam)[ii]),".def",sep="")
		soilHEADER = c(soilHEADER, paste(filename,'patch_default_filename'))
		filepth = paste(arg[1],'/',rhessysFolder,'/', filename,sep="")
		write.table(cbind(soilParam[, ii], soilParam[,2]), filepth,sep="\t",row.names=F,col.names=F, quote=F)
	}#i
	
	
	## write out selected lulc definition files
	lulcHEADER = NULL
	selectedlulc = lulcParamCOL[match(unique(patchLAND), lulcParamCOL[,'lulcID']), 'lulcDefIndex']
	for(ii in selectedlulc ){
		filename = paste(defsFolder,"/landuse_",gsub("\\.","_",colnames(lulcParam)[ii]),".def",sep="")
		lulcHEADER = c(lulcHEADER, paste(filename,'landuse_default_filename'))
		filepth = paste(arg[1],'/',rhessysFolder,'/', filename,sep="")
		write.table(cbind(lulcParam[, ii], lulcParam[,2]), filepth,sep="\t",row.names=F,col.names=F, quote=F)
	}#i
	
	zoneDEF = NULL
	zoneDEF = c(zoneDEF, '1 zone_default_ID')
	zoneDEF = c(zoneDEF, '0.000029 atm_trans_lapse_rate')
	zoneDEF = c(zoneDEF, '0.0015 dewpoint_lapse_rate')
	zoneDEF = c(zoneDEF, '0.0064 lapse_rate')
	zoneDEF = c(zoneDEF, '10 max_effective_lai')  
	zoneDEF = c(zoneDEF, '1 max_snow_temp')  
	zoneDEF = c(zoneDEF, '-1 min_rain_temp')  
	zoneDEF = c(zoneDEF, '0.001 n_deposition')  
	zoneDEF = c(zoneDEF, '0.0254 pptmin')  
	zoneDEF = c(zoneDEF, '0.75 sea_level_clear_sky_trans')  
	zoneDEF = c(zoneDEF, '0.4 temcf')  
	zoneDEF = c(zoneDEF, '0.003 trans_coeff1')  
	zoneDEF = c(zoneDEF, '2.2 trans_coeff2')  
	zoneDEF = c(zoneDEF, '1 wind')  
	write(zoneDEF, paste(arg[9],"/zone_zone.def",sep=""))
	
	basinDEF = NULL
	basinDEF = c(basinDEF, '1 basin_default_ID')
	write(basinDEF, paste(arg[9],"/basin_basin.def",sep=""))
	
	hillDEF = NULL
	hillDEF = c(hillDEF, '1 hillslope_default_ID')
	hillDEF = c(hillDEF, '1.0 gw_loss_coeff')
	hillDEF = c(hillDEF, '1.0 sat_to_gw_coeff')
	write(hillDEF, paste(arg[9],"/hillslope_hillslope.def",sep=""))
	
	worldHEADER = NULL
	worldHEADER = c(worldHEADER, paste(1,'num_basin_files'))
	worldHEADER = c(worldHEADER, paste(defsFolder,'/basin_basin.def basin_default_filename',sep=''))	
	worldHEADER = c(worldHEADER, paste(1,'num_hillslope_files'))	
	worldHEADER = c(worldHEADER, paste(defsFolder,'/hillslope_hillslope.def hillslope_default_filename',sep=''))	
	worldHEADER = c(worldHEADER, paste(1,'num_zone_files'))	
	worldHEADER = c(worldHEADER, paste(defsFolder,'/zone_zone.def zone_default_filename',sep=''))	
	
	worldHEADER = c(worldHEADER, paste(length(soilHEADER),'num_patch_files'))	
	worldHEADER = c(worldHEADER, soilHEADER)
	worldHEADER = c(worldHEADER, paste(length(lulcHEADER),'num_landuse_files'))	
	worldHEADER = c(worldHEADER, lulcHEADER)
	worldHEADER = c(worldHEADER, paste(length(vegHEADER),'num_stratum_files'))	
	worldHEADER = c(worldHEADER, vegHEADER)
	
	worldHEADER = c(worldHEADER, paste(1,'num_base_stations'))
	worldHEADER = c(worldHEADER, paste(climateStationNAME,'base_station_filename'))
	
	write(worldHEADER,arg[8])
	
	
	
	

options(scipen=999)
arg = commandArgs(T)
library(rgrass7)
library(sp)
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})

#arg=c('basin','roadExitDEM','roadExit_neighbor_id','roadExit_neighbor_usdDEM','dem','xmap','ymap','patch','roadExit_neighbor_usdDEMmed','roadExitOutletPatchID','roadExitOutlet', '120')

rast = readRAST(arg[1:8])
mask = !is.na(rast@data[[1]])
roadExtDEM = rast@data[[2]][mask]
clumpIDMAP = rast@data[[3]][mask]
valueMAP = rast@data[[4]][mask]
dem = rast@data[[5]][mask]
xx = rast@data[[6]][mask]
yy = rast@data[[7]][mask]
patch = rast@data[[8]][mask]
rast$tmp = rep(NA,length(mask))
rast$tmpII = rep(NA,length(mask))


roadInletCond = !is.na(roadExtDEM)
roadInlet_dem = dem[roadInletCond]
roadInlet_x  = xx[roadInletCond]
roadInlet_y  = yy[roadInletCond]
roadInlet_patch  = patch[roadInletCond]
roadInlet_outlet_index = seq_len(length(roadInlet_x))
roadInlet_outlet_patch = rep(NA,length(roadInlet_x))
roadInlet_outlet_dist = rep(1000,length(roadInlet_x))
roadInlet_outlet_dem = rep(roadInlet_dem,length(roadInlet_x))

clumpID = unique(clumpIDMAP)
clumpID = clumpID[!is.na(clumpID)]
for(ii in clumpID){
	# zonal stats
	cond = !is.na(clumpIDMAP) & (clumpIDMAP==ii); # clumpIDMAP[cond]
	targetValue = median(valueMAP[cond],na.rm=T)
	rast$tmp[mask][cond] = targetValue
	
	# find nearest roadInlet that has higher elevation
	condII = !is.na(valueMAP[cond]) & (valueMAP[cond]>=targetValue); # valueMAP[cond][condII]
	zonalpoints_dem = dem[cond][condII]
	zonalpoints_x = xx[cond][condII]
	zonalpoints_y = yy[cond][condII]
	zonalpoints_patch = patch[cond][condII]
	
	# into the many-to-many relationship
    thresDist = as.numeric(arg[12])
	for(jj in seq_along(zonalpoints_x)){
		distList = sqrt( (roadInlet_x-zonalpoints_x[jj])^2 + (roadInlet_y-zonalpoints_y[jj])^2 )
		selectedInlet = distList < thresDist & roadInlet_dem > zonalpoints_dem[jj]
		
		#finalCond = roadInlet_outlet_dem[roadInlet_outlet_index[selectedInlet]] > zonalpoints_dem[jj];
		
		finalCond = (roadInlet_dem[roadInlet_outlet_index[selectedInlet]] - roadInlet_outlet_dem[roadInlet_outlet_index[selectedInlet]])/roadInlet_outlet_dist[roadInlet_outlet_index[selectedInlet]] < (roadInlet_dem[roadInlet_outlet_index[selectedInlet]]-zonalpoints_dem[jj])/distList[selectedInlet]
		
		roadInlet_outlet_dist[roadInlet_outlet_index[selectedInlet]][finalCond] = distList[selectedInlet][finalCond]
		roadInlet_outlet_dem[roadInlet_outlet_index[selectedInlet]][finalCond] = zonalpoints_dem[jj]
		roadInlet_outlet_patch[roadInlet_outlet_index[selectedInlet]][finalCond] = zonalpoints_patch[jj]
	}#jj
	
}#ii
cbind(roadInlet_patch, roadInlet_outlet_patch)
writeRAST(rast,arg[9],zcol='tmp',overwrite=T)

rast$tmpII[mask][roadInletCond] = roadInlet_outlet_patch
writeRAST(rast,arg[10],zcol='tmpII', overwrite=T)

rast$tmpII = rep(NA,length(mask))
cond = !is.na(roadInlet_outlet_patch)
match_index = match(roadInlet_outlet_patch[cond],patch)
rast$tmpII[mask][match_index] = roadInlet_patch[cond]
writeRAST(rast,arg[11],zcol='tmpII', overwrite=T)

options(scipen=999)
LIBnrow = function(x){
	return <- ifelse(is.null(dim(x)[1]), 1, dim(x)[1]) 
}#function

arg=commandArgs(T)

# arg=c(
	# "NA",
	# "/Users/laurencelin/Dropbox/Myself/UNC/WS14_dynamicNdep/setup_rhessys_5_20_bolstad/rhessys/worldfiles/modify_bolstad_add.csv",
	# "/Users/laurencelin/Dropbox/Myself/UNC/WS14_dynamicNdep/setup_rhessys_5_20_bolstad/rhessys/worldfiles/world_vegBolstad_add2")

# arg=c(
	# 'na','~/Desktop/worldfile.csv','~/Desktop/worldfile'
# )

header = arg[1]
basefile = arg[2]
outputfile = arg[3]
print( paste('header = ', header,sep='') )
print( paste('basefile = ', basefile,sep='') )
print( paste('outputfile = ', outputfile,sep='') )

dd = as.matrix(read.csv(basefile))
keytable=cbind(colnames(dd),1:ncol(dd))
LEN = 1:dim(dd)[1]

	## this indexing system here is not efficient! maybe future updates
worldIndex = 1
basinID = unique(dd[,'basinID']); basinIndex = t(simplify2array(tapply(LEN, INDEX=match(dd[,'basinID'],basinID),function(ii){return<-c(dd[ii,'worldID'][1],dd[ii,'basinID'][1], ii[1]); })))
hillID = unique(dd[,'hillID']); hillIndex = t(simplify2array(tapply(LEN, INDEX=match(dd[,'hillID'],hillID),function(ii){return<-c(dd[ii,'worldID'][1],dd[ii,'basinID'][1],dd[ii,'hillID'][1], ii[1]); })))
zoneID = unique(dd[,'zoneID']); zoneIndex = t(simplify2array(tapply(LEN, INDEX=match(dd[,'zoneID'],zoneID),function(ii){return<-c(dd[ii,'worldID'][1],dd[ii,'basinID'][1],dd[ii,'hillID'][1], dd[ii,'zoneID'][1], ii[1]); })))
patchID = unique(dd[,'patchID']); patchIndex = t(simplify2array(tapply(LEN, INDEX=match(dd[,'patchID'],patchID),function(ii){return<-c(dd[ii,'worldID'][1],dd[ii,'basinID'][1],dd[ii,'hillID'][1], dd[ii,'zoneID'][1],dd[ii,'patchID'][1], ii[1]); })))
stratumID = unique(dd[,'strateID']); stratumIndex = t(simplify2array(tapply(LEN, INDEX=match(dd[,'strateID'],stratumID),function(ii){return<-c(dd[ii,'worldID'][1],dd[ii,'basinID'][1],dd[ii,'hillID'][1], dd[ii,'zoneID'][1],dd[ii,'patchID'][1],dd[ii,'strateID'][1], ii[1]); })))




goingAppend=T

### for header
if(header=="" | header=="NA" | header=='0' | header=='na'){
	# do nothing
	goingAppend=F
}else{
	con=file(header); open(con)
	line = readLines(con,warn=F); close(con)
	write(line,file=outputfile,ncolumn=1,append=F)
}

# world

num_world = length(worldIndex);
for(worldi in 1:num_world){
	
	worldID = dd[worldIndex[worldi],'worldID']
	basinIndex_ = basinIndex[basinIndex[,1]==worldID,]
	num_basin = LIBnrow(basinIndex_) ## special case: only one basin and one world
	if(num_basin ==1){basinIndex_ = t(as.matrix(basinIndex_)) }
	line=c(
		paste(formatC(worldID,width=31,format="d",digits=0,flag="-"),"world_id",sep=""),
		paste(formatC(num_basin,width=31,format="d",digits=0,flag="-"),"num_basins",sep="")
	)
	write(line,file=outputfile,ncolumn=1,append=goingAppend); goingAppend=T
	
	for(basini in 1:num_basin){
		
		basinID = dd[basinIndex_[basini,3],'basinID']
		hillIndex_ = hillIndex[hillIndex[,1]==worldID & hillIndex[,2]==basinID,]
		num_hill = LIBnrow(hillIndex_)
		if(num_hill ==1){hillIndex_ = t(as.matrix(hillIndex_)) }
		line=c(
			paste("",formatC(basinID,width=31,format="d",digits=0,flag="-"),"basin_ID",sep=""),
			paste("",formatC(dd[basinIndex_[basini,3],3],width=31,format="f",digits=16,flag="-"),"x",sep=""),
			paste("",formatC(dd[basinIndex_[basini,3],4],width=31,format="f",digits=16,flag="-"),"y",sep=""),
			paste("",formatC(dd[basinIndex_[basini,3],5],width=31,format="f",digits=16,flag="-"),"z",sep=""),
			paste("",formatC(dd[basinIndex_[basini,3],6],width=31,format="d",digits=0,flag="-"),"basin_parm_ID",sep=""),
			paste("",formatC(dd[basinIndex_[basini,3],7],width=31,format="f",digits=16,flag="-"),"latitude",sep=""),
			paste("",formatC(dd[basinIndex_[basini,3],8],width=31,format="d",digits=0,flag="-"),"n_basestations",sep=""),
			paste("",formatC(num_hill,width=31,format="d",digits=0,flag="-"),"num_hillslopes",sep="")
		)
		write(line,file=outputfile,ncolumn=1,append=T)
		
		for(hilli in 1:num_hill){
			
			hillID = dd[hillIndex_[hilli,4],'hillID']
			zoneIndex_ = zoneIndex[zoneIndex[,1]==worldID & zoneIndex[,2]==basinID & zoneIndex[,3]==hillID,]
			num_zone = LIBnrow(zoneIndex_)
			if(num_zone ==1){zoneIndex_ = t(as.matrix(zoneIndex_)) }
			line=c(
				paste("",formatC(hillID,width=31,format="d",digits=0,flag="-"),"hillslope_ID",sep=""),
				paste("",formatC(dd[hillIndex_[hilli,4],10],width=31,format="f",digits=16,flag="-"),"x",sep=""),
				paste("",formatC(dd[hillIndex_[hilli,4],11],width=31,format="f",digits=16,flag="-"),"y",sep=""),
				paste("",formatC(dd[hillIndex_[hilli,4],12],width=31,format="f",digits=16,flag="-"),"z",sep=""),
				paste("",formatC(dd[hillIndex_[hilli,4],13],width=31,format="d",digits=0,flag="-"),"hill_parm_ID",sep=""),
				paste("",formatC(dd[hillIndex_[hilli,4],14],width=31,format="f",digits=16,flag="-"),"gw.storage",sep=""),
				paste("",formatC(dd[hillIndex_[hilli,4],15],width=31,format="f",digits=16,flag="-"),"gw.NO3",sep=""),
				paste("",formatC(dd[hillIndex_[hilli,4],16],width=31,format="d",digits=0,flag="-"),"n_basestations",sep=""),
				paste("",formatC(num_zone,width=31,format="d",digits=0,flag="-"),"num_zones",sep="")
			)
			write(line,file=outputfile,ncolumn=1,append=T)
			
			
			for(zonei in 1:num_zone){	#this num_zone need to read from a quick table
				
				zoneID = dd[zoneIndex_[zonei,5],'zoneID']
				patchIndex_ = patchIndex[patchIndex[,1]==worldID & patchIndex[,2]==basinID & patchIndex[,3]==hillID & patchIndex[,4]==zoneID,]
				num_patch = LIBnrow(patchIndex_)
				if(num_patch==1){patchIndex_ = t(as.matrix(patchIndex_)) }
				line=c(
					paste("",formatC(zoneID,width=31,format="d",digits=0,flag="-"),"zone_ID",sep=""),
					paste("",formatC(dd[zoneIndex_[zonei,5],18],width=31,format="f",digits=16,flag="-"),"x",sep=""),
					paste("",formatC(dd[zoneIndex_[zonei,5],19],width=31,format="f",digits=16,flag="-"),"y",sep=""),
					paste("",formatC(dd[zoneIndex_[zonei,5],20],width=31,format="f",digits=16,flag="-"),"z",sep=""),
					paste("",formatC(dd[zoneIndex_[zonei,5],21],width=31,format="d",digits=0,flag="-"),"zone_parm_ID",sep=""),
					paste("",formatC(dd[zoneIndex_[zonei,5],22],width=31,format="f",digits=16,flag="-"),"area",sep=""),
					paste("",formatC(dd[zoneIndex_[zonei,5],23],width=31,format="f",digits=16,flag="-"),"slope",sep=""),
					paste("",formatC(dd[zoneIndex_[zonei,5],24],width=31,format="f",digits=16,flag="-"),"aspect",sep=""),
					paste("",formatC(dd[zoneIndex_[zonei,5],25],width=31,format="f",digits=16,flag="-"),"precip_lapse_rate",sep=""),
					paste("",formatC(dd[zoneIndex_[zonei,5],26],width=31,format="f",digits=16,flag="-"),"e_horizon",sep=""),
					paste("",formatC(dd[zoneIndex_[zonei,5],27],width=31,format="f",digits=16,flag="-"),"w_horizon",sep=""),
					paste("",formatC(dd[zoneIndex_[zonei,5],28],width=31,format="d",digits=0,flag="-"),"n_basestations",sep=""),
					paste("",formatC(dd[zoneIndex_[zonei,5],29],width=31,format="d",digits=0,flag="-"),"base_station_ID",sep=""),
					paste("",formatC(num_patch,width=31,format="d",digits=0,flag="-"),"num_patches",sep="")
				)
				write(line,file=outputfile,ncolumn=1,append=T)
				
				for(patchi in 1:num_patch){
					
					patchID = dd[patchIndex_[patchi,6],'patchID']
					stratumIndex_ = stratumIndex[stratumIndex[,1]==worldID & stratumIndex[,2]==basinID & stratumIndex[,3]==hillID & stratumIndex[,4]==zoneID & stratumIndex[,5]==patchID,]
					num_strate = LIBnrow(stratumIndex_)
					if(num_strate==1){stratumIndex_ = t(as.matrix(stratumIndex_)) }
				
					#. ... patch
					line=c(
						paste("",formatC(patchID,width=31,format="d",digits=0,flag="-"),"patch_ID",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],31],width=31,format="f",digits=16,flag="-"),"x",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],32],width=31,format="f",digits=16,flag="-"),"y",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],33],width=31,format="f",digits=16,flag="-"),"z",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],34],width=31,format="d",digits=0,flag="-"),"soil_parm_ID",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],35],width=31,format="d",digits=0,flag="-"),"landuse_parm_ID",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],36],width=31,format="f",digits=16,flag="-"),"area",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],37],width=31,format="f",digits=16,flag="-"),"slope",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],38],width=31,format="f",digits=16,flag="-"),"lna",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],39],width=31,format="f",digits=16,flag="-"),"Ksat_vertical",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],40],width=31,format="f",digits=16,flag="-"),"mpar",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],41],width=31,format="f",digits=16,flag="-"),"rz_storage",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],42],width=31,format="f",digits=16,flag="-"),"unsat_storage",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],43],width=31,format="f",digits=16,flag="-"),"sat_deficit",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],44],width=31,format="f",digits=16,flag="-"),"snowpack.water_equivalent_depth",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],45],width=31,format="f",digits=16,flag="-"),"snowpack.water_depth",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],46],width=31,format="f",digits=16,flag="-"),"snowpack.T",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],47],width=31,format="f",digits=16,flag="-"),"snowpack.surface_age",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],48],width=31,format="f",digits=16,flag="-"),"snowpack.energy_deficit",sep=""),
						
						paste("",formatC(dd[patchIndex_[patchi,6],49],width=31,format="f",digits=16,flag="-"),"litter.cover_fraction",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],50],width=31,format="f",digits=16,flag="-"),"litter.rain_stored",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],51],width=31,format="f",digits=16,flag="-"),"litter_cs.litr1c",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],52],width=31,format="f",digits=16,flag="-"),"litter_ns.litr1n",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],53],width=31,format="f",digits=16,flag="-"),"litter_cs.litr2c",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],54],width=31,format="f",digits=16,flag="-"),"litter_cs.litr3c",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],55],width=31,format="f",digits=16,flag="-"),"litter_cs.litr4c",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],56],width=31,format="f",digits=16,flag="-"),"soil_cs.soil1c",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],57],width=31,format="f",digits=16,flag="-"),"soil_ns.sminn",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],58],width=31,format="f",digits=16,flag="-"),"soil_ns.nitrate",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],59],width=31,format="f",digits=16,flag="-"),"soil_cs.soil2c",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],60],width=31,format="f",digits=16,flag="-"),"soil_cs.soil3c",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],61],width=31,format="f",digits=16,flag="-"),"soil_cs.soil4c",sep=""),
						paste("",formatC(dd[patchIndex_[patchi,6],62],width=31,format="d",digits=0,flag="-"),"n_basestations",sep=""),
						paste("",formatC(num_strate,width=31,format="d",digits=0,flag="-"),"num_stratum",sep="")
					)
					write(line,file=outputfile,ncolumn=1,append=T)

					for(stratei in 1:num_strate){
						
						strateID = dd[stratumIndex_[stratei,7],'strateID']
						line=c(
							paste("",formatC(strateID,width=31,format="d",digits=0,flag="-"),"canopy_strata_ID",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],64],width=31,format="d",digits=0,flag="-"),"veg_parm_ID",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],65],width=31,format="f",digits=16,flag="-"),"cover_fraction",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],66],width=31,format="f",digits=16,flag="-"),"gap_fraction",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],67],width=31,format="f",digits=16,flag="-"),"rootzone.depth",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],68],width=31,format="f",digits=16,flag="-"),"snow_stored",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],69],width=31,format="f",digits=16,flag="-"),"rain_stored",sep=""),	
							paste("",formatC(dd[stratumIndex_[stratei,7],70],width=31,format="f",digits=16,flag="-"),"cs.cpool",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],71],width=31,format="f",digits=16,flag="-"),"cs.leafc",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],72],width=31,format="f",digits=16,flag="-"),"cs.dead_leafc",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],73],width=31,format="f",digits=16,flag="-"),"cs.leafc_store",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],74],width=31,format="f",digits=16,flag="-"),"cs.leafc_transfer",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],75],width=31,format="f",digits=16,flag="-"),"cs.live_stemc",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],76],width=31,format="f",digits=16,flag="-"),"cs.livestemc_store",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],77],width=31,format="f",digits=16,flag="-"),"cs.livestemc_transfer",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],78],width=31,format="f",digits=16,flag="-"),"cs.dead_stemc",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],79],width=31,format="f",digits=16,flag="-"),"cs.deadstemc_store",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],80],width=31,format="f",digits=16,flag="-"),"cs.deadstemc_transfer",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],81],width=31,format="f",digits=16,flag="-"),"cs.live_crootc",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],82],width=31,format="f",digits=16,flag="-"),"cs.livecrootc_store",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],83],width=31,format="f",digits=16,flag="-"),"cs.livecrootc_transfer",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],84],width=31,format="f",digits=16,flag="-"),"cs.dead_crootc",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],85],width=31,format="f",digits=16,flag="-"),"cs.deadcrootc_store",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],86],width=31,format="f",digits=16,flag="-"),"cs.deadcrootc_transfer",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],87],width=31,format="f",digits=16,flag="-"),"cs.frootc",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],88],width=31,format="f",digits=16,flag="-"),"cs.frootc_store",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],89],width=31,format="f",digits=16,flag="-"),"cs.frootc_transfer",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],90],width=31,format="f",digits=16,flag="-"),"cs.cwdc",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],91],width=31,format="f",digits=16,flag="-"),"epv.prev_leafcalloc",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],92],width=31,format="f",digits=16,flag="-"),"ns.npool",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],93],width=31,format="f",digits=16,flag="-"),"ns.leafn",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],94],width=31,format="f",digits=16,flag="-"),"ns.dead_leafn",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],95],width=31,format="f",digits=16,flag="-"),"ns.leafn_store",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],96],width=31,format="f",digits=16,flag="-"),"ns.leafn_transfer",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],97],width=31,format="f",digits=16,flag="-"),"ns.live_stemn",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],98],width=31,format="f",digits=16,flag="-"),"ns.livestemn_store",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],99],width=31,format="f",digits=16,flag="-"),"ns.livestemn_transfer",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],100],width=31,format="f",digits=16,flag="-"),"ns.dead_stemn",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],101],width=31,format="f",digits=16,flag="-"),"ns.deadstemn_store",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],102],width=31,format="f",digits=16,flag="-"),"ns.deadstemn_transfer",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],103],width=31,format="f",digits=16,flag="-"),"ns.live_nrootn",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],104],width=31,format="f",digits=16,flag="-"),"ns.livenrootn_store",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],105],width=31,format="f",digits=16,flag="-"),"ns.livenrootn_transfer",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],106],width=31,format="f",digits=16,flag="-"),"ns.dead_nrootn",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],107],width=31,format="f",digits=16,flag="-"),"ns.deadnrootn_store",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],108],width=31,format="f",digits=16,flag="-"),"ns.deadnrootn_transfer",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],109],width=31,format="f",digits=16,flag="-"),"ns.frootn",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],110],width=31,format="f",digits=16,flag="-"),"ns.frootn_store",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],111],width=31,format="f",digits=16,flag="-"),"ns.frootn_transfer",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],112],width=31,format="f",digits=16,flag="-"),"ns.nwdn",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],113],width=31,format="f",digits=16,flag="-"),"ns.retransn",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],114],width=31,format="f",digits=16,flag="-"),"epv.wstress_days",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],115],width=31,format="f",digits=16,flag="-"),"epv.max_fparabs",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],116],width=31,format="f",digits=16,flag="-"),"epv.min_vwc",sep=""),
							paste("",formatC(dd[stratumIndex_[stratei,7],117],width=31,format="d",digits=0,flag="-"),"n_basestations",sep="")
						)
						write(line,file=outputfile,ncolumn=1,append=T)
					}#stratei
				}#patchi
			}#zonei
		}#hilli
	}#basini
}#worldi
#,error=function(err){print(paste(basini,hilli,zonei,stratei));})


# arg=c(
	# "",
	# "/Users/laurencelin/Desktop/WSC/morgancreek/rhessys/worldfiles/mix/world_redefthin_pineplantationDown.csv",
	# "test.csv"
# )

library(rgrass7)
library(sp)
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})
rast=readRAST(c('tmp','basin_','sub_','hill_','str_','drain'))
mask = !is.na(rast@data[[1]]) # use sub as mask
basin=rast@data[[2]][mask]
sub=rast@data[[3]][mask]
hill=rast@data[[4]][mask]
str=rast@data[[5]][mask]
strCOND = !is.na(str)
drain=rast@data[[6]][mask]

rast2=readRAST(c('rowmap','colmap'))
rows = rast2@data[[1]][mask]
cols = rast2@data[[2]][mask]
	strRows = rows[strCOND]
	strCols = cols[strCOND]
	strDRAIN = abs(drain[strCOND])
maxCol = max(cols,na.rm=T)
maskRC = rows*maxCol+cols 
maskRC_string2Index <- new.env(hash=T)
    list2env(setNames(as.list(sub),maskRC),envir=maskRC_string2Index) #<<---- native R hash 
     
    
# ... which sub contain D8basin
index = tapply(seq_along(sub),sub,function(ii){ ii })
index_partial = tapply(seq_along(sub),sub,function(ii){ ii[ !is.na(basin[ii]) ] })
basin_sub = tapply(seq_along(sub),sub,function(ii){ sum(basin[ii],na.rm=T)/length(ii) })
selected_basin_sub = as.numeric(names(basin_sub)[basin_sub>0])
selected_basin_sub_index = match(selected_basin_sub, as.numeric(names(basin_sub)) )
# sapply(seq_along(index),function(k){length(index[[k]])})
# sapply(seq_along(index_partial),function(k){length(index_partial[[k]])})

# ... stream network structure
# 1.  2. 3.  4. 5.  6. 7.  8. (GRASS from current drainTO code order)
# NE, N, NW, W, SW, S, SE, E
colneighbor = c(1,    0,    -1,    -1,    -1,    0,    1,    1)
rowneighbor = c(-1,    -1,    -1,    0,    1,    1,    1,    0)
downstrRC = 
	sapply(seq_along(strRows), FUN=function(x){strRows[x]+rowneighbor[strDRAIN[x] ] }) * maxCol + 
	sapply(seq_along(strCols), FUN=function(x){strCols[x]+colneighbor[strDRAIN[x] ] })

    
    currentstrSUB =  sapply(maskRC[strCOND], function(x){
    		hh = maskRC_string2Index[[ toString(x) ]]
    		return <- ifelse(is.null(hh),NA,hh);
    })

   	downstrSUB =  sapply(downstrRC, function(x){
    		hh = maskRC_string2Index[[ toString(x) ]]
    		return <- ifelse(is.null(hh),NA,hh);
    })
	downstrSUB[is.na(downstrSUB)] = -1

	cond_ = currentstrSUB != downstrSUB
	selectedSUBs = currentstrSUB[cond_]
	selectedSUBs_down = downstrSUB[cond_]
	selectedSUBs_order = match(selected_basin_sub, selectedSUBs)
	
	
# ... SUB to basin
rast$tmp = rep(NA,length(mask))
for( ii in seq_along(selected_basin_sub) ){
	
	if(selectedSUBs_down[selectedSUBs_order[ii]] %in% selected_basin_sub){
		# upslope sub
        rast$tmp[mask][ index[[ selected_basin_sub_index[ii] ]] ] = 1
	}else{
        # outlet sub
        rast$tmp[mask][ index_partial[[ selected_basin_sub_index[ii] ]] ] = 1
	}

}#ii
basinCond = !is.na(rast$tmp[mask]) 
writeRAST(rast,"basin",zcol='tmp', overwrite=T)

rast$tmp = rep(NA,length(mask))
rast$tmp[mask][basinCond] = sub[basinCond]
writeRAST(rast,"sub",zcol='tmp', overwrite=T)

rast$tmp = rep(NA,length(mask))
rast$tmp[mask][basinCond] = hill[basinCond]
writeRAST(rast,"hill",zcol='tmp', overwrite=T)

rast$tmp = rep(NA,length(mask))
rast$tmp[mask][basinCond] = str[basinCond]
writeRAST(rast,"str",zcol='tmp', overwrite=T)

# rast$tmp = rep(NA,length(mask))
# rast$tmp[mask][basinCond] = maskRC[basinCond]
# writeRAST(rast,"patch",zcol='tmp', overwrite=T)

arg=commandArgs(T)

w = read.csv(arg[1])
output = data.frame(codeID = as.numeric( gsub('[a-z]','',colnames(w)[-1:-2]) ))
output$vegID1 = rep(0,dim(output)[1])
write("name",arg[2],ncolumns=1,append=F)
write.table(output,arg[2],row.names=F, append=T,sep=',')

## flow table
options(scipen=999)
arg=commandArgs(T)
library(sp)
library(XML)
library(rgrass7)
library(rgdal)
gis = gmeta()
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})
DtoR = pi/180
RtoD = 1/DtoR
# bounded by GIS mask

	## ... basic maps
	basinMap = 'basin'
	hillslopeMap = 'hill'
	zoneMAP = 'zone'
	xMap = 'xmap'
	yMap = 'ymap'
	patchMAP = 'patch'
	rowMap = 'rowmap' ##<<--- raster calculator row()
	colMap = 'colmap' ##<<--- raster calculator col()
	demMap = 'dem'
	slopeMap = 'slope' ## unit in degree
	rast0 = readRAST(c(basinMap, hillslopeMap, zoneMAP, patchMAP, rowMap, colMap),NODATA=0)
		mask = !is.na(rast0@data[[1]])
		basin = rast0@data[[1]][mask]
		hill = rast0@data[[2]][mask]
		zone = rast0@data[[3]][mask]
		patch = rast0@data[[4]][mask]
		rows = rast0@data[[5]][mask]
		cols = rast0@data[[6]][mask]
	rast1 = readRAST(c(demMap, xMap, yMap, slopeMap))
		dem = rast1@data[[1]][mask]
		xx = rast1@data[[2]][mask]
		yy = rast1@data[[3]][mask]
		slope = rast1@data[[4]][mask]
		

	streamMap = 'str'
	rast2 = readRAST(streamMap)	
		stream = rast2@data[[1]][mask]

	roadMap = 'roads' # mountain dirt road; not paved road
	rast3 = readRAST(roadMap)		
		road = rast3@data[[1]][mask]

	drainMap = 'drain'
	rast4 = readRAST(drainMap)		
		drain = abs(rast4@data[[1]][mask])
		
		
	## assume grids are squares 
	cellarea = gis$nsres * gis$ewres
	cellsize = sqrt(cellarea) 
	flatDEMdrop = tan(DtoR*0.143)*cellsize # only 0.25m drop per 100m.
	roadWidth = 5
	roadWidth = ifelse(cellsize>=9.99,
		5, # meters (default)
		ifelse(roadWidth>cellsize, cellsize, roadWidth)
	 )# ifelse
	directEdge = cellsize*0.5
	diagonalEdge = cellsize*sqrt(0.5)	
		
	# 1.  2. 3.  4. 5.  6. 7.  8. (GRASS from current drainTO code order)
	# NE, N, NW, W, SW, S, SE, E
	colneighbor = c(1,	0,	-1,	-1,	-1,	0,	1,	1)	
	rowneighbor = c(-1,	-1,	-1,	0,	1,	1,	1,	0)	
	directEdgeIndex = c(2,4,6,8)
	indirectEdgeIndex = c(1,3,5,7)
	 
	maxCol = max(cols,na.rm=T) 
	maskRC = rows*maxCol+cols #paste(rows, cols,sep=':') ## row*[max col]+col (yes: unique ID)
	maskRC_string2Patch_num <- new.env(hash=T)
	list2env(setNames(as.list(patch),maskRC),envir=maskRC_string2Patch_num) #<<---- native R hash
	gridSurroundRC = sapply(rows, FUN=function(x){x+rowneighbor})*maxCol+sapply(cols, FUN=function(x){x+colneighbor})
	gridSurroundRC[!(gridSurroundRC %in% maskRC)] = -1
	
	# part 1: gathering information to temporary files
	#patch_title = c('patchID','dem','xx','yy','basin','hill','zone','rr','cc','grid','strQ','roadQ','accgrid','mslope','Mslope')

	fullLength = seq(1,length.out=length(patch))
	patch_info_dem = tapply(dem,INDEX=patch,mean)
	orderedPatch = as.numeric(names(patch_info_dem[order(patch_info_dem,decreasing=T)])) ### patch could be longer than 'orderedPatch'
	outputOrder = match(patch, orderedPatch) # has the same length as 'patch'
		# test = tapply(patch, outputOrder,mean); sum(test==orderedPatch)==length(orderedPatch)
	maskRC_string2outputOrder_num <- new.env(hash=T)
	list2env(setNames(as.list(outputOrder),maskRC),envir=maskRC_string2outputOrder_num) #<<---- native R hash
	maskRC_string2maskRC_num <- new.env(hash=T)
	list2env(setNames(as.list(maskRC),maskRC),envir= maskRC_string2maskRC_num) #<<---- native R hash
	
	print('starting step I')
	patchInfo = tapply(fullLength, INDEX=outputOrder, FUN=function(ii){
		
		return <- c(
			patchID = mean(patch[ii]), 			#1 patchID
			elevation = mean(dem[ii]),				#2 elevation
			xx = mean(xx[ii]),				#3 x coordinate
			yy = mean(yy[ii]),				#4 y coordinate
			hillID = mean(hill[ii]),				#6 hillID
			zoneID = mean(zone[ii]),				#7 zoneID
			rr = mean(rows[ii]),				#8 row index (from left to right)
			cc = mean(cols[ii]),				#9 col index (from top to bottom)
			len = length(ii),					#10 num of cells
			strQ = sum(!is.na(stream[ii])),	#11 strQ (checking whether patch contains stream grids)
			aveSlope = tan(mean(slope[ii])*DtoR),	#13 average slope
			maxSlope = tan(max(slope[ii])*DtoR),	#14 max slope
			mtnRoadQ = sum(!is.na(road[ii]))
			);
	})#tapply <--- this output is a list of c() in outputOrder
	patch_info_lowest = patchInfo[[ length(patchInfo) ]]
	 
	 
	 
	 
	 
	## part 2: sort by 'elevation' & finding neighbor 
	print('starting step II') 
		
	## .......... Neighbour
		# ii=which(orderedPatch==24110) #500
		patchNeighbourRC_edge = tapply(fullLength, INDEX=outputOrder, FUN=function(jj){
			withinPatchGridRC = rows[jj]*maxCol+cols[jj]; # within
	
			hold = as.vector(gridSurroundRC[directEdgeIndex,jj]);
			hold[hold%in% withinPatchGridRC] = -1
			
			hold2 = as.vector(gridSurroundRC[indirectEdgeIndex,jj]);
			hold2[hold2%in% withinPatchGridRC] = -1
	
			return <- c( tapply(hold[hold>0],hold[hold>0],length)*directEdge, tapply(hold2[hold2>0],hold2[hold2>0],length)*diagonalEdge) 
			 
		})
			
		patchNeighbourRC_LEN = seq_along(patchNeighbourRC_edge) ## <<--------------------------- ordered patch aggregated neighbours
		patchNeighbourRC = sapply(patchNeighbourRC_LEN, function(ii){
			sapply(names(patchNeighbourRC_edge[[ii]]), function(x){maskRC_string2maskRC_num[[ x ]]})
		})
		patchNeighbourPatch = sapply(patchNeighbourRC_LEN, function(ii){
			sapply(names(patchNeighbourRC_edge[[ii]]), function(x){maskRC_string2Patch_num[[ x ]]})
		})
		patchNeighbourPatchIndex = sapply(patchNeighbourRC_LEN, function(ii){
			sapply(names(patchNeighbourRC_edge[[ii]]), function(x){maskRC_string2outputOrder_num[[ x ]]})
		})


	## .......... prefer Neighbour
		patchPreferNeighbourRC = tapply(fullLength, INDEX=outputOrder, FUN=function(ii){
			withinPatchGridRC = rows[ii]*maxCol+cols[ii]; # within
			drainTO_index = cbind(drain[ii],ii)
			hold3 = as.vector(gridSurroundRC[ drainTO_index ])
			hold3[hold3%in% withinPatchGridRC] = -1
			
			return <- sapply(names(tapply(hold3[hold3>0], hold3[hold3>0],length)),function(x){maskRC_string2maskRC_num[[ x ]]})
		})

	
	## ...........................................
	## .......... writing out flow table
	subsurfaceflow_table_buff <- file(arg[1],'w') # open a file connection
	cat( length(patchInfo), '\n', file=subsurfaceflow_table_buff) #,sep='\n'

	
	#silent = sapply(patchNeighbourRC_LEN, function(ii){
	for(ii in patchNeighbourRC_LEN){

		withinNeighbourRC_edge = patchNeighbourRC_edge[[ii]] 	
		withinNeighbourRC = patchNeighbourRC[[ii]]					
		withinNeighbourRC_prefer = rep(0,length(withinNeighbourRC))			##<<------
			withinNeighbourRC_prefer[withinNeighbourRC%in%patchPreferNeighbourRC[[ii]] ] = 1
		index4neighbour = patchNeighbourPatchIndex[[ii]] 
		 			 	
		current_patch_info = patchInfo[[ii]]
		drainage_type = ifelse(current_patch_info['strQ']>0, 1, # class::stream
						ifelse(current_patch_info['mtnRoadQ']>0, 2, 
						0 # LAND in default RHESSys
						))			
		
				
		
		neighbourLength = 1:length(withinNeighbourRC)	
		neighbourOrder = match(withinNeighbourRC,unique(withinNeighbourRC))
		
		allNeighbourInfo = simplify2array(tapply(neighbourLength, INDEX=neighbourOrder, function(jj){
			## exploring information between "current" and neighbour(jj)
				# index4neighbour[jj][1] # index of neighbour(jj) in "patchInfo" list
				# withinNeighbourRC_edge[jj] # all edges between current and neighbour(jj)
				# withinNeighbourRC_prefer[jj] # all prefers between current and neighbour(jj)
			
			neighbor_patch_info = patchInfo[[ index4neighbour[jj][1] ]];
			idiffDEM = current_patch_info['elevation']-neighbor_patch_info['elevation']
			idiffDEM = ifelse(idiffDEM<0,0, idiffDEM)
			
			return <- c(
				patchID = as.numeric(neighbor_patch_info['patchID']), #patchID, zone, hill [1,2,3]
                zoneID = as.numeric(neighbor_patch_info['zoneID']),
                hillID = as.numeric(neighbor_patch_info['hillID']),
				## ... distance
				dist = as.numeric(sqrt((neighbor_patch_info['xx']-current_patch_info['xx'])^2 +
					(neighbor_patch_info['yy']-current_patch_info['yy'])^2)), # distance [4]
				## ... rise
				rise = as.numeric(idiffDEM), #rise (local prefer) [5] # zero correct
				riseRegion= ifelse( mean(withinNeighbourRC_prefer[jj])>0, flatDEMdrop, 0), #rise (regional prefer) [6] # zero correct
				## ... shared edge
				sharedEdge = sum(withinNeighbourRC_edge[jj]) #edge [7]
			)
		}))#tapply <<--- not in a right order
		
		## local prefer 
		slope_jj_l = allNeighbourInfo['rise',]/allNeighbourInfo['dist',] # rise / distance
		gamma_jj_l = slope_jj_l*allNeighbourInfo['sharedEdge',] # edge (width)
		
		## regional prefer 
		slope_jj_r = allNeighbourInfo['riseRegion',]/allNeighbourInfo['dist',] # rise / distance
		gamma_jj_r = slope_jj_r*allNeighbourInfo['sharedEdge',]
		
		cc1 = sum(gamma_jj_l)==0 # use gamma_jj_r
		cc2 = sum(gamma_jj_l < gamma_jj_r)==0 	## T: use gamma_jj_l	
		cc3 = sum(gamma_jj_l) > sum(gamma_jj_r)	
		if(cc1){
			gamma_jj = gamma_jj_r
			selectedFlow2neigbour = slope_jj_r>0
		}else if(cc2){
			gamma_jj = gamma_jj_l
			selectedFlow2neigbour = slope_jj_l>0
		}else if(cc3){
			gamma_jj = gamma_jj_l/sum(gamma_jj_l)*0.3 + (gamma_jj_r>0)*0.7
			selectedFlow2neigbour = slope_jj_r>0 | slope_jj_l>0
		}else{
			gamma_jj = gamma_jj_l + gamma_jj_r
			selectedFlow2neigbour = slope_jj_r>0 | slope_jj_l>0
		}	
		
		## ... neighbour gamma fraction
		neighbor_frac_gamma = gamma_jj/ifelse(sum(gamma_jj)>0,sum(gamma_jj),1)
		
		## ... total_gamma
		total_perimeter = sum( allNeighbourInfo['sharedEdge', selectedFlow2neigbour] )
		total_gamma = sum(gamma_jj)/total_perimeter*current_patch_info['len']*cellarea; # currrent CF calculation
		if(drainage_type==1) total_gamma = current_patch_info['aveSlope']*current_patch_info['len']*cellarea; # special for stream
			
	
		cat(
			paste(current_patch_info[c('patchID','zoneID','hillID')], collapse=' '),
			paste(sprintf('%.1f',current_patch_info[c('rr','cc','elevation')]), collapse=' '),
			sprintf('%.2f',1.0),
			sprintf('%.2f',0.0),
			drainage_type, 
			total_gamma, length(withinNeighbourRC),'\n',
            file=subsurfaceflow_table_buff,sep=' ')
		
		cat( paste(
			allNeighbourInfo['patchID',],
			allNeighbourInfo['zoneID',],
			allNeighbourInfo['hillID',],
			sprintf('%.5f',neighbor_frac_gamma),
			#sprintf('%.2f',allNeighbourInfo['sharedEdge',]/allNeighbourInfo['dist',]),
			#sprintf('%.2f',allNeighbourInfo['sharedEdge',]),
            sep=' '),
            file=subsurfaceflow_table_buff,sep='\n')
		
		if(drainage_type==2) cat (
			patch_info_lowest['patchID'],
			patch_info_lowest['zoneID'],
			patch_info_lowest['hillID'],
			roadWidth,'\n',
            file=subsurfaceflow_table_buff,sep=' ')  #*current_patch_info[16]
			

	}# for loop ii 
	close(subsurfaceflow_table_buff)
	
	## part 3: write out
	#write(subsurfaceflow_table_buff, arg[1], ncolumns=1)
		
		

#source("~/LIB_misc.r")
options(scipen=999)
arg=commandArgs(T)
inputfile = arg[1]
skip = as.numeric(arg[2])
output=arg[3]


con=file(inputfile)
open(con)

worldid=0; 
num_basin=0;
num_hill=0;
num_zone=0;
num_patch=0;

# title=c(
	# "worldID","numBaisn",
	# "basinID","basinX","basinY","basinZ","basinDefID","basinLatitude","basinBase","numHill",
	
	# "hillID","hillX","hillY","hillZ","hillDefID","hillgws","hillgwno3","hillBase","numZone",
	
	# "zoneID","zoneX","zoneY","zoneZ","zoneDefID","zoneArea","zoneSlope","zoneAspect","zoneIso","zoneEH","zoneWH", "zoneBase","zoneBaseID","numPatch",
	
	# "patchID","patchX","patchY","patchZ","patchSoilID","patchLandID","patchArea","patchSlope","patchLNA","patchKsat","patchMpar",
	# "patchRZstorage","patchUnsat","patchSat",
	# "patchSnowEZ","patchSnowZ","patchSnowT","patchSnowAge","patchSnowED", 
	# "patchLittercfrac","patchLitterStorage","patchLitterc1","patchLittern1","patchLitterc2","patchLitterc3","patchLitterc4",
	# "patchSoilc1","patchSoilsminn","patchSoilNO3","patchSoilc2","patchSoilc3","patchSoilc4","patchBase","numStrate",
	
	# "strateID","stratePlantID","stratecfrac","strateGap","strateRZ","strateSnowStored","strateRainStored",
	# "stratecpool","strateleafc","stratedleafc","strateleafcstore","strateleafctrans","stratelstemc","stratelstemcstore","stratelstemctrans",
	# "stratedstemc","stratedstemcstore","stratedstemctrans","stratelrootc","stratelrootcstore","stratelrootctrans",
	# "stratedrootc","stratedrootcstore","stratedrootctrans","stratefrootc","stratefrootcstore","stratefrootctrans",
	# "stratecwdc","strateEPVleafcalloc",
	# "stratenpool","strateleafn","stratedleafn","strateleafnstore","strateleafntrans","stratelstemn","stratelstemnstore","stratelstemntrans",
	# "stratedstemn","stratedstemnstore","stratedstemntrans","stratelrootn","stratelrootnstore","stratelrootntrans",
	# "stratedrootn","stratedrootnstore","stratedrootntrans","stratefrootn","stratefrootnstore","stratefrootntrans",
	# "stratecwdn","strateRetransn","epv_wstress_days","epv_max_fparabs","epv_min_vwc","strateBase"
# )
# write(title,file=paste("worldfile.",region,".sp500Table.csv",sep=""),sep=",",ncolumns=2+8+9+14+34+55, append=F)

title=c(
	"worldID",
	"basinID","basinX","basinY","basinZ","basinDefID","basinLatitude","basinBase", #8
	
	"hillID","hillX","hillY","hillZ","hillDefID","hillgws","hillgwno3","hillBase", #16
	
	"zoneID","zoneX","zoneY","zoneZ","zoneDefID","zoneArea","zoneSlope","zoneAspect","zoneIso","zoneEH","zoneWH", "zoneBase","zoneBaseID", #29
	
	"patchID","patchX","patchY","patchZ","patchsoilID","patchLandID","patchArea","patchSlope","patchLNA","patchKsat","patchMpar",
	"patchRZstorage","patchUnsat","patchSat",
	"patchSnowEZ","patchSnowZ","patchSnowT","patchSnowAge","patchSnowED", 
	"patchLittercfrac","patchLitterStorage","patchLitterc1","patchLittern1","patchLitterc2","patchLitterc3","patchLitterc4",
	"patchSoilc1","patchSoilsminn","patchSoilNO3","patchSoilc2","patchSoilc3","patchSoilc4","patchBase",
	
	"strateID","stratePlantID","stratecfrac","strateGap","strateRZ","strateSnowStored","strateRainStored",
	"stratecpool","strateleafc","stratedleafc","strateleafcstore","strateleafctrans","stratelstemc","stratelstemcstore","stratelstemctrans",
	"stratedstemc","stratedstemcstore","stratedstemctrans","stratelrootc","stratelrootcstore","stratelrootctrans",
	"stratedrootc","stratedrootcstore","stratedrootctrans","stratefrootc","stratefrootcstore","stratefrootctrans",
	"stratecwdc","strateEPVleafcalloc",
	"stratenpool","strateleafn","stratedleafn","strateleafnstore","strateleafntrans","stratelstemn","stratelstemnstore","stratelstemntrans",
	"stratedstemn","stratedstemnstore","stratedstemntrans","stratelrootn","stratelrootnstore","stratelrootntrans",
	"stratedrootn","stratedrootnstore","stratedrootntrans","stratefrootn","stratefrootnstore","stratefrootntrans",
	"stratecwdn","strateRetransn","epv_wstress_days","epv_max_fparabs","epv_min_vwc","strateBase"
)
write(title,file=output,sep=",",ncolumns=8+8+13+33+55, append=F)


#skip headers
if(skip>0){w=readLines(con,n=skip,warn=F)}
#w=readLines(con,n=58,warn=F)# header in old RHESSys worldfile
#w=readLines(con,n=1,warn=F)# header in new RHESSys worldfile


# world
line=readLines(con,n=1,warn=F)
worldid = as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[1]))); ###<<---------------------- worldID

#basin
line=readLines(con,n=1,warn=F) 
num_basin = as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[1]))) ###<<----------
for(bi in 1:num_basin){
	
	line=readLines(con,n=8,warn=F)
	basinObj = c(
		worldid,
		num_basin,
		as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[1]))), #<<---- basin ID
		as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[2]))), #<<---- basin x
		as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[3]))), #<<---- basin y
		as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[4]))), #<<---- basin z
		as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[5]))), #<<---- basin def ID
		as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[6]))), #<<---- basin latitude
		as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[7]))), #<<---- basin #bnasestation
		as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[8])))  #<<---- # hill
	)
	#as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[1])))
	
	num_hill= basinObj[10];
	
	for(hi in 1:num_hill){
		
		line=readLines(con,n=9,warn=F)
		hillObj =c(
			as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[1]))), #<<---- hill ID
			as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[2]))), #<<---- hill x
			as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[3]))), #<<---- hill y
			as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[4]))), #<<---- hill z
			as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[5]))), #<<---- hill def ID
			as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[6]))), #<<---- hill gw.storage
			as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[7]))), #<<---- hill gw.no3 <<--- this 3
			as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[8]))), #<<---- hill #basestation [what is it? always zero!]
			as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[9]))) #<<---- # zone
		)
		num_zone= hillObj[9];
		
		for(zi in 1:num_zone){
			
			line=readLines(con,n=14,warn=F)
			zoneObj=c(
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[1]))), #<<---- zone ID
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[2]))), #<<---- zone x
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[3]))), #<<---- zone y
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[4]))), #<<---- zone z 
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[5]))), #<<---- zone def ID 5
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[6]))), #<<---- zone area
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[7]))), #<<---- zone slope
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[8]))), #<<---- zone aspect
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[9]))), #<<---- zone isohyet [how does it work with def?]
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[10]))), #<<---- zone e_horizon 10
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[11]))), #<<---- zone w_horizon
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[12]))), #<<---- zone #basestation
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[13]))), #<<---- zone p basestation ID
				as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[14]))) #<<---- # patch 14
			)
			num_patch= zoneObj[14];
			
			
			for(pi in 1:num_patch){
				
				line=readLines(con,n=34,warn=F)
				patchObj=c(
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[1]))), #<<---- patch ID
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[2]))), #<<---- patch x
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[3]))), #<<---- patch y
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[4]))), #<<---- patch z
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[5]))), #<<---- patch soil ID
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[6]))),  #<<---- patch land ID
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[7]))),  #<<---- patch area
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[8]))),  #<<---- patch slope
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[9]))),  #<<---- patch lna [what is it?]
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[10]))),  #<<---- patch ksat
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[11]))),  #<<---- patch m_par 
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[12]))),  #<<---- patch rz_storage
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[13]))),  #<<---- patch unsat_storage
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[14]))),  #<<---- patch sat_deficit
					
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[15]))),  #<<---- patch snowpack water Eq depth
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[16]))),  #<<---- patch snowpack water depth
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[17]))),  #<<---- patch snowpack T
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[18]))),  #<<---- patch snowpack surface age
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[19]))),  #<<---- patch snowpack energy deficit
					
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[20]))),  #<<---- patch litter cover fraction
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[21]))),  #<<---- patch litter rain stored
					
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[22]))), #<<---- patch litter_cs.litr1c
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[23]))), #<<---- patch litter_ns.litr1n
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[24]))), #<<---- patch litter_cs.litr2c
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[25]))), #<<---- patch litter_cs.litr3c
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[26]))), #<<---- patch litter_cs.litr4c
					
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[27]))), #<<---- patch soil_cs.soil1c
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[28]))), #<<---- patch soil_ns.sminn
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[29]))), #<<---- patch soil_ns.nitrate
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[30]))), #<<---- patch soil_cs.soil2c
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[31]))), #<<---- patch soil_cs.soil3c
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[32]))), #<<---- patch soil_cs.soil4c 
					
					
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[33]))), #<<---- patch #basestation
					as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[34]))) #<<---- # strate
				)
				
				#assume zone = patch = canopy_strata_ID
				num_strate = patchObj[34];
				for(si in 1:num_strate){
					line=readLines(con,n=55,warn=F)
					strateObj=c(
					
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[1]))), #<<---- # canopy ID
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[2]))), #<<---- # canopy plant ID
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[3]))), #<<---- # canopy cover fraction
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[4]))), #<<---- # canopy gap_fraction
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[5]))), #<<---- # canopy root_depth
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[6]))), #<<---- # canopy snow stored
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[7]))), #<<---- # canopy rain stored
						
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[8]))), #<<---- # canopy cs_cpool
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[9]))), #<<---- # canopy cs_leafc
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[10]))), #<<---- # canopy cs_dead_leafc
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[11]))), #<<---- # canopy cs_leafc_store
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[12]))), #<<---- # canopy cs_leafc_transfer
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[13]))), #<<---- # canopy cs_live_stemc
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[14]))), #<<---- # canopy cs_livestemc_store
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[15]))), #<<---- # canopy cs_livestemc_transfer
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[16]))), #<<---- # canopy cs_dead_stemc
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[17]))), #<<---- # canopy cs_deadstemc_store
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[18]))), #<<---- # canopy cs_deadstemc_transfer
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[19]))), #<<---- # canopy cs_live_crootc
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[20]))), #<<---- # canopy cs_livecrootc_store
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[21]))), #<<---- # canopy cs_livecrootc_transfer
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[22]))), #<<---- # canopy cs_dead_crootc
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[23]))), #<<---- # canopy cs_deadcrootc_store
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[24]))), #<<---- # canopy cs_deadcrootc_transfer			
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[25]))), #<<---- # canopy cs_frootc
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[26]))), #<<---- # canopy cs_frootc_store
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[27]))), #<<---- # canopy cs_frootc_transfer
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[28]))), #<<---- # canopy cs_cwdc
						
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[29]))), #<<---- # canopy epv.prev_leafcalloc [what is it?]
						
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[30]))), #<<---- # canopy ns_npool
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[31]))), #<<---- # canopy ns_leafn
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[32]))), #<<---- # canopy ns_dead_leafn
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[33]))), #<<---- # canopy ns_leafn_store
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[34]))), #<<---- # canopy ns_leafn_transfer
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[35]))), #<<---- # canopy ns_live_stemn
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[36]))), #<<---- # canopy ns_livestemn_store
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[37]))), #<<---- # canopy ns_livestemn_transfer
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[38]))), #<<---- # canopy ns_dead_stemn
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[39]))), #<<---- # canopy ns_deadstemn_store
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[40]))), #<<---- # canopy ns_deadstemn_transfer
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[41]))), #<<---- # canopy ns_live_crootn
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[42]))), #<<---- # canopy ns_livecrootn_store
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[43]))), #<<---- # canopy ns_livecrootn_transfer
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[44]))), #<<---- # canopy ns_dead_crootn
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[45]))), #<<---- # canopy ns_deadcrootn_store
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[46]))), #<<---- # canopy ns_deadcrootn_transfer			
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[47]))), #<<---- # canopy ns_frootn
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[48]))), #<<---- # canopy ns_frootn_store
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[49]))), #<<---- # canopy ns_frootn_transfer
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[50]))), #<<---- # canopy ns_cwdn
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[51]))), #<<---- # canopy ns_retransn [what is it?]
						
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[52]))), #<<---- # canopy epv_wstress_days [what is it?]
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[53]))), #<<---- # canopy epv_max_fparabs [what is it?]
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[54]))), #<<---- # canopy epv_max_fparabs [what is it?]
						as.numeric(gsub("[^0-9.-]","",gsub("[[:lower:]]\\..","",line[55]))) #<<---- # canopy # basestation
					)
					#tmp=c(basinObj,hillObj,zoneObj,patchObj,strateObj) 122
					#tmp=c(basinObj[c(1,3:9)],hillObj[1:8],zoneObj[1:13],patchObj[1:33],strateObj) 117
					
					write(
						c(basinObj[c(1,3:9)],hillObj[1:8],zoneObj[1:13],patchObj[1:33],strateObj),
						file=output,sep=",",ncolumns=117, append=T
					)
				}#si			
			}#pi
		}#zone
	}#hill
}#basin

close(con)

arg=commandArgs(T)

replaceNA0 = function(x,value){
	x[is.na(x) | x<=0] = value;
	return <- x;	
}#function
weightedAverage = function(xx,weight){
    new_weight = weight;
    new_weight[is.na(xx)] = 0;
    if( sum(new_weight)>0 ){
        return <- sum(xx * new_weight/sum(new_weight), na.rm=T)
    }else{
        return <- NA
    }
}#function
horizonOrder = c('O','A','E','B','C','R')
htitle = c('horizonThinkness','horizonMeanDepth','horizonTopDepth','horizonBottomDepth','sand','silt','clay','ksat','POR','BD','om','density','por_size_index','psi_air_entry','albedo')
horizonThicknessDefault = c(2, 5, 5, 10, 10, 10)*0.0254 #inches to meter; https://www.sheffield.ac.uk/ssa/soil-facts/horizons
soildepth_rtz_ratio = sum(horizonThicknessDefault)/sum(horizonThicknessDefault[1:5])
soildepth_act_ratio = sum(horizonThicknessDefault)/sum(horizonThicknessDefault[1:4])



horizons = read.csv(paste(arg[1],'/soil_mukey_texture.csv',sep=''),stringsAsFactors=F)
cat_mukey = read.csv(arg[2], stringsAsFactors=F, header=F)# use command "v.out.ascii"
colnames(cat_mukey) = c('x','y','cat','mukey')
LOCATION_cat_mukey = match(cat_mukey[,'mukey'], horizons[,'mukey']) ## cat(LOCATION) <-- mukey


what = data.frame(
	catid = cat_mukey[,'cat'],
	mukey = horizons[LOCATION_cat_mukey,'mukey'],
	# -- full	
	soil_texture = horizons[LOCATION_cat_mukey,'texture'], 
	soildepth = horizons[LOCATION_cat_mukey,'R_horizonBottomDepth'],
	soil_a_meanz = horizons[LOCATION_cat_mukey,'A_horizonMeanDepth'],
	soil_a_BD = horizons[LOCATION_cat_mukey,'A_BD'],
	soil_a_PD = horizons[LOCATION_cat_mukey,'A_density'],
	soil_a_POR = horizons[LOCATION_cat_mukey,'A_POR'],
	soil_a_ksat = horizons[LOCATION_cat_mukey,'A_ksat'],
	soil_a_por_size_index = horizons[LOCATION_cat_mukey,'A_por_size_index'],
	soil_a_psi_air_entry = horizons[LOCATION_cat_mukey,'A_psi_air_entry'],
	soil_b_meanz = horizons[LOCATION_cat_mukey,'B_horizonMeanDepth'],
	soil_b_BD = horizons[LOCATION_cat_mukey,'B_BD'],
	soil_b_PD = horizons[LOCATION_cat_mukey,'B_density'],
	soil_b_POR = horizons[LOCATION_cat_mukey,'B_POR'],
	soil_b_ksat = horizons[LOCATION_cat_mukey,'B_ksat'],
	soil_b_por_size_index = horizons[LOCATION_cat_mukey,'B_por_size_index'],
	soil_b_psi_air_entry = horizons[LOCATION_cat_mukey,'B_psi_air_entry'],
	soil_c_meanz = horizons[LOCATION_cat_mukey,'C_horizonMeanDepth'],
	soil_c_BD = horizons[LOCATION_cat_mukey,'C_BD'],
	soil_c_PD = horizons[LOCATION_cat_mukey,'C_density'],
	soil_c_POR = horizons[LOCATION_cat_mukey,'C_POR'],
	soil_c_ksat = horizons[LOCATION_cat_mukey,'C_ksat'],
	soil_c_por_size_index = horizons[LOCATION_cat_mukey,'C_por_size_index'],
	soil_c_psi_air_entry = horizons[LOCATION_cat_mukey,'C_psi_air_entry'],
	soil_c_thickness = horizons[LOCATION_cat_mukey,'C_horizonThinkness'],
	#soil_BD
	#soil_PD
	# soil_ksat0
	# soil_ksatdecay
	# soil_POR0
	# soil_PORdecay
	# -- upper layers
	soil_maxrootdepth = horizons[LOCATION_cat_mukey,'C_horizonBottomDepth'],
	soil_activedepth = horizons[LOCATION_cat_mukey,'B_horizonBottomDepth'],
	soil_a_albedo = horizons[LOCATION_cat_mukey,'A_albedo'],
	soil_a_thickness = horizons[LOCATION_cat_mukey,'A_horizonThinkness'],
	soil_a_om = horizons[LOCATION_cat_mukey,'A_om'],
	soil_a_sand = horizons[LOCATION_cat_mukey,'A_sand'],
	soil_a_clay = horizons[LOCATION_cat_mukey,'A_clay'],
	soil_a_silt = horizons[LOCATION_cat_mukey,'A_silt'],
	soil_b_thickness = horizons[LOCATION_cat_mukey,'B_horizonThinkness'],
	soil_b_om = horizons[LOCATION_cat_mukey,'B_om'],
	soil_b_sand = horizons[LOCATION_cat_mukey,'B_sand'],
	soil_b_clay = horizons[LOCATION_cat_mukey,'B_clay'],
	soil_b_silt = horizons[LOCATION_cat_mukey,'B_silt'],
    soil_c_om = horizons[LOCATION_cat_mukey,'C_om'],
	soil_r_thickness = horizons[LOCATION_cat_mukey,'R_horizonThinkness'],
	soil_r_active_ratio = (horizons[LOCATION_cat_mukey,'A_horizonThinkness']+horizons[LOCATION_cat_mukey,'B_horizonThinkness']+horizons[LOCATION_cat_mukey,'C_horizonThinkness']+horizons[LOCATION_cat_mukey,'R_horizonThinkness'])/(horizons[LOCATION_cat_mukey,'A_horizonThinkness']+horizons[LOCATION_cat_mukey,'B_horizonThinkness']),
    soil_r_maxrtz_ratio = (horizons[LOCATION_cat_mukey,'A_horizonThinkness']+horizons[LOCATION_cat_mukey,'B_horizonThinkness']+horizons[LOCATION_cat_mukey,'C_horizonThinkness']+horizons[LOCATION_cat_mukey,'R_horizonThinkness'])/(horizons[LOCATION_cat_mukey,'A_horizonThinkness']+horizons[LOCATION_cat_mukey,'B_horizonThinkness']+horizons[LOCATION_cat_mukey,'C_horizonThinkness'])
)# data.frame
cond = !is.na(what$soildepth) & !is.na(what$soil_maxrootdepth) & (what$soildepth < what$soil_maxrootdepth);sum(cond)
cond = !is.na(what$soildepth) & !is.na(what$soil_activedepth) & (what$soildepth < what$soil_activedepth);sum(cond)
cond = !is.na(what$soil_maxrootdepth) & !is.na(what$soil_activedepth) & (what$soil_maxrootdepth < what$soil_activedepth);sum(cond)
cond = !is.na(what$soildepth); sum(cond); dim(what)[1]
# what[cond,c('mukey','soildepth','soil_maxrootdepth','soil_activedepth')][1:10,]

what$check = sapply(seq_len(dim(what)[1]),function(ii){ sum(is.na(what[ii,]))>0 })
what_LEN = seq_len(dim(what)[1])
counting = 1
constrainedDist=1000
while(sum(what$check)>0){	
	finalTable = what
	print(paste('counting', counting, sum(what$check) ))
	for(ii in what_LEN[what$check]){
		dist = sqrt((cat_mukey[ii,'x']-cat_mukey[,'x'])^2 + (cat_mukey[ii,'y']-cat_mukey[,'y'])^2)
		weights = exp(-0.04*dist) * ifelse(dist>0 & dist<constrainedDist,1,0)
		cond = weights>0
        
        if(is.na(what$soil_texture[ii])){
            texturecount = tapply(weights[cond],what$soil_texture[cond],sum)
            finalTable $soil_texture[ii] = as.numeric(names(texturecount))[which.max(texturecount)]
        }#if
            
		if(is.na(what$soildepth[ii])) finalTable $soildepth[ii] = weightedAverage(what$soildepth[cond], weights[cond])
		if(is.na(what$soil_r_thickness[ii])) finalTable $soil_r_thickness[ii] = weightedAverage(what$soil_r_thickness[cond], weights[cond])
		if(is.na(what$soil_r_active_ratio[ii])) finalTable $soil_r_active_ratio[ii] = weightedAverage(what$soil_r_active_ratio[cond], weights[cond])
        if(is.na(what$soil_r_maxrtz_ratio[ii])) finalTable $soil_r_maxrtz_ratio[ii] = weightedAverage(what$soil_r_maxrtz_ratio[cond], weights[cond])
		
		if(is.na(what$soil_a_meanz[ii])) finalTable $soil_a_meanz[ii] = weightedAverage(what$soil_a_meanz[cond], weights[cond])
		if(is.na(what$soil_a_BD[ii])) finalTable $soil_a_BD[ii] = weightedAverage(what$soil_a_BD[cond], weights[cond])
		if(is.na(what$soil_a_PD[ii])) finalTable $soil_a_PD[ii] = weightedAverage(what$soil_a_PD[cond], weights[cond])
		if(is.na(what$soil_a_POR[ii])) finalTable $soil_a_POR[ii] = weightedAverage(what$soil_a_POR[cond], weights[cond])
		if(is.na(what$soil_a_ksat[ii])) finalTable $soil_a_ksat[ii] = weightedAverage(what$soil_a_ksat[cond], weights[cond])
		if(is.na(what$soil_a_por_size_index[ii])) finalTable $soil_a_por_size_index[ii] = weightedAverage(what$soil_a_por_size_index[cond], weights[cond])
		if(is.na(what$soil_a_psi_air_entry[ii])) finalTable $soil_a_psi_air_entry[ii] = weightedAverage(what$soil_a_psi_air_entry[cond], weights[cond])
		
		if(is.na(what$soil_b_meanz[ii])) finalTable $soil_b_meanz[ii] = weightedAverage(what$soil_b_meanz[cond], weights[cond])
		if(is.na(what$soil_b_BD[ii])) finalTable $soil_b_BD[ii] = weightedAverage(what$soil_b_BD[cond], weights[cond])
		if(is.na(what$soil_b_PD[ii])) finalTable $soil_b_PD[ii] = weightedAverage(what$soil_b_PD[cond], weights[cond])
		if(is.na(what$soil_b_POR[ii])) finalTable $soil_b_POR[ii] = weightedAverage(what$soil_b_POR[cond], weights[cond])
		if(is.na(what$soil_b_ksat[ii])) finalTable $soil_b_ksat[ii] = weightedAverage(what$soil_b_ksat[cond], weights[cond])
		if(is.na(what$soil_b_por_size_index[ii])) finalTable $soil_b_por_size_index[ii] = weightedAverage(what$soil_b_por_size_index[cond], weights[cond])
		if(is.na(what$soil_b_psi_air_entry[ii])) finalTable $soil_b_psi_air_entry[ii] = weightedAverage(what$soil_b_psi_air_entry[cond], weights[cond])
		
		if(is.na(what$soil_c_meanz[ii])) finalTable $soil_c_meanz[ii] = weightedAverage(what$soil_c_meanz[cond], weights[cond])
		if(is.na(what$soil_c_BD[ii])) finalTable $soil_c_BD[ii] = weightedAverage(what$soil_c_BD[cond], weights[cond])
		if(is.na(what$soil_c_PD[ii])) finalTable $soil_c_PD[ii] = weightedAverage(what$soil_c_PD[cond], weights[cond])
		if(is.na(what$soil_c_POR[ii])) finalTable $soil_c_POR[ii] = weightedAverage(what$soil_c_POR[cond], weights[cond])
		if(is.na(what$soil_c_ksat[ii])) finalTable $soil_c_ksat[ii] = weightedAverage(what$soil_c_ksat[cond], weights[cond])
		if(is.na(what$soil_c_por_size_index[ii])) finalTable $soil_c_por_size_index[ii] = weightedAverage(what$soil_c_por_size_index[cond], weights[cond])
		if(is.na(what$soil_c_psi_air_entry[ii])) finalTable $soil_c_psi_air_entry[ii] = weightedAverage(what$soil_c_psi_air_entry[cond], weights[cond])
		if(is.na(what$soil_c_thickness[ii])) finalTable $soil_c_thickness[ii] = weightedAverage(what$soil_c_thickness[cond], weights[cond])
		
		if(is.na(what$soil_maxrootdepth[ii])) finalTable $soil_maxrootdepth[ii] = weightedAverage(what$soil_maxrootdepth[cond], weights[cond])
		if(is.na(what$soil_activedepth[ii])) finalTable $soil_activedepth[ii] = weightedAverage(what$soil_activedepth[cond], weights[cond])
		
		if(is.na(what$soil_a_albedo[ii])) finalTable $soil_a_albedo[ii] = weightedAverage(what$soil_a_albedo[cond], weights[cond])
		if(is.na(what$soil_a_thickness[ii])) finalTable $soil_a_thickness[ii] = weightedAverage(what$soil_a_thickness[cond], weights[cond])
		if(is.na(what$soil_a_om[ii])) finalTable $soil_a_om[ii] = weightedAverage(what$soil_a_om[cond], weights[cond])
		if(is.na(what$soil_a_sand[ii])) finalTable $soil_a_sand[ii] = weightedAverage(what$soil_a_sand[cond], weights[cond])
		if(is.na(what$soil_a_clay[ii])) finalTable $soil_a_clay[ii] = weightedAverage(what$soil_a_clay[cond], weights[cond])
		if(is.na(what$soil_a_silt[ii])) finalTable $soil_a_silt[ii] = weightedAverage(what$soil_a_silt[cond], weights[cond])
		
		if(is.na(what$soil_b_thickness[ii])) finalTable $soil_b_thickness[ii] = weightedAverage(what$soil_b_thickness[cond], weights[cond])
		if(is.na(what$soil_b_om[ii])) finalTable $soil_b_om[ii] = weightedAverage(what$soil_b_om[cond], weights[cond])
		if(is.na(what$soil_b_sand[ii])) finalTable $soil_b_sand[ii] = weightedAverage(what$soil_b_sand[cond], weights[cond])
		if(is.na(what$soil_b_clay[ii])) finalTable $soil_b_clay[ii] = weightedAverage(what$soil_b_clay[cond], weights[cond])
		if(is.na(what$soil_b_silt[ii])) finalTable $soil_b_silt[ii] = weightedAverage(what$soil_b_silt[cond], weights[cond])
        
        if(is.na(what$soil_c_om[ii])) finalTable $soil_c_om[ii] = weightedAverage(what$soil_c_om[cond], weights[cond])
        ##----------- fixing rtz and soildepth, 4011
        # finalTable[ii,]
        finaldepth = max(
            finalTable$soil_maxrootdepth[ii] * finalTable$soil_r_maxrtz_ratio[ii],
            finalTable$soil_activedepth[ii] * finalTable$soil_r_active_ratio[ii],
            finalTable$soil_maxrootdepth[ii] * soildepth_rtz_ratio,
            finalTable$soil_activedepth[ii] * soildepth_act_ratio,
            finalTable$soildepth[ii], -1, na.rm=T)
        if(finaldepth>0){
            finalTable$soildepth[ii] = finaldepth
            finalTable$soil_r_thickness[ii] = finaldepth - finalTable$soil_maxrootdepth[ii]
            finalTable$soil_r_maxrtz_ratio[ii] = finalTable$soildepth[ii]/finalTable$soil_maxrootdepth[ii]
            finalTable$soil_r_active_ratio[ii] = finalTable$soildepth[ii]/finalTable$soil_activedepth[ii]
        }
      
    }#ii for
	finalTable $check = sapply(seq_len(dim(finalTable)[1]),function(ii){ sum(is.na(finalTable[ii,]))>0 })
	if(sum(finalTable $check)==sum(what $check)) constrainedDist=constrainedDist*1.5
	what = finalTable
	counting = counting+1
	
}#while
# write.csv(finalTable,'~/Downloads/test.csv',row.names=F) # debug
# sum(finalTable$soildepth < finalTable$soil_maxrootdepth)
# sum(finalTable$soildepth < finalTable$soil_activedepth)





active_wa = finalTable$soil_a_thickness/(finalTable$soil_a_thickness+finalTable$soil_b_thickness)
active_wb = 1 - active_wa

full_wa = finalTable$soil_a_thickness/(finalTable$soil_a_thickness+finalTable$soil_b_thickness+finalTable$soil_c_thickness)
full_wb = finalTable$soil_b_thickness/(finalTable$soil_a_thickness+finalTable$soil_b_thickness+finalTable$soil_c_thickness)
full_wc = 1 - full_wa - full_wb

	# debug:
	# range(finalTable$soil_a_meanz)
	# range(finalTable$soil_a_ksat)
	# range(finalTable$soil_a_POR)
	# range(finalTable$soil_a_om)
	
	# range(finalTable$soil_b_meanz)
	# range(finalTable$soil_b_ksat)
	# range(finalTable$soil_b_POR)
	# range(finalTable$soil_b_om) ##<---- 0 om
	
	# range(finalTable$soil_c_meanz)
	# range(finalTable$soil_c_ksat)
	# range(finalTable$soil_c_POR)
	# range(finalTable$soil_c_om) ##<---- 0 om
	
profileRates = do.call(rbind, lapply(what_LEN, function(ii){
	profile = data.frame(
		z = c(finalTable$soil_a_meanz[ii],finalTable$soil_b_meanz[ii],finalTable$soil_c_meanz[ii]),
		ksat = c(finalTable$soil_a_ksat[ii], finalTable$soil_b_ksat[ii], finalTable$soil_c_ksat[ii]),
		por = c(finalTable$soil_a_POR[ii], finalTable$soil_b_POR[ii], finalTable$soil_c_POR[ii]),
        om = c(finalTable$soil_a_om[ii], finalTable$soil_b_om[ii], finalTable$soil_c_om[ii])
	)#
	if(sum(profile$ksat<=0)>0){ print(paste('soil profile',ii,'has 0 ksat')); profile$ksat[profile$ksat<=0]=0.0001; }
	if(sum(profile$por <=0)>0){ print(paste('soil profile',ii,'has 0 por' )); profile$por[profile$por <=0]=0.0001; }
	if(sum(profile$om<=0)>0){ profile$om[profile$om<=0]=0.00001; }
	ksat_log = log(profile$ksat)
	por_log = log(profile$por)
	om_log = log(profile$om)
	
	ksat_cof = lm(ksat_log~z,profile)$coefficient
	por_cof = lm(por_log~z,profile)$coefficient
    om_cof = lm(om_log~z,profile)$coefficient
	return <- unlist(list(
		ksat0 = exp(ksat_cof[1]),
		ksatdecay = ifelse(abs(1/ksat_cof[2])>4000,4000,-1/ksat_cof[2]),
		por0 = exp(por_cof[1]),
		pordecay = ifelse(abs(1/por_cof[2])>4000,4000,-1/por_cof[2]),
        om0 = exp(om_cof[1]),
        omdecay = ifelse(abs(1/om_cof[2])>4000,4000,-1/om_cof[2])
	))# 
}))#
mean_ksat = finalTable$soil_a_ksat*full_wa + finalTable$soil_b_ksat*full_wb + finalTable$soil_c_ksat*full_wc
mean_por = finalTable$soil_a_POR*full_wa + finalTable$soil_b_POR*full_wb + finalTable$soil_c_POR*full_wc

# adjust for rhessys
#cond = profileRates[,2]<0; profileRates[cond,1]= mean_ksat[cond]; # cbind(profileRates[cond,1], mean_ksat[cond])
#cond = profileRates[,4]<0;
#profileRates[cond,3]= mean_por[cond]; # cbind(profileRates[cond,3], mean_por[cond])
#profileRates[cond,4]= 4000


rhessys_soil_table = data.frame(
	cat = finalTable$catid,
	mukey = finalTable$mukey,
	texture = finalTable$soil_texture,
	soildepth = finalTable$soildepth,
	albedo = finalTable$soil_a_albedo,
	activedepth = finalTable$soil_activedepth,
	maxrootdepth = finalTable$soil_maxrootdepth,
	
	sand = finalTable$soil_a_sand*active_wa + finalTable$soil_b_sand*active_wb,
	clay = finalTable$soil_a_clay*active_wa + finalTable$soil_b_clay*active_wb,
	silt = finalTable$soil_a_silt*active_wa + finalTable$soil_b_silt*active_wb,
	om = finalTable$soil_a_om + finalTable$soil_b_om, # kgC/m2
    omdecay = profileRates[,6],
	
	bulkdensity = finalTable$soil_a_BD*full_wa + finalTable$soil_b_BD*full_wb + finalTable$soil_c_BD*full_wc,
	por_size_index = finalTable$soil_a_por_size_index*full_wa + finalTable$soil_b_por_size_index*full_wb + finalTable$soil_c_por_size_index*full_wc,
	psi_air_entry = finalTable$soil_a_psi_air_entry*full_wa + finalTable$soil_b_psi_air_entry*full_wb + finalTable$soil_c_psi_air_entry*full_wc,
	particledensity = finalTable$soil_a_PD*full_wa + finalTable$soil_b_PD*full_wb + finalTable$soil_c_PD*full_wc,
	
	ksat0 = profileRates[,1],
	ksatdecay = profileRates[,2],
	por0 = profileRates[,3],
	pordecay = profileRates[,4]
	)# data.frame
	


write.csv(rhessys_soil_table,arg[3], row.names=F)

arg=commandArgs(T)

library(sp)
library(XML)
library(rgrass7)
library(rgdal)
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})

rast = readRAST(arg[1])
soil_rhessys = read.csv(arg[2], stringsAsFactors=F)

	
	# sorting matched mukey to the map organization
	cond2 = match(rast@data[[1]], soil_rhessys[,'cat'])
	if(length(arg)>2){ suffix = arg[3]; } else { suffix=''; }
    # texture class
    rast$soil_texture = as.integer(soil_rhessys[cond2,'texture']); writeRAST(rast,paste('soil_texture',suffix,sep=''),zcol='soil_texture',overwrite=T)
	
	# other variables
	rast$soil_texture = soil_rhessys[cond2,'ksat0']; writeRAST(rast,paste('soil_ksat_0',suffix,sep=''),zcol='soil_texture',overwrite=T)
	
	rast$soil_texture = soil_rhessys[cond2,'ksatdecay']; writeRAST(rast,paste('soil_ksat_decay',suffix,sep=''),zcol='soil_texture',overwrite=T)
	
	rast$soil_texture = soil_rhessys[cond2,'por0']; writeRAST(rast,paste('soil_por_0',suffix,sep=''),zcol='soil_texture',overwrite=T)
	
	rast$soil_texture = soil_rhessys[cond2,'pordecay']; writeRAST(rast,paste('soil_por_decay',suffix,sep=''),zcol='soil_texture',overwrite=T)
	
	rast$soil_texture = soil_rhessys[cond2,'sand']; writeRAST(rast,paste('soil_sand',suffix,sep=''),zcol='soil_texture',overwrite=T)

	rast$soil_texture = soil_rhessys[cond2,'silt']; writeRAST(rast,paste('soil_silt',suffix,sep=''),zcol='soil_texture',overwrite=T)
	
	rast$soil_texture = soil_rhessys[cond2,'clay']; writeRAST(rast,paste('soil_clay',suffix,sep=''),zcol='soil_texture',overwrite=T)
	
	rast$soil_texture = soil_rhessys[cond2,'bulkdensity']; writeRAST(rast,paste('soil_bulkdensity',suffix,sep=''),zcol='soil_texture',overwrite=T)

    rast$soil_texture = soil_rhessys[cond2,'particledensity']; writeRAST(rast,paste('soil_particledensity',suffix,sep=''),zcol='soil_texture',overwrite=T)

    rast$soil_texture = soil_rhessys[cond2,'om']; writeRAST(rast,paste('soil_soilc',suffix,sep=''),zcol='soil_texture',overwrite=T)

    rast$soil_texture = soil_rhessys[cond2,'omdecay']; writeRAST(rast,paste('soil_omdecay',suffix,sep=''),zcol='soil_texture',overwrite=T)

	rast$soil_texture = soil_rhessys[cond2,'soildepth']; writeRAST(rast,paste('soil_soildepth',suffix,sep=''),zcol='soil_texture',overwrite=T)

    rast$soil_texture = soil_rhessys[cond2,'activedepth']; writeRAST(rast,paste('soil_activedepth',suffix,sep=''),zcol='soil_texture',overwrite=T)
    
    rast$soil_texture = soil_rhessys[cond2,'maxrootdepth']; writeRAST(rast,paste('soil_maxrootdepth',suffix,sep=''),zcol='soil_texture',overwrite=T)

    rast$soil_texture = soil_rhessys[cond2,'albedo']; writeRAST(rast,paste('soil_albedo',suffix,sep=''),zcol='soil_texture',overwrite=T)

    rast$soil_texture = soil_rhessys[cond2,'por_size_index']; writeRAST(rast,paste('soil_por_size_index',suffix,sep=''),zcol='soil_texture',overwrite=T)

    rast$soil_texture = soil_rhessys[cond2,'psi_air_entry']; writeRAST(rast,paste('soil_psi_air_entry',suffix,sep=''),zcol='soil_texture',overwrite=T)

arg=commandArgs(T)

w = read.csv(arg[1])
output = data.frame(lulcCode = as.numeric( gsub('[a-z]','',colnames(w)[-1:-2]) ))
output$lulcComposition_forest = rep(0,dim(output)[1])
output$lulcComposition_shrub = rep(0,dim(output)[1])
output$lulcComposition_crop = rep(0,dim(output)[1])
output$lulcComposition_lawn = rep(0,dim(output)[1])
output$lulcComposition_imp = rep(0,dim(output)[1])
output$impBreakdownFrac_roof = rep(0,dim(output)[1])
output$impBreakdownFrac_driveway = rep(0,dim(output)[1])
output$impBreakdownFrac_pavedRoad = rep(0,dim(output)[1])
write.csv(output,arg[2],row.names=F)

options(scipen=999)
library(sp)
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})
library(XML)
library(rgrass7)
rast = readRAST(c('basin','str','LULCcode'))
mask = !is.na(rast@data[[1]])
str = rast@data[[2]][mask]
lulc = rast@data[[3]][mask]

rast$vegid = rep(NA,length(mask))
rast$landuse = rep(NA,length(mask))
rast$lai = rep(NA,length(mask))
rast$impervious = rep(NA,length(mask))
rast$coverFrac = rep(NA,length(mask))

#--- forest
    cond=(lulc==41 | lulc==43 | lulc==90 | lulc==95) & is.na(str); 
    rast$vegid[mask][cond] = as.integer(2) # deciduous @ vegCollection.csv
    rast$landuse[mask][cond] = as.integer(2) # undeveloped @ lulcCollection.csv
    rast$coverFrac[mask][cond] = 1.0
    rast$lai[mask][cond] = 4.5
    rast$impervious[mask][cond] = 0.0

    cond=(lulc==42) & is.na(str); 
    rast$vegid[mask][cond] = as.integer(1) # evergreen @ vegCollection.csv 
    rast$landuse[mask][cond] = as.integer(2) # undeveloped @ lulcCollection.csv
    rast$coverFrac[mask][cond] = 1.0
    rast$lai[mask][cond] = 5.0
    rast$impervious[mask][cond] = 0.0

    cond=(lulc==51 | lulc==52) & is.na(str); 
    rast$vegid[mask][cond] = as.integer(6) # shrub @ vegCollection.csv 
    rast$landuse[mask][cond] = as.integer(2) # undeveloped @ lulcCollection.csv
    rast$coverFrac[mask][cond] = 1.0
    rast$lai[mask][cond] = 2
    rast$impervious[mask][cond] = 0.0

#--- pasture / grass / agriculture 
    cond=(lulc==71 | lulc==72 | lulc==81 | lulc==82) & is.na(str); 
    rast$vegid[mask][cond] = as.integer(3) # grass @ vegCollection.csv 
    rast$landuse[mask][cond] = as.integer(1) # grass @ lulcCollection.csv
    rast$coverFrac[mask][cond] = 1.0
    rast$lai[mask][cond] = 1.5
    rast$impervious[mask][cond] = 0.0

#--- urban / barren
    cond=(lulc==31) & is.na(str); 
    rast$vegid[mask][cond] = as.integer(6) # shrub @ vegCollection.csv (may vary by state/county/city/local)
    rast$landuse[mask][cond] = as.integer(2) # undeveloped @ lulcCollection.csv
    rast$coverFrac[mask][cond] = 0.15 # 15% grass/lawn
    rast$lai[mask][cond] = 3.0
    rast$impervious[mask][cond] = 0.85

    cond=(lulc==21) & is.na(str); 
    rast$vegid[mask][cond] = as.integer(3) # grass @ vegCollection.csv (may vary by state/county/city/local)
    rast$landuse[mask][cond] = as.integer(3) # urban @ lulcCollection.csv
    rast$coverFrac[mask][cond] = 0.8 # 80% grass/lawn
    rast$lai[mask][cond] = 1.5
    rast$impervious[mask][cond] = 0.2

    cond=(lulc==22) & is.na(str); 
    rast$vegid[mask][cond] = as.integer(3) # grass @ vegCollection.csv (may vary by state/county/city/local)
    rast$landuse[mask][cond] = as.integer(3) # urban @ lulcCollection.csv
    rast$coverFrac[mask][cond] = 0.5 # 50% grass/lawn
    rast$lai[mask][cond] = 1.5
    rast$impervious[mask][cond] = 0.5

    cond=(lulc==23) & is.na(str); 
    rast$vegid[mask][cond] = as.integer(3) # grass @ vegCollection.csv (may vary by state/county/city/local)
    rast$landuse[mask][cond] = as.integer(3) # urban @ lulcCollection.csv
    rast$coverFrac[mask][cond] = 0.2 # 20% grass/lawn
    rast$lai[mask][cond] = 1.5
    rast$impervious[mask][cond] = 0.8

    cond=(lulc==24) & is.na(str); 
    rast$vegid[mask][cond] = as.integer(4) # no-veg @ vegCollection.csv (may vary by state/county/city/local)
    rast$landuse[mask][cond] = as.integer(3) # urban @ lulcCollection.csv
    rast$coverFrac[mask][cond] = 1.0
    rast$lai[mask][cond] = 1.0
    rast$impervious[mask][cond] = 1.0

    cond= !is.na(str); 
    rast$vegid[mask][cond] = as.integer(4) # no-veg @ vegCollection.csv (may vary by state/county/city/local)
    rast$landuse[mask][cond] = as.integer(2) # undeveloped @ lulcCollection.csv
    rast$coverFrac[mask][cond] = 1.0
    rast$lai[mask][cond] = 0.0
    rast$impervious[mask][cond] = 0.0

writeRAST(rast,'vegid',zcol='vegid',overwrite=T)
writeRAST(rast,'landuse',zcol='landuse',overwrite=T)
writeRAST(rast,'coverFrac',zcol='coverFrac',overwrite=T)
writeRAST(rast,'lai',zcol='lai',overwrite=T)
writeRAST(rast,'impervious',zcol='impervious',overwrite=T)

arg=commandArgs(T)


library(sp)
library(XML)
library(rgrass7)
library(rgdal)
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})

rast = readRAST('soil_ssurgo')
soil_cat_mukey = arg[1] 
soil_mukey_texture = arg[2]
if(length(arg)>2){ suffix = arg[3]; } else { suffix=''; }

cat_mukey = read.csv(soil_cat_mukey, stringsAsFactors=F,header=F)
if( is.numeric(cat_mukey[1,1]) ){
    colnames(cat_mukey) = c('x','y','cat','MUKEY')
}else{
    cat_mukey = read.csv(soil_cat_mukey, stringsAsFactors=F)
}

mukey_texture = read.csv(soil_mukey_texture, stringsAsFactors=F)
	
	# matching SSURGO dataset product to the mapping mukey
	cond = match(cat_mukey[,'MUKEY'],mukey_texture[,'mukey'])
	cat_texture = mukey_texture[cond,'rhessys_soilid']
	
	# sorting matched mukey to the map organization
	cond2 = match(rast@data[[1]], cat_mukey[,'cat'])
	rast$soil_texture = as.integer(cat_texture[cond2]); writeRAST(rast,paste('soil_texture',suffix,sep=''),zcol='soil_texture',overwrite=T)

## single basin
## sub-patch/grid setting
#----------------------------------------------------------------------------------------------
source('LIB_misc.R')
	options(scipen=999)
    arg = commandArgs(T)

    DtoR = pi/180
	RtoD = 1/DtoR
    BASEMENT_DEPTH = 3 #meter
    PAVEDROAD_DEPTH = 0 #0.3 #meter

    # initial worldfile write out
    defaultWorldName = c('world_ID')
	defaultBasinName = c('basin_ID','x','y','z','latitude')
	defaultHillName = c('hillslope_ID','x','y','z')
	defaultZoneName = c('zone_ID','x','y','z','area','slope','aspect','precip_lapse_rate','e_horizon','w_horizon','base_station_ID')
	defaultPatchName = c('patch_ID','x','y','z','soil_parm_ID','landuse_parm_ID','area','slope','lna','Ksat_vertical')

	defaultStratumName = c(
        'canopy_strata_ID',
        'veg_parm_ID',
        'cover_fraction',
        'gap_fraction',
        'rootzone.depth',
        'snow_stored',
        'rain_stored',
        'cs.cpool',
        'cs.leafc','cs.dead_leafc','cs.leafc_store','cs.leafc_transfer',
        'cs.live_stemc','cs.livestemc_store','cs.livestemc_transfer',
        'cs.dead_stemc','cs.deadstemc_store','cs.deadstemc_transfer',
        'cs.live_crootc','cs.livecrootc_store','cs.livecrootc_transfer',
        'cs.dead_crootc','cs.deadcrootc_store','cs.deadcrootc_transfer',
        'cs.frootc','cs.frootc_store','cs.frootc_transfer',
        'cs.cwdc',
        'epv.prev_leafcalloc',
        'ns.npool',
        'ns.leafn','ns.dead_leafn','ns.leafn_store','ns.leafn_transfer',
        'ns.live_stemn','ns.livestemn_store','ns.livestemn_transfer',
        'ns.dead_stemn','ns.deadstemn_store','ns.deadstemn_transfer',
        'ns.live_crootn','ns.livecrootn_store','ns.livecrootn_transfer',
        'ns.dead_crootn','ns.deadcrootn_store','ns.deadcrootn_transfer',
        'ns.frootn','ns.frootn_store','ns.frootn_transfer',
        'ns.cwdn',
        'ns.retransn',
        'epv.wstress_days',
        'epv.max_fparabs',
        'epv.min_vwc')
	#title = c(defaultWorldName, defaultBasinName, defaultHillName, defaultZoneName, defaultPatchName, defaultStratumName)
	

#----------------------------------------------------------------------------------------------

    library(sp)
    library(XML)
    library(rgrass7)
    library(rgdal)
    tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})
    gis = gmeta()
    gridarea = round(gis$nsres * gis$ewres)

    #read template
    # (this part can be read in from stationList.csv)
    # https://stackoverflow.com/questions/17288197/reading-a-csv-file-organized-horizontally
    # modified by Lin June 23 2018
    read.tcsv = function(file, header=T, sep=" ", vskip=0, hskip=0, len=-1, ncolReadin=0, ncolReadout=0, ...) {
        # x = readLines(file)
        # .splitvar = function(x, sep, n) {
        #     var = unlist(strsplit(x, split=sep))
        #     length(var) = n
        #     return(var)
        # }#function
        # x = do.call(cbind, lapply(x[(vskip+1):endline], .splitvar, sep=sep, n=n))
        # x = apply(x[(hskip+1):dim(x)[1],], 1, paste, collapse=sep)
        # out = read.csv(text=x, sep=sep, header=header, skip=0, ...)
        if(ncolReadin>0){
            x = read.table(file, sep=sep, fill=T, stringsAsFactors=F, col.names=seq_len(ncolReadin));
            n = ncolReadin;
        }else{
            x = read.table(file, sep=sep, fill=T, stringsAsFactors=F);
            rowCountFields = count.fields(file, sep=sep);
            if(vskip>0) rowCountFields = rowCountFields[-1:-vskip];
            n = max( rowCountFields, na.rm=TRUE);
        }
        if(ncolReadout>0){
            n = min(hskip+1+ncolReadout,n)
        }
        endline = dim(x)[1]
        if(len>0) endline = vskip+len
        transformedX = sapply( (hskip+1):n, function(ii){
        	paste( x[(vskip+1):endline, ii], collapse=',')
        });
        out = read.csv(text=transformedX, sep=',', header=header, skip=0, ...)
        
        return(out)
    }#function
    print(arg)
    
    headerEndLine = max(grep('projdir|output|Collection',readLines(arg[1]))); print(headerEndLine)
    templateACTION = read.tcsv(ifelse(length(arg)==5,arg[5],arg[1]),stringsAsFactors=F, len=headerEndLine,ncolReadin=3);
    template = read.tcsv(ifelse(length(arg)==5,arg[5],arg[1]),stringsAsFactors=F, vskip=headerEndLine, ncolReadin=3, ncolReadout=1);

    projectFolder = ifelse(length(arg)==5, arg[1], templateACTION$projdir[1])
    climateStationID = as.numeric(template$stationID[1])
	climateStationNAME = template$stationFile[1] # prefix-like (single station)
	
		
	## user provides a customized vegetation.csv containing all vegetation vegParameters.
    if(length(arg)==5){
        ParamFileName= ifelse(arg[2]=='default'|arg[2]=='NA'|arg[2]=='na'|arg[2]=='.','vegCollection.csv', arg[2])
    }else{
        ParamFileName = templateACTION$vegCollection[1];
    }
	vegParam = read.csv(ParamFileName,skip=4,header=T,stringsAsFactors=F) #<<------
	vegParamCOL = cbind(as.numeric(unique(vegParam[1,3:ncol(vegParam)])), 3:ncol(vegParam)); 
	colnames(vegParamCOL) = c('vegID','vegDefIndex')
    print(colnames(vegParamCOL))
	vegParam_len = ncol(vegParam)
	

    if(length(arg)==5){
        ParamFileName= ifelse(arg[3]=='default'|arg[3]=='NA'|arg[3]=='na'|arg[3]=='.','soilCollection.csv', arg[3])
    }else{
        ParamFileName = templateACTION$soilCollection[1];
    }
	soilParam = read.csv(ParamFileName,skip=4,header=T,stringsAsFactors=F) #<<------
	soilParamCOL = cbind(as.numeric(unique(soilParam[1,3:ncol(soilParam)])), 3:ncol(soilParam)); 
	colnames(soilParamCOL) = c('soilID','soilDefIndex')
	soilParam_len = ncol(soilParam)
	
    if(length(arg)==5){
        ParamFileName= ifelse(arg[4]=='default'|arg[4]=='NA'|arg[4]=='na'|arg[4]=='.','lulcCollectionEC.csv', arg[4])
    }else{
        ParamFileName = templateACTION$lulcCollection[1];
    }
	lulcParam = read.csv(ParamFileName,skip=4,header=T,stringsAsFactors=F) #<<------
	lulcParamCOL = cbind(as.numeric(unique(lulcParam[1,3:ncol(lulcParam)])), 3:ncol(lulcParam)); 
	colnames(lulcParamCOL) = c('lulcID','lulcDefIndex')
	lulcParam_len = ncol(lulcParam)


    ParamFileName = ifelse(is.null(templateACTION$hillCollection[1]),'hillCollection.csv',templateACTION$hillCollection[1])
    hillParam = read.csv(ParamFileName,skip=4,header=T,stringsAsFactors=F) #<<------
    hillParamCOL = cbind(as.numeric(unique(hillParam[1,3:ncol(hillParam)])), 3:ncol(hillParam));
    colnames(hillParamCOL) = c('hillID','hillDefIndex')
    hillParam_len = ncol(hillParam)

    ParamFileName = ifelse(is.null(templateACTION$zoneCollection[1]),'zoneCollection.csv',templateACTION$zoneCollection[1])
    zoneParam = read.csv(ParamFileName,skip=4,header=T,stringsAsFactors=F) #<<------
    zoneParamCOL = cbind(as.numeric(unique(zoneParam[1,3:ncol(zoneParam)])), 3:ncol(zoneParam));
    colnames(zoneParamCOL) = c('zoneID','zoneDefIndex')
    zoneParam_len = ncol(zoneParam)
	
#----------------------------------------------------------------------------------------------

    ## spatial structures (must have)
	rast = readRAST(c(template$basinMap, template$hillslopeMap, template$zoneMAP, template$patchMAP),NODATA=0)
		mask = !is.na(rast@data[[1]])
		hill = rast@data[[2]][mask]
		zone = rast@data[[3]][mask]
		patch = rast@data[[4]][mask]
        emptyMAP = rep(NA,sum(mask))
	print('reading basin, hill, zone, patch ... DONE')
	
	##--------- climate station (assume one zone for one station)
	if(is.na(climateStationID)){
        # climateStationID = as.numeric(template$stationID[1]) above; if it's not a single integer, then it's NA
        rast = readRAST(template$stationID[1])
		climateStationID = rast@data[[1]][mask]
        print(paste('multiple base stations',template$stationID[1],'...DONE'))
	}else{
		climateStationID = rep(as.numeric(template$stationID[1]), sum(mask))
	}#if else
	
    ## GW
    hillDefID=NULL;tryCatch({
           tmpnum = as.numeric(template$hillDefID)
           if(is.na(tmpnum)){
               rast = readRAST(template$hillDefID);
               hillDefID <- tapply(rast@data[[1]][mask],INDEX=hill, FUN=most)
           }else{
               hillDefID <- rep(tmpnum, length(unique(hill)))
           }},
           error = function(e){ }
           )#tryCatch
    hillGWiniQ=NULL;tryCatch({
        tmpnum = as.numeric(template$GWiniStorage)
        if(is.na(tmpnum)){
            rast = readRAST(template$GWiniStorage);
            hillGWiniQ <- tapply(rast@data[[1]][mask],INDEX=hill, FUN=mean)
        }else{
            hillGWiniQ <- rep(tmpnum, length(unique(hill)))
        }},
        error = function(e){ }
        )#tryCatch
    hillGWiniNO3=NULL;tryCatch({
        tmpnum = as.numeric(template$GWiniNO3)
        if(is.na(tmpnum)){
            rast = readRAST(template$GWiniStorage);
            hillGWiniNO3 <- tapply(rast@data[[1]][mask],INDEX=hill, FUN=mean)
        }else{
            hillGWiniNO3 <- rep(tmpnum, length(unique(hill)))
        }},
        error = function(e){ }
        )#tryCatch
    hillGWiniNH4=NULL;tryCatch({
        tmpnum = as.numeric(template$GWiniNH4)
        if(is.na(tmpnum)){
            rast = readRAST(template$GWiniStorage);
            hillGWiniNH4 <- tapply(rast@data[[1]][mask],INDEX=hill, FUN=mean)
        }else{
            hillGWiniNH4 <- rep(tmpnum, length(unique(hill)))
        }},
        error = function(e){ }
        )#tryCatch
    hillGWiniDOC=NULL;tryCatch({
        tmpnum = as.numeric(template$GWiniDOC)
        if(is.na(tmpnum)){
            rast = readRAST(template$GWiniStorage);
            hillGWiniDOC <- tapply(rast@data[[1]][mask],INDEX=hill, FUN=mean)
        }else{
            hillGWiniDOC <- rep(tmpnum, length(unique(hill)))
        }},
        error = function(e){ }
        )#tryCatch
    hillGWiniDON=NULL;tryCatch({
        tmpnum = as.numeric(template$GWiniDON)
        if(is.na(tmpnum)){
            rast = readRAST(template$GWiniStorage);
            hillGWiniDON <- tapply(rast@data[[1]][mask],INDEX=hill, FUN=mean)
        }else{
            hillGWiniDON <- rep(tmpnum, length(unique(hill)))
        }},
        error = function(e){ }
        )#tryCatch
    print('reading hillGWiniQ, hillGWiniNO3, hillGWiniNH4, hillGWiniDOC, hillGWiniDON ... DONE')
	


    zoneDefID=NULL;tryCatch({
        tmpnum = as.numeric(template$zoneDefID)
        if(is.na(tmpnum)){
            rast = readRAST(template$zoneDefID);
            zoneDefID <- tapply(rast@data[[1]][mask],INDEX=zone, FUN=most)
        }else{
            zoneDefID <- rep(tmpnum, length(unique(zone)))
        }},
        error = function(e){ }
        )#tryCatch

    
	# extract soil def IDs; how to handle catchments that have no data?
    rast = readRAST(template$soiltexture,NODATA=0)
        soiltexture = rast@data[[1]][mask]
        
    soil_extID=NULL;tryCatch({
        tmpnum = as.numeric(template$soilidMAP)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilidMAP);
            soil_extID <- rast@data[[1]][mask]
        }else{
            soil_extID <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soil_extID <<- soiltexture }
        )#tryCatch
    soilksat0=NULL;tryCatch({
        tmpnum = as.numeric(template$soilksat0)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilksat0);
            soilksat0 <- rast@data[[1]][mask]
        }else{
            soilksat0 <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilksat0 <<- emptyMAP }
        )#tryCatch
    soilksatdecay=NULL;tryCatch({
        tmpnum = as.numeric(template$soilksatdecay)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilksatdecay);
            soilksatdecay <- rast@data[[1]][mask]
        }else{
            soilksatdecay <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilksatdecay <<- emptyMAP }
        )#tryCatch
    soilpor0=NULL;tryCatch({
        tmpnum = as.numeric(template$soilpor0)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilpor0);
            soilpor0 <- rast@data[[1]][mask]
        }else{
            soilpor0 <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilpor0 <<- emptyMAP }
        )#tryCatch
    soilpordecay=NULL;tryCatch({
        tmpnum = as.numeric(template$soilpordecay)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilpordecay);
            soilpordecay <- rast@data[[1]][mask]
        }else{
            soilpordecay <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilpordecay <<- emptyMAP }
        )#tryCatch
    soilsand=NULL;tryCatch({
        tmpnum = as.numeric(template$soilsand)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilsand);
            soilsand <- rast@data[[1]][mask]
        }else{
            soilsand <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilsand <<- emptyMAP }
        )#tryCatch
    soilsilt=NULL;tryCatch({
        tmpnum = as.numeric(template$soilsilt)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilsilt);
            soilsilt <- rast@data[[1]][mask]
        }else{
            soilsilt <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilsilt <<- emptyMAP }
        )#tryCatch
    soilclay=NULL;tryCatch({
        tmpnum = as.numeric(template$soilclay)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilclay);
            soilclay <- rast@data[[1]][mask]
        }else{
            soilclay <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilclay <<- emptyMAP }
        )#tryCatch
    soilbulkdensity=NULL;tryCatch({
        tmpnum = as.numeric(template$soilbulkdensity)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilbulkdensity);
            soilbulkdensity <- rast@data[[1]][mask]
        }else{
            soilbulkdensity <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilbulkdensity <<- emptyMAP }
        )#tryCatch
    soilparticledensity=NULL;tryCatch({
        tmpnum = as.numeric(template$soilparticledensity)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilparticledensity);
            soilparticledensity <- rast@data[[1]][mask]
        }else{
            soilparticledensity <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilparticledensity <<- emptyMAP }
        )#tryCatch
    soilsoildepth=NULL;tryCatch({
        tmpnum = as.numeric(template$soilsoildepth)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilsoildepth);
            soilsoildepth <- rast@data[[1]][mask]
        }else{
            soilsoildepth <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilsoildepth <<- emptyMAP }
        )#tryCatch
    soilactivedepth=NULL;tryCatch({
        tmpnum = as.numeric(template$soilactivedepth)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilactivedepth);
            soilactivedepth <- rast@data[[1]][mask]
        }else{
            soilactivedepth <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilactivedepth <<- emptyMAP }
        )#tryCatch
    soilmaxrootdepth=NULL;tryCatch({
        tmpnum = as.numeric(template$soilmaxrootdepth)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilmaxrootdepth);
            soilmaxrootdepth <- rast@data[[1]][mask]
        }else{
            soilmaxrootdepth <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilmaxrootdepth <<- emptyMAP }
        )#tryCatch
    soilalbedo=NULL;tryCatch({
        tmpnum = as.numeric(template$soilalbedo)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilalbedo);
            soilalbedo <- rast@data[[1]][mask]
        }else{
            soilalbedo <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilalbedo <<- emptyMAP }
        )#tryCatch
    soilpor_size_index=NULL;tryCatch({
        tmpnum = as.numeric(template$soilpor_size_index)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilpor_size_index);
            soilpor_size_index <- rast@data[[1]][mask]
        }else{
            soilpor_size_index <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilpor_size_index <<- emptyMAP }
        )#tryCatch
    soilpsi_air_entry=NULL;tryCatch({
        tmpnum = as.numeric(template$soilpsi_air_entry)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilpsi_air_entry);
            soilpsi_air_entry <- rast@data[[1]][mask]
        }else{
            soilpsi_air_entry <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilpsi_air_entry <<- emptyMAP }
        )#tryCatch
    soilsoilc=NULL;tryCatch({
        tmpnum = as.numeric(template$soilsoilc)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilsoilc);
            soilsoilc <- rast@data[[1]][mask]
        }else{
            soilsoilc <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilsoilc <<- emptyMAP }
        )#tryCatch
    soilomdecay=NULL;tryCatch({
        tmpnum = as.numeric(template$soilomdecay)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilomdecay);
            soilomdecay <- rast@data[[1]][mask]
        }else{
            soilomdecay <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ soilomdecay <<- emptyMAP }
        )#tryCatch
    soilLegecyCNScaler=NULL;tryCatch({
        tmpnum = as.numeric(template$soilLegecyCNScaler)
        if(is.na(tmpnum)){
            rast = readRAST(template$soilLegecyCNScaler);
            soilLegecyCNScaler <- tapply(rast@data[[1]][mask],INDEX=patch, FUN=mean)
        }else{
            soilLegecyCNScaler <- rep(tmpnum, length(unique(patch)))
        }},
        error = function(e){ }
        )#tryCatch
    print('reading soils ... DONE')

    # extract RHESSys LULC IDs
    LULCID=NULL;tryCatch({
        tmpnum = as.numeric(template$LULCidMAP)
        if(is.na(tmpnum)){
            rast = readRAST(template$LULCidMAP);
            LULCID <- rast@data[[1]][mask]
        }else{
            LULCID <- rep(tmpnum, sum(mask))
        }},
        error = function(e){ LULCID <<- emptyMAP }
        )#tryCatch


	# extract patch positive numerical values [0 -> +X] (must have)
    # aspect ##<<----- 90=north, 360=east, 180=west 270=south
	rast = readRAST(c(template$xMAP, template$yMAP, template$demMAP, template$slopeMap, template$aspectMAP, template$twiMAP, template$whorizonMAP, template$ehorizonMAP, template$isohyetMAP), NODATA=-1)
		xx = rast@data[[1]][mask]
		yy = rast@data[[2]][mask]
		dem = rast@data[[3]][mask]
		slope = rast@data[[4]][mask] ## ... could be a problem at the edge of the DEM
		aspect = rast@data[[5]][mask] ## ... could be a problem at the edge of the DEM 
		twi = rast@data[[6]][mask] ## ... could be a problem at the edge of the DEM
		whorizon = rast@data[[7]][mask]
		ehorizon = rast@data[[8]][mask]
		isohyet = rast@data[[9]][mask]

    rast = readRAST(c(template$rowMap, template$colMap),NODATA=0)
        rows = rast@data[[1]][mask]
        cols = rast@data[[2]][mask]
    rast = readRAST(template$drainMap)
        drain = abs(rast@data[[1]][mask]) # guide the "flat" surface or surface pit water exit
    print('reading xx,yy,.... ... DONE')

    # extract LULC information (must have)
    impFrac=NULL;tryCatch({
        rast = readRAST(template$impFracMAP);
        impFrac <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ impFrac <<- emptyMAP }
        )#tryCatch
    forestFrac=NULL;tryCatch({
        rast = readRAST(template$forestFracMAP);
        forestFrac <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ forestFrac <<- emptyMAP }
        )#tryCatch
    shrubFrac=NULL;tryCatch({
        rast = readRAST(template$shrubFracMAP);
        shrubFrac <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ shrubFrac <<- emptyMAP }
        )#tryCatch
    cropFrac=NULL;tryCatch({
        rast = readRAST(template$cropFracMAP);
        cropFrac <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ cropFrac <<- emptyMAP }
        )#tryCatch
    lawnFrac=NULL;tryCatch({
        rast = readRAST(template$grassFracMAP);
        lawnFrac <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ lawnFrac <<- emptyMAP }
        )#tryCatch

    # extract other LULC information -- surface routing -- stream extension
    stream=NULL;tryCatch({
        rast = readRAST(template$streamMap);
        stream <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ stream <<- emptyMAP }
        )#tryCatch
    fullstreamExt=NULL; tryCatch({
        rast = readRAST(template$streamFullextension);
        fullstreamExt <- rast@data[[1]][mask];
        print('reading strExtension ... DONE')},
        error = function(e){ fullstreamExt <<- stream }
        )#tryCatch
    waterFrac=NULL;tryCatch({
        rast = readRAST(template$waterFracMAP);
        waterFrac <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ waterFrac <<- emptyMAP }
        )#tryCatch

    # extract other LULC information -- surface routing -- road storm drainage
    otherImpFrac=NULL;tryCatch({
        rast = readRAST(template$otherImpMAP);
        otherImpFrac <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ otherImpFrac <<- emptyMAP }
        )#tryCatch
    pavedRoadFrac=NULL;tryCatch({
        rast = readRAST(template$pavedRoadFracMAP);
        pavedRoadFrac <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ pavedRoadFrac <<- emptyMAP }
        )#tryCatch
    onRoadDraingeDir=NULL;tryCatch({
        rast = readRAST(template$onRoadDraingeDir);
        onRoadDraingeDir <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ onRoadDraingeDir <<- emptyMAP }
        )#tryCatch
    roadStormDrainInlet=NULL; tryCatch({
        rast = readRAST(template$roadStormDrainInlet);
        roadStormDrainInlet <- rast@data[[1]][mask];
        print('reading roadStormDrainInlet ... DONE')},
        error = function(e){ roadStormDrainInlet <<- emptyMAP }
        )#tryCatch
    roadStormDrainOutlet=NULL; tryCatch({
        rast = readRAST(template$roadStormDrainOutlet);
        roadStormDrainOutlet <- rast@data[[1]][mask];
        print('reading roadStormDrainInlet ... DONE')},
        error = function(e){ roadStormDrainOutlet <<- emptyMAP }
        )#tryCatch

    # extract other LULC information -- surface routing -- surface drainage via pipes
    additionalSurfaceDrainInlet=NULL; tryCatch({
        rast = readRAST(template$additionalSurfaceDrainInletMAP);
        additionalSurfaceDrainInlet <- rast@data[[1]][mask];
        print('reading additional surf drinage ... DONE')},
        error = function(e){ additionalSurfaceDrainInlet <<- emptyMAP }
        )#tryCatch
    additionalSurfaceDrainOutlet=NULL; tryCatch({
        rast = readRAST(template$additionalSurfaceDrainOutlet);
        additionalSurfaceDrainOutlet <- rast@data[[1]][mask];
        print('reading additional surf drinage ... DONE')},
        error = function(e){ additionalSurfaceDrainOutlet <<- emptyMAP }
        )#tryCatch

    # extract other LULC information -- surface routing -- housing & drive way
    roofFrac=NULL;tryCatch({
        rast = readRAST(template$roofMAP);
        roofFrac <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ roofFrac <<- emptyMAP }
        )#tryCatch
    roofDrainDir=NULL;tryCatch({
        rast = readRAST(template$roofDrainMAP);
        roofDrainDir <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ roofDrainDir <<- emptyMAP }
        )#tryCatch
    roofDrainInlet=NULL;tryCatch({
        rast = readRAST(template$roofRedirectedInlet);
        roofDrainInlet <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ roofDrainInlet <<- emptyMAP }
        )#tryCatch
    roofDrainOutlet=NULL;tryCatch({
        rast = readRAST(template$roofDrainOutlet);
        roofDrainOutlet <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ roofDrainOutlet <<- emptyMAP }
        )#tryCatch

    # extract other LULC information -- subsurface drainages -- pipelines and sewers
    sewercover=NULL; tryCatch({
        rast = readRAST(template$sewercoverMAP);
        sewercover <- rast@data[[1]][mask];
        print('reading sewer ... DONE')},
        error = function(e){ sewercover <<- emptyMAP }
        )#tryCatch
    pipecover=NULL; tryCatch({
        rast = readRAST(template$pipecoverMAP);
        pipecover <- rast@data[[1]][mask];
        print('reading pipe ... DONE')},
        error = function(e){ pipecover <<- emptyMAP }
        )#tryCatch

    # extract other LULC information -- subsurface drainages -- interrcepts
    compactedsoilQ=NULL; tryCatch({
        rast = readRAST(template$compactedSoilMAP);
        compactedsoilQ <- rast@data[[1]][mask];
        print('reading non-impacted soil ... DONE')},
        error = function(e){ compactedsoilQ <<- emptyMAP }
        )#tryCatch
    unpavedroad=NULL; tryCatch({
        rast = readRAST(template$unpavedRoadMap);
        unpavedroad <- rast@data[[1]][mask];
        print('reading unpavedRoad ... DONE')},
        error = function(e){ unpavedroad <<- emptyMAP }
        )#tryCatch
    riparian=NULL; tryCatch({
        rast = readRAST(template$riparianMAP);
        riparian <- rast@data[[1]][mask];
        print('reading riparian ... DONE')},
        error = function(e){ riparian <<- emptyMAP }
        )#tryCatch
    basement=NULL; tryCatch({
        rast = readRAST(template$basementFracMAP);
        basement <- rast@data[[1]][mask];
        print('reading riparian ... DONE')},
        error = function(e){ basement <<- emptyMAP }
        )#tryCatch


    septic=NULL; tryCatch({
        rast = readRAST(template$septicMAP);
        septic <- rast@data[[1]][mask];
        print('reading septic ... DONE')},
        error = function(e){ septic <<- emptyMAP }
        )#tryCatch 
    irrigationArea=NULL;tryCatch({
        rast = readRAST(template$irrigationMAP);
        irrigationArea <- rast@data[[1]][mask];
        print('reading irrigationArea ... DONE')},
        error = function(e){ irrigationArea <<- emptyMAP }
        )#tryCatch 
    
    print('reading lulc ... DONE')

    # extract strata information
	treeLAI = lapply(1:15, function(i){
		tryCatch({
            rast = readRAST( template[[paste('tree',i,'LAI',sep='')]] ) # paste('tree',i,'LAI',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	treeID = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('tree',i,'StratumID',sep='')]] ) # paste('tree',i,'StratumID',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	treeFFrac = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('tree',i,'FFrac',sep='')]] ) # paste('tree',i,'FFrac',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})

	shrubLAI = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('shrub',i,'LAI',sep='')]] ) # paste('shrub',i,'LAI',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	shrubID = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('shrub',i,'StratumID',sep='')]] ) # paste('shrub',i,'StratumID',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	shrubFFrac = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('shrub',i,'FFrac',sep='')]] ) # paste('shrub',i,'FFrac',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
    # is(shrubLAI[[2]]); is(shrubID[[2]]); is(shrubFFrac[[2]])
	
	grassLAI = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('grass',i,'LAI',sep='')]] ) # paste('grass',i,'LAI',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	grassID = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('grass',i,'StratumID',sep='')]] ) # paste('grass',i,'StratumID',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	grassFFrac = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('grass',i,'FFrac',sep='')]] ) # paste('grass',i,'FFrac',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
    # is(grassLAI[[2]]); is(grassID[[2]]); is(grassFFrac[[2]])

	cropLAI = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('crop',i,'LAI',sep='')]] ) # paste('crop',i,'LAI',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	cropID = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('crop',i,'StratumID',sep='')]] ) # paste('crop',i,'StratumID',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	cropFFrac = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('crop',i,'FFrac',sep='')]] ) # paste('crop',i,'FFrac',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
    # is(cropLAI[[2]]); is(cropID[[2]]); is(cropFFrac[[2]])


    PRINT_patch=NULL; tryCatch({
        rast = readRAST(template$PRINT_patchMAP);
        PRINT_patch <- rast@data[[1]][mask];
        print('reading pipe ... DONE')},
        error = function(e){ PRINT_patch <<- emptyMAP }
        )#tryCatch


	## basin centroid and latitude
	sputm <- SpatialPoints(cbind(mean(xx),mean(yy)), proj4string=CRS(gmeta()$proj4) )  
  	spgeo <- spTransform(sputm, CRS("+proj=longlat +datum=WGS84"))
	latitude = spgeo@coords[2]
	
	##-----<< order >>------#
	len = sum(mask)
	RHESSysOrder = order(hill,zone,patch) ### somehow we need to cut deplulated
	tapplyOrder = rep(NA,sum(mask)); tapplyOrder[RHESSysOrder] = match(patch[RHESSysOrder], unique(patch[RHESSysOrder]))
	
	##-----<< list out IDs >>------#
	idMatrix = unique(cbind(patch,zone,hill)[RHESSysOrder,])
	colnames(idMatrix) = c('patchList', 'zoneList', 'hillList')
	
	## hill 
	hillX = tapply(xx,INDEX=hill, FUN=mean)
	hillY = tapply(yy,INDEX=hill, FUN=mean)
	hillZ = tapply(dem,INDEX=hill, FUN=mean)
		hillID = as.numeric(names(hillX))
		numhill = length(hillID)
		hillIDrhessysOrder = match(idMatrix[,'hillList'], hillID) ## organize unique hill into the idMatrix order

	## zone
	zoneEast = tapply(sin(ehorizon*DtoR),INDEX=zone, FUN=mean)
	zoneWest = tapply(sin(whorizon*DtoR),INDEX=zone, FUN=mean)
	
	zoneSlope = tapply(slope,INDEX=zone, FUN=mean) # vector
		aspectcos = tapply(cos(aspect*DtoR)*sin(slope*DtoR),INDEX=zone, FUN=mean)
		aspectsin = tapply(sin(aspect*DtoR)*sin(slope*DtoR),INDEX=zone, FUN=mean)
	zoneAspect = atan(aspectsin/aspectcos)* RtoD ## always between -90 and 90
		zoneAspect[aspectcos<0] = zoneAspect[aspectcos<0] + 180 #yes
		zoneAspect[aspectsin<0 & aspectcos>0] = zoneAspect[aspectsin<0 & aspectcos>0] + 360
		
	zoneX = tapply(xx,INDEX=zone, FUN=mean)
	zoneY = tapply(yy,INDEX=zone, FUN=mean)
	zoneZ = tapply(dem,INDEX=zone, FUN=mean)
    zoneISOHYET = tapply(isohyet,INDEX=zone, FUN=mean)
	zoneArea = tapply(rep(1,len),INDEX=zone, FUN=sum)*gridarea
		zoneID = as.numeric(names(zoneX))
		numzone = length(zoneID)
		zoneIDrhessysOrder = match(idMatrix[,'zoneList'], zoneID) ## organize unique zone into the idMatrix order
	zoneStationID = tapply(climateStationID,INDEX=zone, FUN=mean)

	# cbind(zoneAspect,aspect,slope)[80:100,]
	# plot(aspect, zoneAspect); abline(a=0,b=1,lty=2)
	
	
	## patch (patch >= grid)
	patchX = tapply(xx,INDEX=patch, FUN=mean)
	patchY = tapply(yy,INDEX=patch, FUN=mean)
	patchZ = tapply(dem,INDEX=patch, FUN=mean)
	patchCount = tapply(rep(1,len),INDEX=patch, FUN=sum)
	patchArea = patchCount* gridarea

    # for every patch, find the dominated soil class / soil_cat
    patchSOIL_info = do.call(rbind,tapply(seq_along(patch),INDEX=patch, FUN=function(ii){
        hold=table(soiltexture[ii]);
        holdII=table(soil_extID[ii])
        return <- c(
        as.numeric(names(hold)[which.max(hold)]), # soil texture,
        as.numeric(names(holdII)[which.max(holdII)]) # soilPextID
        )
    }))
    patchSOIL = patchSOIL_info[,2] # soil_extID
    # pull the dominated soil_extID information together
    ssurgo_info = do.call(rbind,tapply(seq_along(patch), INDEX=soil_extID, FUN=function(ii){
        return <- c(
        soil_extID[ii][1], # soil_cat
        soilksat0[ii][1],
        soilksatdecay[ii][1],
        soilpor0[ii][1],
        soilpordecay[ii][1],
        soilsand[ii][1],
        soilsilt[ii][1],
        soilclay[ii][1],
        soilbulkdensity[ii][1],
        soilparticledensity[ii][1],
        soilsoildepth[ii][1],
        soilactivedepth[ii][1],
        soilmaxrootdepth[ii][1],
        soilalbedo[ii][1],
        soilpor_size_index[ii][1],
        soilpsi_air_entry[ii][1],
        soilsoilc[ii][1],
        soilomdecay[ii][1]
        )
    }));colnames(ssurgo_info)=c('soil_extID','soilksat0','soilksatdecay','soilpor0','soilpordecay','soilsand','soilsilt','soilclay','soilbulkdensity','soilparticledensity','soilsoildepth','soilactivedepth','soilmaxrootdepth','soilalbedo','soilpor_size_index','soilpsi_air_entry','soilsoilc','soilomdecay')


    
	patchSLOPE = tapply(slope,INDEX=patch, FUN=mean)
	patchTWI = tapply(abs(twi),INDEX=patch, FUN=mean); patchTWI[is.na(patchTWI)]=0;
		patchID = as.numeric(names(patchX))
		numpatch = length(patchID)	
		patchIDrhessysOrder = match(idMatrix[,'patchList'], patchID) ## organize unique patch into the idMatrix order
	# rep(patchIDrhessysOrder, times=patchVegnum) in below is expending the idMatrix order by Vegnum
	
	## sub-patch/grid setting
	subGridAssignment = matrix(NA,4,5)
	subGridAssignment[2:4,1] = c(NA,	NA,	NA) # tree [LAI, vegID, rootz]
	subGridAssignment[2:4,2] = c(NA,	NA,	NA) # shrub [LAI, vegID, rootz]
	subGridAssignment[2:4,3] = c(NA,	NA,	NA) # crop [LAI, vegID, rootz]
	subGridAssignment[2:4,4] = c(NA,	NA,	NA) # lawn [LAI, vegID, rootz]
	subGridAssignment[2:4,5] = c(0.0,	4,	0) # no veg [LAI, vegID, rootz]		
	#landuseClass = c(2,2,1,1,3) # RHESSys def (update RHESSys LULC! need these at all? detention size, fertilizer?, what exact does lulc class do? )
	
		## scanning each grid within a patch and forming within patch configuration using the subgrid information
	subGrid_buff = 'patchID frac lai vegID rootz land imp'
	patchVegnum = tapply(1:sum(mask),INDEX=tapplyOrder, FUN=function(x){
            # 7 -> x= 9029
            #patchSTR = sum(fullstreamExt[x], na.rm=T); # patchSTR==0 --> no canopy on all stream extension!
            patchSTR = sum(stream[x], na.rm=T)/length(x)
            patchWATER = sum(waterFrac[x], na.rm=T)/length(x) # include any water surface and potential non-vegetated channel
			subGridAssignment[1,] = c(
                ifelse(patchSTR==0,1,1-patchWATER)*sum(forestFrac[x], na.rm=T)/length(x), #1 tree
                ifelse(patchSTR==0,1,1-patchWATER)*sum(shrubFrac[x], na.rm=T)/length(x),  #2 shrub
                ifelse(patchSTR==0,1,1-patchWATER)*sum(cropFrac[x], na.rm=T)/length(x),   #3 crop
                ifelse(patchSTR==0,1,1-patchWATER)*sum(lawnFrac[x], na.rm=T)/length(x),   #4 lawn
                ifelse(patchSTR==0,1,1-patchWATER)*sum(impFrac[x], na.rm=T)/length(x)     #5 no veg
				)
			if(is.na(subGridAssignment[1,1]) ) subGridAssignment[1,1]=0
			if(is.na(subGridAssignment[1,2]) ) subGridAssignment[1,2]=0
			if(is.na(subGridAssignment[1,3]) ) subGridAssignment[1,3]=0
            if(is.na(subGridAssignment[1,4]) ) subGridAssignment[1,4]=0
            if(is.na(subGridAssignment[1,5]) ) subGridAssignment[1,5]=0
			
            land_ = table(LULCID[x]); if(length(land_)==0){ land_ = 11; names(land_)=11; }
            land = as.numeric(names(land_)[which.max(land_)])
            if(sum(PRINT_patch[x],na.rm=T)>0){ land = land + 600}
                
			imp = subGridAssignment[1,5]
            fracQ = c(	subGridAssignment[1,1]>0,   # tree
                        subGridAssignment[1,2]>0,   # shrub
                        subGridAssignment[1,3]>0,   # crop
                        subGridAssignment[1,4]>0,   # lawn
						F # no veg
                        )#
                        fracQ[5] = ifelse(sum(fracQ)==0, T, F) # no veg
						
			numVeg = 0			
			subGrid_buff_string = NULL			
			if(fracQ[1]){
				## count how many trees
				FFraclist = sapply(1:15,function(i){ mean(treeFFrac[[i]][x]) }) * subGridAssignment[1,1]
				LAIlist = sapply(1:15,function(i){ mean(treeLAI[[i]][x]) })
				vegIDlist = sapply(1:15,function(i){ treeID[[i]][x][1] })
                
                vegCount = !is.na(FFraclist) & FFraclist>0 & !is.na(LAIlist) & LAIlist>0 & !is.na(vegIDlist) & vegIDlist>0
				numVeg = numVeg + sum(vegCount)		
				subGrid_buff_string = c(subGrid_buff_string,
					sapply(seq_len(15)[vegCount], function(i){
						paste(patch[x][1], FFraclist[i], LAIlist[i], vegIDlist[i], 1, land,imp, sep=' ')
						})
					)#c		
			}# fracQ[1] 
			if(fracQ[2]){ 
				## count how many shrub
				FFraclist = sapply(1:15,function(i){ mean(shrubFFrac[[i]][x]) }) * subGridAssignment[1,2]
				LAIlist = sapply(1:15,function(i){ mean(shrubLAI[[i]][x]) })
				vegIDlist = sapply(1:15,function(i){ shrubID[[i]][x][1] })
                vegCount = !is.na(FFraclist) & FFraclist>0 & !is.na(LAIlist) & LAIlist>0 & !is.na(vegIDlist) & vegIDlist>0
				numVeg = numVeg + sum(vegCount)	
				subGrid_buff_string = c(subGrid_buff_string,
					sapply(seq_len(15)[vegCount], function(i){
						paste(patch[x][1], FFraclist[i], LAIlist[i], vegIDlist[i], 1, land,imp, sep=' ')
						})
					)#c	
			}#fracQ[2]
            if(fracQ[3]){
                ## count how many crop
                FFraclist = sapply(1:15,function(i){ mean(cropFFrac[[i]][x]) }) * subGridAssignment[1,3]
                LAIlist = sapply(1:15,function(i){ mean(cropLAI[[i]][x]) })
                vegIDlist = sapply(1:15,function(i){ cropID[[i]][x][1] })
                vegCount = !is.na(FFraclist) & FFraclist>0 & !is.na(LAIlist) & LAIlist>0 & !is.na(vegIDlist) & vegIDlist>0
                numVeg = numVeg + sum(vegCount)
                subGrid_buff_string = c(subGrid_buff_string,
                sapply(seq_len(15)[vegCount], function(i){
                        paste(patch[x][1], FFraclist[i], LAIlist[i], vegIDlist[i], 0.3, land,imp, sep=' ')
                })
                )#c
            }#fracQ[3]
			if(fracQ[4]){
				## count how many lawn
				FFraclist = sapply(1:15,function(i){ mean(grassFFrac[[i]][x]) }) * subGridAssignment[1,4]
				LAIlist = sapply(1:15,function(i){ mean(grassLAI[[i]][x]) })
				vegIDlist = sapply(1:15,function(i){ grassID[[i]][x][1] })
                vegCount = !is.na(FFraclist) & FFraclist>0 & !is.na(LAIlist) & LAIlist>0 & !is.na(vegIDlist) & vegIDlist>0
				numVeg = numVeg + sum(vegCount)			
				subGrid_buff_string = c(subGrid_buff_string,
					sapply(seq_len(15)[vegCount], function(i){
						paste(patch[x][1], FFraclist[i], LAIlist[i], vegIDlist[i], 0.2, land,imp, sep=' ')
						})
					)#c	
            }#fracQ[4];  numVeg; subGrid_buff_string
			if(fracQ[5]){
				numVeg = numVeg + 1
				subGridAssignment[1,5]=1; #coverFrac for no veg
				subGrid_buff_string = c(subGrid_buff_string,
                        paste(patch[x][1],paste(subGridAssignment[,5],collapse=' '), land,imp, sep=' '))
			}#fracQ[5]
			
			subGrid_buff <<- c(subGrid_buff, unlist(subGrid_buff_string))
			
			return <- numVeg
		})# tapply
		
	subGrid_info = read.table(textConnection(subGrid_buff),sep=' ',header=T)	
	patchVegCover = subGrid_info[,'frac']
	patchVegLAI = subGrid_info[,'lai']
	patchVegID = subGrid_info[,'vegID']
	patchLAND = subGrid_info[,'land'] 	
	patchIMP = subGrid_info[,'imp']  #<<----	
	patchRZ = subGrid_info[,'rootz']

    table(patchVegnum)
    dim(subGrid_info)[1] >= length(patchSLOPE)
    length(patchVegnum) == length(patchSLOPE)
    table(patchVegID)

	lai_ = patchVegLAI ## already ordered
		stratum = patchVegID
		vegDefID = as.numeric(vegParam[1,3:ncol(vegParam)])
		stratumIndex = match(stratum, vegDefID) # return index
		stratumMass=matrix(0,length(lai_),13)
		colnames(stratumMass) = c("leafc","lstemc","dstemc","lrootc","drootc","frootc","leafcalloc","leafn","lstemn","dstemn","lrootn","drootn","frootn")
		
		cond = lai_ >0 
		stratum.SLA = as.numeric(vegParam[48,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.LS = as.numeric(vegParam[12,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.LIVED = as.numeric(vegParam[10,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.DEAD = 1/stratum.LIVED -1; 
		stratum.DEAD[!is.finite(stratum.DEAD)]=0
		stratum.SC = as.numeric(vegParam[8,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.LR = as.numeric(vegParam[9,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.CNL = as.numeric(vegParam[33,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.CNR = as.numeric(vegParam[21,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.CNLW = as.numeric(vegParam[39,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.CNDW = rep(333.33,sum(cond))
	
		stratumMass[cond,1] =  lai_[cond]/stratum.SLA #leafc
		stratumMass[cond,2] = stratumMass[cond,1]* stratum.LS * stratum.LIVED #live stemc
		stratumMass[cond,3] = stratumMass[cond,2]* stratum.DEAD # dead stemc
		stratumMass[cond,4] = (stratumMass[cond,2]+stratumMass[cond,3])* stratum.SC* stratum.LIVED # live crootc
		stratumMass[cond,5] = stratumMass[cond,4]*stratum.DEAD #dead crootc
		stratumMass[cond,6] = stratumMass[cond,1]* stratum.LR #frootc
		
			#iniRootmass = stratumMass[cond,4]+stratumMass[cond,5]+stratumMass[cond,6]
			#iniRTZ = 3/8 * (2* iniRootmass)^(0.8)
		
		stratum.totmass = rowSums(stratumMass)
		stratumMass[cond,7] = stratumMass[cond,1]*0.05 ##strateEPVleafcalloc
		stratumMass[cond,8] = stratumMass[cond,1]/stratum.CNL
		stratumMass[cond,9] = stratumMass[cond,2]/stratum.CNLW
		stratumMass[cond,10] = stratumMass[cond,3]/stratum.CNDW
		stratumMass[cond,11] = stratumMass[cond,4]/stratum.CNLW
		stratumMass[cond,12] = stratumMass[cond,5]/stratum.CNDW
		stratumMass[cond,13] = stratumMass[cond,6]/stratum.CNR	
		

#----------------------------------------------------------------------------------------------		
if(as.numeric(templateACTION$outputWorldfile[2])>0 ){
    outWorldFilePath = templateACTION$outputWorldfile[1]
	title = c(defaultWorldName, defaultBasinName, defaultHillName,
        switch( is.null(hillDefID)+1,'hill_parm_ID',NULL),
        switch( is.null(hillGWiniQ)+1,'gw.storage',NULL),
        switch( is.null(hillGWiniNO3)+1,'gw.NO3',NULL),
        switch( is.null(hillGWiniNH4)+1,'gw.NH4',NULL),
        switch( is.null(hillGWiniDOC)+1,'gw.DOC',NULL),
        switch( is.null(hillGWiniDON)+1,'gw.DON',NULL),
        defaultZoneName,
        switch( is.null(zoneDefID)+1,'zone_parm_ID',NULL),
        defaultPatchName,
        switch( is.null(soilLegecyCNScaler)+1,'legacySoilCNScaler',NULL),
        defaultStratumName)
	write( title, outWorldFilePath, ncolumns=length(title), append=F, sep=',')
		
		
	WorldBasinColumn = rep(1, sum(patchVegnum)) %o% c(1,1, mean(xx), mean(yy), mean(dem), latitude)
	
	hillColumn = cbind(
        hillID,hillX, hillY, hillZ,
        switch( is.null(hillDefID)+1,hillDefID,NULL),
        switch( is.null(hillGWiniQ)+1,hillGWiniQ,NULL),
        switch( is.null(hillGWiniNO3)+1,hillGWiniNO3,NULL),
        switch( is.null(hillGWiniNH4)+1,hillGWiniNH4,NULL),
        switch( is.null(hillGWiniDOC)+1,hillGWiniDOC,NULL),
        switch( is.null(hillGWiniDON)+1,hillGWiniDON,NULL)
        #rep(1, numhill) %o% c(1,0,0,0)
		)[rep(hillIDrhessysOrder, times=patchVegnum),]## hill
   
        
	zoneColumn = cbind(
		zoneID, zoneX, zoneY, zoneZ, 
        #rep(1, numzone), ##<<---- zone def ID
		zoneArea, 
		zoneSlope, 
		zoneAspect,
		zoneISOHYET, 
		zoneEast, 
		zoneWest,
        #rep(1, numzone), #<<---- number of base station
		zoneStationID,  #<<---- base station ID -> id of .base file
        switch( is.null(zoneDefID)+1,zoneDefID,NULL)
		#rep(1, numzone) %o% c(1, climateStationID) 
		)[rep(zoneIDrhessysOrder, times=patchVegnum),]## zone
	
	patchColumn1 = cbind(
		patchID, patchX, patchY, patchZ, patchSOIL)[rep(patchIDrhessysOrder, times=patchVegnum),]## patch
	
	patchColumn2 = cbind(
		patchArea,
        patchSLOPE,
        patchTWI,
        switch( is.null(soilLegecyCNScaler)+1,soilLegecyCNScaler,NULL))[rep(patchIDrhessysOrder, times=patchVegnum),]## patch
		
        #patchColumn3 = cbind(rep(1, numpatch) %o% c(0.12, 0,0,0, 0.28, 0, -10, 0, -0.5,1,0, 0.0000001,0.0,0.0,0.0,0.0,0.0000001, 0,0, 0.0000002,2,6,0))[rep(patchIDrhessysOrder, times=patchVegnum),]## patch
						
	stratumColumn = matrix(0, sum(patchVegnum),length(defaultStratumName))	
	stratumColumn[,1] = 1:dim(stratumColumn)[1] #strateID
	stratumColumn[,2] = patchVegID # stratePlantID
	stratumColumn[,3] = patchVegCover # stratecfrac -->affect precipitation intercept 
	stratumColumn[,4] = 0 # strateGap -->affect sunlight intercept 
	stratumColumn[,5] = patchRZ # strateRZ 1m by default
	stratumColumn[,c(9,13,16,19,22,25,29,31,35,38,41,44,47)] = stratumMass
	
	
	write.table(cbind(
		WorldBasinColumn,
		hillColumn,
		zoneColumn,
		patchColumn1,
		patchLAND,
		patchColumn2,
		1-patchIMP,
        #patchColumn3,
		stratumColumn
	), outWorldFilePath, row.names=F,col.names=F, append=T, sep=',')
}# if templateACTION$outputWorldfile[2]

#----------------------------------------------------------------------------------------------

    tmp = unlist(strsplit(templateACTION$outputDefs[1],'/'))
	defsFolder = tmp[length(tmp)]
	rhessysFolder = tmp[length(tmp)-1]
	
	## write out selected veg definition files
	vegHEADER = NULL
	selectedVeg = vegParamCOL[match(unique(patchVegID), vegParamCOL[,'vegID']), 'vegDefIndex']
	for(ii in selectedVeg ){
		filename = paste(defsFolder,"/stratum_",gsub("\\.","_",colnames(vegParam)[ii]),".def",sep="")
		vegHEADER = c(vegHEADER, paste(filename,'stratum_default_filename'))
        filepth = paste(projectFolder,'/',rhessysFolder,'/', filename,sep="")
		if(as.numeric(templateACTION$outputDefs[2])>0) write.table(cbind(vegParam[, ii], vegParam[,2]), filepth,sep="\t",row.names=F,col.names=F, quote=F)
	}#i

	
	## write out selected soil definition files
    soilHEADER = NULL
    selectedsoil = soilParamCOL[match(unique(patchSOIL_info[,1]), soilParamCOL[,'soilID']), 'soilDefIndex']
    what = tapply(seq_len(dim(patchSOIL_info)[1]), patchSOIL_info[,1], function(ii){ unique(patchSOIL_info[ii,2]) })
    for(ii in selectedsoil ){
        for(jj in what[[toString(soilParam[1,ii])]] ){ # soil texture id --> ssurgo mukey
            filename = paste(defsFolder,"/soil_",gsub("\\.","_",colnames(soilParam)[ii]),"_",jj,".def",sep="")
            soilHEADER = c(soilHEADER, paste(filename,'patch_default_filename'))
            filepth = paste(projectFolder,'/',rhessysFolder,'/', filename,sep="")
            ## modify the generic
            cond = ssurgo_info[,1]==jj ## select ONE of the dominated soil_extID
            soil_char = soilParam[, ii]
            soil_char[1] = jj # id
            ## ... below ...  soilParam[,1:2] for checking index
            if(!is.na(ssurgo_info[cond,'soilksat0'])){soil_char[match('Ksat_0',soilParam[,2])] = ssurgo_info[cond,'soilksat0']} # ksat0 (m/day)
            if(!is.na(ssurgo_info[cond,'soilksat0'])){soil_char[match('Ksat_0_v',soilParam[,2])] = ssurgo_info[cond,'soilksat0']}
            if(!is.na(ssurgo_info[cond,'soilksatdecay'])){soil_char[match('m',soilParam[,2])] = ssurgo_info[cond,'soilksatdecay']} # it's meter (horizontal)
            if(!is.na(ssurgo_info[cond,'soilksatdecay'])){soil_char[match('m_z',soilParam[,2])] = ssurgo_info[cond,'soilksatdecay']} # it's meter (vertical)
            if(!is.na(ssurgo_info[cond,'soilpor0'])){soil_char[match('porosity_0',soilParam[,2])] = ssurgo_info[cond,'soilpor0']} # porosity_0
            if(!is.na(ssurgo_info[cond,'soilpordecay'])){soil_char[match('porosity_decay',soilParam[,2])] = ssurgo_info[cond,'soilpordecay']} # porosity_decay (m) <<----- disabled for now June 20th, 2019
            if(!is.na(ssurgo_info[cond,'soilactivedepth'])){soil_char[match('active_zone_z',soilParam[,2])] = ssurgo_info[cond,'soilactivedepth']}
            if(!is.na(ssurgo_info[cond,'soilsoildepth'])){soil_char[match('soil_depth',soilParam[,2])] = ssurgo_info[cond,'soilsoildepth']}
            if(!is.na(ssurgo_info[cond,'soilalbedo'])){soil_char[match('albedo',soilParam[,2])] = ssurgo_info[cond,'soilalbedo']}
            if(!is.na(ssurgo_info[cond,'soilclay'])){soil_char[match('clay',soilParam[,2])] = ssurgo_info[cond,'soilclay']}
            if(!is.na(ssurgo_info[cond,'soilsilt'])){soil_char[match('silt',soilParam[,2])] = ssurgo_info[cond,'soilsilt']}
            if(!is.na(ssurgo_info[cond,'soilsand'])){soil_char[match('sand',soilParam[,2])] = ssurgo_info[cond,'soilsand']}
            if(!is.na(ssurgo_info[cond,'soilpor_size_index'])){soil_char[match('pore_size_index',soilParam[,2])] = ssurgo_info[cond,'soilpor_size_index']}
            if(!is.na(ssurgo_info[cond,'soilpsi_air_entry'])){soil_char[match('psi_air_entry',soilParam[,2])] = ssurgo_info[cond,'soilpsi_air_entry']}
            if(!is.na(ssurgo_info[cond,'soilmaxrootdepth'])){soil_char[match('maxrootdepth',soilParam[,2])] = ssurgo_info[cond,'soilmaxrootdepth']}
            if(!is.na(ssurgo_info[cond,'soilparticledensity'])){soil_char[match('particledensity',soilParam[,2])] = ssurgo_info[cond,'soilparticledensity']}
            if(!is.na(ssurgo_info[cond,'soilsoilc'])){soil_char[match('soilc',soilParam[,2])] = ssurgo_info[cond,'soilsoilc']}
            #if(!is.na(ssurgo_info[cond,'soilomdecay'])){soil_char[match('DOM_decay_rate',soilParam[,2])] = ssurgo_info[cond,'soilomdecay']}
            #if(!is.na(ssurgo_info[cond,'soilomdecay'])){soil_char[match('N_decay',soilParam[,2])] = ssurgo_info[cond,'soilomdecay']}
            if(!is.na(ssurgo_info[cond,'soilomdecay'])){soil_char[match('soilcDecay',soilParam[,2])] = ssurgo_info[cond,'soilomdecay']}
            
            if(as.numeric(templateACTION$outputDefs[2])>0) write.table(cbind(soil_char, soilParam[,2]), filepth,sep="\t",row.names=F,col.names=F, quote=F)
        }#jj
    }#i



	
	## write out selected lulc definition files
	lulcHEADER = NULL
	selectedlulc = lulcParamCOL[match(unique(patchLAND), lulcParamCOL[,'lulcID']), 'lulcDefIndex']
	for(ii in selectedlulc ){
		filename = paste(defsFolder,"/landuse_",gsub("\\.","_",colnames(lulcParam)[ii]),".def",sep="")
		lulcHEADER = c(lulcHEADER, paste(filename,'landuse_default_filename'))
		filepth = paste(projectFolder,'/',rhessysFolder,'/', filename,sep="")
		if(as.numeric(templateACTION$outputDefs[2])>0) write.table(cbind(lulcParam[, ii], lulcParam[,2]), filepth,sep="\t",row.names=F,col.names=F, quote=F)
	}#i
	

    zoneHEADER = NULL
    if(is.null(zoneDefID)){ zoneDefID = 1; }
    selectedzone = zoneParamCOL[match(unique(zoneDefID), zoneParamCOL[,'zoneID']), 'zoneDefIndex']
    for(ii in selectedzone ){
        filename = paste(defsFolder,"/zone_",gsub("\\.","_",colnames(zoneParam)[ii]),".def",sep="")
        zoneHEADER = c(zoneHEADER, paste(filename,'zone_default_filename'))
        filepth = paste(projectFolder,'/',rhessysFolder,'/', filename,sep="")
        if(as.numeric(templateACTION$outputDefs[2])>0) write.table(cbind(zoneParam[, ii], zoneParam[,2]), filepth,sep="\t",row.names=F,col.names=F, quote=F)
    }#i
	
	basinDEF = NULL
	basinDEF = c(basinDEF, '1 basin_default_ID')
	if(as.numeric(templateACTION$outputDefs[2])>0) write(basinDEF, paste(templateACTION$outputDefs[1],"/basin_basin.def",sep=""))
	
    hillHEADER = NULL
    if(is.null(hillDefID)){ hillDefID = 1; }
    selectedhill = hillParamCOL[match(unique(hillDefID), hillParamCOL[,'hillID']), 'hillDefIndex']
    for(ii in selectedhill ){
        filename = paste(defsFolder,"/hill_",gsub("\\.","_",colnames(hillParam)[ii]),".def",sep="")
        hillHEADER = c(hillHEADER, paste(filename,'hillslope_default_filename'))
        filepth = paste(projectFolder,'/',rhessysFolder,'/', filename,sep="")
        if(as.numeric(templateACTION$outputDefs[2])>0) write.table(cbind(hillParam[, ii], hillParam[,2]), filepth,sep="\t",row.names=F,col.names=F, quote=F)
    }#i

	worldHEADER = NULL
	worldHEADER = c(worldHEADER, paste(1,'num_basin_files'))
	worldHEADER = c(worldHEADER, paste(defsFolder,'/basin_basin.def basin_default_filename',sep=''))	
	worldHEADER = c(worldHEADER, paste(length(hillHEADER),'num_hillslope_files'))
    worldHEADER = c(worldHEADER, hillHEADER)
	worldHEADER = c(worldHEADER, paste(length(zoneHEADER),'num_zone_files'))
	worldHEADER = c(worldHEADER, zoneHEADER)
	
	worldHEADER = c(worldHEADER, paste(length(soilHEADER),'num_patch_files'))	
	worldHEADER = c(worldHEADER, soilHEADER)
	worldHEADER = c(worldHEADER, paste(length(lulcHEADER),'num_landuse_files'))	
	worldHEADER = c(worldHEADER, lulcHEADER)
	worldHEADER = c(worldHEADER, paste(length(vegHEADER),'num_stratum_files'))	
	worldHEADER = c(worldHEADER, vegHEADER)
	
	## ... listing all .base files
	zoneStation_uniqueID = unique(zoneStationID)
	worldHEADER = c(worldHEADER, paste(length(zoneStation_uniqueID),'num_base_stations'))
	if(length(zoneStation_uniqueID)==1){
		worldHEADER = c(worldHEADER, paste(climateStationNAME,'base_station_filename'))
	}else{
		for(bii in zoneStation_uniqueID){
			worldHEADER = c(worldHEADER, paste(climateStationNAME,bii,'.base base_station_filename',sep=''))
		}# bii
	}# if else
	
	if(as.numeric(templateACTION$outputWorldfileHDR[2])>0) write(worldHEADER,templateACTION$outputWorldfileHDR[1] )




	##-------------------------------------------------------------------------------------------------------##
	## flow table -- assume square grid
    cellarea = gis$nsres * gis$ewres
    cellsize = sqrt(cellarea)
    flatDEMdrop = tan(DtoR*0.143)*cellsize # only 0.25m drop per 100m.
    roadWidth = 5
    roadWidth = ifelse(cellsize>=9.99,
    	5, # meters (default)
    	ifelse(roadWidth>cellsize, cellsize, roadWidth)
    )# ifelse
    directEdge = cellsize*0.5
    diagonalEdge = cellsize*sqrt(0.5)

    # 1.  2. 3.  4. 5.  6. 7.  8. (GRASS from current drainTO code order)
    # NE, N, NW, W, SW, S, SE, E
    colneighbor = c(1,    0,    -1,    -1,    -1,    0,    1,    1)
    rowneighbor = c(-1,  -1,    -1,     0,     1,    1,    1,    0)
    directEdgeIndex = c(2,4,6,8)
    indirectEdgeIndex = c(1,3,5,7)

    maxCol = max(cols,na.rm=T)
    maskRC = rows*maxCol+cols #paste(rows, cols,sep=':') ## row*[max col]+col (yes: unique ID)
    maskRC_string2Patch_num <- new.env(hash=T)
    list2env(setNames(as.list(patch),maskRC),envir=maskRC_string2Patch_num) #<<---- native R hash
    gridSurroundRC = sapply(rows, FUN=function(x){x+rowneighbor}) * maxCol + sapply(cols, FUN=function(x){x+colneighbor})
    gridSurroundRC[!(gridSurroundRC %in% maskRC)] = -1
	
    # part 1: gathering information to temporary files
    fullLength = seq(1,length.out=length(patch))
    patch_info_dem = tapply(dem,INDEX=patch,mean) # use elevation to organize patch order in the file output
    orderedPatch = as.numeric(names(patch_info_dem[order(patch_info_dem,decreasing=T)])) ### patch could be longer than 'orderedPatch'
    outputOrder = match(patch, orderedPatch) # has the same length as 'patch'
    # ... finding basin outlet and hillslope outlets
    strCOND = !is.na(stream)
    subID = 2*ceiling(hill*0.5)
    suboutlet_orderedPatch_index = tapply(fullLength[strCOND], subID[strCOND],function(ii){
        # must be stream channel
        return <- match(patch[ii][which.min(dem[ii])], orderedPatch)
    })#
    suboutlet_orderedPatch_index_hillID = as.numeric(names(suboutlet_orderedPatch_index))
    basinoutlet_orderedPatch_index = match(patch[strCOND][which.min(dem[strCOND])], orderedPatch)


    maskRC_string2outputOrder_num <- new.env(hash=T)
    list2env(setNames(as.list(outputOrder),maskRC),envir=maskRC_string2outputOrder_num) #<<---- native R hash
    maskRC_string2maskRC_num <- new.env(hash=T)
    list2env(setNames(as.list(maskRC),maskRC),envir= maskRC_string2maskRC_num) #<<---- native R hash
	
    print('starting step I')
    patchInfo = tapply(fullLength, INDEX=outputOrder, FUN=function(ii){
        numPatch = length(ii);
        if(numPatch==0){numPatch=1;}
        return <- c(
            subIDindex = match(mean(subID[ii]),suboutlet_orderedPatch_index_hillID),
            patchID = mean(patch[ii]),             #1 patchID
            elevation = mean(dem[ii]),             #2 elevation
            xx = mean(xx[ii]),                #3 x coordinate
            yy = mean(yy[ii]),                #4 y coordinate
            hillID = mean(hill[ii]),                #6 hillID
            zoneID = mean(zone[ii]),                #7 zoneID
            rr = mean(rows[ii]),                #8 row index (from left to right)
            cc = mean(cols[ii]),                #9 col index (from top to bottom)
            len = length(ii),                   #10 num of cells
            aveSlope = tan(mean(slope[ii])*DtoR),   #13 average slope
            maxSlope = tan(max(slope[ii])*DtoR),    #14 max slope
            
            ## ... surface routing -- stream extension (yes/no)
            strQ = sum(!is.na(stream[ii])),         #11 modeled stream grids
            nonmodelstrgridQ = sum(!is.na(fullstreamExt[ii])),    #21 non-modeled stream grid (treat as land grids)
            
            ## ... surface routing -- road storm drainage
            otherImpQfrac = sum(otherImpFrac[ii],na.rm=T)/numPatch, #<<---
            pavedRoadQfrac = sum(pavedRoadFrac[ii],na.rm=T) * (sum(!is.na(fullstreamExt[ii]))==0)/numPatch,
            roadStormdrainInletQfrac = (sum(!is.na(roadStormDrainInlet[ii]))>0)*sum(pavedRoadFrac[ii],na.rm=T)*(sum(!is.na(fullstreamExt[ii]))==0)/numPatch,
            
            ## ... surface routing -- surface drainage via pipes
            nonstrsurfdrainQfrac = sum(additionalSurfaceDrainInlet[ii],na.rm=T)*(sum(!is.na(fullstreamExt[ii]))==0)/numPatch, # 22 (non-stream) land grids need surface water drain
                
            ## ... surface routing -- housing & drive way
            roofRedirectedQfrac = sum(roofFrac[ii],na.rm=T) * as.numeric(sum(!is.na(roofDrainInlet[ii]))>0)*(sum(!is.na(fullstreamExt[ii]))==0)/numPatch,
            roofQfrac = sum(roofFrac[ii],na.rm=T)/numPatch,
            
            ## ... subsurface drainages -- pipelines and sewers (yes/no)
            sewerdrainQ = sum(!is.na(sewercover[ii])), #17 (checking whether patch contains sewercover grids)
            subsurfpipedrainQ = sum(!is.na(pipecover[ii])), # other non-sewer pipes
            
            ## ... subsurface -- interrcepts
            unpavedRoadQ = sum(!is.na(unpavedroad[ii])), # assume it cuts watertable
            basementQfrac = sum(basement[ii],na.rm=T)/numPatch,
            
            ## ... surface/subsurface -- transfer
            riparianQ = sum(!is.na(riparian[ii])),    #16 (checking whether patch contains riparian grids)
            irrigateQfrac = min(
                sum(irrigationArea[ii],na.rm=T),
                sum(lawnFrac[ii],na.rm=T) + sum(cropFrac[ii],na.rm=T))/numPatch,
                # constrainted by lawn and crop frac
            septicQfrac = min(
            	sum(septic[ii],na.rm=T),
            	sum(lawnFrac[ii],na.rm=T) + sum(cropFrac[ii],na.rm=T))/numPatch
        );
    })#tapply <--- this output is a list of c() in outputOrder
    patch_info_lowest = patchInfo[[ length(patchInfo) ]] ## assume basin outlet
    patch_info_basinoutlet = patchInfo[[ basinoutlet_orderedPatch_index ]]
    patch_info_suboulet = lapply(suboutlet_orderedPatch_index, function(ii){ patchInfo[[ii]] })
    #cbind(suboutlet_orderedPatch_index_hillID, suboutlet_orderedPatch_index)
    
    #-------- marking down the drainTO destinations / drainIN sources
    patch_info_patchID = tapply(fullLength, INDEX=outputOrder, FUN=function(ii){
        return <- mean(patch[ii])
    })
    patchInfo_surf_roadStormDrainOutlet = tapply(fullLength, INDEX=outputOrder, FUN=function(ii){
        # "roadStormDrainOutlet" documents the outlet patchID at the road storm drain inlet point.
        tmpCond = !is.na(roadStormDrainOutlet[ii]) & roadStormDrainOutlet[ii]>0
        if(sum(tmpCond)>0){
            return_index = match(roadStormDrainOutlet[ii][tmpCond],patch_info_patchID)
            # return NA when outlet is outside of subcatchment!
            # otherwise, return the index location in the patch_info list
            outlet_index_cond = !is.na(return_index);
            if(sum(outlet_index_cond)>0){return <- return_index[outlet_index_cond]; }else{ return <- NULL;}
        }else{
            return <- NULL
        }
    }) # tapply

    patchInfo_surf_additionalSurfaceDrainOutlet = tapply(fullLength, INDEX=outputOrder, FUN=function(ii){
        tmpCond = !is.na(additionalSurfaceDrainOutlet[ii]) & additionalSurfaceDrainOutlet[ii]>0
        if(sum(tmpCond)>0){
            return_index = match(additionalSurfaceDrainOutlet[ii][tmpCond],patch_info_patchID)
            outlet_index_cond = !is.na(return_index);
            if(sum(outlet_index_cond)>0){return <- return_index[outlet_index_cond]; }else{ return <- NULL;}
        }else{
            return <- NULL
        }
    })##

    patchInfo_surf_roofRedirectedOutlet = tapply(fullLength, INDEX=outputOrder, FUN=function(ii){
        tmpCond = !is.na(roofDrainOutlet[ii]) & roofDrainOutlet[ii]>0
        if(sum(tmpCond)>0){
            return_index = match(roofDrainOutlet[ii][tmpCond],patch_info_patchID)
            outlet_index_cond = !is.na(return_index);
            if(sum(outlet_index_cond)>0){return <- return_index[outlet_index_cond]; }else{ return <- NULL;}
        }else{
            return <- NULL
        }
    })##

    ## ... setpic (lots of warnings)
    patchInfo_septicSource = vector(mode='list',length(fullLength))
    patchInfo_septicSourceMODE = vector(mode='list',length(fullLength))
    if( length(template$septicInOutTable)>0 ){
        if(!is.na(template$septicInOutTable)){
            tableInOut = read.csv(template$septicInOutTable)
            tableOutIndex = match(tableInOut$outPatch,patch_info_patchID)
            tableInIndex = match(tableInOut$inPatch,patch_info_patchID)
            
            tableInIndexList = tapply(seq_along(tableOutIndex),tableOutIndex,function(ii){
                tmp = tableInIndex[ii]
                tmp = tmp[!is.na(tmp)]
                if(length(tmp)>0){return <- tmp;}else{return <- NULL;}
            });
            tableInModeList = tapply(seq_along(tableOutIndex),tableOutIndex,function(ii){
                tmp = tableInOut$mode[ii]
                tmp = tmp[!is.na(tmp)]
                if(length(tmp)>0){return <- tmp;}else{return <- NULL;}
            });
            indexList = tapply(seq_along(tableOutIndex),tableOutIndex,function(ii){
                return <- tableOutIndex[ii][1]
            });
            
            for(ii in seq_along(indexList)){
                patchInfo_septicSource[[ indexList[ii] ]] = tableInIndexList[[ii]]
                patchInfo_septicSourceMODE[[ indexList[ii] ]] = tableInModeList[[ii]]
                patchInfo[[ indexList[ii] ]]['septicQfrac'] = 1 #make sure it has septic release
            }# end of for loop ii
        }#if
    }# vector of source patch index in "patch_info_patchID"


    ## ... irrigation (re-use some variables here)
    patchInfo_irrigationSource = vector(mode='list',length(fullLength))
    patchInfo_irrigationSourceMODE = vector(mode='list',length(fullLength))
    if( length(template$irrigationInOutTable)>0 ){
        if( !is.na(template$irrigationInOutTable) ){
            tableInOut = read.csv(template$irrigationInOutTable)
            tableOutIndex = match(tableInOut$irrigrationPatchID,patch_info_patchID)
            tableInIndex = match(tableInOut$sourcePatchID,patch_info_patchID)
            
            tableInIndexList = tapply(seq_along(tableOutIndex),tableOutIndex,function(ii){
                tmp = tableInIndex[ii]
                tmp = tmp[!is.na(tmp)]
                if(length(tmp)>0){return <- tmp;}else{return <- NULL;}
            });
            tableInModeList = tapply(seq_along(tableOutIndex),tableOutIndex,function(ii){
                tmp = tableInOut$mode[ii]
                tmp = tmp[!is.na(tmp)]
                if(length(tmp)>0){return <- tmp;}else{return <- NULL;}
            });
            indexList = tapply(seq_along(tableOutIndex),tableOutIndex,function(ii){
                return <- tableOutIndex[ii][1]
            });
            
            for(ii in seq_along(indexList)){
                patchInfo_irrigationSource[[ indexList[ii] ]] = tableInIndexList[[ii]]
                patchInfo_irrigationSourceMODE[[ indexList[ii] ]] = tableInModeList[[ii]]
                patchInfo[[ indexList[ii] ]]['irrigateQfrac'] = 1 # make sure it irrigates
            }# end of for loop ii
        }# if
    }# vector of source patch index in "patch_info_patchID"
    
    

#-----------------------------------------------------------------

    ## part 2: sort by 'elevation' & finding neighbor
    print('starting step II')
    ## .......... Neighbour
    
    patchNeighbourRC_edge = tapply(fullLength, INDEX=outputOrder, FUN=function(jj){
        withinPatchGridRC = rows[jj]*maxCol+cols[jj]; # within
        
        hold = as.vector(gridSurroundRC[directEdgeIndex,jj]);
        hold[hold%in% withinPatchGridRC] = -1
        
        hold2 = as.vector(gridSurroundRC[indirectEdgeIndex,jj]);
        hold2[hold2%in% withinPatchGridRC] = -1
        
        return <- c( tapply(hold[hold>0],hold[hold>0],length)*directEdge, tapply(hold2[hold2>0],hold2[hold2>0],length)*diagonalEdge)
        
    })

    patchNeighbourRC_LEN = seq_along(patchNeighbourRC_edge) ## <<--------------------------- ordered patch aggregated neighbours
    patchNeighbourRC = sapply(patchNeighbourRC_LEN, function(ii){
        sapply(names(patchNeighbourRC_edge[[ii]]), function(x){maskRC_string2maskRC_num[[ x ]]})
    })
    patchNeighbourPatch = sapply(patchNeighbourRC_LEN, function(ii){
        sapply(names(patchNeighbourRC_edge[[ii]]), function(x){maskRC_string2Patch_num[[ x ]]})
    })
    patchNeighbourPatchIndex = sapply(patchNeighbourRC_LEN, function(ii){
        sapply(names(patchNeighbourRC_edge[[ii]]), function(x){maskRC_string2outputOrder_num[[ x ]]})
    })


    ## .......... prefer Neighbour (subsurface)
    patchPreferNeighbourRC = tapply(fullLength, INDEX=outputOrder, FUN=function(ii){
        withinPatchGridRC = rows[ii]*maxCol+cols[ii]; # within
        drainTO_index = cbind(abs(drain[ii]),ii)
        hold3 = as.vector(gridSurroundRC[ drainTO_index ])
        hold3[hold3%in% withinPatchGridRC] = -1
        
        return <- sapply(names(tapply(hold3[hold3>0], hold3[hold3>0],length)),function(x){maskRC_string2maskRC_num[[ x ]]})
    })#

    ## .......... prefer Neighbour (surface)
	patchPreferNeighbourRC_surf = tapply(fullLength, INDEX=outputOrder, FUN=function(ii){
        withinPatchGridRC = rows[ii]*maxCol+cols[ii]; # within
        listOfDrain = sapply(ii,function(x){
            allDir = c(onRoadDraingeDir[x], roofDrainDir[x])
            if(length(allDir)>0){
                condtmp = !is.na(allDir)
                if(sum(condtmp)>0){
                    return <- allDir[condtmp]
                }else{
                    return <- drain[x]
                }
            }else{
                return <- drain[x]
            }
        })
        drainTO_index = cbind(abs(listOfDrain),ii)
        hold3 = as.vector(gridSurroundRC[ drainTO_index ])
        hold3[hold3%in% withinPatchGridRC] = -1
        
        return <- sapply(names(tapply(hold3[hold3>0], hold3[hold3>0],length)),function(x){maskRC_string2maskRC_num[[ x ]]})
    })#
	
	
	
	
	
    ## .......... writing out flow table
    if(as.numeric(templateACTION$outputSubFlow[2])>0 ){
        subsurfaceflow_table_buff <- file(templateACTION$outputSubFlow[1],'w') # open a file connection
        cat( length(patchInfo), '\n', file=subsurfaceflow_table_buff) #,sep='\n'
    }
    if(as.numeric(templateACTION$outputSurfFlow[2])>0 ){
        surfaceflow_table_buff <- file(templateACTION$outputSurfFlow[1],'w') # open a file connection
        cat( length(patchInfo), '\n', file=surfaceflow_table_buff) #,sep='\n'
    }

    for(ii in patchNeighbourRC_LEN){
        
        withinNeighbourRC_edge = patchNeighbourRC_edge[[ii]]
        withinNeighbourRC = patchNeighbourRC[[ii]]
        withinNeighbourRC_prefer = rep(0,length(withinNeighbourRC))            
        withinNeighbourRC_prefer[withinNeighbourRC%in%patchPreferNeighbourRC[[ii]] ] = 1
        withinNeighbourRC_prefer_surf = rep(0,length(withinNeighbourRC))
        withinNeighbourRC_prefer_surf[withinNeighbourRC%in%patchPreferNeighbourRC_surf[[ii]] ] = 1
        index4neighbour = patchNeighbourPatchIndex[[ii]]
        
        current_patch_info = patchInfo[[ii]]
        ## actionCode is mostly for subsurface processes; surface storm drain see below.
        # land (default) = 0
        # impFrac = roofFrac + otherImpFrac + pavedpavedRoadFrac
        # gw_drainage is bounded by imp
        class_stream = 1
        class_road = 2
        actionSTORMDRAIN = 3 # surface water drainage to fixed locations or outlet (for road network)
        actionGWDRAIN = 5 # surface -> deep gw storage
        actionRIPARIAN =7 # receive deep gw seeping
        actionSEWER = 11 # conditional subsurface drain out of system
        actionPIPEDRAIN = 17 # conditional subsurface drain to outlet
        #
        actionIRRIGATION = 13 # = actionFERTILIZER (will be gone)
        actionSEPTIC = 19 # (will be gone)
        actionCode = 	ifelse(	current_patch_info['pavedRoadQfrac']+
        						current_patch_info['roofQfrac']+
        						current_patch_info['otherImpQfrac']>=1,1,actionGWDRAIN) * # GW drain except road/roof/parkinglot
        				ifelse(current_patch_info['sewerdrainQ']>0,actionSEWER,1) * # sewer drain (top 3-m)
						ifelse(current_patch_info['subsurfpipedrainQ']>0,actionPIPEDRAIN,1) * # subsurface pipe drain (top 1-m) along the ROAD	
        				## ...		
        				ifelse(current_patch_info['riparianQ']>0,actionRIPARIAN,1) * # riparian
        				## ...
        				ifelse(current_patch_info['irrigateQfrac']>0,actionIRRIGATION,1) * # lawn irrigation & fertilizer
        				## ...
        				ifelse(current_patch_info['septicQfrac']>0,actionSEPTIC,1) * # septic
        				## ...
                    	ifelse(current_patch_info['roadStormdrainInletQfrac']>0,
                    		ifelse(current_patch_info['nonmodelstrgridQ']>0,1,actionSTORMDRAIN), 1)  # count for stream under road bridge
						
		drainage_type = ifelse(current_patch_info['strQ']>0, 1, # class::stream
						ifelse(actionCode>1, actionCode,0))	
        
        
        
        neighbourLength = 1:length(withinNeighbourRC)
        neighbourOrder = match(withinNeighbourRC,unique(withinNeighbourRC))
        
        allNeighbourInfo = simplify2array(tapply(neighbourLength, INDEX=neighbourOrder, function(jj){
            ## exploring information between "current" and neighbour(jj)
            # index4neighbour[jj][1] # index of neighbour(jj) in "patchInfo" list
            # withinNeighbourRC_edge[jj] # all edges between current and neighbour(jj)
            # withinNeighbourRC_prefer[jj] # all prefers between current and neighbour(jj)
            
            neighbor_patch_info = patchInfo[[ index4neighbour[jj][1] ]];
            idiffDEM = current_patch_info['elevation']-neighbor_patch_info['elevation']
            idiffDEM = ifelse(idiffDEM<0,0, idiffDEM)
            
            idiffDEM_surf = current_patch_info['elevation']-neighbor_patch_info['elevation'] + 10*current_patch_info['roofQfrac'] # roof height > 10m
            idiffDEM_surf = ifelse(idiffDEM_surf<0,0, idiffDEM_surf)
            
            surfWeight = min(1,current_patch_info['pavedRoadQfrac']+current_patch_info['otherImpQfrac'])
            
            return <- c(
                patchID = as.numeric(neighbor_patch_info['patchID']), #patchID, zone, hill [1,2,3]
                zoneID = as.numeric(neighbor_patch_info['zoneID']),
                hillID = as.numeric(neighbor_patch_info['hillID']),
                ## ... distance
                dist = as.numeric(sqrt((neighbor_patch_info['xx']-current_patch_info['xx'])^2 +
                (neighbor_patch_info['yy']-current_patch_info['yy'])^2)), # distance [4]
                ## ... rise
                rise = as.numeric(idiffDEM), #rise (local prefer) [5] # zero correct
                riseRegion = ifelse( mean(withinNeighbourRC_prefer[jj])>0, flatDEMdrop, 0), #rise (regional prefer) [6] # zero correct
               
                rise_surf = as.numeric(idiffDEM_surf)*(1-surfWeight) + as.numeric(idiffDEM_surf)*surfWeight*withinNeighbourRC_prefer_surf[jj],
                    # if a neighbour is prefered by surf drain, then drain to there more
                    # current_patch_info['elevation']
               
                ## ... shared edge
                sharedEdge = sum(withinNeighbourRC_edge[jj]), #edge [7]
                ## info
                neighbor_patch_info['roofQfrac'], # roof 8
                neighbor_patch_info['pavedRoadQfrac'], # road 9
                neighbor_patch_info['otherImpQfrac'], # parking 10
                neighbor_patch_info['irrigateQfrac'] # lawn 11
            )
        }))#tapply
        #allNeighbourInfo['rise',]
        #allNeighbourInfo['riseRegion',]
        #allNeighbourInfo['rise_surf',]
        
        ## local prefer
        slope_jj_l = allNeighbourInfo['rise',]/allNeighbourInfo['dist',] # rise / distance
        gamma_jj_l = slope_jj_l*allNeighbourInfo['sharedEdge',] # edge (width)
        
        ## regional prefer
        slope_jj_r = allNeighbourInfo['riseRegion',]/allNeighbourInfo['dist',] # rise / distance
        gamma_jj_r = slope_jj_r*allNeighbourInfo['sharedEdge',]
        
        cc1 = sum(gamma_jj_l)==0 # use gamma_jj_r
        cc2 = sum(gamma_jj_l < gamma_jj_r)==0  ## if T, all local gamma is > regional gamma: use gamma_jj_l
        cc3 = sum(gamma_jj_l) > sum(gamma_jj_r)
        if(cc1){
            gamma_jj = gamma_jj_r
            selectedFlow2neigbour = slope_jj_r>0
        }else if(cc2){
            gamma_jj = gamma_jj_l
            selectedFlow2neigbour = slope_jj_l>0
        }else if(cc3){
            gamma_jj = gamma_jj_l/sum(gamma_jj_l)*0.3 + (gamma_jj_r>0)*0.7
            selectedFlow2neigbour = slope_jj_r>0 | slope_jj_l>0
        }else{
            gamma_jj = gamma_jj_l + gamma_jj_r
            selectedFlow2neigbour = slope_jj_r>0 | slope_jj_l>0
        }
        # cbind(allNeighbourInfo[1,], gamma_jj)
        
        
        ## surface prefer
        final_rise_surf = allNeighbourInfo['rise_surf',]
        if(sum(final_rise_surf)==0){ final_rise_surf=allNeighbourInfo['riseRegion',]; }
        slope_jj_s = final_rise_surf/allNeighbourInfo['dist',] # rise / distance
        gamma_jj_s = slope_jj_s*allNeighbourInfo['sharedEdge',] # edge (width)
        if( sum(gamma_jj_s)==0 ){
            print(paste(ii, current_patch_info['patchID']) )
            gamma_jj_s = rep(1, length(gamma_jj_s))
        }#if
        #cbind(allNeighbourInfo[1,], gamma_jj_s, allNeighbourInfo['rise_surf',], gamma_jj, allNeighbourInfo['rise',])
        # cbind(slope_jj_l,slope_jj_r,slope_jj_s)
        # cbind(gamma_jj_l,gamma_jj_r,gamma_jj_s)
        
        ## ... neighbour gamma fraction
        neighbor_frac_gamma = gamma_jj/ifelse(sum(gamma_jj)>0,sum(gamma_jj),1)
        neighbor_frac_gamma_surf = gamma_jj_s/sum(gamma_jj_s)
        cbind(allNeighbourInfo[1,], neighbor_frac_gamma_surf, neighbor_frac_gamma)
        
        ## ... total_gamma (subsurface)
        total_perimeter = sum( allNeighbourInfo['sharedEdge', selectedFlow2neigbour] )
        total_gamma = sum(gamma_jj)/total_perimeter*current_patch_info['len']*cellarea; # currrent CF calculation
        if(drainage_type==1) total_gamma = current_patch_info['aveSlope']*current_patch_info['len']*cellarea; # special for stream
            
        septic_num_drainIN = length(patchInfo_septicSource[[ii]])
        irrigation_num_drainIN = length(patchInfo_irrigationSource[[ii]])
        maxWithdrawalDailyWater_mmd = ifelse( length(template$maxWithdrawalDailyWater_mmd)>0,
            template$maxWithdrawalDailyWater_mmd,
            4)
      #-------------- subsurface -------------------# within a for loop
        if(as.numeric(templateACTION$outputSubFlow[2])>0){
            
            if(abs(sum(neighbor_frac_gamma)-1)>1e-10){ print(paste('subsurface',ii,current_patch_info['patchID'],sum(neighbor_frac_gamma))) }
            cat(
				paste(current_patch_info[c('patchID','zoneID','hillID')], collapse=' '),
				paste(sprintf('%.1f',current_patch_info[c('rr','cc')]), collapse=' '),
                paste(sprintf('%.1f', -septic_num_drainIN)), # use negative number because some old file may have 1 here
                paste(sprintf('%.1f', -irrigation_num_drainIN)), # use negative number because some old file may have 1 here
				sprintf('%.2f', ifelse(!is.na(current_patch_info['basementQfrac']),current_patch_info['basementQfrac'],0)*BASEMENT_DEPTH + ifelse(!is.na(current_patch_info['pavedRoadQfrac']),current_patch_info['pavedRoadQfrac'],0)*PAVEDROAD_DEPTH + ifelse(!is.na(current_patch_info['otherImpQfrac']),current_patch_info['otherImpQfrac'],0)*PAVEDROAD_DEPTH), #wttd
				drainage_type,
				total_gamma, length(withinNeighbourRC),'\n', file=subsurfaceflow_table_buff,sep=' ')
            
            cat( paste(
				allNeighbourInfo['patchID',],
				allNeighbourInfo['zoneID',],
				allNeighbourInfo['hillID',],
				sprintf('%.5f',neighbor_frac_gamma),
				sprintf('%.2f',allNeighbourInfo['sharedEdge',]/allNeighbourInfo['dist',]),
				sprintf('%.2f',allNeighbourInfo['sharedEdge',]),sep=' '), file=subsurfaceflow_table_buff,sep='\n')
            
            # ... traditional road grid, which cannot be stream or outlet grid
            if(drainage_type==2) cat (
				patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'],
				patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['zoneID'],
				patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['hillID'],
				#patch_info_lowest['patchID'],
				#patch_info_lowest['zoneID'],
				#patch_info_lowest['hillID'],
				roadWidth,'\n', file=subsurfaceflow_table_buff,sep=' ')  #cellsize*current_patch_info[15]
            
            # ... this is for known sources of irrigation / septic water
            # design note: ACTION_flags (irrigation or septic) enable irrigation or septic release to occur
            # 			   If drainIN neighbors present then, the release water is constrained by the source available water
           	#			   If no drainIN neighbors present then, irrigation or septic release is just constrained by the parameter in lulc.def
            #patchID, zoneID, hillID,
			#maxDailyDrain: max withdrawal flux (mm/d)
			#propDrainFrmSurf: drain from surface or SAT at the source --> source Mode: 1 = surf only; 0 = subsurface; 2 = other storage;
			#DrainFrac: fraction among sources
			#
			
			
			## septic
			if( length(patchInfo_septicSource[[ii]])>0 ){
				drainIN_patch_info = do.call(cbind,patchInfo[ patchInfo_septicSource[[ii]] ]);
				num_Source = dim(drainIN_patch_info)[2]; 
				cat( paste(
				drainIN_patch_info['patchID',],
				drainIN_patch_info['zoneID',],
				drainIN_patch_info['hillID',],
				sprintf('%.3f',rep(maxWithdrawalDailyWater_mmd,num_Source)),
				sprintf('%.3f',patchInfo_septicSourceMODE[[ii]]), #<<--- check here
				sprintf('%.3f',rep(1/num_Source,num_Source)),sep=' '), file=subsurfaceflow_table_buff,sep='\n')}
			
			## irrigation
			if( length(patchInfo_irrigationSource[[ii]])>0 ){
				drainIN_patch_info = do.call(cbind,patchInfo[ patchInfo_irrigationSource[[ii]] ]);
				num_Source = dim(drainIN_patch_info)[2]; 
				cat( paste(
				drainIN_patch_info['patchID',],
				drainIN_patch_info['zoneID',],
				drainIN_patch_info['hillID',],
				sprintf('%.3f',rep(maxWithdrawalDailyWater_mmd,num_Source)),
				sprintf('%.3f',patchInfo_irrigationSourceMODE[[ii]]), #<<--- check here
				sprintf('%.3f',rep(1/num_Source,num_Source)),sep=' '), file=subsurfaceflow_table_buff,sep='\n')}
                
            
        }# if subsurface output
        
        #-------------- surface -------------------# within a for loop
        if(as.numeric(templateACTION$outputSurfFlow[2])>0){
            
            if( (current_patch_info['roofRedirectedQfrac']>0 | current_patch_info['roadStormdrainInletQfrac']>0 | current_patch_info['nonstrsurfdrainQfrac']>0) & current_patch_info['strQ']==0 ){
                
                # roof / parking / road on current patch
                stormsurfacedrainFrac = c(
                    ifelse(current_patch_info['roofRedirectedQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0,current_patch_info['roofRedirectedQfrac'],0),  # roof Frac
                    ifelse(current_patch_info['roadStormdrainInletQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0,current_patch_info['roadStormdrainInletQfrac'],0),  # road Frac
                    ifelse(current_patch_info['nonstrsurfdrainQfrac']>0 &
                        current_patch_info['nonmodelstrgridQ']==0,0.9,0) # e.g., surface drain around the roof/road/parkinglot
                ); names(stormsurfacedrainFrac) = c('roof','road','extenddrain')
                if(sum(stormsurfacedrainFrac[1:2])>=1){
                    stormsurfacedrainFrac[1:2] = stormsurfacedrainFrac[1:2]/sum(stormsurfacedrainFrac[1:2]);
                    stormsurfacedrainFrac[3]=0;
                }else if(stormsurfacedrainFrac[3]>0 & sum(stormsurfacedrainFrac[1:3])>=1){ stormsurfacedrainFrac[3] = 1 - sum(stormsurfacedrainFrac[1:2]); }
                
                
                # adjust the gamma fractions
                normal_neighborNum = length(neighbor_frac_gamma_surf)
                normalFrac = 1 - sum(stormsurfacedrainFrac) - ifelse(current_patch_info['nonmodelstrgridQ']>0, 0.4,0.0);
                if(normalFrac<0){
                    print(paste(ii, normalFrac));
                    normalFrac = 0;
                } #<<---- problem to check
                normal_neighbor_frac_gamma = (neighbor_frac_gamma_surf * normalFrac)
                
                #if(abs(sum(normal_neighbor_frac_gamma)-1)>1e-10) print(paste('surface (special)',ii,current_patch_info['patchID'],sum(normal_neighbor_frac_gamma)))
                
                
                ## stop routing from current to roof on surface
                normal_neighbor_frac_gammaSUM = sum(normal_neighbor_frac_gamma)
                normal_neighbor_frac_gamma = normal_neighbor_frac_gamma * sapply( (1.0-allNeighbourInfo['roofQfrac',]+current_patch_info['roofQfrac']),function(x){return <- min(1,x)}) # roofFrac of neighbour patch
                if(sum(normal_neighbor_frac_gamma)>0){
                    normal_neighbor_frac_gamma = normal_neighbor_frac_gamma/sum(normal_neighbor_frac_gamma)*normal_neighbor_frac_gammaSUM;
                }else{
                    normal_neighbor_frac_gamma = rep(0,length(normal_neighbor_frac_gamma))
                }
                
                
                ## counting number of neighbours
                if(current_patch_info['roofRedirectedQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0) normal_neighborNum = normal_neighborNum + max(1, length(patchInfo_surf_roofRedirectedOutlet[[ii]])); # roof (* need update!)
                
                if(current_patch_info['roadStormdrainInletQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0) normal_neighborNum = normal_neighborNum + max(1, length(patchInfo_surf_roadStormDrainOutlet[[ii]])); # road
                
                if(current_patch_info['nonstrsurfdrainQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0) normal_neighborNum = normal_neighborNum + max(1, length(patchInfo_surf_additionalSurfaceDrainOutlet[[ii]])); # surface drain around the roof/road/parkinglot (* need update!)
                
                if( current_patch_info['nonmodelstrgridQ']>0) normal_neighborNum = normal_neighborNum + 1; # stream ext.
                
                cat(
                    paste(current_patch_info[c('patchID','zoneID','hillID')], collapse=' '),
                    paste(sprintf('%.1f',current_patch_info[c('rr','cc')]), collapse=' '),
                    paste(sprintf('%.1f', -septic_num_drainIN)), # use negative number because some old file may have 1 here
               	 	paste(sprintf('%.1f', -irrigation_num_drainIN)), # use negative number because some old file may have 1 here
                    sprintf('%.2f', ifelse(!is.na(current_patch_info['basementQfrac']),current_patch_info['basementQfrac'],0)*BASEMENT_DEPTH + ifelse(!is.na(current_patch_info['pavedRoadQfrac']),current_patch_info['pavedRoadQfrac'],0)*PAVEDROAD_DEPTH + ifelse(!is.na(current_patch_info['otherImpQfrac']),current_patch_info['otherImpQfrac'],0)*PAVEDROAD_DEPTH),
                    drainage_type,
                    total_gamma, normal_neighborNum, '\n', file=surfaceflow_table_buff,sep=' ')
                
                cat( paste(
                    allNeighbourInfo['patchID',],
                    allNeighbourInfo['zoneID',],
                    allNeighbourInfo['hillID',],
                    sprintf('%.5f',normal_neighbor_frac_gamma),
                    sprintf('%.2f',allNeighbourInfo['sharedEdge',]/allNeighbourInfo['dist',]),
                    sprintf('%.2f',allNeighbourInfo['sharedEdge',]),sep=' '), file=surfaceflow_table_buff,sep='\n')
                
                
                # road / storm drain --> sub-catchment outlet ***
                if(current_patch_info['roadStormdrainInletQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0){
                    if( length(patchInfo_surf_roadStormDrainOutlet[[ii]])>0 & sum(is.na(patchInfo_surf_roadStormDrainOutlet[[ii]]))==0){
                        for(outleti in patchInfo_surf_roadStormDrainOutlet[[ii]] ){
                            cat(
                                # ... to designed outlet
                                patchInfo[[ outleti ]]['patchID'],
                                patchInfo[[ outleti ]]['zoneID'],
                                patchInfo[[ outleti ]]['hillID'],
                                # ... to the designed outlet
                                sprintf('%.5f', stormsurfacedrainFrac['road']),
                                sprintf('%.2f',1.0),
                                sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                        }# for outleti
                    }else{
                        cat(
                            # ... to sub-basin outlet
                            patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'],
                            patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['zoneID'],
                            patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['hillID'],
                            # ... to baisn outlet
                            #patch_info_lowest['patchID'],
                            #patch_info_lowest['zoneID'],
                            #patch_info_lowest['hillID'],
                            sprintf('%.5f', stormsurfacedrainFrac['road']),
                            sprintf('%.2f',1.0),
                            sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                    }#else
                }#if
                
                # roof tops --> sub-catchment outlet ***
                if(current_patch_info['roofRedirectedQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0){
                    if( length(patchInfo_surf_roofRedirectedOutlet[[ii]])>0 & sum(is.na(patchInfo_surf_roofRedirectedOutlet[[ii]]))==0){
                        for(outleti in patchInfo_surf_roofRedirectedOutlet[[ii]] ){
                            cat(
                                # ... to designed outlet
                                patchInfo[[ outleti ]]['patchID'],
                                patchInfo[[ outleti ]]['zoneID'],
                                patchInfo[[ outleti ]]['hillID'],
                                # ... to the designed outlet
                                sprintf('%.5f', stormsurfacedrainFrac['roof']),
                                sprintf('%.2f',1.0),
                                sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                        }# for outleti
                    }else{
                        cat(
                            # ... to sub-basin outlet
                            patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'],
                            patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['zoneID'],
                            patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['hillID'],
                            # ... to baisn outlet
                            #patch_info_lowest['patchID'],
                            #patch_info_lowest['zoneID'],
                            #patch_info_lowest['hillID'],
                            sprintf('%.5f', stormsurfacedrainFrac['roof']),
                            sprintf('%.2f',1.0),
                            sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                    }#else
                }# if
                
                # other imp --> sub-catchment outlet ***
                if(current_patch_info['nonstrsurfdrainQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0){
                    if( length(patchInfo_surf_additionalSurfaceDrainOutlet[[ii]])>0 & sum(is.na(patchInfo_surf_additionalSurfaceDrainOutlet[[ii]]))==0){
                        for(outleti in patchInfo_surf_additionalSurfaceDrainOutlet[[ii]] ){
                            cat(
                                # ... to designed outlet
                                patchInfo[[ outleti ]]['patchID'],
                                patchInfo[[ outleti ]]['zoneID'],
                                patchInfo[[ outleti ]]['hillID'],
                                # ... to the designed outlet
                                sprintf('%.5f', stormsurfacedrainFrac['extenddrain']),
                                sprintf('%.2f',1.0),
                                sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                        }# for outleti
                    }else{
                        cat(
                            # ... to sub-basin outlet
                            patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'],
                            patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['zoneID'],
                            patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['hillID'],
                            # ... to baisn outlet
                            #patch_info_lowest['patchID'],
                            #patch_info_lowest['zoneID'],
                            #patch_info_lowest['hillID'],
                            sprintf('%.5f', stormsurfacedrainFrac['extenddrain']),
                            sprintf('%.2f',1.0),
                            sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                    }#else
                }# if

                # strExt (surface) & NOT str grid @ outlet
                if(current_patch_info['nonmodelstrgridQ']>0 & current_patch_info['patchID']!=patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'] ) cat(
                    patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'],
                    patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['zoneID'],
                    patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['hillID'],
                    #patch_info_lowest['patchID'],
                    #patch_info_lowest['zoneID'],
                    #patch_info_lowest['hillID'],
                    sprintf('%.5f', 0.4),
                    sprintf('%.2f',1.0),
                    sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                
                # strExt (surface) & str grid @ outlet
                if(current_patch_info['nonmodelstrgridQ']>0 & current_patch_info['patchID']==patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID']) cat(
                    patch_info_basinoutlet['patchID'],
                    patch_info_basinoutlet['zoneID'],
                    patch_info_basinoutlet['hillID'],
                    sprintf('%.5f', 0.4),
                    sprintf('%.2f',1.0),
                    sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                
                ## septic
                if( length(patchInfo_septicSource[[ii]])>0 ){
                    drainIN_patch_info = do.call(cbind,patchInfo[ patchInfo_septicSource[[ii]] ]);
                    num_Source = dim(drainIN_patch_info)[2];
                    cat( paste(
                    drainIN_patch_info['patchID',],
                    drainIN_patch_info['zoneID',],
                    drainIN_patch_info['hillID',],
                    sprintf('%.3f',rep(maxWithdrawalDailyWater_mmd,num_Source)),
                    sprintf('%.3f',patchInfo_septicSourceMODE[[ii]]), #<<--- check here
                    sprintf('%.3f',rep(1/num_Source,num_Source)),sep=' '), file=surfaceflow_table_buff,sep='\n')}
                
                ## irrigation
                if( length(patchInfo_irrigationSource[[ii]])>0 ){
                    drainIN_patch_info = do.call(cbind,patchInfo[ patchInfo_irrigationSource[[ii]] ]);
                    num_Source = dim(drainIN_patch_info)[2];
                    cat( paste(
                    drainIN_patch_info['patchID',],
                    drainIN_patch_info['zoneID',],
                    drainIN_patch_info['hillID',],
                    sprintf('%.3f',rep(maxWithdrawalDailyWater_mmd,num_Source)),
                    sprintf('%.3f',patchInfo_irrigationSourceMODE[[ii]]), #<<--- check here
                    sprintf('%.3f',rep(1/num_Source,num_Source)),sep=' '), file=surfaceflow_table_buff,sep='\n')}
                
            }else{
                # same as subsurface flow
                normal_neighbor_frac_gamma = neighbor_frac_gamma_surf
                #if(abs(sum(normal_neighbor_frac_gamma)-1)>1e-10) print(paste('surface (normal)',ii,current_patch_info['patchID'],sum(normal_neighbor_frac_gamma)))
                
                    
                ## stop routing from current to roof on surface
                normal_neighbor_frac_gammaSUM = sum(normal_neighbor_frac_gamma)
                normal_neighbor_frac_gamma = normal_neighbor_frac_gamma * sapply( (1.0-allNeighbourInfo['roofQfrac',]+current_patch_info['roofQfrac']),function(x){return <- min(1,x)}) # roofFrac
                if(sum(normal_neighbor_frac_gamma)>0){normal_neighbor_frac_gamma = normal_neighbor_frac_gamma/sum(normal_neighbor_frac_gamma)*normal_neighbor_frac_gammaSUM;}else{ normal_neighbor_frac_gamma = rep(0,length(normal_neighbor_frac_gamma)) }
                    
                cat(
                    paste(current_patch_info[c('patchID','zoneID','hillID')], collapse=' '),
                    paste(sprintf('%.1f',current_patch_info[c('rr','cc')]), collapse=' '),
                    paste(sprintf('%.1f', -septic_num_drainIN)), # use negative number because some old file may have 1 here
                	paste(sprintf('%.1f', -irrigation_num_drainIN)), # use negative number because some old file may have 1 here
                    sprintf('%.2f', ifelse(!is.na(current_patch_info['basementQfrac']),current_patch_info['basementQfrac'],0)*BASEMENT_DEPTH + ifelse(!is.na(current_patch_info['pavedRoadQfrac']),current_patch_info['pavedRoadQfrac'],0)*PAVEDROAD_DEPTH + ifelse(!is.na(current_patch_info['otherImpQfrac']),current_patch_info['otherImpQfrac'],0)*PAVEDROAD_DEPTH),
                    drainage_type,
                    total_gamma,length(withinNeighbourRC),'\n', file=surfaceflow_table_buff,sep=' ')
                
                cat( paste(
                    allNeighbourInfo['patchID',],
                    allNeighbourInfo['zoneID',],
                    allNeighbourInfo['hillID',],
                    sprintf('%.5f', normal_neighbor_frac_gamma),
                    sprintf('%.2f',allNeighbourInfo['sharedEdge',]/allNeighbourInfo['dist',]),
                    sprintf('%.2f',allNeighbourInfo['sharedEdge',]),sep=' '), file=surfaceflow_table_buff,sep='\n')
                    #sprintf('%.2f',allNeighbourInfo[7,]/allNeighbourInfo[4,]),
                    #sprintf('%.2f',allNeighbourInfo[7,]),sep=' '), file=surfaceflow_table_buff,sep='\n')
                
                ## septic
                if( length(patchInfo_septicSource[[ii]])>0 ){
                    drainIN_patch_info = do.call(cbind,patchInfo[ patchInfo_septicSource[[ii]] ]);
                    num_Source = dim(drainIN_patch_info)[2];
                    cat( paste(
                    drainIN_patch_info['patchID',],
                    drainIN_patch_info['zoneID',],
                    drainIN_patch_info['hillID',],
                    sprintf('%.3f',rep(maxWithdrawalDailyWater_mmd,num_Source)),
                    sprintf('%.3f',patchInfo_septicSourceMODE[[ii]]), #<<--- check here
                    sprintf('%.3f',rep(1/num_Source,num_Source)),sep=' '), file=surfaceflow_table_buff,sep='\n')}
                
                ## irrigation
                if( length(patchInfo_irrigationSource[[ii]])>0 ){
                    drainIN_patch_info = do.call(cbind,patchInfo[ patchInfo_irrigationSource[[ii]] ]);
                    num_Source = dim(drainIN_patch_info)[2];
                    cat( paste(
                    drainIN_patch_info['patchID',],
                    drainIN_patch_info['zoneID',],
                    drainIN_patch_info['hillID',],
                    sprintf('%.3f',rep(maxWithdrawalDailyWater_mmd,num_Source)),
                    sprintf('%.3f',patchInfo_irrigationSourceMODE[[ii]]), #<<--- check here
                    sprintf('%.3f',rep(1/num_Source,num_Source)),sep=' '), file=surfaceflow_table_buff,sep='\n')}
                
            }# else

            
        }# surf table print out
    
    }# for loop ii

    if(as.numeric(templateACTION$outputSubFlow[2])>0 ){
       close(subsurfaceflow_table_buff)
    }
    if(as.numeric(templateACTION$outputSurfFlow[2])>0 ){
        close(surfaceflow_table_buff)
    }

arg=commandArgs(T)


library(rgrass7)
library(sp)
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})

rast = readRAST(arg[1]) # rast = readRAST('patch')
mask = !is.na(rast@data[[1]])

patchlulcFrac = read.csv(arg[2]); patchlulcFracCODE = colnames(patchlulcFrac)[c(-1,-2)]; print('read patchlulcFrac')
lulcCodeFrac = read.csv(arg[3]); lulcCodeFracCODE = paste('lulc',lulcCodeFrac$lulcCode,sep=''); print('read lulcCodeFrac')
toPatchCond = match(patchlulcFracCODE,lulcCodeFracCODE)
if( sum(is.na(toPatchCond)) ){
	print(patchlulcFracCODE)
	print(lulcCodeFracCODE)
    print('ERROR: the LULC composition table does not match with LULC GIS data.')
}else{
    
    lulcCodeFrac = lulcCodeFrac[toPatchCond,]
    forestCode = list(); forestCode$title=NULL; forestCode$value=NULL;
    shrubCode = list(); shrubCode$title=NULL; shrubCode$value=NULL;
    cropCode = list(); cropCode$title=NULL; cropCode$value=NULL;
    lawCode = list(); lawCode$title=NULL; lawCode$value=NULL;
    impCode = list(); impCode$title=NULL; impCode$value=NULL;
    roofCode = list(); roofCode$title=NULL; roofCode$value=NULL;
    drivewayCode = list(); drivewayCode$title=NULL; drivewayCode$value=NULL;
    pavedroadCode = list(); pavedroadCode$title=NULL; pavedroadCode$value=NULL;
    noDataCode = list(); noDataCode$title=NULL; noDataCode$value=NULL;
    waterCode = list(); waterCode$title=NULL; waterCode$value=NULL;
    
    tmp=lulcCodeFrac$lulcCode[lulcCodeFrac$lulcComposition_forest>0];
        if(length(tmp)>0){ forestCode$title = paste('lulc',tmp,sep=''); forestCode$value = match(tmp,lulcCodeFrac$lulcCode); }
    tmp=lulcCodeFrac$lulcCode[lulcCodeFrac$lulcComposition_shrub>0];
        if(length(tmp)>0){ shrubCode$title = paste('lulc',tmp,sep=''); shrubCode$value = match(tmp,lulcCodeFrac$lulcCode); }
    tmp=lulcCodeFrac$lulcCode[lulcCodeFrac$lulcComposition_crop>0];
        if(length(tmp)>0){ cropCode$title = paste('lulc',tmp,sep=''); cropCode$value = match(tmp,lulcCodeFrac$lulcCode); }
    tmp=lulcCodeFrac$lulcCode[lulcCodeFrac$lulcComposition_lawn>0];
        if(length(tmp)>0){ lawCode$title = paste('lulc',tmp,sep=''); lawCode$value = match(tmp,lulcCodeFrac$lulcCode); }
    
    tmp=lulcCodeFrac$lulcCode[lulcCodeFrac$lulcComposition_imp>0];
        if(length(tmp)>0){ impCode$title = paste('lulc',tmp,sep=''); impCode$value = match(tmp,lulcCodeFrac$lulcCode); }
    tmp=lulcCodeFrac$lulcCode[lulcCodeFrac$impBreakdownFrac_roof>0];
        if(length(tmp)>0){ roofCode$title = paste('lulc',tmp,sep=''); roofCode$value = match(tmp,lulcCodeFrac$lulcCode); }
    tmp=lulcCodeFrac$lulcCode[lulcCodeFrac$impBreakdownFrac_driveway>0];
        if(length(tmp)>0){ drivewayCode$title = paste('lulc',tmp,sep=''); drivewayCode$value = match(tmp,lulcCodeFrac$lulcCode); }
    tmp=lulcCodeFrac$lulcCode[lulcCodeFrac$impBreakdownFrac_pavedRoad>0];
        if(length(tmp)>0){ pavedroadCode$title = paste('lulc',tmp,sep=''); pavedroadCode$value = match(tmp,lulcCodeFrac$lulcCode); }
    
    tmp=lulcCodeFrac$lulcCode[lulcCodeFrac$noData>0];
    if(length(tmp)>0){ noDataCode$title = paste('lulc',tmp,sep=''); noDataCode$value = match(tmp,lulcCodeFrac$lulcCode); }
    
    tmp=lulcCodeFrac$lulcCode[lulcCodeFrac$waterFrac>0];
    if(length(tmp)>0){ waterCode$title = paste('lulc',tmp,sep=''); waterCode$value = match(tmp,lulcCodeFrac$lulcCode); }
   
   
   
    if(length(arg)>3){suffix = arg[4] }else{ suffix = ''}
    
    #modeList = list()
    gisOrder = match(rast@data[[1]][mask], patchlulcFrac$patchID)
    # ... constructing GIS maps
    rast$lulcComposition = rep(0,length(rast@data[[1]]))
    if(length(forestCode$title)>=1){
        rast$lulcComposition[mask] = (rowSums(do.call(cbind,lapply(seq_along(forestCode$title), function(ii){
            patchlulcFrac[, forestCode$title[ii]]* lulcCodeFrac$lulcComposition_forest[forestCode$value[ii]]
        })))/patchlulcFrac$total)[gisOrder]
    }#if
    writeRAST(rast,paste('forestFrac', suffix,sep=''),zcol='lulcComposition',overwrite=T)
    #modeList[[1]] = (patchlulcFrac[, forestCode]/patchlulcFrac$total)[gisOrder]
    
    rast$lulcComposition = rep(0,length(rast@data[[1]]))
    if(length(shrubCode$title)>=1){
        rast$lulcComposition[mask] = (rowSums(do.call(cbind,lapply(seq_along(shrubCode$title), function(ii){
            patchlulcFrac[, shrubCode$title[ii]]* lulcCodeFrac$lulcComposition_shrub[shrubCode$value[ii]]
        })))/patchlulcFrac$total)[gisOrder]
    }#if
    writeRAST(rast,paste('shrubFrac', suffix,sep=''),zcol='lulcComposition',overwrite=T)
    
    rast$lulcComposition = rep(0,length(rast@data[[1]]))
    if(length(cropCode$title)>=1){
        rast$lulcComposition[mask] = (rowSums(do.call(cbind,lapply(seq_along(cropCode$title), function(ii){
            patchlulcFrac[, cropCode$title[ii]]* lulcCodeFrac$lulcComposition_crop[cropCode$value[ii]]
        })))/patchlulcFrac$total)[gisOrder]
    }#if
    writeRAST(rast,paste('cropFrac', suffix,sep=''),zcol='lulcComposition',overwrite=T)
    
    rast$lulcComposition = rep(0,length(rast@data[[1]]))
    if(length(lawCode$title)>=1){
        rast$lulcComposition[mask] = (rowSums(do.call(cbind,lapply(seq_along(lawCode$title), function(ii){
            patchlulcFrac[, lawCode$title[ii]]* lulcCodeFrac$lulcComposition_lawn[lawCode$value[ii]]
        })))/patchlulcFrac$total)[gisOrder]
    }#if
    writeRAST(rast,paste('lawnFrac', suffix,sep=''),zcol='lulcComposition',overwrite=T)
    
    
    
    
    rast$lulcComposition = rep(0,length(rast@data[[1]]))
    if(length(impCode$title)>=1){
        rast$lulcComposition[mask] = (rowSums(do.call(cbind,lapply(seq_along(impCode$title), function(ii){
            patchlulcFrac[, impCode$title[ii]]* lulcCodeFrac$lulcComposition_imp[impCode$value[ii]]
        })))/patchlulcFrac$total)[gisOrder]
    }#if
    writeRAST(rast,paste('impFrac', suffix,sep=''),zcol='lulcComposition',overwrite=T)
    
    rast$lulcComposition = rep(0,length(rast@data[[1]]))
    if(length(roofCode$title)>=1){
        rast$lulcComposition[mask] = (rowSums(do.call(cbind,lapply(seq_along(roofCode$title), function(ii){
            patchlulcFrac[, roofCode$title[ii]]* lulcCodeFrac$impBreakdownFrac_roof[roofCode$value[ii]]
        })))/patchlulcFrac$total)[gisOrder]
    }#if
    writeRAST(rast,paste('roofFrac', suffix,sep=''),zcol='lulcComposition',overwrite=T)
    
    rast$lulcComposition = rep(0,length(rast@data[[1]]))
    if(length(drivewayCode$title)>=1){
        rast$lulcComposition[mask] = (rowSums(do.call(cbind,lapply(seq_along(drivewayCode$title), function(ii){
            patchlulcFrac[, drivewayCode$title[ii]]* lulcCodeFrac$impBreakdownFrac_driveway[drivewayCode$value[ii]]
        })))/patchlulcFrac$total)[gisOrder]
    }#if
    writeRAST(rast,paste('drivewayFrac', suffix,sep=''),zcol='lulcComposition',overwrite=T)
    
    rast$lulcComposition = rep(0,length(rast@data[[1]]))
    if(length(pavedroadCode$title)>=1){
        rast$lulcComposition[mask] = (rowSums(do.call(cbind,lapply(seq_along(pavedroadCode$title), function(ii){
            patchlulcFrac[, pavedroadCode$title[ii]]* lulcCodeFrac$impBreakdownFrac_pavedRoad[pavedroadCode$value[ii]]
        })))/patchlulcFrac$total)[gisOrder]
    }#if
    writeRAST(rast,paste('pavedroadFrac', suffix,sep=''),zcol='lulcComposition',overwrite=T)
    
    
    
    rast$lulcComposition = rep(0,length(rast@data[[1]]))
    if(length(noDataCode$title)>=1){
        rast$lulcComposition[mask] = (rowSums(do.call(cbind,lapply(seq_along(noDataCode$title), function(ii){
            patchlulcFrac[, noDataCode$title[ii]]* lulcCodeFrac$noData[noDataCode$value[ii]]
        })))/patchlulcFrac$total)[gisOrder]
    }#if
    writeRAST(rast,paste('noDataFrac', suffix,sep=''),zcol='lulcComposition',overwrite=T)
    
    rast$lulcComposition = rep(0,length(rast@data[[1]]))
    if(length(waterCode$title)>=1){
        rast$lulcComposition[mask] = (rowSums(do.call(cbind,lapply(seq_along(waterCode$title), function(ii){
            patchlulcFrac[, waterCode$title[ii]]* lulcCodeFrac$waterFrac[waterCode$value[ii]]
        })))/patchlulcFrac$total)[gisOrder]
    }#if
    writeRAST(rast,paste('waterFrac', suffix,sep=''),zcol='lulcComposition',overwrite=T)
    
}# if wrong LULC code table

options(stringsAsFactors = FALSE)

vectorMin = function(aa,bb){
	sapply(seq_along(aa),function(ii){min(aa[ii],bb[ii])})
}#function

movingAverage = function(x,n=5){
	filter(x,rep(1/n,n), sides=2)
}

can.be.numeric <- function(x) {
    stopifnot(is.atomic(x) || is.list(x)) # check if x is a vector
    numNAs <- sum(is.na(x))
    numNAs_new <- suppressWarnings( sum(is.na(as.numeric(x))) )
    return(numNAs_new == numNAs)
}

# (this part can be read in from stationList.csv)	
# https://stackoverflow.com/questions/17288197/reading-a-csv-file-organized-horizontally
# modified by Lin June 23 2018
read.tcsv = function(file=NULL, text=NULL, nfield=NULL, header=T, sep=",", vskip=0, hskip=0, ...) {
	if(!is.null(file)){
		n = max(count.fields(file, sep=sep), na.rm=TRUE)
		x = readLines(file)
	}else if(!is.null(text) & !is.null(nfield)){
		n = nfield
		x = text
	}

	.splitvar = function(x, sep, n) {
		var = unlist(strsplit(x, split=sep))
	    length(var) = n
	    return(var)
	}#function
	x = do.call(cbind, lapply(x[(vskip+1):length(x)], .splitvar, sep=sep, n=n))
	x = apply(x[(hskip+1):dim(x)[1],], 1, paste, collapse=sep) 
	out = read.csv(text=x, sep=sep, header=header, skip=0, ...)
	return(out)
}#function	


##------------------------------------ for convenience ------------------------------------##
keyTable = function(data){
	return <- cbind(1:ncol(data), colnames(data) )
}

makeTransparent<-function(someColor, alpha=255){
  newColor<-col2rgb(someColor)
  apply(newColor, 2, function(curcoldata){rgb(red=curcoldata[1], green=curcoldata[2],
    blue=curcoldata[3],alpha=alpha/100*255, maxColorValue=255)})
}

## https://www.dataanalytics.org.uk/make-transparent-colors-in-r/
## Transparent colors
## Mark Gardener 2015
## www.dataanalytics.org.uk
t_col <- function(color, percent = 50, name = NULL) {
	rgb.val <- col2rgb(color)
	return <- rgb(rgb.val[1], rgb.val[2], rgb.val[3],
	             max = 255,
	             alpha = (100 - percent) * 255 / 100,
	             names = name)
}


NSE=function(obs,y){
	#assume no zero/NA/Inf, filtered, clean
	obsM = mean(obs,na.rm=T)
	return <- 1 - sum((obs-y)^2,na.rm=T)/sum((obs-obsM)^2,na.rm=T)
}

normalize=function(x){
	xmean=mean(x)
	return <- (x-xmean)/sd(x)
}

rescale = function(x){
	return <- (x-min(x))/(max(x) - min(x))	
}

most = function(x){
    tmp = table(x); # ignore NA
	return <- ifelse(length(tmp)>0,as.numeric(names(tmp)[which.max(tmp)]),NA)
}
##------------------------------------ special functions ------------------------------------##
fivedayblockbaseflow = function(x){
	## 5 day block
	num5dblock=as.integer(length(x)/5)
	blockID = c(rep(1: num5dblock,each=5),rep(num5dblock+1,(length(x)-5* num5dblock) ))
	blockIDx_ = c(rep(1:5, num5dblock),1:(length(x)-5* num5dblock) )
	blockIDx = which(blockIDx_==3) ##<<< ----- missing one at the end
	if(length(blockIDx)<max(blockID)){ blockIDx = append(blockIDx, length(x)) }
	
	minima = tapply(x,blockID, min, na.rm=T) #grpMins(x, blockID)
	baseline = rep(NA,length(minima))
	for(i in 2:(length(baseline)-1)){
		if(0.9*minima[i]<minima[i-1] | 0.9*minima[i]<minima[i+1] ){baseline[i]=minima[i]}
	}#i
	i=length(baseline);baseline[i]=minima[i]; #if(0.9*minima[i]<minima[i-1]){baseline[i]=minima[i]}
	i=1; baseline[i]=minima[i]; #if(0.9*minima[i]<minima[i+1]){baseline[i]=minima[i]}
	
	#plot(x,type='l')
	#points(blockIDx, baseline,col="red")
	
	cond = !is.na(baseline)
	baseflowPt = baseline[cond]
	baseflowPtx = blockIDx[cond]
	tmp =approx(x= baseflowPtx,y=baseflowPt,xout=1:length(x),yleft=baseflowPt[1],yright=baseflowPt[length(baseflowPt)] )
	baseflow=tmp$y
	for(i in 1:length(baseflow)){
		if(!is.na(x[i])){if(baseflow[i]>x[i]){baseflow[i]=x[i]}}
	}

	return <- baseflow
	#lines(baseflow,lty=2,col="green")
}



##------------------------------------ GIS map coloring functions ------------------------------------##
coloringMultiMAPS = function(maps,COLORS=c('red','white','blue'), DELTASIZE=NULL, BREAKS=NULL, NBLOCKS=NULL, MAXV=NULL, MINV=NULL){
    # map is list of maps
    ALL = do.call(c,lapply(seq_along(maps),function(ii){ 
    	cond = !is.na(maps[[ii]])
    	return <- maps[[ii]][cond]
    }))
    if(!is.null(MAXV)){ ALL = ALL[ALL <= MAXV] }
    if(!is.null(MINV)){ ALL = ALL[ALL >= MINV] }
    
    myoptions = c(!is.null(DELTASIZE), !is.null(BREAKS), !is.null(NBLOCKS))
    
    if(sum(myoptions==c(T,F,F))==3){
    	# use DELTASIZE
        theLOW = floor(min(ALL,na.rm=T)/DELTASIZE)*DELTASIZE
        theHIGH = ceiling(max(ALL,na.rm=T)/DELTASIZE)*DELTASIZE
        breaks_ = seq(theLOW,theHIGH,DELTASIZE);
        
    }else if(sum(myoptions==c(T,F,F))==3){
    	# use breaks_
        theLOW = min(ALL,na.rm=T)
        theHIGH = max(ALL,na.rm=T)
        breaks_ = BREAKS;
        if(min(breaks_) > theLOW) breaks_ = c(theLOW,breaks_)
        if(max(breaks_) < theHIGH) breaks_ = c(breaks_,theHIGH)
        
    }else if(sum(myoptions==c(F,F,T))==3){
    	# use nblocks
        theLOW = min(ALL,na.rm=T)
        theHIGH = max(ALL,na.rm=T)
        breaks_ = seq(theLOW,theHIGH,length.out=NBLOCKS)

    }else{
    	# use none
        theLOW = min(ALL,na.rm=T)
        theHIGH = max(ALL,na.rm=T)
        breaks_ = seq(theLOW,theHIGH,length.out=300)
    }
    
        
    
    if(theLOW<0 & theHIGH>0){
        # special case for difference
        ZEROCOLOR = which(COLORS=='white')
        if( length(ZEROCOLOR)>0 & ZEROCOLOR>1 ){
            if(length(COLORS)>ZEROCOLOR){
                colorFUN = colorRampPalette(COLORS[ZEROCOLOR:length(COLORS)])
            }else{
                colorFUN = colorRampPalette(c(COLORS[ZEROCOLOR],'blue'))
            }#
            colorlist = colorFUN( sum(breaks_>=0) );
            
            INVERTED_COLORS = COLORS[1:ZEROCOLOR]
            colorFUN = colorRampPalette( INVERTED_COLORS)
            inverted_colorlist = colorFUN( sum(breaks_<0) );
            colorlist = c(inverted_colorlist,colorlist)
        }else{
            colorFUN = colorRampPalette( COLORS)
            colorlist = colorFUN( sum(breaks_>=0) );
            
            INVERTED_COLORS = sapply(rev(COLORS),function(x){ do.call(rgb, as.list(abs(col2rgb(x)-255)/255)) })
            colorFUN = colorRampPalette( INVERTED_COLORS)
            inverted_colorlist = colorFUN( sum(breaks_<0) );
            colorlist = c(inverted_colorlist,rgb(1,1,1),colorlist)
        }
    }else{
        colorFUN = colorRampPalette( COLORS)
        colorlist = colorFUN(length(breaks_));
    }#
    
    result = hist(ALL, breaks=breaks_, border=colorlist);
    return <- data.frame(bp=result$breaks, col=sapply(colorlist,function(x){ paste(col2rgb(x),collapse=':')}) );
}#function

colorBarImage = function(cs,digits=1,vertical=F, ...){
    colorscheme_RCOL = sapply(cs$col, function(x){do.call(rgb, as.list(as.numeric(unlist(strsplit(x,split=':')))/255)) })
    xx = seq_along(cs$bp)
    xx_mark = quantile(xx/max(xx),probs=c(0,0.25,0.5,0.75,1))
    if(vertical){
        dev.new(width=1.2,height=4);
        par(mar=c(1,1,1,4), ...)
        image(t(as.matrix(xx)),col=colorscheme_RCOL,yaxt='n',xaxt='n')
        axis(4, at=xx_mark, labels=round(quantile(cs$bp,probs=c(0,0.25,0.5,0.75,1)),digits),las=2)
    }else{
        dev.new(width=4,height=1);
        par(mar=c(3,1,1,1), ...)
        image(as.matrix(xx),col=colorscheme_RCOL,yaxt='n',xaxt='n')
        axis(1, at=xx_mark, labels=round(quantile(cs$bp,probs=c(0,0.25,0.5,0.75,1)),digits),las=1)
    }
}#function

mapVisual = function(basemap,title=NULL, cs=NULL, xres=1, yres=1, new=T){
	
	stats = c(
		sum=sum(basemap,na.rm=T),
		mean=mean(basemap,na.rm=T),
		quantile(basemap,c(0.025,0.25,0.5,0.75,1-0.025),na.rm=T))
	print(stats)
	if(is.null(cs)){
		if(new) dev.new();
		par(mar=c(1,1,2,1));image(basemap,asp=yres/xres,xaxt='n',yaxt='n',bty='n',main=title); 
	}else{
		#colorBarImage(cs);
		colorscheme_RCOL = sapply(cs$col, function(x){do.call(rgb, as.list(as.numeric(unlist(strsplit(x,split=':')))/255)) })
		newvalue = apply(basemap,2,function(xx){ sapply(xx,function(yy){ ifelse(is.na(yy),NA,which.min(abs(cs$bp-yy))) }) })
		colrange = unique(as.vector(newvalue)); colrange = sort(colrange[!is.na(colrange)]); # = newvalueID
		fin = apply(newvalue,2,function(xx){ match(xx, colrange) })
		
		# newvalue = do.call(cbind, lapply(seq_len(dim(basemap)[2]),function(xx){ 
			# sapply(basemap[,xx],function(yy){ifelse(is.na(yy),NA,which.min(abs(cs$bp-yy))) }) 
		# }))
		
		#print(colrange)
		if(new) dev.new();
		par(mar=c(1,1,2,1));
		image(
			fin,
			asp=yres/xres,main=title,
			xaxt='n',yaxt='n',bty='n',
			col=colorscheme_RCOL[colrange]);
	}# end of if
}#function

flowDistributionPlot = function(qm3pd, stack=F, ...){
	xx = seq(0,1,0.01)
	yy = quantile(qm3pd*1000/3600/24,xx) # --> L/s
	if(stack){ lines((1-xx)*100, yy, ...) }else{ plot((1-xx)*100, yy, ...) }
}# function

arg=commandArgs(T)


library(rgrass7)
library(sp)
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})

rast = readRAST(arg[1])
mask = !is.na(rast@data[[1]])

# ... read the GIS extracted file (row=patchID, column=code)
patchCodeFrac = read.csv(arg[2]);
patchCodeFracCODE = colnames(patchCodeFrac)[c(-1,-2)];
print('read patchCodeFrac')

# ... read the code-veg table (row=unique code ID, column=veg name & ID & Ffrac)
lulcCodeFrac_title = unlist(strsplit(readLines(arg[3],n=1),split=','))[-1];
lulcCodeFrac_vegID = as.numeric(unlist(strsplit(readLines(arg[3],n=2)[2],split=','))[-1]);
lulcCodeFrac = read.csv(arg[3],skip=2,header=F); print('read lulcCodeFrac')
lulcCodeFracCODE = paste('lulc',lulcCodeFrac[,1],sep='');

# .... combining information
toPatchCond = match(patchCodeFracCODE,lulcCodeFracCODE)
if( sum(is.na(toPatchCond)) ){
    print('ERROR: the LULC composition table does not match with LULC GIS data.')
}else{
    
    lulcCodeFrac = lulcCodeFrac[toPatchCond,]# reorganized lulcCodeFrac
    gisOrder = match(rast@data[[1]][mask], patchCodeFrac$patchID)
    rast$tmp = rep(NA,length(rast@data[[1]]))
    for(i in seq_along(lulcCodeFrac_title)){
        
        rast$tmp[mask] = (apply(sapply(which(lulcCodeFrac[,i+1]>0),function(j){patchCodeFrac[,j+2]*lulcCodeFrac[j,i+1]}),1,sum)/patchCodeFrac$total )[gisOrder]
        	# .. sum(Ffrac * codeFrac_in_patch)
        writeRAST(rast,paste(lulcCodeFrac_title[i],'_frac',sep=''),zcol='tmp',overwrite=T)
        
        rast$tmp[mask] = (apply(sapply(which(lulcCodeFrac[,i+1]>0),function(j){patchCodeFrac[,j+2]*lulcCodeFrac[j,i+1]}),1,sum) / apply(sapply(which(lulcCodeFrac[,i+1]>0),function(j){patchCodeFrac[,j+2]}),1,sum))[gisOrder]
        	# .. sum(Ffrac * codeFrac_in_patch)
        writeRAST(rast,paste(lulcCodeFrac_title[i],'_Ffrac',sep=''),zcol='tmp',overwrite=T)
        
        cond = !is.na(rast$tmp[mask]) & rast$tmp[mask]>0
        rast$id = rep(NA,length(rast@data[[1]]))
        rast$id[mask][cond] = as.integer(lulcCodeFrac_vegID[i])
        writeRAST(rast,paste(lulcCodeFrac_title[i],'_vegid',sep=''),zcol='id',overwrite=T)
    }#i
    
}# if wrong LULC code table

## single basin
## sub-patch/grid setting
#----------------------------------------------------------------------------------------------
	options(scipen=999)	
	arg=commandArgs(T)
	
	
#----------------------------------------------------------------------------------------------
	# read in rast
	library(rgrass7)
	library(rgdal)
	library(sp)
	tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})

	# bounded by GIS mask
	basinMap = 'basin'
	rast0 = readRAST(basinMap)
	mask = !is.na(rast0@data[[1]])
		
	strMAP = 'str'	
	rast3 = readRAST(strMAP)
	str = rast3@data[[1]][mask]	
	
	lulcMAP = 'NLCD' # NLCD coded
	rast4 = readRAST(lulcMAP)
	lulc = rast4@data[[1]][mask]	
		
	
	rast0$vegid = rep(NA,length(mask))
	rast0$landuse = rep(NA,length(mask))
	rast0$lai = rep(NA,length(mask))
	rast0$impervious = rep(NA,length(mask))
	rast0$coverFrac = rep(NA,length(mask))
	
	#--- forest
		cond=(lulc==41 | lulc==43 | lulc==90 | lulc==95) & is.na(str); 
		rast0$vegid[mask][cond] = as.integer(2) # deciduous @ vegCollection.csv
		rast0$landuse[mask][cond] = as.integer(2) # undeveloped @ lulcCollection.csv
		rast0$coverFrac[mask][cond] = 1.0
		rast0$lai[mask][cond] = 4.5
		rast0$impervious[mask][cond] = 0.0
		
		cond=(lulc==42) & is.na(str); 
		rast0$vegid[mask][cond] = as.integer(1) # evergreen @ vegCollection.csv 
		rast0$landuse[mask][cond] = as.integer(2) # undeveloped @ lulcCollection.csv
		rast0$coverFrac[mask][cond] = 1.0
		rast0$lai[mask][cond] = 5.0
		rast0$impervious[mask][cond] = 0.0
	
		cond=(lulc==51 | lulc==52) & is.na(str); 
		rast0$vegid[mask][cond] = as.integer(6) # shrub @ vegCollection.csv 
		rast0$landuse[mask][cond] = as.integer(2) # undeveloped @ lulcCollection.csv
		rast0$coverFrac[mask][cond] = 1.0
		rast0$lai[mask][cond] = 2
		rast0$impervious[mask][cond] = 0.0

	#--- pasture / grass / agriculture 
		cond=(lulc==71 | lulc==72 | lulc==81 | lulc==82) & is.na(str); 
		rast0$vegid[mask][cond] = as.integer(3) # grass @ vegCollection.csv 
		rast0$landuse[mask][cond] = as.integer(1) # grass @ lulcCollection.csv
		rast0$coverFrac[mask][cond] = 1.0
		rast0$lai[mask][cond] = 1.5
		rast0$impervious[mask][cond] = 0.0

	#--- urban / barren
		cond=(lulc==31) & is.na(str); 
		rast0$vegid[mask][cond] = as.integer(6) # no-veg @ vegCollection.csv (may vary by state/county/city/local)
		rast0$landuse[mask][cond] = as.integer(2) # undeveloped @ lulcCollection.csv
		rast0$coverFrac[mask][cond] = 0.15
		rast0$lai[mask][cond] = 3.0
		rast0$impervious[mask][cond] = 0.85
		
		cond=(lulc==21) & is.na(str); 
		rast0$vegid[mask][cond] = as.integer(3) # grass @ vegCollection.csv (may vary by state/county/city/local)
		rast0$landuse[mask][cond] = as.integer(3) # urban @ lulcCollection.csv
		rast0$coverFrac[mask][cond] = 0.8
		rast0$lai[mask][cond] = 1.5
		rast0$impervious[mask][cond] = 0.2
		
		cond=(lulc==22) & is.na(str); 
		rast0$vegid[mask][cond] = as.integer(3) # grass @ vegCollection.csv (may vary by state/county/city/local)
		rast0$landuse[mask][cond] = as.integer(3) # urban @ lulcCollection.csv
		rast0$coverFrac[mask][cond] = 0.5
		rast0$lai[mask][cond] = 1.5
		rast0$impervious[mask][cond] = 0.5
		
		cond=(lulc==23) & is.na(str); 
		rast0$vegid[mask][cond] = as.integer(3) # grass @ vegCollection.csv (may vary by state/county/city/local)
		rast0$landuse[mask][cond] = as.integer(3) # urban @ lulcCollection.csv
		rast0$coverFrac[mask][cond] = 0.2
		rast0$lai[mask][cond] = 1.5
		rast0$impervious[mask][cond] = 0.8
		
		cond=(lulc==24) & is.na(str); 
		rast0$vegid[mask][cond] = as.integer(4) # no-veg @ vegCollection.csv (may vary by state/county/city/local)
		rast0$landuse[mask][cond] = as.integer(3) # urban @ lulcCollection.csv
		rast0$coverFrac[mask][cond] = 1.0
		rast0$lai[mask][cond] = 1.0
		rast0$impervious[mask][cond] = 1.0
	
		cond= !is.na(str); 
		rast0$vegid[mask][cond] = as.integer(4) # no-veg @ vegCollection.csv (may vary by state/county/city/local)
		rast0$landuse[mask][cond] = as.integer(2) # undeveloped @ lulcCollection.csv
		rast0$coverFrac[mask][cond] = 1.0
		rast0$lai[mask][cond] = 0.0
		rast0$impervious[mask][cond] = 0.0
		
	writeRAST(rast0,'vegid',zcol='vegid',overwrite=T)
	writeRAST(rast0,'landuse',zcol='landuse',overwrite=T)
	writeRAST(rast0,'coverFrac',zcol='coverFrac',overwrite=T)
	writeRAST(rast0,'lai',zcol='lai',overwrite=T)
	writeRAST(rast0,'impervious',zcol='impervious',overwrite=T)
		
		
		
		

options(scipen=999)	
arg=commandArgs(T)

library(rgrass7)
library(sp)
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})
rast = readRAST(arg[1:3])
xx = rast@data[[1]]
yy = rast@data[[2]]
dem = rast@data[[3]]

meta = gmeta()
xres = meta$ewres
yres = meta$nsres
xres_1 = 1.0/meta$ewres
yres_1 = 1.0/meta$nsres

# linear method (horizontal, vertical, 45-degree line) to edit DEM within channel flowline
fromPoints = list()
fromPoints[[1]] = c(345405.30, 4359785.16) # xx,yy UTM
fromPoints[[2]] = c(345406.30, 4359795.59) # xx,yy UTM

toPoints = list()
toPoints[[1]] = c(345440.75, 4359788.80) # xx,yy UTM
toPoints[[2]] = c(345445.17, 4359794.65) # xx,yy UTM

numOfLINE = length(fromPoints)

fromINDEX = sapply( seq_len(numOfLINE), function(i){ which.min(abs(xx-fromPoints[[i]][1])+abs(yy-fromPoints[[i]][2])) })
toINDEX = sapply( seq_len(numOfLINE), function(i){ which.min(abs(xx-toPoints[[i]][1])+abs(yy-toPoints[[i]][2]))})

## ... filling between two endpoints
lineINDEX = lapply( seq_len(numOfLINE), function(i){
	xnum = floor( (xx[toINDEX[i]] - xx[fromINDEX[i]])*xres_1 );
	ynum = floor( (yy[toINDEX[i]] - yy[fromINDEX[i]])*yres_1 );
	
	if( xnum==0 ){
		linepty = yy[fromINDEX[i]] + (0:ynum)*yres;
		return <- sapply( seq_along(linepty), function(jj){which.min(abs(xx-xx[fromINDEX[i]])+abs(yy-linepty[jj])) })
	}else if( ynum==0 ){
		lineptx = xx[fromINDEX[i]] + (0:xnum)*xres;
		return <- sapply( seq_along(lineptx), function(jj){which.min(abs(xx-lineptx[jj])+abs(yy-yy[fromINDEX[i]])) })
	}else if( xnum==ynum ){
		linepty = yy[fromINDEX[i]] + (0:ynum)*yres;
		lineptx = xx[fromINDEX[i]] + (0:xnum)*xres;
		return <- sapply( seq_along(lineptx), function(jj){which.min(abs(xx-lineptx[jj])+abs(yy-linepty[jj])) })
	}else{
		return <- NA	
	}
})#lapply


## ... calculate elevation slope and value
lineFIX = lapply( seq_len(numOfLINE), function(i){
	lineElevation = dem[lineINDEX[[i]]]
	lineSlope = (lineElevation[length(lineElevation)] - lineElevation[1])/(length(lineElevation)-1)
	return <- lineElevation[1] + lineSlope*(seq_along(lineElevation)-1)
})#lapply

rast$dem = dem
for(i in seq_len(numOfLINE)){
	rast$dem[lineINDEX[[i]]] = lineFIX[[i]]
}#i
#cond = rast$dem != dem; sum(cond)


## ... write back to GRASS
writeRAST(rast,'dem',zcol='dem', overwrite=T)
	
	
	
	

options(scipen=999)	
arg=commandArgs(T)

library(rgrass7)
library(rgdal)
library(sp)
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})
# arg=c('dem','colmap', 'rowmap', 'drain','hill', 'strExt')

rast = readRAST(arg,NODATA=0)
mask = !is.na(rast@data[[1]])
dem = rast@data[[1]][mask]
cols = rast@data[[2]][mask]
rows = rast@data[[3]][mask]
drain = rast@data[[4]][mask]
hill = rast@data[[5]][mask]
str = rast@data[[6]][mask]

DtoR = pi/180
colneighbor = c(1,	0,	-1,	-1,	-1,	0,	1,	1)	
rowneighbor = c(-1,	-1,	-1,	0,	1,	1,	1,	0)

maxCol = max(cols,na.rm=T) 
maskRC = rows*maxCol+cols #paste(rows, cols,sep=':') ## row*[max col]+col (yes: unique ID)
hashenv <- new.env(hash=T)
list2env(setNames(as.list(seq_along(dem)),maskRC),envir=hashenv) #<<---- native R hash

	##############################################################################################
	### ---------------- calculate difference in elevation from current cell to its downslope cell
	print('processing dsd ...')
	rast$output = rep(NA,length(mask))
	rast$output[mask] = unlist(lapply(seq_along(dem), function(ii){
		downIndex = hashenv[[ toString((rows[ii] + rowneighbor[drain[ii]])*maxCol + (cols[ii] + colneighbor[drain[ii]])) ]]
		if(length(downIndex)>0){
			return <- dem[ii] - dem[downIndex]
		}else{
			return <- NA
		}	
	}))#sapply
	rast$output[!mask] = NA
	writeRAST(rast, paste('dsd',toupper(arg[1]),sep=''), zcol='output', overwrite=T)
	
	##############################################################################################
	### ----------------- calculate averaged difference in elevation from current cell to its upslope cell
	print('processing usd ...')
	rast$usdDEM = rep(0,length(mask))
	rast$usdDEMCount = rep(0,length(mask))
	for(ii in seq_along(dem)){
		downIndex = hashenv[[ toString((rows[ii] + rowneighbor[drain[ii]])*maxCol + (cols[ii] + colneighbor[drain[ii]])) ]]
		demDIFF = ifelse(length(downIndex)>0, dem[ii] - dem[downIndex], NA)
		#averagedValue = mean(c(rast$usdDEM[mask][downIndex], demDIFF),na.rm=T)
		#rast$usdDEM[mask][downIndex] = ifelse(is.na(averagedValue),NA, averagedValue)	
		rast$usdDEM[mask][downIndex] = rast$usdDEM[mask][downIndex] + ifelse(is.na(demDIFF), 0, demDIFF)
		rast$usdDEMCount[mask][downIndex] = rast$usdDEMCount[mask][downIndex] + ifelse(is.na(demDIFF), 0, 1)
	}#
	COND = rast$usdDEMCount>0
	rast$usdDEM[COND] = rast$usdDEM[COND]/rast$usdDEMCount[COND]
	rast$usdDEM[!mask] = NA
	writeRAST(rast, paste('usd',toupper(arg[1]),sep=''), zcol='usdDEM', overwrite=T)
	
	##############################################################################################
	### ----------
	print('processing hands ...')
	rast$handsDEM = rep(NA,length(mask)); #	rast$processed = rep(0,length(mask))
	maxlen = sum(mask)
	for(ii in seq_along(dem)){
		traceIndex = list()
		traceIndex_ii = 1;
		
		cii = ii; traceIndex[[traceIndex_ii]]=ii; traceIndex_ii=traceIndex_ii+1
		downIndex = hashenv[[ toString((rows[cii] + rowneighbor[drain[cii]])*maxCol + (cols[cii] + colneighbor[drain[cii]])) ]]
		if( is.null(downIndex) | length(downIndex)==0 ){
			rast$handsDEM[mask][ii] = 0
		}else{
			while( traceIndex_ii<=maxlen &(is.na(str[downIndex]) | is.na(rast$handsDEM[mask][downIndex])) ){
				cii = downIndex; traceIndex[[traceIndex_ii]]=downIndex; traceIndex_ii=traceIndex_ii+1
				downIndex = hashenv[[ toString((rows[cii] + rowneighbor[drain[cii]])*maxCol + (cols[cii] + colneighbor[drain[cii]])) ]]
				if(is.null(downIndex) | length(downIndex)==0 ){ downIndex=traceIndex[[traceIndex_ii-1]]; break; } 
			}#while
			if( traceIndex_ii>=maxlen ) print(paste('warning ',ii,sep=''))
			rast$handsDEM[mask][unlist(traceIndex)] = dem[unlist(traceIndex)] - dem[downIndex] + 
				ifelse(is.na(str[downIndex]) & !is.na(rast$handsDEM[mask][downIndex]),rast$handsDEM[mask][downIndex],0)
		}#
	}# for ii
	#rast$handsDEM[!mask]=NA
	writeRAST(rast, paste('hands',toupper(arg[1]),sep=''), zcol='handsDEM', overwrite=T)
	
	##############################################################################################
	# MC Cluster Analysis bounded with hillslopes
	# library(mclust)
	
	# mostChangeDEMindex = unlist(tapply(seq_along(hill), hill, function(ii){
		# fit <- Mclust(rast$usdDEM[mask][ii]);
		# resultTable = aggregate(rast$usdDEM[mask][ii],by=list(fit$classification),FUN=mean);
		# selectClass = resultTable[resultTable[,2]>mean(resultTable[,2]),1];
		# return <- ii[fit$classification %in% selectClass]
	# }))#tapply
	
	# riparian = rep(NA,length(mask))
	# riparian[mask][mostChangeDEMindex] = 1
	# rast$riparian = as.integer(riparian);
	# writeRAST(rast, paste('usd',toupper(arg[1]),'riparian',sep=''), zcol="riparian", overwrite=T)
	
	
	############################################################################################## (previous)
	# # K-Means Cluster Analysis
	# fit <- Mclust(data.frame(usd=rast$usdDEM[mask],sub=sub)) #plot(fit) #summary(fit)
	# fit$cluster = fit$classification
	
	# # K-Means Cluster Analysis
	# # fit <- kmeans(rast$usdDEM[mask], 20,iter.max=1000) # 80 cluster solution
	
	# # get cluster means 
	# resultTable = aggregate(rast$usdDEM[mask],by=list(fit$cluster),FUN=mean)
	# selectClass = resultTable[resultTable[,2]>mean(resultTable[,2]),1]
	
	# zoneGIS = rep(NA,length(mask))
	# zoneGIS[mask] = fit$cluster
	# rast$output = as.integer(zoneGIS);
	# writeRAST(rast, paste('usd',toupper(arg[1]),'analysis',sep=''), zcol="output", overwrite=T)
	
	# riparian = rep(NA,length(mask))
	# riparian[mask][fit$cluster %in% selectClass] = 1
	# rast$riparian = as.integer(riparian);
	# writeRAST(rast, paste('usd',toupper(arg[1]),'riparian',sep=''), zcol="riparian", overwrite=T)

arg=commandArgs(T)


library(rgrass7)
library(sp)
tryCatch({ use_sp() },error=function(cond){message(cond)},warning=function(cond){message(cond)},finally={message("Please update the rgrass7 package on R")})
#arg=c('patch30m','demRAW','lawnfieldIDs','rooftopIDs','rooftopIDlawnIDs','xmap','ymap')
rast = readRAST(arg[1:7])
mask = !is.na(rast@data[[1]])
patch = rast@data[[1]][mask]
dem = rast@data[[2]][mask]
lawn = rast@data[[3]][mask]
roof = rast@data[[4]][mask]
rooflawn = rast@data[[5]][mask]
xx = rast@data[[6]][mask]
yy = rast@data[[7]][mask]

cond = !is.na(roof)
roofID = unique(roof[cond])
roof_drain_table = do.call(rbind, lapply(roofID,function(id){
    
    
    roof_patchID = unique(patch[cond][roof[cond]==id])
    roof_dem = mean(dem[cond][roof[cond]==id])
    roof_patch = patch[patch%in%roof_patchID]
    roof_x = mean(xx[cond][roof[cond]==id])
    roof_y = mean(yy[cond][roof[cond]==id])
    # sources
    sourceCond = dem[patch%in%roof_patchID] > roof_dem & is.na(roof[patch%in%roof_patchID])
    if(sum(sourceCond)>0){
        source_patch_count = table(roof_patch[sourceCond])
        source_patch = as.numeric(names(source_patch_count)[which.max(source_patch_count)]);source_patch
    }else{
        source_patch_count = table(roof_patch)
        source_patch = as.numeric(names(source_patch_count)[which.max(source_patch_count)]);source_patch
    }

    # drain field (rasterization shifted the boundaries)
    dfCond = dem[patch%in%roof_patchID] < roof_dem & !is.na(lawn[patch%in%roof_patchID]) & is.na(roof[patch%in%roof_patchID])
    if(sum(dfCond)>0){
        df_patch_count = table(roof_patch[dfCond])
        df_patch = as.numeric(names(df_patch_count)[which.max(df_patch_count)]);df_patch
    }else{
        # look for nearest lawn field
        nearlawnID = unique(rooflawn[cond][roof[cond]==id])
        nearlawnCond = !is.na(lawn) & lawn%in%nearlawnID
        if(sum(nearlawnCond)>0){
            dist = tapply(sqrt((xx[nearlawnCond] - roof_x)^2 + (yy[nearlawnCond] - roof_y)^2), patch[nearlawnCond], mean)
            selectCond = which.min(dist[table(patch[nearlawnCond])>4])
            df_patch = ifelse(sum(selectCond)>0,as.numeric(names(dist)[selectCond]),NA)
        }else{
            df_patch = NA
        }
    }# if

    # irrigration lawn: roof->lawnID->patch->irrigation area
    roof_lawnID = unique(lawn[patch%in%roof_patchID]); roof_lawnID = roof_lawnID[!is.na(roof_lawnID)]
    lawn_patch = patch[lawn%in%roof_lawnID]
    lawn_patchID = unique(lawn_patch)
    lawn_patchID_count = patch[patch%in%lawn_patchID]
    lawn_patchX = xx[lawn%in%roof_lawnID]
    lawn_patchY = yy[lawn%in%roof_lawnID]
    dist = sqrt((lawn_patchX-roof_x)^2 + (lawn_patchY-roof_y)^2)
    irrigration_weight = ifelse(dist<50, 1, exp(-dist*0.25))
    patch_scale_weight = round(tapply(irrigration_weight,lawn_patch,sum) / tapply(rep(1,length(lawn_patchID_count)),lawn_patchID_count,sum),3)
    irrigration_string = paste(paste(names(patch_scale_weight),collapse=';'),paste(patch_scale_weight,collapse=';'),sep='_')
    
    
    #print(paste(id,source_patch,df_patch, irrigration_string))
    #}
    
    return <-c(id,source_patch,df_patch, irrigration_string,0)
}))
colnames(roof_drain_table)=c('rooftopID','inPatch','outPatch','irrigrationString','mode')
write.csv(roof_drain_table[,c(1:3,5)],arg[8],row.names=F,quote=F)

irrigrationTable = do.call(rbind,lapply(seq_len(dim(roof_drain_table)[1]),function(ii){
    
    source_patchID = as.numeric(roof_drain_table[ii,2])
    stringVar = unlist(strsplit(roof_drain_table[ii,4],'_',fixed=T))
    if(length(stringVar)>1){
        patchID = as.numeric(unlist(strsplit(stringVar[1],';',fixed=T)))
        patchIrriFrac = as.numeric(unlist(strsplit(stringVar[2],';',fixed=T)))
        selectCond = patchIrriFrac>0
        if(sum(selectCond)>0){
            return <- cbind(source_patchID,patchID[selectCond],patchIrriFrac[selectCond],0)
        }else{
            return <- NULL
        }
    }else{
        return <- NULL
    }
}))#
colnames(irrigrationTable)=c('sourcePatchID','irrigrationPatchID','frac','mode')
write.csv(irrigrationTable,arg[9],row.names=F,quote=F)

## need to update this one to write out surface, subsurface, mode

## single basin
## sub-patch/grid setting
#----------------------------------------------------------------------------------------------
source('https://raw.githubusercontent.com/laurencelin/Date_analysis/master/LIB_misc.r')
	options(scipen=999)
    arg = commandArgs(T)

    DtoR = pi/180
	RtoD = 1/DtoR
    BASEMENT_DEPTH = 3 #meter
    PAVEDROAD_DEPTH = 0.3 #meter


	defaultWorldName = c('worldID')
	defaultBasinName = c('basinID','basinX','basinY','basinZ','basinDefID','basinLatitude','basinBase')
	defaultHillName = c('hillID','hillX','hillY','hillZ','hillDefID','hillgws','hillgwno3','hillBase')
	defaultZoneName = c('zoneID','zoneX','zoneY','zoneZ','zoneDefID','zoneArea','zoneSlope','zoneAspect','zoneIso','zoneEH','zoneWH','zoneBase','zoneBaseID')
	defaultPatchName = c('patchID','patchX','patchY','patchZ','patchsoilID','patchLandID','patchArea','patchSlope','patchLNA','patchKsat','patchMpar','patchRZstorage','patchUnsat','patchSat','patchSnowEZ','patchSnowZ','patchSnowT','patchSnowAge','patchSnowED','patchLittercfrac','patchLitterStorage','patchLitterc1','patchLittern1','patchLitterc2','patchLitterc3','patchLitterc4','patchsoilIDc1','patchsoilIDsminn','patchsoilIDNO3','patchsoilIDc2','patchsoilIDc3','patchsoilIDc4','patchBase')
	defaultStratumName = c('strateID','stratePlantID','stratecfrac','strateGap','strateRZ','strateSnowStored','strateRainStored','stratecpool','strateleafc','stratedleafc','strateleafcstore','strateleafctrans','stratelstemc','stratelstemcstore','stratelstemctrans','stratedstemc','stratedstemcstore','stratedstemctrans','stratelrootc','stratelrootcstore','stratelrootctrans','stratedrootc','stratedrootcstore','stratedrootctrans','stratefrootc','stratefrootcstore','stratefrootctrans','stratecwdc','strateEPVleafcalloc','stratenpool','strateleafn','stratedleafn','strateleafnstore','strateleafntrans','stratelstemn','stratelstemnstore','stratelstemntrans','stratedstemn','stratedstemnstore','stratedstemntrans','stratelrootn','stratelrootnstore','stratelrootntrans','stratedrootn','stratedrootnstore','stratedrootntrans','stratefrootn','stratefrootnstore','stratefrootntrans','stratecwdn','strateRetransn','epv_wstress_days','epv_max_fparabs','epv_min_vwc','strateBase')
	title = c(defaultWorldName, defaultBasinName, defaultHillName, defaultZoneName, defaultPatchName, defaultStratumName)
	

#----------------------------------------------------------------------------------------------

    library(sp)
    library(XML)
    library(rgrass7)
    library(rgdal)
    gis = gmeta()
    gridarea = round(gis$nsres * gis$ewres)

    #read template
    # (this part can be read in from stationList.csv)
    # https://stackoverflow.com/questions/17288197/reading-a-csv-file-organized-horizontally
    # modified by Lin June 23 2018
    read.tcsv = function(file, header=T, sep=" ", vskip=0, hskip=0, len=-1, ...) {
        rowCountFields = count.fields(file, sep=sep)
        if(vskip>0) rowCountFields = rowCountFields[-1:-vskip]
        n = max( rowCountFields, na.rm=TRUE)
        
        # x = readLines(file)
        # .splitvar = function(x, sep, n) {
        #     var = unlist(strsplit(x, split=sep))
        #     length(var) = n
        #     return(var)
        # }#function
        # x = do.call(cbind, lapply(x[(vskip+1):endline], .splitvar, sep=sep, n=n))
        # x = apply(x[(hskip+1):dim(x)[1],], 1, paste, collapse=sep)
        # out = read.csv(text=x, sep=sep, header=header, skip=0, ...)
        
        x = read.table(file, sep=' ', fill=T, stringsAsFactors=F )
        endline = dim(x)[1]
        if(len>0) endline = vskip+1+len
        transformedX = sapply( (hskip+1):n, function(ii){
        	paste( x[(vskip+1):endline, ii], collapse=',')
        });
        out = read.csv(text=transformedX, sep=',', header=header, skip=0, ...)
        
        return(out)
    }#function

    templateACTION = read.tcsv(arg[5],stringsAsFactors=F, len=7);
    template = read.tcsv(arg[5],stringsAsFactors=F, vskip=7);
    if(is.null(template$streamFullextension)) template$streamFullextension=''
    if(is.null(template$unpavedroadMap)) template$unpavedroadMap=''
    if(is.null(template$riparianMAP)) template$riparianMAP=''
    if(is.null(template$sewercoverMAP)) template$sewercoverMAP=''
    if(is.null(template$pipecoverMAP)) template$pipecoverMAP=''
    if(is.null(template$stormdrainMAP)) template$stormdrainMAP=''
    if(is.null(template$compactedsoilMAP)) template$compactedsoilMAP=''
    if(is.null(template$additionalSurfaceDrainMAP)) template$additionalSurfaceDrainMAP=''

	projectFolder = arg[1]
	climateStationID = as.numeric(templateACTION$stationID[1])
	climateStationNAME = templateACTION$stationFile[1]
		
	## user provides a customized vegetation.csv containing all vegetation vegParameters.
    print(arg)
	vegParam = read.csv(ifelse(arg[2]=='default'|arg[2]=='NA'|arg[2]=='na'|arg[2]=='.','https://raw.githubusercontent.com/laurencelin/GIS2RHESSys/master/vegCollection.csv', arg[2]),skip=4,header=T,stringsAsFactors=F) #<<------
	vegParamCOL = cbind(as.numeric(unique(vegParam[1,3:ncol(vegParam)])), 3:ncol(vegParam)); 
	colnames(vegParamCOL) = c('vegID','vegDefIndex')
	vegParam_len = ncol(vegParam)
	
	soilParam = read.csv(ifelse(arg[3]=='default'|arg[3]=='NA'|arg[3]=='na'|arg[3]=='.','https://raw.githubusercontent.com/laurencelin/GIS2RHESSys/master/soilCollection.csv', arg[3]),skip=4,header=T,stringsAsFactors=F) #<<------
	soilParamCOL = cbind(as.numeric(unique(soilParam[1,3:ncol(soilParam)])), 3:ncol(soilParam)); 
	colnames(soilParamCOL) = c('soilID','soilDefIndex')
	soilParam_len = ncol(soilParam)
	
	lulcParam = read.csv(ifelse(arg[4]=='default'|arg[4]=='NA'|arg[4]=='na'|arg[4]=='.','https://raw.githubusercontent.com/laurencelin/GIS2RHESSys/master/lulcCollectionEC.csv', arg[4]),skip=4,header=T,stringsAsFactors=F) #<<------
	lulcParamCOL = cbind(as.numeric(unique(lulcParam[1,3:ncol(lulcParam)])), 3:ncol(lulcParam)); 
	colnames(lulcParamCOL) = c('lulcID','lulcDefIndex')
	lulcParam_len = ncol(lulcParam)
	
#----------------------------------------------------------------------------------------------

    ## spatial structures (must have)
	rast = readRAST(c(template$basinMap, template$hillslopeMap, template$zoneMAP, template$patchMAP),NODATA=0)
		mask = !is.na(rast@data[[1]])
		hill = rast@data[[2]][mask]
		zone = rast@data[[3]][mask]
		patch = rast@data[[4]][mask]
	print('reading basin, hill, zone, patch ... DONE')
	
	# extract soil def IDs (must have)
	rast = readRAST(template$soilidMAP,NODATA=0)
		soil = rast@data[[1]][mask]
    print('reading soils ... DONE')

	# extract patch positive numerical values [0 -> +X] (must have)
    # aspect ##<<----- 90=north, 360=east, 180=west 270=south
	rast = readRAST(c(template$xMAP, template$yMAP, template$demMAP, template$slopeMap, template$aspectMAP, template$twiMAP, template$whorizonMAP, template$ehorizonMAP, template$isohyetMAP), NODATA=-1)
		xx = rast@data[[1]][mask]
		yy = rast@data[[2]][mask]
		dem = rast@data[[3]][mask]
		slope = rast@data[[4]][mask] ## ... could be a problem at the edge of the DEM
		aspect = rast@data[[5]][mask] ## ... could be a problem at the edge of the DEM 
		twi = rast@data[[6]][mask] ## ... could be a problem at the edge of the DEM
		whorizon = rast@data[[7]][mask]
		ehorizon = rast@data[[8]][mask]
		isohyet = rast@data[[9]][mask]

    rast = readRAST(c(template$rowMap, template$colMap),NODATA=0)
        rows = rast@data[[1]][mask]
        cols = rast@data[[2]][mask]
    rast = readRAST(template$drainMap)
        drain = abs(rast@data[[1]][mask]) # guide the "flat" surface or surface pit water exit
    print('reading xx,yy,.... ... DONE')

    # extract LULC information (must have)
    rast = readRAST(c(
        template$impFracMAP,#1
        template$roofMAP, #2
        template$drivewayMAP,#3
        template$pavedRoadFracMAP,#4
        template$forestFracMAP,#5
        template$shrubFracMAP,#6
        template$cropFracMAP,#7
        template$grassFracMAP #8
        ), NODATA=-1)

        impFrac = rast@data[[1]][mask]
        roofFrac = rast@data[[2]][mask]
        drivewayFrac = rast@data[[3]][mask]
        pavedRoadFrac = rast@data[[4]][mask]
        forestFrac = rast@data[[5]][mask]
        shrubFrac = rast@data[[6]][mask]
        cropFrac = rast@data[[7]][mask]
        lawnFrac = rast@data[[8]][mask]

    print('reading lulc ... DONE')

    # extract flow table related information
    stream=NULL;tryCatch({
        rast = readRAST(template$streamMap);
        stream <- rast@data[[1]][mask];
        print('reading str ... DONE')},
        error = function(e){ stream <<- rep(NA,length(mask)) }
        )#tryCatch
    fullstreamExt=NULL; tryCatch({
        rast = readRAST(template$streamFullextension);
        fullstreamExt <- rast@data[[1]][mask];
        print('reading strExtension ... DONE')},
        error = function(e){ fullstreamExt <<- stream }
        )#tryCatch
    unpavedroad=NULL; tryCatch({
        rast = readRAST(template$unpavedroadMap);
        unpavedroad <- rast@data[[1]][mask];
        print('reading unpavedRoad ... DONE')},
        error = function(e){ unpavedroad <<- rep(NA,length(mask)) }
        )#tryCatch
    riparian=NULL; tryCatch({
        rast = readRAST(template$riparianMAP);
        riparian <- rast@data[[1]][mask];
        print('reading riparian ... DONE')},
        error = function(e){ riparian <<- rep(NA,length(mask)) }
        )#tryCatch
    sewercover=NULL; tryCatch({
        rast = readRAST(template$sewercoverMAP);
        sewercover <- rast@data[[1]][mask];
        print('reading sewer ... DONE')},
        error = function(e){ sewercover <<- rep(NA,length(mask)) }
        )#tryCatch
    septic=NULL; tryCatch({
        rast = readRAST(template$septicMAP);
        septic <- rast@data[[1]][mask];
        print('reading septic ... DONE')},
        error = function(e){ septic <<- rep(NA,length(mask)) }
        )#tryCatch
    pipecover=NULL; tryCatch({
        rast = readRAST(template$pipecoverMAP);
        pipecover <- rast@data[[1]][mask];
        print('reading pipe ... DONE')},
        error = function(e){ pipecover <<- rep(NA,length(mask)) }
        )#tryCatch
    stormdrain=NULL; tryCatch({
        rast = readRAST(template$stormdrainMAP);
        stormdrain <- rast@data[[1]][mask];
        print('reading stormdrain ... DONE')},
        error = function(e){ stormdrain <<- rep(NA,length(mask)) }
        )#tryCatch
    compactedsoilQ=NULL; tryCatch({
        rast = readRAST(template$compactedsoilMAP);
        compactedsoilQ <- rast@data[[1]][mask];
        print('reading non-impacted soil ... DONE')},
        error = function(e){ compactedsoilQ <<- rep(NA,length(mask)) }
        )#tryCatch
    additionalSurfaceDrain=NULL; tryCatch({
        rast = readRAST(template$additionalSurfaceDrainMAP);
        additionalSurfaceDrain <- rast@data[[1]][mask];
        print('reading additional surf drinage ... DONE')},
        error = function(e){ additionalSurfaceDrain <<- rep(NA,length(mask)) }
        )#tryCatch


    # extract strata information
	treeLAI = lapply(1:15, function(i){
		tryCatch({
            rast = readRAST( template[[paste('tree',i,'LAI',sep='')]] ) # paste('tree',i,'LAI',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	treeID = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('tree',i,'StratumID',sep='')]] ) # paste('tree',i,'StratumID',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	treeFFrac = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('tree',i,'FFrac',sep='')]] ) # paste('tree',i,'FFrac',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})

	shrubLAI = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('shrub',i,'LAI',sep='')]] ) # paste('shrub',i,'LAI',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	shrubID = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('shrub',i,'StratumID',sep='')]] ) # paste('shrub',i,'StratumID',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	shrubFFrac = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('shrub',i,'FFrac',sep='')]] ) # paste('shrub',i,'FFrac',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
    # is(shrubLAI[[2]]); is(shrubID[[2]]); is(shrubFFrac[[2]])
	
	grassLAI = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('grass',i,'LAI',sep='')]] ) # paste('grass',i,'LAI',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	grassID = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('grass',i,'StratumID',sep='')]] ) # paste('grass',i,'StratumID',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	grassFFrac = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('grass',i,'FFrac',sep='')]] ) # paste('grass',i,'FFrac',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
    # is(grassLAI[[2]]); is(grassID[[2]]); is(grassFFrac[[2]])

	cropLAI = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('crop',i,'LAI',sep='')]] ) # paste('crop',i,'LAI',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	cropID = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('crop',i,'StratumID',sep='')]] ) # paste('crop',i,'StratumID',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
	cropFFrac = lapply(1:15, function(i){ 
		tryCatch({
            rast = readRAST( template[[paste('crop',i,'FFrac',sep='')]] ) # paste('crop',i,'FFrac',sep='')
			return <- as.numeric(rast@data[[1]][mask]) },
			
			error = function(e){ return <- NA}
			)#tryCatch
		})
    # is(cropLAI[[2]]); is(cropID[[2]]); is(cropFFrac[[2]])



	## basin centroid and latitude
	sputm <- SpatialPoints(cbind(mean(xx),mean(yy)), proj4string=CRS(gmeta()$proj4) )  
  	spgeo <- spTransform(sputm, CRS("+proj=longlat +datum=WGS84"))
	latitude = spgeo@coords[2]
	
	##-----<< order >>------#
	len = sum(mask)
	RHESSysOrder = order(hill,zone,patch) ### somehow we need to cut deplulated
	tapplyOrder = rep(NA,sum(mask)); tapplyOrder[RHESSysOrder] = match(patch[RHESSysOrder], unique(patch[RHESSysOrder]))
	
	##-----<< list out IDs >>------#
	idMatrix = unique(cbind(patch,zone,hill)[RHESSysOrder,])
	colnames(idMatrix) = c('patchList', 'zoneList', 'hillList')
	
	## hill 
	hillX = tapply(xx,INDEX=hill, FUN=mean)
	hillY = tapply(yy,INDEX=hill, FUN=mean)
	hillZ = tapply(dem,INDEX=hill, FUN=mean)
		hillID = as.numeric(names(hillX))
		numhill = length(hillID)
		hillIDrhessysOrder = match(idMatrix[,'hillList'], hillID) ## organize unique hill into the idMatrix order

	## zone
	zoneEast = tapply(sin(ehorizon*DtoR),INDEX=zone, FUN=mean)
	zoneWest = tapply(sin(whorizon*DtoR),INDEX=zone, FUN=mean)
	
	zoneSlope = tapply(slope,INDEX=zone, FUN=mean) # vector
		aspectcos = tapply(cos(aspect*DtoR)*sin(slope*DtoR),INDEX=zone, FUN=mean)
		aspectsin = tapply(sin(aspect*DtoR)*sin(slope*DtoR),INDEX=zone, FUN=mean)
	zoneAspect = atan(aspectsin/aspectcos)* RtoD ## always between -90 and 90
		zoneAspect[aspectcos<0] = zoneAspect[aspectcos<0] + 180 #yes
		zoneAspect[aspectsin<0 & aspectcos>0] = zoneAspect[aspectsin<0 & aspectcos>0] + 360
		
	zoneX = tapply(xx,INDEX=zone, FUN=mean)
	zoneY = tapply(yy,INDEX=zone, FUN=mean)
	zoneZ = tapply(dem,INDEX=zone, FUN=mean)
    zoneISOHYET = tapply(isohyet,INDEX=zone, FUN=mean)
	zoneArea = tapply(rep(1,len),INDEX=zone, FUN=sum)*gridarea
		zoneID = as.numeric(names(zoneX))
		numzone = length(zoneID)
		zoneIDrhessysOrder = match(idMatrix[,'zoneList'], zoneID) ## organize unique zone into the idMatrix order

	# cbind(zoneAspect,aspect,slope)[80:100,]
	# plot(aspect, zoneAspect); abline(a=0,b=1,lty=2)
	
	
	## patch (patch >= grid)
	patchX = tapply(xx,INDEX=patch, FUN=mean)
	patchY = tapply(yy,INDEX=patch, FUN=mean)
	patchZ = tapply(dem,INDEX=patch, FUN=mean)
	patchCount = tapply(rep(1,len),INDEX=patch, FUN=sum)
	patchArea = patchCount* gridarea
	patchSOIL = tapply(seq_along(patch),INDEX=patch, FUN=function(ii){
		hold=table(soil[ii]); 
		return <- as.numeric(names(hold)[which.max(hold)]) + ifelse(sum(compactedsoilQ[ii],na.rm=T)>0,100,0)# plus 100 for compacted soil.
        # here is a problem when no nonimpactedsoil is defined!!
	})
	patchSLOPE = tapply(slope,INDEX=patch, FUN=mean)
	patchTWI = tapply(abs(twi),INDEX=patch, FUN=mean); patchTWI[is.na(patchTWI)]=0;
		patchID = as.numeric(names(patchX))
		numpatch = length(patchID)	
		patchIDrhessysOrder = match(idMatrix[,'patchList'], patchID) ## organize unique patch into the idMatrix order
	# rep(patchIDrhessysOrder, times=patchVegnum) in below is expending the idMatrix order by Vegnum
	
	## sub-patch/grid setting
	subGridAssignment = matrix(NA,4,5)
	subGridAssignment[2:4,1] = c(NA,	NA,	NA) # tree [LAI, vegID, rootz]
	subGridAssignment[2:4,2] = c(NA,	NA,	NA) # shrub [LAI, vegID, rootz]
	subGridAssignment[2:4,3] = c(NA,	NA,	NA) # crop [LAI, vegID, rootz]
	subGridAssignment[2:4,4] = c(NA,	NA,	NA) # lawn [LAI, vegID, rootz]
	subGridAssignment[2:4,5] = c(0.0,	4,	0) # no veg [LAI, vegID, rootz]		
	landuseClass = c(2,2,1,1,3) # RHESSys def (update RHESSys LULC! need these at all? detention size, fertilizer?, what exact does lulc class do? )
	
		## scanning each grid within a patch and forming within patch configuration using the subgrid information
	subGrid_buff = 'patchID frac lai vegID rootz land imp'
	patchVegnum = tapply(1:sum(mask),INDEX=tapplyOrder, FUN=function(x){
            # 7 -> x= 9029
            #patchSTR = sum(fullstreamExt[x], na.rm=T); # patchSTR==0 --> no canopy on all stream extension!
            patchSTR = sum(stream[x], na.rm=T)
			subGridAssignment[1,] = c(
                ifelse(patchSTR==0,mean(forestFrac[x]),0), #1 tree
                ifelse(patchSTR==0,mean(shrubFrac[x]),0),  #2 shrub
                ifelse(patchSTR==0,mean(cropFrac[x]),0),   #3 crop
                ifelse(patchSTR==0,mean(lawnFrac[x]),0),   #4 lawn
                ifelse(patchSTR==0,mean(impFrac[x]),0)     #5 no veg
				)
			if(is.na(subGridAssignment[1,1]) ) subGridAssignment[1,1]=0
			if(is.na(subGridAssignment[1,2]) ) subGridAssignment[1,2]=0
			if(is.na(subGridAssignment[1,3]) ) subGridAssignment[1,3]=0
            if(is.na(subGridAssignment[1,4]) ) subGridAssignment[1,4]=0
            if(is.na(subGridAssignment[1,5]) ) subGridAssignment[1,5]=0
			
            land = ifelse(sum(septic[x],na.rm=T)>0, 4, landuseClass[which.max(subGridAssignment[1,])] )#  ### not very useful
                # management ACTIONcodes: < (subpatch scale variable)
                # 2 = actionIRRIGRATION  {irrigration daily max} < lawnFrac
                # 3 = actionFERTILIZE {fertilizer application schedule and amount} < lawnFrac
                # 5 = actionGLAZING {lawn/crop glazing} < lawnFrac
                # 7 = actionHARVEST {harvest schedule and amount and aftermath} < lawnFrac & forestFrac?
                # 11 = actionSEPTIC {setpic leaks annual Q and N} < lawnFrac
                # 13 = actionDETENTION {surface detention e.g., very small ponds?, bottom leak, top drainage}
                
                # drainage/routing ACTIONcodes: < (subpatch scale variable)
                # 0 = land (default)
                # 1 = class::stream
                # 2 = class::road
                # 3 = actionSTORMDRAIN {drainage surface Q along roads}
                # 5 = actionGWDRAIN {gw1} < impFrac
                # 7 = actionRIPARIAN {gw2riparian}
                # 17 = actionPIPEDRAIN {drainage surface excessive Q within some areas, e.g., lawn, park}
                # 11 = actionSEWER {drainge subsurface Q; loss of Q}
                
                
			imp = subGridAssignment[1,5]
            fracQ = c(	subGridAssignment[1,1]>0,   # tree
                        subGridAssignment[1,2]>0,   # shrub
                        subGridAssignment[1,3]>0,   # crop
                        subGridAssignment[1,4]>0,   # lawn
						F # no veg
                        )#
                        fracQ[5] = ifelse(sum(fracQ)==0, T, F) # no veg
						
			numVeg = 0			
			subGrid_buff_string = NULL			
			if(fracQ[1]){
				## count how many trees
				FFraclist = sapply(1:15,function(i){ mean(treeFFrac[[i]][x]) }) * subGridAssignment[1,1]
				LAIlist = sapply(1:15,function(i){ mean(treeLAI[[i]][x]) })
				vegIDlist = sapply(1:15,function(i){ treeID[[i]][x][1] })
                
                vegCount = !is.na(FFraclist) & FFraclist>0 & !is.na(LAIlist) & LAIlist>0 & !is.na(vegIDlist) & vegIDlist>0
				numVeg = numVeg + sum(vegCount)		
				subGrid_buff_string = c(subGrid_buff_string,
					sapply(seq_len(15)[vegCount], function(i){
						paste(patch[x][1], FFraclist[i], LAIlist[i], vegIDlist[i], 1, land,imp, sep=' ')
						})
					)#c		
			}# fracQ[1] 
			if(fracQ[2]){ 
				## count how many shrub
				FFraclist = sapply(1:15,function(i){ mean(shrubFFrac[[i]][x]) }) * subGridAssignment[1,2]
				LAIlist = sapply(1:15,function(i){ mean(shrubLAI[[i]][x]) })
				vegIDlist = sapply(1:15,function(i){ shrubID[[i]][x][1] })
                vegCount = !is.na(FFraclist) & FFraclist>0 & !is.na(LAIlist) & LAIlist>0 & !is.na(vegIDlist) & vegIDlist>0
				numVeg = numVeg + sum(vegCount)	
				subGrid_buff_string = c(subGrid_buff_string,
					sapply(seq_len(15)[vegCount], function(i){
						paste(patch[x][1], FFraclist[i], LAIlist[i], vegIDlist[i], 1, land,imp, sep=' ')
						})
					)#c	
			}#fracQ[2]
            if(fracQ[3]){
                ## count how many crop
                FFraclist = sapply(1:15,function(i){ mean(cropFFrac[[i]][x]) }) * subGridAssignment[1,3]
                LAIlist = sapply(1:15,function(i){ mean(cropLAI[[i]][x]) })
                vegIDlist = sapply(1:15,function(i){ cropID[[i]][x][1] })
                vegCount = !is.na(FFraclist) & FFraclist>0 & !is.na(LAIlist) & LAIlist>0 & !is.na(vegIDlist) & vegIDlist>0
                numVeg = numVeg + sum(vegCount)
                subGrid_buff_string = c(subGrid_buff_string,
                sapply(seq_len(15)[vegCount], function(i){
                        paste(patch[x][1], FFraclist[i], LAIlist[i], vegIDlist[i], 0.3, land,imp, sep=' ')
                })
                )#c
            }#fracQ[3]
			if(fracQ[4]){
				## count how many lawn
				FFraclist = sapply(1:15,function(i){ mean(grassFFrac[[i]][x]) }) * subGridAssignment[1,4]
				LAIlist = sapply(1:15,function(i){ mean(grassLAI[[i]][x]) })
				vegIDlist = sapply(1:15,function(i){ grassID[[i]][x][1] })
                vegCount = !is.na(FFraclist) & FFraclist>0 & !is.na(LAIlist) & LAIlist>0 & !is.na(vegIDlist) & vegIDlist>0
				numVeg = numVeg + sum(vegCount)			
				subGrid_buff_string = c(subGrid_buff_string,
					sapply(seq_len(15)[vegCount], function(i){
						paste(patch[x][1], FFraclist[i], LAIlist[i], vegIDlist[i], 0.2, land,imp, sep=' ')
						})
					)#c	
            }#fracQ[4];  numVeg; subGrid_buff_string
			if(fracQ[5]){
				numVeg = numVeg + 1
				subGridAssignment[1,5]=1; #coverFrac for no veg
				subGrid_buff_string = c(subGrid_buff_string,
                        paste(patch[x][1],paste(subGridAssignment[,5],collapse=' '), land,imp, sep=' '))
			}#fracQ[5]
			
			subGrid_buff <<- c(subGrid_buff, unlist(subGrid_buff_string))
			
			return <- numVeg
		})# tapply
		
	subGrid_info = read.table(textConnection(subGrid_buff),sep=' ',header=T)	
	patchVegCover = subGrid_info[,'frac']
	patchVegLAI = subGrid_info[,'lai']
	patchVegID = subGrid_info[,'vegID']
	patchLAND = subGrid_info[,'land'] 	
	patchIMP = subGrid_info[,'imp']  #<<----	
	patchRZ = subGrid_info[,'rootz']

    table(patchVegnum)
    dim(subGrid_info)[1] >= length(patchSLOPE)
    length(patchVegnum) == length(patchSLOPE)
    table(patchVegID)

	lai_ = patchVegLAI ## already ordered
		stratum = patchVegID
		vegDefID = as.numeric(vegParam[1,3:ncol(vegParam)])
		stratumIndex = match(stratum, vegDefID) # return index
		stratumMass=matrix(0,length(lai_),13)
		colnames(stratumMass) = c("leafc","lstemc","dstemc","lrootc","drootc","frootc","leafcalloc","leafn","lstemn","dstemn","lrootn","drootn","frootn")
		
		cond = lai_ >0 
		stratum.SLA = as.numeric(vegParam[48,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.LS = as.numeric(vegParam[12,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.LIVED = as.numeric(vegParam[10,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.DEAD = 1/stratum.LIVED -1; 
		stratum.DEAD[!is.finite(stratum.DEAD)]=0
		stratum.SC = as.numeric(vegParam[8,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.LR = as.numeric(vegParam[9,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.CNL = as.numeric(vegParam[33,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.CNR = as.numeric(vegParam[21,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.CNLW = as.numeric(vegParam[39,3:ncol(vegParam)])[stratumIndex[cond]]
		stratum.CNDW = rep(333.33,sum(cond))
	
		stratumMass[cond,1] =  lai_[cond]/stratum.SLA #leafc
		stratumMass[cond,2] = stratumMass[cond,1]* stratum.LS * stratum.LIVED #live stemc
		stratumMass[cond,3] = stratumMass[cond,2]* stratum.DEAD # dead stemc
		stratumMass[cond,4] = (stratumMass[cond,2]+stratumMass[cond,3])* stratum.SC* stratum.LIVED # live crootc
		stratumMass[cond,5] = stratumMass[cond,4]*stratum.DEAD #dead crootc
		stratumMass[cond,6] = stratumMass[cond,1]* stratum.LR #frootc
		
			#iniRootmass = stratumMass[cond,4]+stratumMass[cond,5]+stratumMass[cond,6]
			#iniRTZ = 3/8 * (2* iniRootmass)^(0.8)
		
		stratum.totmass = rowSums(stratumMass)
		stratumMass[cond,7] = stratumMass[cond,1]*0.05 ##strateEPVleafcalloc
		stratumMass[cond,8] = stratumMass[cond,1]/stratum.CNL
		stratumMass[cond,9] = stratumMass[cond,2]/stratum.CNLW
		stratumMass[cond,10] = stratumMass[cond,3]/stratum.CNDW
		stratumMass[cond,11] = stratumMass[cond,4]/stratum.CNLW
		stratumMass[cond,12] = stratumMass[cond,5]/stratum.CNDW
		stratumMass[cond,13] = stratumMass[cond,6]/stratum.CNR	
		

#----------------------------------------------------------------------------------------------		
if(as.numeric(templateACTION$outputWorldfile[2])>0 ){
    outWorldFilePath = templateACTION$outputWorldfile[1]
	title = c(defaultWorldName, defaultBasinName, defaultHillName, defaultZoneName, defaultPatchName, defaultStratumName)
	write( title, outWorldFilePath, ncolumns=length(title), append=F, sep=',')
		
		
	WorldBasinColumn = rep(1, sum(patchVegnum)) %o% c(1,1, mean(xx), mean(yy), mean(dem), 1, latitude, 0)
	
	hillColumn = cbind(
		hillID,hillX, hillY, hillZ,
		rep(1, numhill) %o% c(1,0,0,0)
		)[rep(hillIDrhessysOrder, times=patchVegnum),]## hill
		
	zoneColumn = cbind(
		zoneID, zoneX, zoneY, zoneZ, 
		rep(1, numzone), zoneArea, zoneSlope, zoneAspect,
		zoneISOHYET, zoneEast, zoneWest,
		rep(1, numzone) %o% c(1, climateStationID)
		)[rep(zoneIDrhessysOrder, times=patchVegnum),]## zone
	
	patchColumn1 = cbind(
		patchID, patchX, patchY, patchZ, patchSOIL)[rep(patchIDrhessysOrder, times=patchVegnum),]## patch
	
	patchColumn2 = cbind(
		patchArea, patchSLOPE, patchTWI)[rep(patchIDrhessysOrder, times=patchVegnum),]## patch
		
	patchColumn3 = cbind(rep(1, numpatch) %o% c(0.12, 0,0,0, 0.28, 0, -10, 0, -0.5,1,0, 0.0000001,0.0000001,0.0000002,0.0000003,0.0000004,0.0000001, 0,0, 0.0000002,2,6,0))[rep(patchIDrhessysOrder, times=patchVegnum),]## patch
						
	stratumColumn = matrix(0, sum(patchVegnum),length(defaultStratumName))	
	stratumColumn[,1] = 1:dim(stratumColumn)[1] #strateID
	stratumColumn[,2] = patchVegID # stratePlantID
	stratumColumn[,3] = patchVegCover # stratecfrac -->affect precipitation intercept 
	stratumColumn[,4] = 0 # strateGap -->affect sunlight intercept 
	stratumColumn[,5] = patchRZ # strateRZ 1m by default
	stratumColumn[,c(9,13,16,19,22,25,29,31,35,38,41,44,47)] = stratumMass
	
	
	write.table(cbind(
		WorldBasinColumn,
		hillColumn,
		zoneColumn,
		patchColumn1,
		patchLAND,
		patchColumn2,
		1-patchIMP,
		patchColumn3,
		stratumColumn
	), outWorldFilePath, row.names=F,col.names=F, append=T, sep=',')
}# if templateACTION$outputWorldfile[2]

#----------------------------------------------------------------------------------------------

    tmp = unlist(strsplit(templateACTION$outputDefs[1],'/'))
	defsFolder = tmp[length(tmp)]
	rhessysFolder = tmp[length(tmp)-1]
	
	## write out selected veg definition files
	vegHEADER = NULL
	selectedVeg = vegParamCOL[match(unique(patchVegID), vegParamCOL[,'vegID']), 'vegDefIndex']
	for(ii in selectedVeg ){
		filename = paste(defsFolder,"/stratum_",gsub("\\.","_",colnames(vegParam)[ii]),".def",sep="")
		vegHEADER = c(vegHEADER, paste(filename,'stratum_default_filename'))
		filepth = paste(arg[1],'/',rhessysFolder,'/', filename,sep="")
		if(as.numeric(templateACTION$outputDefs[2])>0) write.table(cbind(vegParam[, ii], vegParam[,2]), filepth,sep="\t",row.names=F,col.names=F, quote=F)
	}#i

	
	## write out selected soil definition files
	soilHEADER = NULL
	selectedsoil = soilParamCOL[match(unique(patchSOIL), soilParamCOL[,'soilID']), 'soilDefIndex']
	for(ii in selectedsoil ){
		filename = paste(defsFolder,"/soil_",gsub("\\.","_",colnames(soilParam)[ii]),".def",sep="")
		soilHEADER = c(soilHEADER, paste(filename,'patch_default_filename'))
		filepth = paste(arg[1],'/',rhessysFolder,'/', filename,sep="")
		if(as.numeric(templateACTION$outputDefs[2])>0) write.table(cbind(soilParam[, ii], soilParam[,2]), filepth,sep="\t",row.names=F,col.names=F, quote=F)
	}#i
	
	
	## write out selected lulc definition files
	lulcHEADER = NULL
	selectedlulc = lulcParamCOL[match(unique(patchLAND), lulcParamCOL[,'lulcID']), 'lulcDefIndex']
	for(ii in selectedlulc ){
		filename = paste(defsFolder,"/landuse_",gsub("\\.","_",colnames(lulcParam)[ii]),".def",sep="")
		lulcHEADER = c(lulcHEADER, paste(filename,'landuse_default_filename'))
		filepth = paste(arg[1],'/',rhessysFolder,'/', filename,sep="")
		if(as.numeric(templateACTION$outputDefs[2])>0) write.table(cbind(lulcParam[, ii], lulcParam[,2]), filepth,sep="\t",row.names=F,col.names=F, quote=F)
	}#i
	
	zoneDEF = NULL
	zoneDEF = c(zoneDEF, '1 zone_default_ID')
	zoneDEF = c(zoneDEF, '0.000029 atm_trans_lapse_rate')
	zoneDEF = c(zoneDEF, '0.0015 dewpoint_lapse_rate')
	zoneDEF = c(zoneDEF, '0.0064 lapse_rate')
	zoneDEF = c(zoneDEF, '10 max_effective_lai')  
	zoneDEF = c(zoneDEF, '1 max_snow_temp')  
	zoneDEF = c(zoneDEF, '-1 min_rain_temp')  
	zoneDEF = c(zoneDEF, '0.001 n_deposition')  
	zoneDEF = c(zoneDEF, '0.0254 pptmin')  
	zoneDEF = c(zoneDEF, '0.75 sea_level_clear_sky_trans')  
	zoneDEF = c(zoneDEF, '0.4 temcf')  
	zoneDEF = c(zoneDEF, '0.003 trans_coeff1')  
	zoneDEF = c(zoneDEF, '2.2 trans_coeff2')  
	zoneDEF = c(zoneDEF, '1 wind')  
	if(as.numeric(templateACTION$outputDefs[2])>0) write(zoneDEF, paste(templateACTION$outputDefs[1],"/zone_zone.def",sep=""))
	
	basinDEF = NULL
	basinDEF = c(basinDEF, '1 basin_default_ID')
	if(as.numeric(templateACTION$outputDefs[2])>0) write(basinDEF, paste(templateACTION$outputDefs[1],"/basin_basin.def",sep=""))
	
	hillDEF = NULL
	hillDEF = c(hillDEF, '1 hillslope_default_ID')
	hillDEF = c(hillDEF, '1.0 gw_loss_coeff')
	hillDEF = c(hillDEF, '1.0 sat_to_gw_coeff')
	if(as.numeric(templateACTION$outputDefs[2])>0) write(hillDEF, paste(templateACTION$outputDefs[1],"/hillslope_hillslope.def",sep=""))
	
	worldHEADER = NULL
	worldHEADER = c(worldHEADER, paste(1,'num_basin_files'))
	worldHEADER = c(worldHEADER, paste(defsFolder,'/basin_basin.def basin_default_filename',sep=''))	
	worldHEADER = c(worldHEADER, paste(1,'num_hillslope_files'))	
	worldHEADER = c(worldHEADER, paste(defsFolder,'/hillslope_hillslope.def hillslope_default_filename',sep=''))	
	worldHEADER = c(worldHEADER, paste(1,'num_zone_files'))	
	worldHEADER = c(worldHEADER, paste(defsFolder,'/zone_zone.def zone_default_filename',sep=''))	
	
	worldHEADER = c(worldHEADER, paste(length(soilHEADER),'num_patch_files'))	
	worldHEADER = c(worldHEADER, soilHEADER)
	worldHEADER = c(worldHEADER, paste(length(lulcHEADER),'num_landuse_files'))	
	worldHEADER = c(worldHEADER, lulcHEADER)
	worldHEADER = c(worldHEADER, paste(length(vegHEADER),'num_stratum_files'))	
	worldHEADER = c(worldHEADER, vegHEADER)
	
	worldHEADER = c(worldHEADER, paste(1,'num_base_stations'))
	worldHEADER = c(worldHEADER, paste(climateStationNAME,'base_station_filename'))
	
	if(as.numeric(templateACTION$outputWorldfileHDR[2])>0) write(worldHEADER,templateACTION$outputWorldfileHDR[1] )




	##-------------------------------------------------------------------------------------------------------##
	## flow table -- assume square grid
    cellarea = gis$nsres * gis$ewres
    cellsize = sqrt(cellarea)
    flatDEMdrop = tan(DtoR*0.143)*cellsize # only 0.25m drop per 100m.
    roadWidth = 5
    roadWidth = ifelse(cellsize>=9.99,
    	5, # meters (default)
    	ifelse(roadWidth>cellsize, cellsize, roadWidth)
    )# ifelse
    directEdge = cellsize*0.5
    diagonalEdge = cellsize*sqrt(0.5)

    # 1.  2. 3.  4. 5.  6. 7.  8. (GRASS from current drainTO code order)
    # NE, N, NW, W, SW, S, SE, E
    colneighbor = c(1,    0,    -1,    -1,    -1,    0,    1,    1)
    rowneighbor = c(-1,    -1,    -1,    0,    1,    1,    1,    0)
    directEdgeIndex = c(2,4,6,8)
    indirectEdgeIndex = c(1,3,5,7)

    maxCol = max(cols,na.rm=T)
    maskRC = rows*maxCol+cols #paste(rows, cols,sep=':') ## row*[max col]+col (yes: unique ID)
    maskRC_string2Patch_num <- new.env(hash=T)
    list2env(setNames(as.list(patch),maskRC),envir=maskRC_string2Patch_num) #<<---- native R hash
    gridSurroundRC = sapply(rows, FUN=function(x){x+rowneighbor})*maxCol+sapply(cols, FUN=function(x){x+colneighbor})
    gridSurroundRC[!(gridSurroundRC %in% maskRC)] = -1
	
    # part 1: gathering information to temporary files
    fullLength = seq(1,length.out=length(patch))
    patch_info_dem = tapply(dem,INDEX=patch,mean) # use elevation to organize patch order in the file output
    orderedPatch = as.numeric(names(patch_info_dem[order(patch_info_dem,decreasing=T)])) ### patch could be longer than 'orderedPatch'
    outputOrder = match(patch, orderedPatch) # has the same length as 'patch'
    # ... finding basin outlet and hillslope outlets
    strCOND = !is.na(stream)
    subID = 2*ceiling(hill*0.5)
    suboutlet_orderedPatch_index = tapply(fullLength[strCOND], subID[strCOND],function(ii){
        # must be stream channel
        return <- match(patch[ii][which.min(dem[ii])], orderedPatch)
    })#
    suboutlet_orderedPatch_index_hillID = as.numeric(names(suboutlet_orderedPatch_index))
    basinoutlet_orderedPatch_index = match(patch[strCOND][which.min(dem[strCOND])], orderedPatch)


    maskRC_string2outputOrder_num <- new.env(hash=T)
    list2env(setNames(as.list(outputOrder),maskRC),envir=maskRC_string2outputOrder_num) #<<---- native R hash
    maskRC_string2maskRC_num <- new.env(hash=T)
    list2env(setNames(as.list(maskRC),maskRC),envir= maskRC_string2maskRC_num) #<<---- native R hash
	
    print('starting step I')
    patchInfo = tapply(fullLength, INDEX=outputOrder, FUN=function(ii){
        return <- c(
            subIDindex = match(mean(subID[ii]),suboutlet_orderedPatch_index_hillID),
            patchID = mean(patch[ii]),             #1 patchID
            elevation = mean(dem[ii]),             #2 elevation
            xx = mean(xx[ii]),                #3 x coordinate
            yy = mean(yy[ii]),                #4 y coordinate
            hillID = mean(hill[ii]),                #6 hillID
            zoneID = mean(zone[ii]),                #7 zoneID
            rr = mean(rows[ii]),                #8 row index (from left to right)
            cc = mean(cols[ii]),                #9 col index (from top to bottom)
            len = length(ii),                   #10 num of cells
            aveSlope = tan(mean(slope[ii])*DtoR),   #13 average slope
            maxSlope = tan(max(slope[ii])*DtoR),    #14 max slope
            
            ## ... 
            irrigateQfra = mean(lawnFrac[ii],na.rm=T), # 23 lawnFrac for irrigate
            ## ...
            riparianQ = sum(!is.na(riparian[ii])),	#16 (checking whether patch contains riparian grids)
            sewerdrainQ = sum(!is.na(sewercover[ii])), #17 (checking whether patch contains sewercover grids)
            subsurfpipedrainQ = sum(!is.na(pipecover[ii])), # other non-sewer pipes
            compactedsoilQfrac = mean(compactedsoilQ[ii],na.rm=T), # 24 compactedsoilQ
            ## ... surface routing
            strQ = sum(!is.na(stream[ii])),         #11 modeled stream grids
            nonmodelstrgridQ = sum(!is.na(fullstreamExt[ii])),	#21 non-modeled stream grid (treat as land grids)
            nonstrsurfdrainQ = sum(!is.na(additionalSurfaceDrain[ii])), # 22 (non-stream) land grids need surface water drain
			stormdrainQ = sum(!is.na(stormdrain[ii])), #18 drainage points on paved road network
			# note: impFrac = roofFrac + drivewayFrac + pavedroadFrac
			roofQfrac = mean(roofFrac[ii],na.rm=T), 
			drivewayQfrac = mean(drivewayFrac[ii],na.rm=T), 
			pavedRoadQfrac = mean(pavedRoadFrac[ii],na.rm=T), 
			
            ## ... roads
            pavedRoadQ = sum(!is.na(pavedRoadFrac[ii]) & pavedRoadFrac[ii]>0), # assume does not cut watertable
            unpavedRoadQ = sum(!is.na(unpavedroad[ii])) # assume it cuts watertable
        );
    })#tapply <--- this output is a list of c() in outputOrder
    patch_info_lowest = patchInfo[[ length(patchInfo) ]] ## assume basin outlet
    patch_info_basinoutlet = patchInfo[[ basinoutlet_orderedPatch_index ]]
    patch_info_suboulet = lapply(suboutlet_orderedPatch_index, function(ii){ patchInfo[[ii]] })
    #cbind(suboutlet_orderedPatch_index_hillID, suboutlet_orderedPatch_index)


    ## part 2: sort by 'elevation' & finding neighbor
    print('starting step II')
    ## .......... Neighbour
    # ii=which(orderedPatch==24110) #500
    patchNeighbourRC_edge = tapply(fullLength, INDEX=outputOrder, FUN=function(jj){
        withinPatchGridRC = rows[jj]*maxCol+cols[jj]; # within
        
        hold = as.vector(gridSurroundRC[directEdgeIndex,jj]);
        hold[hold%in% withinPatchGridRC] = -1
        
        hold2 = as.vector(gridSurroundRC[indirectEdgeIndex,jj]);
        hold2[hold2%in% withinPatchGridRC] = -1
        
        #return <- c(table(hold[hold>0])* directEdge, table(hold2[hold2>0])* diagonalEdge)
        return <- c( tapply(hold[hold>0],hold[hold>0],length)*directEdge, tapply(hold2[hold2>0],hold2[hold2>0],length)*diagonalEdge)
        
    })

    patchNeighbourRC_LEN = seq_along(patchNeighbourRC_edge) ## <<--------------------------- ordered patch aggregated neighbours
    patchNeighbourRC = sapply(patchNeighbourRC_LEN, function(ii){
        sapply(names(patchNeighbourRC_edge[[ii]]), function(x){maskRC_string2maskRC_num[[ x ]]})
    })
    patchNeighbourPatch = sapply(patchNeighbourRC_LEN, function(ii){
        sapply(names(patchNeighbourRC_edge[[ii]]), function(x){maskRC_string2Patch_num[[ x ]]})
    })
    patchNeighbourPatchIndex = sapply(patchNeighbourRC_LEN, function(ii){
        sapply(names(patchNeighbourRC_edge[[ii]]), function(x){maskRC_string2outputOrder_num[[ x ]]})
    })


    ## .......... prefer Neighbour
    patchPreferNeighbourRC = tapply(fullLength, INDEX=outputOrder, FUN=function(ii){
        withinPatchGridRC = rows[ii]*maxCol+cols[ii]; # within
        drainTO_index = cbind(drain[ii],ii)
        hold3 = as.vector(gridSurroundRC[ drainTO_index ])
        hold3[hold3%in% withinPatchGridRC] = -1
        
        return <- sapply(names(tapply(hold3[hold3>0], hold3[hold3>0],length)),function(x){maskRC_string2maskRC_num[[ x ]]})
    })#

	
	
	
	
	
	
    ## .......... writing out flow table
    if(as.numeric(templateACTION$outputSubFlow[2])>0 ){
        subsurfaceflow_table_buff <- file(templateACTION$outputSubFlow[1],'w') # open a file connection
        cat( length(patchInfo), '\n', file=subsurfaceflow_table_buff) #,sep='\n'
    }
    if(as.numeric(templateACTION$outputSurfFlow[2])>0 ){
        surfaceflow_table_buff <- file(templateACTION$outputSurfFlow[1],'w') # open a file connection
        cat( length(patchInfo), '\n', file=surfaceflow_table_buff) #,sep='\n'
    }

    for(ii in patchNeighbourRC_LEN){
        
        withinNeighbourRC_edge = patchNeighbourRC_edge[[ii]]
        withinNeighbourRC = patchNeighbourRC[[ii]]
        withinNeighbourRC_prefer = rep(0,length(withinNeighbourRC))            
        withinNeighbourRC_prefer[withinNeighbourRC%in%patchPreferNeighbourRC[[ii]] ] = 1
        index4neighbour = patchNeighbourPatchIndex[[ii]]
        
        current_patch_info = patchInfo[[ii]]
        # 0 = land (default)
        # 1 = class::stream
        # 2 = class::road
        # 3 = actionSTORMDRAIN
        # 5 = actionGWDRAIN
        # 7 = actionRIPARIAN
        # 11 = actionSEWER
        # 13 = actionIRRIGRATION
        # 17 = actionPIPEDRAIN
        
        ## actionCode is mostly for subsurface processes; surface storm drain see below.
        # impFrac = roofFrac + drivewayFrac + pavedpavedRoadFrac
        # gw_drainage is bounded by imp
        actionCode = 	ifelse(	current_patch_info['pavedRoadQfrac']+
        						current_patch_info['roofQfrac']+
        						current_patch_info['drivewayQfrac']>=1,1,5) * # GW drain except road/roof/parkinglot
        				ifelse(current_patch_info['sewerdrainQ']>0,11,1) * # sewer drain (top 3-m)
						ifelse(current_patch_info['subsurfpipedrainQ']>0,17,1) * # subsurface pipe drain (top 1-m) along the ROAD	
        				## ...		
        				ifelse(current_patch_info['riparianQ']>0,7,1) * # riparian
        				## ...
        				ifelse(current_patch_info['irrigateQfra']>0,13,1) * # lawn irrigration & fertilizer
        				## ...
						ifelse(current_patch_info['stormdrainQ']>0,ifelse(current_patch_info['nonmodelstrgridQ']>0,1,3), 1)  # count for stream under road bridge
						
		drainage_type = ifelse(current_patch_info['strQ']>0, 1, # class::stream
						ifelse(actionCode>1, actionCode,0)
						)	
        
        
        
        neighbourLength = 1:length(withinNeighbourRC)
        neighbourOrder = match(withinNeighbourRC,unique(withinNeighbourRC))
        
        allNeighbourInfo = simplify2array(tapply(neighbourLength, INDEX=neighbourOrder, function(jj){
            ## exploring information between "current" and neighbour(jj)
            # index4neighbour[jj][1] # index of neighbour(jj) in "patchInfo" list
            # withinNeighbourRC_edge[jj] # all edges between current and neighbour(jj)
            # withinNeighbourRC_prefer[jj] # all prefers between current and neighbour(jj)
            
            neighbor_patch_info = patchInfo[[ index4neighbour[jj][1] ]];
            idiffDEM = current_patch_info['elevation']-neighbor_patch_info['elevation']
            idiffDEM = ifelse(idiffDEM<0,0, idiffDEM)
            
            return <- c(
            patchID = as.numeric(neighbor_patch_info['patchID']), #patchID, zone, hill [1,2,3]
            zoneID = as.numeric(neighbor_patch_info['zoneID']),
            hillID = as.numeric(neighbor_patch_info['hillID']),
            ## ... distance
            dist = as.numeric(sqrt((neighbor_patch_info['xx']-current_patch_info['xx'])^2 +
            (neighbor_patch_info['yy']-current_patch_info['yy'])^2)), # distance [4]
            ## ... rise
            rise = as.numeric(idiffDEM), #rise (local prefer) [5] # zero correct
            riseRegion = ifelse( mean(withinNeighbourRC_prefer[jj])>0, flatDEMdrop, 0), #rise (regional prefer) [6] # zero correct
            ## ... shared edge
            sharedEdge = sum(withinNeighbourRC_edge[jj]), #edge [7]
            ## info
            neighbor_patch_info['roofQfrac'], # roof 8
            neighbor_patch_info['pavedRoadQfrac'], # road 9
            neighbor_patch_info['drivewayQfrac'], # parking 10
            neighbor_patch_info['irrigateQfra'] # lawn 11
            )
        }))#tapply <<--- not in a right order
        
        ## local prefer
        slope_jj_l = allNeighbourInfo['rise',]/allNeighbourInfo['dist',] # rise / distance
        gamma_jj_l = slope_jj_l*allNeighbourInfo['sharedEdge',] # edge (width)
        
        ## regional prefer
        slope_jj_r = allNeighbourInfo['riseRegion',]/allNeighbourInfo['dist',] # rise / distance
        gamma_jj_r = slope_jj_r*allNeighbourInfo['sharedEdge',]
        
        cc1 = sum(gamma_jj_l)==0 # use gamma_jj_r
        cc2 = sum(gamma_jj_l < gamma_jj_r)==0     ## T: use gamma_jj_l
        cc3 = sum(gamma_jj_l) > sum(gamma_jj_r)
        if(cc1){
            gamma_jj = gamma_jj_r
            selectedFlow2neigbour = slope_jj_r>0
        }else if(cc2){
            gamma_jj = gamma_jj_l
            selectedFlow2neigbour = slope_jj_l>0
        }else if(cc3){
            gamma_jj = gamma_jj_l/sum(gamma_jj_l)*0.3 + (gamma_jj_r>0)*0.7
            selectedFlow2neigbour = slope_jj_r>0 | slope_jj_l>0
        }else{
            gamma_jj = gamma_jj_l + gamma_jj_r
            selectedFlow2neigbour = slope_jj_r>0 | slope_jj_l>0
        }
        
        ## ... neighbour gamma fraction
        neighbor_frac_gamma = gamma_jj/ifelse(sum(gamma_jj)>0,sum(gamma_jj),1)
        
        ## ... total_gamma
        total_perimeter = sum( allNeighbourInfo['sharedEdge', selectedFlow2neigbour] )
        total_gamma = sum(gamma_jj)/total_perimeter*current_patch_info['len']*cellarea; # currrent CF calculation
        if(drainage_type==1) total_gamma = current_patch_info['aveSlope']*current_patch_info['len']*cellarea; # special for stream
        
    #-------------- subsurface -------------------# within a for loop
        if(as.numeric(templateACTION$outputSubFlow[2])>0 ){
            cat(
            paste(current_patch_info[c('patchID','zoneID','hillID')], collapse=' '),
            paste(sprintf('%.1f',current_patch_info[c('rr','cc','elevation')]), collapse=' '),
            sprintf('%.2f',1.0),
            sprintf('%.2f', ifelse(!is.na(current_patch_info['roofQfrac']),current_patch_info['roofQfrac'],0)*BASEMENT_DEPTH + ifelse(!is.na(current_patch_info['pavedRoadQfrac']),current_patch_info['pavedRoadQfrac'],0)*PAVEDROAD_DEPTH + ifelse(!is.na(current_patch_info['drivewayQfrac']),current_patch_info['drivewayQfrac'],0)*PAVEDROAD_DEPTH),
            drainage_type,
            total_gamma, length(withinNeighbourRC),'\n', file=subsurfaceflow_table_buff,sep=' ')
            
            cat( paste(
            allNeighbourInfo['patchID',],
            allNeighbourInfo['zoneID',],
            allNeighbourInfo['hillID',],
            sprintf('%.5f',neighbor_frac_gamma),
            sprintf('%.2f',allNeighbourInfo['sharedEdge',]/allNeighbourInfo['dist',]),
            sprintf('%.2f',allNeighbourInfo['sharedEdge',]),sep=' '), file=subsurfaceflow_table_buff,sep='\n')
            
            # ... traditional road grid, which cannot be stream or outlet grid
            if(drainage_type==2) cat (
            patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'],
            patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['zoneID'],
            patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['hillID'],
            #patch_info_lowest['patchID'],
            #patch_info_lowest['zoneID'],
            #patch_info_lowest['hillID'],
            roadWidth,'\n', file=subsurfaceflow_table_buff,sep=' ')  #cellsize*current_patch_info[15]
        }
        

	#-------------- surface -------------------# within a for loop
        if( (current_patch_info['roofQfrac']>0 | current_patch_info['drivewayQfrac']>0 | current_patch_info['pavedRoadQfrac']>0 | current_patch_info['nonstrsurfdrainQ']>0) & current_patch_info['strQ']==0 ){
            # debug: surface water is the "detention" in the model; not calculated by gamma/total_gamma
            # debug: road grids (by frac) has only one drain direction; storm drain will overwrite every direction;
            # debug: parking/roof has partial direction by their frac of the grid
            # this scheme (roof/parking to road and then storm) does not work in RHESSys because surface water only move by one grid per day!
            # correction: we need to teleport surface water from root/parking/road to stream (storm drain targets)
            
            # surface
            # what needs to be surface:
            # roof / parking / road on current patch
            stormsurfacedrainFrac = c(
                ifelse(current_patch_info['roofQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0,current_patch_info['roofQfrac'],0),  # roof Frac
                ifelse(current_patch_info['drivewayQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0,current_patch_info['drivewayQfrac'],0), # parking Frac
                ifelse(current_patch_info['pavedRoadQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0,current_patch_info['pavedRoadQfrac'],0),  # road Frac
                ifelse(current_patch_info['nonstrsurfdrainQ']>0 &
                    current_patch_info['nonmodelstrgridQ']==0,0.9,0) # e.g., surface drain around the roof/road/parkinglot
            ); names(stormsurfacedrainFrac) = c('roof','parking','road','extenddrain')
            if(sum(stormsurfacedrainFrac[1:3])>=1){
                stormsurfacedrainFrac[1:3] = stormsurfacedrainFrac[1:3]/sum(stormsurfacedrainFrac[1:3]);
                stormsurfacedrainFrac[4]=0;
            }else if(stormsurfacedrainFrac[4]>0 & sum(stormsurfacedrainFrac[1:4])>=1){ stormsurfacedrainFrac[4] = 1 - sum(stormsurfacedrainFrac[1:3]); }
            
            normal_neighborNum = length(neighbor_frac_gamma)
            normalFrac = 1 - sum(stormsurfacedrainFrac) - ifelse(current_patch_info['nonmodelstrgridQ']>0, 0.4,0.0);
            # current_patch_info[22] = surfaceDrain <= streamExtension
            # current_patch_info[21] = streamExtension
            if(normalFrac<0){ print(paste(ii, normalFrac)); normalFrac = 0;} #<<---- problem to check
            normal_neighbor_frac_gamma = (neighbor_frac_gamma * normalFrac)
            
            
            ## stop routing from roof to roof on surface
            normal_neighbor_frac_gammaSUM = sum(normal_neighbor_frac_gamma)
            normal_neighbor_frac_gamma = normal_neighbor_frac_gamma * (1.0 - allNeighbourInfo['roofQfrac',]) # roofFrac of neighbour patch
            if(sum(normal_neighbor_frac_gamma)>0){
                normal_neighbor_frac_gamma = normal_neighbor_frac_gamma/sum(normal_neighbor_frac_gamma)*normal_neighbor_frac_gammaSUM;
            }else{
                normal_neighbor_frac_gamma = rep(0,length(normal_neighbor_frac_gamma))
            }
            
            
            ## counting number of neighbours
            if(current_patch_info['roofQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0) normal_neighborNum = normal_neighborNum + 1; # roof
            if(current_patch_info['drivewayQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0) normal_neighborNum = normal_neighborNum + 1; # parking
            if(current_patch_info['pavedRoadQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0) normal_neighborNum = normal_neighborNum + 1; # road
            if( stormsurfacedrainFrac['extenddrain']>0 & current_patch_info['nonmodelstrgridQ']==0) normal_neighborNum = normal_neighborNum + 1; # surface drain around the roof/road/parkinglot
            if( current_patch_info['nonmodelstrgridQ']>0) normal_neighborNum = normal_neighborNum + 1; # stream ext.
            
            if(as.numeric(templateACTION$outputSurfFlow[2])>0 ){
                cat(
                paste(current_patch_info[c('patchID','zoneID','hillID')], collapse=' '),
                paste(sprintf('%.1f',current_patch_info[c('rr','cc','elevation')]), collapse=' '),
                sprintf('%.2f',1.0),
                sprintf('%.2f', ifelse(!is.na(current_patch_info['roofQfrac']),current_patch_info['roofQfrac'],0)*BASEMENT_DEPTH + ifelse(!is.na(current_patch_info['pavedRoadQfrac']),current_patch_info['pavedRoadQfrac'],0)*PAVEDROAD_DEPTH + ifelse(!is.na(current_patch_info['drivewayQfrac']),current_patch_info['drivewayQfrac'],0)*PAVEDROAD_DEPTH),
                drainage_type,
                total_gamma, normal_neighborNum, '\n', file=surfaceflow_table_buff,sep=' ')
                
                cat( paste(
                allNeighbourInfo['patchID',],
                allNeighbourInfo['zoneID',],
                allNeighbourInfo['hillID',],
                sprintf('%.5f',normal_neighbor_frac_gamma),
                sprintf('%.2f',allNeighbourInfo[7,]/allNeighbourInfo[4,]),
                sprintf('%.2f',allNeighbourInfo[7,]),sep=' '), file=surfaceflow_table_buff,sep='\n')
                
                # current_patch_info[15]>0    road / storm drain & NOT str grid & NOT strExt
                if(current_patch_info['pavedRoadQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0) cat(
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'],
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['zoneID'],
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['hillID'],
                #patch_info_lowest['patchID'],
                #patch_info_lowest['zoneID'],
                #patch_info_lowest['hillID'],
                sprintf('%.5f', stormsurfacedrainFrac['road']),
                sprintf('%.2f',1.0),
                sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                
                # current_patch_info[19]>0 roof & NOT str grid & NOT strExt
                if(current_patch_info['roofQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0) cat(
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'],
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['zoneID'],
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['hillID'],
                #patch_info_lowest['patchID'],
                #patch_info_lowest['zoneID'],
                #patch_info_lowest['hillID'],
                sprintf('%.5f', stormsurfacedrainFrac['roof']),
                sprintf('%.2f',1.0),
                sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                
                # current_patch_info[20]>0 parking & NOT str grid & NOT strExt
                if(current_patch_info['drivewayQfrac']>0 & current_patch_info['nonmodelstrgridQ']==0) cat(
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'],
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['zoneID'],
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['hillID'],
                #patch_info_lowest['patchID'],
                #patch_info_lowest['zoneID'],
                #patch_info_lowest['hillID'],
                sprintf('%.5f', stormsurfacedrainFrac['parking']),
                sprintf('%.2f',1.0),
                sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                
                # current_patch_info[17]>0 extenddrain & NOT str grid & NOT strExt
                if(stormsurfacedrainFrac['extenddrain']>0 & current_patch_info['nonmodelstrgridQ']==0) cat(
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'],
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['zoneID'],
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['hillID'],
                #patch_info_lowest['patchID'],
                #patch_info_lowest['zoneID'],
                #patch_info_lowest['hillID'],
                sprintf('%.5f', stormsurfacedrainFrac['extenddrain']),
                sprintf('%.2f',1.0),
                sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                
                # strExt (surface) & NOT str grid @ outlet
                if(current_patch_info['nonmodelstrgridQ']>0 & current_patch_info['patchID']!=patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'] ) cat(
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID'],
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['zoneID'],
                patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['hillID'],
                #patch_info_lowest['patchID'],
                #patch_info_lowest['zoneID'],
                #patch_info_lowest['hillID'],
                sprintf('%.5f', 0.4),
                sprintf('%.2f',1.0),
                sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                
                # strExt (surface) & str grid @ outlet
                if(current_patch_info['nonmodelstrgridQ']>0 & current_patch_info['patchID']==patch_info_suboulet[[ current_patch_info['subIDindex'] ]]['patchID']) cat(
                patch_info_basinoutlet['patchID'],
                patch_info_basinoutlet['zoneID'],
                patch_info_basinoutlet['hillID'],
                sprintf('%.5f', 0.4),
                sprintf('%.2f',1.0),
                sprintf('%.2f',1.0),'\n', file=surfaceflow_table_buff,sep=' ')
                
            }# if
        }else{
            # same as subsurface flow
            
            normal_neighbor_frac_gamma = neighbor_frac_gamma
            
            ## stop routing from roof to roof on surface
            normal_neighbor_frac_gammaSUM = sum(normal_neighbor_frac_gamma)
            normal_neighbor_frac_gamma = normal_neighbor_frac_gamma * (1.0 - allNeighbourInfo[8,]) # roofFrac
            if(sum(normal_neighbor_frac_gamma)>0){normal_neighbor_frac_gamma = normal_neighbor_frac_gamma/sum(normal_neighbor_frac_gamma)*normal_neighbor_frac_gammaSUM;}else{ normal_neighbor_frac_gamma = rep(0,length(normal_neighbor_frac_gamma)) }
            
            if(as.numeric(templateACTION$outputSurfFlow[2])>0 ){
                cat(
                paste(current_patch_info[c('patchID','zoneID','hillID')], collapse=' '),
                paste(sprintf('%.1f',current_patch_info[c('rr','cc','elevation')]), collapse=' '),
                sprintf('%.2f',1.0),
                sprintf('%.2f', ifelse(!is.na(current_patch_info['roofQfrac']),current_patch_info['roofQfrac'],0)*BASEMENT_DEPTH + ifelse(!is.na(current_patch_info['pavedRoadQfrac']),current_patch_info['pavedRoadQfrac'],0)*PAVEDROAD_DEPTH + ifelse(!is.na(current_patch_info['drivewayQfrac']),current_patch_info['drivewayQfrac'],0)*PAVEDROAD_DEPTH),
                drainage_type,
                total_gamma,length(withinNeighbourRC),'\n', file=surfaceflow_table_buff,sep=' ')
                
                cat( paste(
                allNeighbourInfo['patchID',],
                allNeighbourInfo['zoneID',],
                allNeighbourInfo['hillID',],
                sprintf('%.5f', normal_neighbor_frac_gamma),
                sprintf('%.2f',allNeighbourInfo[7,]/allNeighbourInfo[4,]),
                sprintf('%.2f',allNeighbourInfo[7,]),sep=' '), file=surfaceflow_table_buff,sep='\n')
            }#if
        }# else
    }# for loop ii

    if(as.numeric(templateACTION$outputSubFlow[2])>0 ){
       close(subsurfaceflow_table_buff)
    }
    if(as.numeric(templateACTION$outputSurfFlow[2])>0 ){
        close(surfaceflow_table_buff)
    }
	
	
	
	
	
	
	
	
	
	
	
	
	
	

#!/bin/bash
inputThreshold=$1
inputLower=$2
inputUpper=$3
#
g.region raster=dem
r.mask -r
# set maxcol
declare $(r.info map=dem | awk 'NR==13{print "maxcol="$3}')
# set x, y, and physical variables (e.g., slope, aspect ... etc) based on elevation
r.mapcalc --overwrite expression="xmap = x()"
r.mapcalc --overwrite expression="ymap = y()"
r.watershed -s --overwrite elevation=dem accumulation=uaa drainage=drain tci=wetness_index
r.slope.aspect --overwrite elevation=dem slope=slope_ aspect=aspect_
r.horizon --overwrite -d elevation=dem direction=180 output="west" distance=1.0
r.horizon --overwrite -d elevation=dem direction=0 output="east" distance=1.0
# finding the nearest stream/uaa to the provided "outlet" point (vector data)
r.mapcalc --overwrite expression="tmp = if(abs(uaa)>=$inputLower&&abs(uaa)<=$inputUpper,1,null())"
r.to.vect input=tmp output=tmp type=line
declare $(v.distance -p from=outlet from_type=point to=tmp to_type=line upload=to_x,to_y separator=space | awk '{print "xyCoord=" $2 "," $3}')
g.remove -f type=vector name=tmp
g.remove -f type=raster name=tmp
# delineate catchment based on the nearest outlet point on the stream/uaa
r.water.outlet --overwrite input=drain output=basin coordinates=$xyCoord
g.region zoom=basin
r.watershed -s --overwrite elevation=dem threshold=$inputThreshold basin=sub stream=str half_basin=hill
r.mask raster=basin
r.mapcalc --overwrite expression="basin = if(isnull(hill),null(),1)"
g.region raster=dem
g.region zoom=basin
r.mask -r
r.mask raster=basin
# set patch and other variables
r.mapcalc --overwrite expression="patch = row()*$maxcol+col()"
r.mapcalc --overwrite expression="zone = patch"
r.mapcalc --overwrite expression="rowmap = row()"
r.mapcalc --overwrite expression="colmap = col()"
r.mapcalc --overwrite expression="ZERO = 0"
r.mapcalc --overwrite expression="ONE = 1"
r.mapcalc --overwrite expression="slope = if(isnull(slope_),0.143,slope_)"
r.mapcalc --overwrite expression="aspect = if(isnull(aspect_),abs(drain)*45,aspect_)"

#!/bin/bash
# define forest community 
r.mapcalc --overwrite expression="evergreen = if(forestFrac>0&&(NLCD==42||NLCD==43),1,null())" 
r.mapcalc --overwrite expression="evergreen_Frac = if(forestFrac>0,if(NLCD==42,1.0,if(NLCD==43,0.5,null())),null())" 
r.mapcalc --overwrite expression="evergreen_LAI = if(forestFrac>0,if(NLCD==42,5.0,if(NLCD==43,3.5,null())),null())" 

r.mapcalc --overwrite expression="decidious = if(forestFrac>0&&(NLCD==41||NLCD==43),2,null())" 
r.mapcalc --overwrite expression="decidious_FFrac = if(forestFrac>0,if(NLCD==41,1.0,if(NLCD==43,0.5,null())),null())" 
r.mapcalc --overwrite expression="decidious_LAI = if(forestFrac>0,if(NLCD==41,4.5,if(NLCD==43,3.0,null())),null())" 

r.mapcalc --overwrite expression="shurb = if(forestFrac>0&&(NLCD==51||NLCD==52),6,null())" 
r.mapcalc --overwrite expression="shurb_FFrac = if(forestFrac>0,if(NLCD==51||NLCD==52,1,null()),null())" 
r.mapcalc --overwrite expression="shurb_LAI = if(forestFrac>0,if(NLCD==51||NLCD==52,3.5,null()),null())" 

#!/bin/bash
grassCMD='grass'
### setup GRASS dataset
PROJDIR=$1 # full path to the project location;
EPSGCODE=$2 # need to (manually) lookup the EPSG code for NAD83 UTM ##N for the catchment
RESOLUTION=$3 #spatial resolution (meters) of the grids
RHESSysNAME=$4 # e.g., rhessys_baisman10m
GISDBASE="$PROJDIR"/$5
LOCATION_NAME="$RHESSysNAME"
LOCATION="$GISDBASE"/$LOCATION_NAME
MAPSET=PERMANENT

$grassCMD -c $EPSGCODE -e "$LOCATION" 

# define forest fraction 

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="urban1Canopy = if(forestFrac>0&&(NLCD==21||NLCD==22),2,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="urban1Canopy_FFrac = if(forestFrac>0,if(NLCD==21||NLCD==22,1,null()),null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="urban1Canopy_LAI = if(forestFrac>0,if(NLCD==21||NLCD==22,3.5,null()),null())" 

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="urban2Canopy = if(forestFrac>0&&(NLCD==21||NLCD==23),2,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="urban2Canopy_FFrac = if(forestFrac>0,if(NLCD==21||NLCD==23,1,null()),null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="urban2Canopy_LAI = if(forestFrac>0,if(NLCD==21||NLCD==23,3.5,null()),null())" 

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="decidious = if(forestFrac>0&&(NLCD==41||NLCD==43),2,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="decidious_FFrac = if(forestFrac>0,if(NLCD==41,1.0,if(NLCD==43,0.5,null())),null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="decidious_LAI = if(forestFrac>0,if(NLCD==41,4.5,if(NLCD==43,3.0,null())),null())" 

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="evergreen = if(forestFrac>0&&(NLCD==42||NLCD==43),1,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="evergreen_Frac = if(forestFrac>0,if(NLCD==42,1.0,if(NLCD==43,0.5,null())),null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="evergreen_LAI = if(forestFrac>0,if(NLCD==42,5.0,if(NLCD==43,3.5,null())),null())" 

# define shrub fraction 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shrub1StratumID = if(shrubFrac>0&&(NLCD==21||NLCD==22),6,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shrub1_FFrac = if(shrubFrac>0,if(NLCD==21||NLCD==22,1,null()),null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shrub1_LAI = if(shrubFrac>0,if(NLCD==21||NLCD==22,3.5,null()),null())" 

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shrub2StratumID = if(shrubFrac>0&&(NLCD==21||NLCD==23),6,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shrub2_FFrac = if(shrubFrac>0,if(NLCD==21||NLCD==23,1,null()),null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shrub2_LAI = if(shrubFrac>0,if(NLCD==21||NLCD==23,3.5,null()),null())" 

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shrub3StratumID  = if(shrubFrac>0&&(NLCD==51||NLCD==52),6,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shrub3_FFrac = if(shrubFrac>0,if(NLCD==51||NLCD==52,1,null()),null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shrub3_LAI = if(shrubFrac>0,if(NLCD==51||NLCD==52,3.5,null()),null())" 

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shrub4StratumID  = if(shrubFrac>0&&(NLCD==45||NLCD==90),6,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shrub4_FFrac = if(shrubFrac>0,if(NLCD==45||NLCD==90,1,null()),null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shrub4_LAI = if(shrubFrac>0,if(NLCD==45||NLCD==90,3.5,null()),null())" 

# define crop fraction 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="crop1StratumID = if(cropFrac>0&&(NLCD==31||NLCD==46),7,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="crop1FFrac  = if(cropFrac>0,if(NLCD==31||NLCD==46,1,null()),null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="crop1LAI = if(cropFrac>0,if(NLCD==31||NLCD==46,3.5,null()),null())"

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="crop2StratumID = if(cropFrac>0&&(NLCD==81||NLCD==82),7,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="crop2FFrac  = if(cropFrac>0,if(NLCD==81||NLCD==82,1,null()),null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="crop2LAI = if(cropFrac>0,if(NLCD==81||NLCD==82,3.5,null()),null())"

# define lawn fraction 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass1StratumID = if(lawnFrac>0&&(NLCD==31||NLCD==71),3,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass1FFrac = if(lawnFrac>0&&(NLCD==31||NLCD==71),1.0,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass1LAI = if(lawnFrac>0&&(NLCD==31||NLCD==71),1.5,null())"

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass2StratumID = if(lawnFrac>0&&(NLCD==72||NLCD==73),3,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass2FFrac = if(lawnFrac>0&&(NLCD==72||NLCD==73),1.0,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass2LAI = if(lawnFrac>0&&(NLCD==72||NLCD==73),1.5,null())"

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass3StratumID = if(lawnFrac>0&&(NLCD==74||NLCD==95),3,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass3FFrac = if(lawnFrac>0&&(NLCD==74||NLCD==95),1.0,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass3LAI = if(lawnFrac>0&&(NLCD==74||NLCD==95),1.5,null())"

#!/bin/bash
grassCMD='grass'
### setup GRASS dataset
PROJDIR=$1 # full path to the project location;
EPSGCODE=$2 # need to (manually) lookup the EPSG code for NAD83 UTM ##N for the catchment
RESOLUTION=$3 #spatial resolution (meters) of the grids
RHESSysNAME=$4 # e.g., rhessys_baisman10m
GISDBASE="$PROJDIR"/$5
LOCATION_NAME="$RHESSysNAME"
LOCATION="$GISDBASE"/$LOCATION_NAME
MAPSET=PERMANENT

$grassCMD -c $EPSGCODE -e "$LOCATION" 

# define forest community 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="evergreen = if(forestFrac>0&&(NLCD==42||NLCD==43),1,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="evergreen_Frac = if(forestFrac>0,if(NLCD==42,1.0,if(NLCD==43,0.5,null())),null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="evergreen_LAI = if(forestFrac>0,if(NLCD==42,5.0,if(NLCD==43,3.5,null())),null())" 

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="decidious = if(forestFrac>0&&(NLCD==41||NLCD==43),2,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="decidious_FFrac = if(forestFrac>0,if(NLCD==41,1.0,if(NLCD==43,0.5,null())),null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="decidious_LAI = if(forestFrac>0,if(NLCD==41,4.5,if(NLCD==43,3.0,null())),null())" 

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shurb = if(forestFrac>0&&(NLCD==51||NLCD==52),6,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shurb_FFrac = if(forestFrac>0,if(NLCD==51||NLCD==52,1,null()),null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shurb_LAI = if(forestFrac>0,if(NLCD==51||NLCD==52,3.5,null()),null())" 

$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass1StratumID = if(lawnFrac>0,3,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass1FFrac = if(lawnFrac>0,1.0,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass1LAI = if(lawnFrac>0,1.5,null())"

#!/bin/bash
# set maxcol
eval $(r.info map=dem | awk 'NR==13{print "maxcol="$3}')
#
g.region zoom=basin
r.mask raster=basin
r.mapcalc --overwrite expression="basin = if(isnull(hill),null(),1)"
g.region raster=dem
g.region zoom=basin
r.mask -r
r.mask raster=basin
# set patch and other variables
r.mapcalc --overwrite expression="patch = row()*$maxcol+col()"
r.mapcalc --overwrite expression="ZERO = 0"
r.mapcalc --overwrite expression="ONE = 1"
r.mapcalc --overwrite expression="slope = if(isnull(slope_),0.143,slope_)"
r.mapcalc --overwrite expression="aspect = if(isnull(aspect_),abs(drain)*45,aspect_)"
g.remove -f type=vector name=tmp
g.remove -f type=raster name=tmp

#!/bin/bash
inputThreshold=$1
inputLower=$2
inputUpper=$3
#
g.region raster=dem
r.mask -r
# set x, y, and physical variables (e.g., slope, aspect ... etc) based on elevation
r.mapcalc --overwrite expression="xmap = x()"
r.mapcalc --overwrite expression="ymap = y()"
r.mapcalc --overwrite expression="rowmap = row()"
r.mapcalc --overwrite expression="colmap = col()"
r.slope.aspect --overwrite elevation=dem slope=slope_ aspect=aspect_
r.horizon --overwrite -d elevation=dem direction=180 output="west" distance=1.0
r.horizon --overwrite -d elevation=dem direction=0 output="east" distance=1.0
#
r.watershed --overwrite elevation=dem accumulation=uaa drainage=drain tci=wetness_index  # -s
r.watershed --overwrite elevation=dem threshold=$inputThreshold basin=sub_ stream=str_ half_basin=hill_  ## -s
#r.watershed --overwrite elevation=dem accumulation=uaaD8 -s
#
# finding the nearest stream/uaa to the provided "outlet" point (vector data)
# this snapping process gets wrong with D-inf routing !
# ... this is for D-8
#r.mapcalc --overwrite expression="tmp = if(abs(uaa)>=$inputLower&&abs(uaa)<=$inputUpper,1,null())"
#r.to.vect input=tmp output=tmp type=line
#declare $(v.distance -p from=outlet from_type=point to=tmp to_type=line upload=to_x,to_y separator=space | awk '{print "xyCoord=" $2 "," $3}')

# ... this is for D-Inf (maybe do it in R?)
# v.to.rast input=outlet type=point output=outlet_tmp use=cat <--- not
eval $(r.what --quiet map=sub_ points=outlet separator=space | awk '{print "outletSUB=" $3}')
r.mapcalc --overwrite expression="tmp = if(sub_==$outletSUB && str_>0, uaa, null())"
r.to.vect --overwrite input=tmp output=tmp type=line
eval $(v.distance -p from=outlet from_type=point to=tmp to_type=line upload=to_x,to_y separator=space | awk '{print "xyCoord=" $2 "," $3}')
# delineate catchment based on the nearest outlet point on the stream/uaa ##--- this step is contrained by D8
r.water.outlet --overwrite input=drain output=basin_ coordinates=$xyCoord
#
r.to.vect --overwrite input=sub_ output=tmp type=area
v.rast.stats -c map=tmp raster=basin_ column_prefix=select method=average
v.to.rast --overwrite input=tmp type=area where=select_average>0 output=tmp use=attr attribute_column=select_average
#g.region raster=tmp

#!/bin/bash
grassCMD='grass'
### setup GRASS dataset
PROJDIR=$1 # full path to the project location;
EPSGCODE=$2 # need to (manually) lookup the EPSG code for NAD83 UTM ##N for the catchment
RESOLUTION=$3 #spatial resolution (meters) of the grids
RHESSysNAME=$4 # e.g., rhessys_baisman10m
GISDBASE="$PROJDIR"/$5
LOCATION_NAME="$RHESSysNAME"
LOCATION="$GISDBASE"/$LOCATION_NAME
MAPSET=PERMANENT

$grassCMD -c $EPSGCODE -e "$LOCATION" 

# Forest Community
## define evergreen fraction using "forestFrac" and "NLCD 42(Evergreen Forest) & 43(Mixed Forest)"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="evergreen = if(forestFrac>0&&(NLCD==42||NLCD==43),1,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="evergreen_Frac = if(forestFrac>0,if(NLCD==42,1.0,if(NLCD==43,0.5,null())),null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="evergreen_LAI = if(forestFrac>0,if(NLCD==42,5.0,if(NLCD==43,3.5,null())),null())" 
## define decidious fraction using "forestFrac" and "NLCD 41(Deciduous Forest) & 43(Mixed Forest)"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="decidious = if(forestFrac>0&&(NLCD==41||NLCD==43),2,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="decidious_FFrac = if(forestFrac>0,if(NLCD==41,1.0,if(NLCD==43,0.5,null())),null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="decidious_LAI = if(forestFrac>0,if(NLCD==41,4.5,if(NLCD==43,3.0,null())),null())" 
## define shurb fraction using "forestFrac" and "NLCD 51(Dwarf Scrub:AK only) and 52(Shrub/Scrub)"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shurb = if(forestFrac>0&&(NLCD==51||NLCD==52),6,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shurb_FFrac = if(forestFrac>0,if(NLCD==51||NLCD==52,1,null()),null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="shurb_LAI = if(forestFrac>0,if(NLCD==51||NLCD==52,3.5,null()),null())" 
## define oak_canopy fraction using forestFrac
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="oak_canopy = if(forestFrac>0,102,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="oak_canopy_FFrac = if(forestFrac>0,0.8,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="oak_canopy_LAI = if(forestFrac>0,5.5,null())"
## define maple_canopy fraction using forestFrac
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="maple_canopy = if(forestFrac>0,111,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="maple_canopy_FFrac = if(forestFrac>0,0.2,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="maple_canopy_LAI = if(forestFrac>0,5.5,null())"
## define deciduous fraction using "NLCD 41(Deciduous Forest), 43(Mixed Forest), 90(Woody Wetlands), and 95(Emergent Herbaceous Wetlands)"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="deciduous = if(NLCD==41||NLCD==43||NLCD==90||NLCD==95,0,2,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="deciduous_FFrac = if(NLCD==41||NLCD==43||NLCD==90||NLCD==95,0.8,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="deciduous_LAI = if(NLCD==41||NLCD==43||NLCD==90||NLCD==95,4.0,null())"
## define evergreen fraction using "NLCD 42(Evergreen Forest) & 52(Shrub/Scrub)"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="evergreen = if(NLCD==42||NLCD==52,1,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="evergreen_FFrac = if(NLCD==42||NLCD==52,0.8,null())" 
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="evergreen_LAI = if(NLCD==42||NLCD==52,4.0,null())"

# Lawn(GRASS) Community
## define grass fraction using lawnFrac
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass1StratumID = if(lawnFrac>0,3,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass1FFrac = if(lawnFrac>0,1.0,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass1LAI = if(lawnFrac>0,1.5,null())"
## define grass fraction using "NLCD 71(Grasslands/Herbaceous), 72(Sedge/Herbaceous(AK Only)), 81(Pasture/Hay), and 82(Cultivated Crops)"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass1StratumID = if(NLCD==71||NLCD==72||NLCD==81||NLCD==82,3,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass1FFrac = if(NLCD==71||NLCD==72||NLCD==81||NLCD==82,1.0,null())"
$grassCMD "$LOCATION"/"$MAPSET" --exec r.mapcalc --overwrite expression="grass1LAI = if(NLCD==71||NLCD==72||NLCD==81||NLCD==82,1.5,null())"
